/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/* Program Name: PT-COLOR.P
 * Author      : Gerry Seidl
 * Written on  : January 15, 1993
 * Description : Maintains color definitions for protermcap entry
 */

{proterm/pt-share.i} /* GLOBAL DEFS */
/* Definitions of the field level widgets    */

DEFINE BUTTON save-but LABEL "&Save" SIZE 10 BY 1.
DEFINE BUTTON rev-but  LABEL "&Revert" SIZE 10 BY 1.
DEFINE BUTTON can-but  LABEL "&Main Menu" SIZE 12 BY 1.
    
DEFINE VARIABLE ESCSEQ AS CHARACTER FORMAT "X(25)" 
     LABEL "&Escape Sequence"  NO-UNDO.
DEFINE VARIABLE fg AS CHARACTER view-as selection-list 
     inner-chars 15 inner-lines 5.              
DEFINE VARIABLE bg AS CHARACTER view-as selection-list 
     inner-chars 15 inner-lines 5.
DEFINE VARIABLE colorno AS INTEGER VIEW-AS SLIDER MIN-VALUE 5 MAX-VALUE 127 
       LABEL "Color #" initial 5.
DEFINE VARIABLE fgcol AS CHARACTER FORMAT "X(15)" LABEL
    "Foreground Color".
DEFINE VARIABLE bgcol AS CHARACTER FORMAT "X(15)" LABEL 
    "Background Color".    

DEFINE VARIABLE clist AS CHARACTER FORMAT "X(100)".
def var list-status as logical.
def var addit as logical.

/* Definitions of the frame widgets                 */
DEFINE FRAME FRAME-A
     colorno at row 1 col 14
     FG AT ROW 4 COL 5 no-label BG AT ROW 4 COL 30 no-label
     "Foreground" at row 3 col 9 "Background" at row 3 col 34
     ESCSEQ AT ROW 12 COL 6
     "(Example: ~\E[31;40m:~\E[m)" AT ROW 13 COL 23
     save-but at row 15 COL 6 rev-but at row 15 col 18
     can-but at row 15 COL 37
     WITH  1 DOWN OVERLAY SIDE-LABELS
 AT COL 12 ROW 2
 SIZE-CHAR 55 BY 17 
 TITLE "Color definitions for " + termtype.

on choose of save-but in frame frame-a do:
 do with frame frame-a:
    assign fgcol = input fg:screen-value.
    assign bgcol = input bg:screen-value.
    assign escseq = input escseq:screen-value.
    if fgcol = bgcol then do:
       message "Background and Foreground colors cannot be the same."
   view-as alert-box error buttons ok.
       return no-apply.
    end.
    else if escseq = "" then do:
       message "Escape sequence cannot be blank"
    view-as alert-box error buttons ok.
       return no-apply.  
    end.  
    clear frame frame-a.
    find colors where cno = int(colorno:screen-value) no-error.
    if not available (colors) then do:
 create colors.
 assign colors.cno = int(colorno:screen-value).
    end.
    assign colors.bg = bgcol
    colors.fg = fgcol
    colors.c-escseq = escseq.                       
    release colors.
 end. /*do*/
end.

ON VALUE-CHANGED OF colorno in FRAME FRAME-A DO:
  FIND COLORS WHERE cno = int(colorno:screen-value in frame frame-a)
no-error.
  IF AVAILABLE (COLORS) THEN DO:
      if colors.fg <> "" then do:
 find colornames where colorname = colors.fg no-error.
 if available (colornames) then 
 do:
     fg:screen-value = colors.fg.
     apply "value-changed" to fg in frame frame-a.
 end.
 else do:
     message "Color" colors.fg "does not exist in the database."
   "Do you want to add it?" view-as alert-box error buttons
   yes-no update addit.
     if addit then do:
        create colornames.
        assign colorname = colors.fg.
        release colornames.
     end.
     list-status = fg:add-last(colors.fg).
     fg:screen-value = colors.fg.
     apply "value-changed" to fg in frame frame-a.
   end.  
      end.
      else fg:screen-value = "<none>".
      if colors.bg <> "" then do:
 find colornames where colorname = colors.bg no-error.                            
 if available (colornames) then 
 do:
     bg:screen-value = colors.bg.
     apply "value-changed" to bg in frame frame-a.
 end.
 else do:
     message "Color" colors.bg "does not exist in the database."
   "Do you want to add it?" view-as alert-box error buttons
   yes-no update addit.
     if addit then do:
        create colornames.
        assign colorname = colors.bg.
        release colornames.
     end.
     list-status = bg:add-last(colors.bg).
     bg:screen-value = colors.bg.
     apply "value-changed" to bg in frame frame-a.
 end.
      end.
      else bg:screen-value = "<none>".                       
      ASSIGN ESCSEQ = COLORS.C-ESCSEQ.
      DISPLAY ESCSEQ WITH FRAME FRAME-A.
   END.
   ELSE DO:
      /* no color record for this color number */
      fg:screen-value = "<none>".
      bg:screen-value = "<none>".
      ASSIGN ESCSEQ = "".
      DISPLAY ESCSEQ WITH FRAME FRAME-A.
   end.
   RELEASE COLORS.
END.

on choose of rev-but in frame frame-a do: /* restore values */
   if not available (COLORS) then
      FIND COLORS WHERE cno = int(colorno:screen-value in frame frame-a)
         no-error.
   if available (COLORS) then do:
    fg:screen-value = colors.fg.
    bg:screen-value = colors.bg.
     apply "value-changed" to fg in frame frame-a.
     apply "value-changed" to bg in frame frame-a.
    ASSIGN ESCSEQ = COLORS.C-ESCSEQ.
    DISPLAY ESCSEQ WITH FRAME FRAME-A.
   end.
   else do:
      fg:screen-value = "<none>".
      bg:screen-value = "<none>".
      ESCSEQ = "".
      DISPLAY ESCSEQ WITH FRAME FRAME-A.
   END.
END.

on choose of can-but in frame frame-a do:
    HIDE FRAME FRAME-A.
    return.
end.

/* DEFINE AND LOAD UP SELECTION-LISTS */
for each colornames by colornames.colorname:
    list-status = fg:add-last(colornames.colorname) in frame frame-a.
    if not list-status then undo, return.
end.
for each colornames by colornames.colorname:
    list-status = bg:add-last(colornames.colorname) in frame frame-a.
    if not list-status then undo, return.
end.
DISPLAY 
     FG BG ESCSEQ
     WITH FRAME FRAME-A.
ENABLE ALL WITH FRAME FRAME-A.

/* Convert colors in temp table to lower-case */
FOR EACH COLORS:
    ASSIGN colors.bg = LC(colors.bg)
           colors.fg = LC(colors.fg).
END.

/* CHECK FOR COLOR 5 */
   FIND COLORS WHERE cno = 5 no-error.
   IF AVAILABLE (COLORS) THEN DO:
      if colors.fg <> "" then do:
 find colornames where colorname = colors.fg no-error.
 if available (colornames) then 
 do:
     fg:screen-value = colors.fg.
     apply "value-changed" to fg in frame frame-a.
 end.
 else do:
     message "Color" colors.fg "does not exist in the database."
   "Do you want to add it?" view-as alert-box error buttons
   yes-no update addit.
     if addit then do:
        create colornames.
        assign colorname = colors.fg.
        release colornames.
     end.
     list-status = fg:add-last(colors.fg).
     fg:screen-value = colors.fg.
     apply "value-changed" to fg in frame frame-a.
 end.                       
      end.
      else fg:screen-value = "<none>".
      if colors.bg <> "" then do:
 find colornames where colorname = colors.bg no-error.                            
 if available (colornames) then 
 do:
     bg:screen-value = colors.bg.
     apply "value-changed" to bg in frame frame-a.
 end.
 else do:
     message "Color" colors.bg "does not exist in the database."
   "Do you want to add it?" view-as alert-box error buttons
   yes-no update addit.
     if addit then do:
        create colornames.
        assign colorname = colors.bg.
        release colornames.
     end.
     list-status = bg:add-last(colors.bg).
     bg:screen-value = colors.bg.
     apply "value-changed" to bg in frame frame-a.
 end.
      end.
      else bg:screen-value = "<none>".                       
      ASSIGN ESCSEQ = COLORS.C-ESCSEQ.
      DISPLAY ESCSEQ WITH FRAME FRAME-A.
   END.
   ELSE DO:
      fg:screen-value = "<none>".
      bg:screen-value = "<none>".
      ASSIGN ESCSEQ = "".
      DISPLAY ESCSEQ WITH FRAME FRAME-A.
   end.


/* ASSIGN RUN TIME ATTRIBUTES                          */

/* Define temporary widget handle for run-time attributes  */
DEFINE VARIABLE tmp_handle AS WIDGET-HANDLE NO-UNDO.

ASSIGN tmp_handle = ESCSEQ:HANDLE IN FRAME FRAME-A
       tmp_handle:WIDTH-CHARS                   = 25
       tmp_handle:FORMAT    = "X(25)".

/* _RUN-TIME-ATTRIBUTES-END */


WAIT-FOR CHOOSE OF CAN-BUT FOCUS COLORNO.
HIDE FRAME FRAME-A.

/* pt-color.p - end of file */
