/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/* Program Name: PT-ESCD.P
 * Author      : Gerry Seidl
 * Written on  : January 15, 1993
 * Description : Dialog Box that asks for the ESCAPE sequence
 */

{proterm/pt-share.i} /* GLOBAL DEFS */
/* Define a dialog box               */

/* Definitions of the field level widgets                                  */
DEFINE BUTTON BUTTON-2
     LABEL "&Cancel" 
     SIZE-CHAR 10 BY 1 .

DEFINE BUTTON BUTTON-1
     LABEL "&Save" 
     SIZE-CHAR 10 BY 1 .

DEFINE VARIABLE ESCCHAR AS CHARACTER INITIAL "\E" VIEW-AS RADIO-SET
     RADIO-BUTTONS " ~\E or ~^[   " , "~\E",
                   " ~\E[23~~ (VT)" , "~\E[23~~",
                   " Other"          , "Other".                 

/* Definitions of the frame widgets                  */
FORM
     ESCCHAR  AT ROW 2 COL 5 NO-LABELS
     ESCVAL AT ROW 4 COL 18 NO-LABELS
     BUTTON-1 AT ROW 6 COL 5
     BUTTON-2 AT ROW 6 COL 18
        WITH VIEW-AS DIALOG-BOX SIDE-LABELS SIZE-CHAR 31 BY 8 
        TITLE "What is ESC?" 
        FRAME DIALOG-1.

ON CHOOSE OF BUTTON-1 DO:
   do with frame dialog-1.
     if escchar:screen-value = "other" and escval:screen-value = "" then do:
         message "You must enter a value for the ESC character".
         apply "ENTRY" to ESCVAL IN FRAME DIALOG-1.
         return no-apply.
     end.
     assign ESCVAL = (IF ESCCHAR:SCREEN-VALUE = "OTHER" THEN
        ESCVAL:SCREEN-VALUE ELSE ESCCHAR:SCREEN-VALUE).
     ESCVAL = TRIM(ESCVAL).
     RETURN. 
   end.
END.

ON CHOOSE OF BUTTON-2 DO:
   escval = "".
   RETURN.
END.

ON END-ERROR ANYWHERE DO:
   APPLY "CHOOSE" TO BUTTON-2 IN FRAME DIALOG-1.
END.

ON VALUE-CHANGED OF ESCCHAR IN FRAME DIALOG-1 DO:
  do with frame dialog-1:
    if escchar:screen-value = "other" then enable escval.
    else disable escval.
  end.
END.

enable all except escval with frame dialog-1.
wait-for choose of button-1, button-2 in frame dialog-1.
HIDE FRAME DIALOG-1.

/* pt-escd.p - end of file */
