/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/* Program Name: PT-KLD.P
 * Author      : Gerry Seidl
 * Written on  : January 15, 1993
 * Description : Key definition dialog box
 */

/* Define a dialog box                 */
{proterm/pt-share.i}

/* Definitions of the field level widgets                                 */
DEFINE SHARED VARIABLE tmp-kl AS CHARACTER FORMAT "X(19)" 
     LABEL "&Key Label"        NO-UNDO.

DEFINE SHARED VARIABLE tmp-escseq AS CHARACTER FORMAT "X(39)" 
     LABEL "&Esc Seq"  NO-UNDO.

DEFINE BUTTON tmp-can-but
     LABEL "&Cancel"
     SIZE-CHAR 10 BY 1 .

DEFINE BUTTON tmp-save-but
     LABEL "&Save"
     SIZE-CHAR 10 BY 1 .

DEFINE OUTPUT PARAMETER stat AS INT NO-UNDO. /* return code */

/* Definitions of the frame widgets                                           */
DEFINE FRAME DIALOG-1
     tmp-kl AT ROW 2.5 COL 3.72
          LABEL "Key Label"  FORMAT "x(20)" 
     tmp-escseq AT ROW 4.5 COL 5.43
          LABEL "Esc Seq"  FORMAT "x(40)" 
     tmp-save-but AT ROW 7 COL 15
     tmp-can-but AT ROW 7 COL 34
    WITH VIEW-AS DIALOG-BOX SIDE-LABELS SIZE-CHAR 60 BY 10 
        TITLE "Enter the new Key Label and Sequence".

/* ASSIGN RUN TIME ATTRIBUTES */

/* Define temporary widget handle for run-time attributes                 */
DEFINE VARIABLE tmp_handle AS WIDGET-HANDLE NO-UNDO.

ASSIGN tmp_handle = tmp-kl:HANDLE IN FRAME DIALOG-1
       tmp_handle:WIDTH-CHARS         = 21.

ASSIGN tmp_handle = tmp-escseq:HANDLE IN FRAME DIALOG-1
       tmp_handle:WIDTH-CHARS         = 41.

ON CHOOSE OF tmp-can-but DO:
  apply "GO" to frame dialog-1.
  assign tmp-kl = ""
         tmp-escseq = ""
         stat = 1.
  return.
END.

ON CHOOSE OF tmp-save-but DO:
 def var kc as int.
  kc = keycode(tmp-kl:screen-value in frame dialog-1).
  if kc < 1 then do:
      def var choice as logical initial true.
      message tmp-kl:screen-value in frame dialog-1 "is not a valid"
          "PROGRESS key label" view-as alert-box error buttons
          ok-cancel update choice.
      if choice then do:
          apply "ENTRY" to tmp-kl in frame dialog-1.
          return no-apply.
      end.
      else apply "CHOOSE" to tmp-can-but in frame dialog-1.
  end.
  assign tmp-kl = tmp-kl:screen-value in frame dialog-1.
  assign tmp-escseq = tmp-escseq:screen-value in frame dialog-1.
  apply "GO" to frame dialog-1.
  stat = 0.
  return.
END.

ON ENTRY OF tmp-escseq in frame dialog-1 DO:
   IF tmp-kl:screen-value in frame dialog-1 <> "" then do:
       DEF VAR tmp-var LIKE tmp-kl.
       tmp-var = tmp-kl:screen-value in frame dialog-1.
       if index(tmp-var,"ESC") <> 0 then 
           tmp-var = replace(tmp-var,"ESC",escval).
       if index(tmp-var,"CTRL") <> 0 then 
           tmp-var = replace(tmp-var,"CTRL","^").
       if index(tmp-var,"-") <> 0 then 
           tmp-var = replace(tmp-var,"-","").
       assign tmp-escseq = tmp-var.
       display tmp-escseq with frame dialog-1.
   END.
END.
UPDATE 
       tmp-kl
       tmp-escseq
       tmp-save-but
       tmp-can-but WITH FRAME DIALOG-1.
RETURN.

/* pt-kld.p - end of file */
