/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/* Program Name: PT-MAIN.P
 * Author      : Gerry Seidl
 * Written on  : January 15, 1993
 * Description : Manages Main Application Window for the application
 */

/* Shared info for application */
{proterm/pt-share.i "NEW"}

/* Menu Definitions */

DEFINE SUB-MENU m_File 
       MENU-ITEM m_Create           LABEL "&New"
       MENU-ITEM m_Open         LABEL "&Open"
       MENU-ITEM m_Save         LABEL "&Save"
       MENU-ITEM m_SaveAs           LABEL "Save &As"
       MENU-ITEM m_Exit         LABEL "E&xit".

DEFINE SUB-MENU m_Help 
       MENU-ITEM m_About        LABEL "&About...".

DEFINE MENU MENUBAR-WINDOW-1 MENUBAR
       SUB-MENU  m_File         LABEL "&File"
       SUB-MENU  m_Help         LABEL "&Help".

/* Definitions of the frame widgets            */
DEFINE FRAME FRAME-A
     "Protermcap Builder Version 1.0a" AT ROW 10 COL 25
     WITH 1 DOWN OVERLAY SIDE-LABELS
        AT COL 1 ROW 1
        SIZE 78 by 20 COLOR MESSAGES.

ON CHOOSE OF MENU-ITEM m_Exit DO:
   def var choice as logical initial true.
   if termtype <> "" then do:
        message "An entry for terminal" termtype "appears to be" skip
                "open. Do you want to save it first?" view-as alert-box 
                warning buttons yes-no-cancel update choice.
        CASE choice:
           WHEN TRUE THEN 
             do: 
               apply "CHOOSE" to MENU-ITEM m_saveas 
                    in MENU menubar-window-1.
             end.
           WHEN FALSE THEN 
             DO:
                termtype = "".
             END.
           OTHERWISE  return no-apply .
        END CASE.                          
   end.        
   assign choice = false.
   message "Are you sure you want to exit" skip 
           "the Protermcap Builder?" view-as alert-box question
           buttons yes-no update choice.
   if choice then quit.
   else return no-apply.           
END.

ON WINDOW-CLOSE OF CURRENT-WINDOW DO:
    APPLY "CHOOSE" TO MENU-ITEM m_exit in MENU menubar-window-1.
    RETURN NO-APPLY.
END.

ON CHOOSE OF MENU-ITEM m_Save DO:
  IF TERMTYPE = "" THEN DO:
      MESSAGE "There is no terminal entry opened at this time." view-as
           alert-box error buttons ok.
      return no-apply.
  end.
  TERMOUT = TERMTYPE + ".NEW".
  run pt-write.p.
  message "Entry saved to" termout view-as alert-box information buttons ok.
END.

ON CHOOSE OF MENU-ITEM m_Saveas DO:
  IF TERMTYPE = "" THEN DO:
      MESSAGE "There is no terminal entry opened at this time." view-as
           alert-box error buttons ok.
      return no-apply.
  end.
  update termtype titleline format "X(50)" no-label with view-as 
       dialog-box title "Verify the termtype and title for this entry" 
       no-labels frame t.
  TERMOUT = TERMTYPE + ".NEW".
/* System Dialog for Diskfile names from ADE Editor */
DEFINE VAR getf_stat AS LOGICAL.
RUN adeedit/dlggetf.p
       (INPUT " Save As ",
        INPUT YES,
        INPUT 5,
        INPUT-OUTPUT termout,
         OUTPUT getf_stat).
      if getf_stat = NO THEN DO: /* no filename or CANCEL hit */
          view frame frame-a.
          message "Save operation aborted" view-as alert-box error
              buttons ok.
          return no-apply.
      end. 
   run pt-write.p.
   message "Entry saved to" termout view-as alert-box information buttons ok.
END.  

ON CHOOSE OF MENU-ITEM m_About DO:
 run pt-about.p. 
END.

ON CHOOSE OF MENU-ITEM m_Create DO:
   /*hide frame frame-a.*/
   assign defaultkb = false.
   if termtype <> "" then do:
        def var choice as logical.
        message "An entry for terminal" termtype "appears to be" skip
                "open. Do you want to save it first?" view-as alert-box 
                warning buttons yes-no-cancel update choice.
        CASE choice:
           WHEN TRUE THEN 
             do: 
               apply "CHOOSE" to MENU-ITEM m_saveas 
                    in MENU menubar-window-1.
             end.
           WHEN FALSE THEN 
             DO:
                termtype = "".
             END.
           OTHERWISE
           DO:
              return no-apply .
           END.
        END CASE.
   end.
   RUN entryoff.
   run pt-title.p. /* get termtype and title */
   if termtype <> "" then do:
       RUN entryon.
       view frame frame-a.
       run pt-newd.p.
       if termtype = "" then do:           
           message "A new entry was not created." view-as alert-box 
           information buttons ok.
           view frame frame-a.
           run entryoff.
           return no-apply.
       end.    
       os-delete err.out.
       if newfrom = 3 then assign fromfile = 1.
       else assign fromfile = 2.
       if newstat = 2 then do:
           assign termfile = termtype + ".imp".
           os-delete value(termfile).
           assign termfile = alttermtype + ".out". /* file to read in */
           /* create entry to read in */
           def var rescode as int INITIAL 1. /* status of crtmain 0/1 */
           CASE NEWFROM:
           WHEN 1 THEN DO:
             INPUT THROUGH crtmain termcap '""' value(alttermtype) NO-ECHO.
                 SET RESCODE WITH FRAME res.
             INPUT CLOSE.
           END.
           WHEN 2 THEN DO:
             INPUT THROUGH crtmain terminfo '""' value(alttermtype) NO-ECHO.
                 SET RESCODE WITH FRAME res.
             INPUT CLOSE.
           END.
           WHEN 3 THEN DO:
             INPUT THROUGH crtmain protermcap '""' value(alttermtype) NO-ECHO.
                 SET RESCODE WITH FRAME res.
             INPUT CLOSE.
           END.
           END CASE.
           if RESCODE <> 0 then do:
                  view frame frame-a.
                  message "An error occurred in crtmain. Creation aborted"
                      view-as alert-box error
                      buttons ok.
                  termtype = "".
                  run entryoff.
                  return no-apply.
           end.
           run readentry.
       end. 
       run pt-menu.p.
   end.
   else message "A new entry was not created." view-as alert-box 
      information buttons ok.
   view frame frame-a.
END.

ON CHOOSE OF MENU-ITEM m_Open DO:
   assign defaultkb = false.
   if termtype <> "" then do:
        def var choice as logical.
        message "An entry for terminal" termtype "appears to be" skip
                "open. Do you want to save it first?" view-as alert-box 
                warning buttons yes-no-cancel update choice.
        CASE choice:
           WHEN TRUE THEN 
             do: 
               apply "CHOOSE" to MENU-ITEM m_saveas 
                    in MENU menubar-window-1.
             end.
           WHEN FALSE THEN 
             DO:
                termtype = "".
             END.
           OTHERWISE  return no-apply .
        END CASE.                          
   end.        
   run entryoff.
   run clearmem.
   run pt-opend.p.
   if termtype <> "" then do:
       RUN entryon.
       DEF VAR rescode AS INT INITIAL 1. /* status */
       CASE fromfile:
          WHEN 1 THEN DO:
              INPUT THROUGH crtmain protermcap '""' value(termtype) NO-ECHO.
                 SET rescode WITH FRAME res.
              INPUT CLOSE.
          END.
          WHEN 2 THEN DO:
              INPUT THROUGH crtmain other value(termfile) value(termtype)
                      NO-ECHO.
                 SET rescode WITH FRAME res.
              INPUT CLOSE.
          END.
       END CASE.
       IF rescode <> 0 THEN DO: /* crtmain returned error */
           VIEW FRAME FRAME-A.
           MESSAGE "crtmain failed. Open aborted" VIEW-AS ALERT-BOX ERROR
               BUTTONS OK.
           RUN entryoff.
           RUN clearmem.
           VIEW FRAME FRAME-A.
           RETURN NO-APPLY. /* bail out */
       END.
       if fromfile = 2 then termfile = termtype + ".out".
       run readentry.
       run pt-menu.p.
   end.
   else message "No entry was opened." view-as alert-box information buttons
       ok.
   view frame frame-a.
END.

DISPLAY 
    WITH FRAME FRAME-A.
ASSIGN CURRENT-WINDOW:MENUBAR = MENU menubar-window-1:HANDLE.
run entryoff.
WAIT-FOR choose of MENU-ITEM m_exit.

/* INTERNAL PROCEDURES */
PROCEDURE readentry.
    def var termorig like termfile.
    def var titleorig like titleline.
    def var tctimes as int.
    assign termorig = termfile. /* save off old termfile */
    tctimes = 0.
    repeat:
      run pt-read.p.
      tctimes = tctimes + 1.
      if tctimes = 1 then titleorig = titleline.
      find first tcap where code = "tc" no-error.
      if available (tcap) then do:   /* need to read another file */
         if t-escseq = "v7kf" then assign defaultkb = true.
         message "A 'tc' entry was read that points to an entry for"
             t-escseq skip "This file will now be read in." view-as 
             alert-box information buttons ok.
           TERMFILE = t-escseq + ".out". /* filename to read in */
           /* create the entry on disk to read in */
           def var rescode as int INITIAL 1. /* status of crtmain 0/1 */
           IF SELF:LABEL = "&New" THEN DO:   /* Got here from 'New' */
             CASE NEWFROM:
             WHEN 1 THEN DO:
               INPUT THROUGH crtmain termcap '""' value(t-escseq) NO-ECHO.
                   SET RESCODE WITH FRAME res.
               INPUT CLOSE.
             END.
             WHEN 2 THEN DO:
               INPUT THROUGH crtmain terminfo '""' value(t-escseq) NO-ECHO.
                   SET RESCODE WITH FRAME res.
               INPUT CLOSE.
             END.
             WHEN 3 THEN DO:
               INPUT THROUGH crtmain protermcap '""' value(t-escseq) NO-ECHO.
                   SET RESCODE WITH FRAME res.
               INPUT CLOSE.
             END.
             END CASE.
           END. /* IF SELF:LABEL */
           ELSE DO:   /* Got here from Open */
             CASE FROMFILE:
             WHEN 1 THEN DO:
               INPUT THROUGH crtmain protermcap '""' value(t-escseq) NO-ECHO.
                   SET RESCODE WITH FRAME res.
               INPUT CLOSE.
             END.
             WHEN 2 THEN DO:
               INPUT THROUGH crtmain other value(termorig) value(t-escseq)
                        NO-ECHO.
                   SET RESCODE WITH FRAME res.
               INPUT CLOSE.
             END.
             END CASE.
           END.
           if RESCODE <> 0 then do:
                  view frame frame-a.
                  message "An error occurred in crtmain!"    chr(10)
                          "Creation was terminated."                 chr(10)
                          "What was read in is not complete"
                          view-as alert-box error buttons ok.
                  return.
           end.
      end. /* if available */
      else do:
          if termorig <> "" then termfile = termorig.
          if titleorig <> "" then titleline = titleorig.
          leave.
      end.
    end. /* repeat */ 
END.

PROCEDURE clearmem.
/* clear out everything */
    for each TCAP: delete TCAP. END.
    for each KBIND: delete KBIND. END.
    for each COLORS: delete COLORS. END.
    assign termtype = ""
    titleline = ""
    newstat = 1
    newfrom = 1
    ESCVAL = "\E"
    termfile = ""
    termout = ""
    fromfile = 1.
END.

PROCEDURE entryoff.
    CLEAR FRAME o NO-PAUSE.
    HIDE FRAME o NO-PAUSE.
    DISPLAY "No Entry " AT 37 WITH FRAME o OVERLAY ROW 21 NO-BOX.
END.

PROCEDURE entryon.
    CLEAR FRAME o NO-PAUSE.
    HIDE FRAME o NO-PAUSE.
    DISPLAY termtype at 37 NO-LABEL WITH FRAME o OVERLAY ROW 21 NO-BOX.
END.

/* pt-main.p - end of file */
