/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/* Program Name: PT-NEWD.P
 * Author      : Gerry Seidl
 * Written on  : January 15, 1993
 * Description : New term entry dialog box
 */
{proterm/pt-share.i} /* GLOBAL DEFS */
/* Define a dialog box              */

/* Definitions of the field level widgets                                   */
DEFINE BUTTON BUTTON-2
     LABEL "&Cancel"
     SIZE-CHAR 10 BY 1 .

DEFINE BUTTON BUTTON-1
     LABEL "&OK"
     SIZE-CHAR 10 BY 1 .

/* Definitions of the frame widgets */
FORM
     NEWSTAT  AT ROW 2 COL 15 NO-LABELS
     ALTTERMTYPE AT ROW 5 COL 4
     "From: " AT ROW 5 COL 26
     NEWFROM  AT ROW 5 COL 33 NO-LABELS
     BUTTON-1 AT ROW 9 COL 12
     BUTTON-2 AT ROW 9 COL 29
        WITH VIEW-AS DIALOG-BOX SIDE-LABELS SIZE-CHAR 56 BY 12 
        TITLE "Create New Protermcap Entry for " + termtype
        FRAME DIALOG-1.

ON CHOOSE OF BUTTON-1 DO:
   do with frame dialog-1.
     assign alttermtype = input alttermtype:screen-value in frame dialog-1.
     assign newstat  = int(input newstat:screen-value in frame dialog-1).
     assign newfrom  = int(input newfrom:screen-value in frame dialog-1).
     RETURN. 
   end.
END.

ON CHOOSE OF BUTTON-2 DO: 
 assign termtype = "".
 RETURN.
END.

ON VALUE-CHANGED OF NEWSTAT IN FRAME DIALOG-1 DO:
  do with frame dialog-1:
    def var x as int.
    assign newstat = int(input newstat:screen-value in frame dialog-1).
    if newstat = 2 then do:
       enable alttermtype newfrom with frame dialog-1.
       apply "entry" to alttermtype in frame dialog-1.
       assign newstat:tab-position = 1 
              alttermtype:tab-position = 2
              newfrom:tab-position = 3
              button-1:tab-position = 4
              button-2:tab-position = 5.
    end.
    else do:
       disable alttermtype newfrom with frame dialog-1.
       assign newstat:tab-position = 1 
              button-1:tab-position = 2
              button-2:tab-position = 3.
       alttermtype = "".
    end.
  end.
END.

enable newstat button-1 button-2 with frame dialog-1.
wait-for choose of button-1, button-2 in frame dialog-1.

/* pt-newd.p - end of file */
