/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/* Program Name: PT-OPEND.P
 * Author      : Gerry Seidl
 * Written on  : January 15, 1993
 * Description : Open term entry dialog box
 */

{proterm/pt-share.i} /* GLOBAL DEFS */

/* Definitions of the field level widgets                                  */
DEFINE BUTTON BUTTON-1
     LABEL "&OK"
     SIZE-CHAR 10 BY 1 .

DEFINE BUTTON BUTTON-2
     LABEL "&Cancel"
     SIZE-CHAR 10 BY 1 .

/* Definitions of the frame widgets                                              */
DEFINE FRAME DIALOG-1
     TERMTYPE AT ROW 2 COL 8
          LABEL "Term-type"  FORMAT "X(8)" 
     "from:" VIEW-AS TEXT
           AT ROW 4 COL 10
      FROMFILE AT ROW 4 COL 16 
      BUTTON-1 AT ROW 7 COL 10
      BUTTON-2 AT ROW 7 COL 28
      WITH VIEW-AS DIALOG-BOX SIDE-LABELS SIZE-CHAR 50 BY 9 
      TITLE "Open a Protermcap Entry".

ON CHOOSE OF BUTTON-1 DO:
   IF TERMTYPE:SCREEN-VALUE IN FRAME DIALOG-1 = "" then do:
      message "You must enter a terminal type" view-as alert-box
         error buttons ok.
      apply "entry" to termtype in frame dialog-1.
      return no-apply.
   end.
   else do:
      assign TERMTYPE = TERMTYPE:screen-value in frame dialog-1.
      HIDE FRAME DIALOG-1 NO-PAUSE.
        DO WITH FRAME DIALOG-1:
           ASSIGN FROMFILE = INT(INPUT FROMFILE:SCREEN-VALUE IN
           FRAME DIALOG-1).
           TERMFILE = termtype + ".out".
           IF FROMFILE = 2 THEN /* 'other' file */
           DO:
              /* System Dialog for Diskfile names from ADE Editor */
              DEFINE VAR getfname  AS CHAR           FORMAT "X(65)" NO-UNDO.
              DEFINE VAR getf_stat AS LOGICAL.
              RUN adeedit/dlggetf.p
                 (INPUT " Open an alternative file ",
                 INPUT NO,
                 INPUT 5,
                 INPUT-OUTPUT getfname,
                 OUTPUT getf_stat).
              if getf_stat = YES then assign TERMFILE = getfname.
              else do:
                 assign TERMFILE = "".
                 assign TERMTYPE = "".
                 return.
              end.
           END.
        END.
        RETURN.
   end.
END.

ON CHOOSE OF BUTTON-2 DO:
    assign TERMTYPE = "".
    RETURN.
END.

DISPLAY TERMTYPE FROMFILE no-label BUTTON-1 BUTTON-2
   with frame dialog-1.
ENABLE 
       TERMTYPE
       FROMFILE no-label
       BUTTON-1
       BUTTON-2 WITH FRAME DIALOG-1 .
wait-for choose of button-1, button-2 in frame dialog-1.

/* pt-opend.p - end of file */
