/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/* Program Name: PT-SHARE.I
 * Author      : Gerry Seidl
 * Written on  : January 15, 1993
 * Description : Defines shared information for the application
 */

/* Shared Temp-Tables for Protermcap Builder */
DEFINE {1} SHARED TEMP-TABLE TCAP
    FIELD CODE		       AS CHARACTER FORMAT "X(2)" CASE-SENSITIVE
    FIELD T-ESCSEQ AS CHARACTER FORMAT "X(128)"
    INDEX p-tcap   IS PRIMARY code ASC.

DEFINE {1} SHARED TEMP-TABLE KBIND
    FIELD KF		   AS CHARACTER FORMAT "X(20)"
    FIELD KL		   AS CHARACTER FORMAT "X(20)"
    FIELD K-ESCSEQ AS CHARACTER FORMAT "X(50)"
    INDEX p-kbind  IS PRIMARY KF KL
    INDEX a-kf		       kf ASC
    INDEX a-kl		       kl ASC.

DEFINE {1} SHARED TEMP-TABLE COLORS 
    FIELD CNO		   AS INTEGER	       FORMAT 999
    FIELD BG		   AS CHARACTER FORMAT "X(20)"
    FIELD FG		   AS CHARACTER FORMAT "X(20)"
    FIELD C-ESCSEQ AS CHARACTER FORMAT "X(50)"
    INDEX p-cno    IS PRIMARY cno ASC.
    
/* Shared Variables */
DEFINE {1} SHARED VARIABLE NEWSTAT  AS INTEGER INITIAL 1 VIEW-AS RADIO-SET 
	   RADIO-BUTTONS "Create Manually"	    , 1,
			 "Start with base term" , 2.
DEFINE {1} SHARED VARIABLE NEWFROM  AS INTEGER INITIAL 1 VIEW-AS RADIO-SET
	   RADIO-BUTTONS "Termcap"    , 1 ,
			 "Terminfo"   , 2 ,
			 "Protermcap" , 3.
DEFINE {1} SHARED VARIABLE ESCVAL AS CHARACTER FORMAT "X(8)".
DEFINE {1} SHARED VARIABLE TITLELINE AS CHARACTER FORMAT "X(80)"
     LABEL "Title Line".
DEFINE {1} SHARED VARIABLE TERMFILE AS CHARACTER FORMAT "X(45)" 
     LABEL "File Name"		    NO-UNDO.
DEFINE {1} SHARED VARIABLE TERMOUT AS CHARACTER FORMAT "X(45)" 
     LABEL "File Name"		    NO-UNDO.
DEFINE {1} SHARED VARIABLE TERMTYPE AS CHARACTER FORMAT "X(9)" 
     LABEL "Term-type"		    NO-UNDO.
DEFINE {1} SHARED VARIABLE ALTTERMTYPE AS CHARACTER FORMAT "X(9)" 
     LABEL "Term-type"		    NO-UNDO.
DEFINE {1} SHARED VARIABLE FROMFILE AS INT INITIAL 1 VIEW-AS RADIO-SET
    RADIO-BUTTONS "Protermcap" , 1 ,
		  "Other"      , 2.
DEFINE {1} SHARED VARIABLE DEFAULTKB AS LOGICAL INITIAL FALSE. 

/* pt-share.i - end of file */
