/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/* Program Name: PT-TCAP.P
 * Author      : Gerry Seidl
 * Written on  : January 15, 1993
 * Description : Modify Terminal Capabilities
 */

{proterm/pt-share.i}

/* Definitions of the field level widgets                                  */
DEFINE BUTTON can-but
     LABEL "&Main Menu"
     SIZE-CHAR 12 BY 1 .

DEFINE BUTTON rev-but
     LABEL "&Revert"
     SIZE-CHAR 10 BY 1 .

DEFINE BUTTON save-but
     LABEL "&Save"
     SIZE-CHAR 10 BY 1 .
     
DEFINE VARIABLE escseq AS CHARACTER FORMAT "X(128)" 
     LABEL "Esc Seq" view-as editor inner-chars 32 inner-lines 4 NO-UNDO.
DEFINE VARIABLE old-seq LIKE escseq.

DEFINE NEW SHARED VAR s_UIB_TblList  AS CHAR                           NO-UNDO.
DEFINE NEW SHARED VAR s_UIB_FldList  AS CHAR                           NO-UNDO.
DEFINE NEW SHARED VAR s_UIB_OrdList  AS CHAR                           NO-UNDO.
DEFINE NEW SHARED VAR s_UIB_JoinTo   AS INTEGER  EXTENT 20 NO-UNDO.
DEFINE NEW SHARED VAR s_UIB_JoinCode AS CHAR                 EXTENT 20 NO-UNDO.
DEFINE NEW SHARED VAR s_UIB_Where    AS CHAR                 EXTENT 20 NO-UNDO.
DEFINE NEW SHARED VAR s_UIB_Query    AS CHAR                           NO-UNDO.
DEFINE NEW SHARED VAR s_UIB_Browse   AS CHAR                           NO-UNDO.
DEFINE NEW SHARED BUFFER Term_Function FOR Term_Function.
DEFINE NEW SHARED QUERY BROWSER-1 FOR Term_Function SCROLLING.

DEFINE BROWSE BROWSER-1 QUERY BROWSER-1 DISPLAY Term_Fcn WITH 8 DOWN
      TITLE "Term. Function" NO-LABELS.

/* Definitions of the frame widgets                                              */
DEFINE FRAME TCAP
     BROWSER-1 AT ROW 1 COL 2 
     Term_Function.Description AT ROW 2 COL 25 view-as text no-label
     escseq AT ROW 4 COL 25
     save-but AT ROW 9 COL 28
     rev-but AT ROW 9 COL 40
     can-but AT ROW 9 COL 52
     WITH 1 DOWN OVERLAY SIDE-LABELS
        AT COL 1 ROW 4
        SIZE-CHAR 77 BY 12
        TITLE "Terminal Capabilities for " + termtype.
        
ON CHOOSE OF CAN-BUT DO: /* RETURN TO MAIN MENU */
   HIDE FRAME tcap.
   RETURN.
END.

ON CHOOSE OF REV-BUT DO: /* RESTORE ORIGINAL VALUE */
   ASSIGN ESCSEQ = OLD-SEQ.
   DISPLAY ESCSEQ WITH FRAME TCAP.
END.

ON ENTRY OF ESCSEQ IN FRAME TCAP DO: /* Store off for REVERT */
   ASSIGN OLD-SEQ = ESCSEQ:SCREEN-VALUE IN FRAME TCAP. 
END.

ON CHOOSE OF SAVE-BUT DO: /* SAVE NEW VALUE IN TCAP TEMP-TABLE */
    IF INDEX(ESCSEQ:SCREEN-VALUE IN FRAME TCAP,":") <> 0 THEN DO:
        MESSAGE "Colons are not valid in a Terminal Capability definition"
           view-as alert-box error buttons ok.
        RETURN NO-APPLY.
    END. 
    FIND FIRST TCAP EXCLUSIVE-LOCK WHERE CODE = TERM_FUNCTION.TERM_FCN 
        NO-ERROR.
    IF AVAILABLE (TCAP) THEN DO:
        ASSIGN TCAP.T-ESCSEQ = ESCSEQ:SCREEN-VALUE IN FRAME TCAP.
    END.
    ELSE DO:
        CREATE TCAP.
        ASSIGN TCAP.CODE = TERM_FUNCTION.TERM_FCN
               TCAP.T-ESCSEQ = ESCSEQ:SCREEN-VALUE IN FRAME TCAP.
    END.
    RELEASE TCAP.
END.

ON ITERATION-CHANGED OF BROWSE BROWSER-1 DO:
    display term_function.description with frame tcap.
    FIND FIRST TCAP WHERE CODE = TERM_FUNCTION.TERM_FCN NO-ERROR.
    IF AVAILABLE (TCAP) THEN DO:
        ASSIGN ESCSEQ = TCAP.T-ESCSEQ.
        DISPLAY ESCSEQ WITH FRAME TCAP.
    END.
    ELSE DO:
        ASSIGN ESCSEQ = "".
        DISPLAY ESCSEQ WITH FRAME TCAP.
    END.
END.

ON ANY-KEY OF BROWSE BROWSER-1 DO:
    ASSIGN OLD-SEQ = ESCSEQ:SCREEN-VALUE IN FRAME TCAP. 
END.

OPEN QUERY BROWSER-1 FOR EACH Term_Function.
FIND FIRST TERM_FUNCTION NO-LOCK NO-ERROR.
DISPLAY 
     BROWSER-1
     term_function.description when available (TERM_FUNCTION)
     escseq
     save-but
     rev-but
     can-but
     WITH FRAME TCAP.
ENABLE ALL except term_function.description WITH FRAME TCAP.

/* Define temporary widget handle for run-time attributes                  */
DEFINE VARIABLE tmp_handle AS WIDGET-HANDLE NO-UNDO.

ASSIGN tmp_handle = escseq:HANDLE IN FRAME TCAP
       tmp_handle:WIDTH-CHARS              = 30.

WAIT-FOR CHOOSE OF CAN-BUT FOCUS BROWSE BROWSER-1.
HIDE FRAME tcap.

/* pt-tcap.p - end of file */
