/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/*********************************************************************
  Program Name: PT-TITLE.P
  Author      : Gerry Seidl
  Written on  : January 15, 1993
  Description : Modify term type and titleline dialog box
*********************************************************************/

{proterm/pt-share.i}
define button save-but label "&Save" size 10 by 1.
define button can-but label "&Cancel" size 10 by 1.

form skip(1) termtype at 4 skip(1)
     titleline format "X(50)" at 4 skip(1)
     save-but at 20 can-but at 36 skip(1) 
     with frame d side-labels view-as dialog-box title
         "Enter Terminal Type and Title Line".

ON CHOOSE OF SAVE-BUT DO:
    assign termtype = termtype:screen-value in frame d.
    assign titleline = titleline:screen-value in frame d.
    if termtype = "" or titleline = "" then do:
         message "Neither field can be blank" view-as alert-box error
             buttons ok.
         return no-apply.
    end.
    else RETURN.
END.

ON CHOOSE OF CAN-BUT DO:
   assign termtype = ""
          titleline = "".
   return.
END.

ON LEAVE OF TERMTYPE DO:
   assign termtype = termtype:screen-value in frame d.
   if termtype <> "" then
       if titleline:screen-value in frame d = "" then 
           titleline:screen-value = termtype:screen-value + "|".
END.
/* clear out everything */
for each TCAP: delete TCAP. END.
for each KBIND: delete KBIND. END.
for each COLORS: delete COLORS. END.
assign termtype = ""
       titleline = ""
       newstat = 1
       newfrom = 1
       ESCVAL = "\E"
       termfile = ""
       termout = ""
       fromfile = 1.

enable all with frame d.
wait-for choose of save-but, can-but in frame d.

/* pt-title.p - end of file */
