 

 /*------------------------------------------------------------------------

    File        : HTMLExample

    Purpose     : 

    Syntax      : 

    Description : 

    Author(s)   : mferrant

    Created     : Wed Jun 25 11:59:43 EDT 2008

    Notes       : 

  ----------------------------------------------------------------------*/



USING Progress.Lang.*.



USING System.IO.*.

USING System.Collections.*.

USING System.Collections.Specialized.HybridDictionary.



CLASS Documents.HTMLExample   : 



    DEFINE PRIVATE STATIC VARIABLE symbols AS CLASS HybridDictionary NO-UNDO.

    DEFINE PRIVATE STATIC VARIABLE fontSizes AS INTEGER EXTENT 8 INITIAL [6,8,10,12,14,18,24,36].



    DEFINE PRIVATE VARIABLE brushHash    AS CLASS HybridDictionary NO-UNDO.

    DEFINE PRIVATE VARIABLE fontHash     AS CLASS HybridDictionary NO-UNDO.

    DEFINE PRIVATE VARIABLE styleHash    AS CLASS HybridDictionary NO-UNDO.

    DEFINE PRIVATE VARIABLE baseFontSize AS INTEGER                NO-UNDO.



	/*------------------------------------------------------------------------------

			Purpose:

			Notes:

	------------------------------------------------------------------------------*/

	CONSTRUCTOR STATIC HTMLExample (  ):

		symbols = NEW HybridDictionary().

		symbols:ADD("b", 1).

		symbols:Add("i", 2).

		symbols:Add("u", 3).

		symbols:Add("font", 4).

		symbols:Add("a", 5).

		symbols:Add("br", 6).

		symbols:Add("p", 7).

		symbols:Add("div", 8).

		symbols:Add("img", 9).

		symbols:Add("ul", 10).

		symbols:Add("ol", 11).

		symbols:Add("li", 12).

		

	END CONSTRUCTOR.



    /*------------------------------------------------------------------------------

	 		Purpose: 

			Notes:

	------------------------------------------------------------------------------*/

	CONSTRUCTOR PUBLIC HTMLExample (  ):

		SUPER ().



		brushHash = new HybridDictionary(25).

	    fontHash  = new HybridDictionary(25).

		styleHash = new HybridDictionary(25).

		baseFontSize = 3.

	END CONSTRUCTOR.





    METHOD PUBLIC VOID Load(INPUT container AS Infragistics.Documents.Reports.Report.IContainer, INPUT fileStream AS  FileStream):

	    DEFINE VARIABLE fontName AS CHARACTER NO-UNDO.

	    DEFINE VARIABLE fontSize AS DECIMAL NO-UNDO.

	    DEFINE VARIABLE fontStyle AS Infragistics.Documents.Reports.Graphics.FontStyle NO-UNDO.

	    DEFINE VARIABLE fontColor AS Infragistics.Documents.Reports.Graphics.Color NO-UNDO.

	    DEFINE VARIABLE style     AS Infragistics.Documents.Reports.Report.Text.Style NO-UNDO.

        DEFINE VARIABLE hyperLink AS Infragistics.Documents.Reports.Report.Text.Hyperlink NO-UNDO.

        DEFINE VARIABLE textPattern AS Infragistics.Documents.Reports.Report.Text.TextPattern NO-UNDO.

        DEFINE VARIABLE docText     AS Infragistics.Documents.Reports.Report.Text.IText NO-UNDO.

        DEFINE VARIABLE listPattern AS Infragistics.Documents.Reports.Report.List.ListPattern NO-UNDO.

        DEFINE VARIABLE list        AS Infragistics.Documents.Reports.Report.List.IList NO-UNDO.

        DEFINE VARIABLE fontStates   AS System.Collections.Stack NO-UNDO.

        DEFINE VARIABLE fontState    AS Infragistics.Documents.Reports.HTML.FontState NO-UNDO.

        DEFINE VARIABLE fontStyles   AS System.Collections.Stack NO-UNDO. 

        DEFINE VARIABLE sr           AS StreamReader NO-UNDO.

        DEFINE VARIABLE reader       AS Infragistics.Documents.Reports.HTML.Reader NO-UNDO.

        DEFINE VARIABLE lgSkip       AS LOGICAL NO-UNDO.

        DEFINE VARIABLE element      AS Infragistics.Documents.Reports.HTML.Element NO-UNDO.

        DEFINE VARIABLE str AS CHARACTER NO-UNDO.

        DEFINE VARIABLE tag AS Infragistics.Documents.Reports.HTML.StartTag NO-UNDO.

        DEFINE VARIABLE newName AS CHARACTER NO-UNDO.

        DEFINE VARIABLE symbol AS INTEGER NO-UNDO.

        DEFINE VARIABLE charSize AS CHARACTER NO-UNDO.

        DEFINE VARIABLE src AS CHARACTER NO-UNDO.

        DEFINE VARIABLE newImage AS Infragistics.Documents.Reports.Graphics.Image NO-UNDO.

        DEFINE VARIABLE newWidth AS DECIMAL NO-UNDO.

        DEFINE VARIABLE newHeight AS DECIMAL NO-UNDO.

        DEFINE VARIABLE alignment AS Infragistics.Documents.Reports.Report.ImageAlignment NO-UNDO.

        DEFINE VARIABLE align AS CHARACTER NO-UNDO.

        DEFINE VARIABLE endTag AS Infragistics.Documents.Reports.HTML.EndTag NO-UNDO.



        fontName = "Arial".

		fontSize = baseFontSize.

        fontStyle = Infragistics.Documents.Reports.Graphics.FontStyle:Regular.

        fontColor = Infragistics.Documents.Reports.Graphics.Colors:Black.



        style = GetStyle(GetFont(fontName, fontSize, fontStyle), GetBrush(fontColor)).



        textPattern = new Infragistics.Documents.Reports.Report.Text.TextPattern().

        textPattern:Margins:All = 5.

        textPattern:Interval = 2.



        listPattern = new Infragistics.Documents.Reports.Report.List.ListPattern().

        listPattern:Margins:All = 5.

        listPattern:Bullets:Style = new Infragistics.Documents.Reports.Report.Text.Style(Infragistics.Documents.Reports.Graphics.Fonts:Arial, Infragistics.Documents.Reports.Graphics.Brushes:Red).



        ASSIGN fontStates = NEW System.Collections.Stack()

               fontStyles = NEW System.Collections.Stack() 

               sr         = new StreamReader(fileStream)

               reader     = new Infragistics.Documents.Reports.HTML.Reader(sr).

               lgSkip     = TRUE.



        REPEAT:

            element = reader:Next().



            IF element = ? THEN

            DO:

                sr:Close().

                RETURN.

            END.



            IF Progress.Util.EnumHelper:AreEqual(element:Type,Infragistics.Documents.Reports.HTML.ElementType:Content) THEN

            DO:

                str = CAST(element,Infragistics.Documents.Reports.HTML.Content):TEXT.



                IF NOT System.String:IsNullOrEmpty(str) THEN

                DO:

                    IF docText = ? THEN

                    DO:

                        docText = container:AddText().

                        textPattern:Apply(docText).

                    END.



                    docText:AddContent(str, style, hyperlink).

                    lgSkip = FALSE.

                END.

            END. /*Infragistics.Documents.HTML.ElementType:Content*/



            ELSE IF Progress.Util.EnumHelper:AreEqual(element:Type,Infragistics.Documents.Reports.HTML.ElementType:WhiteSpace) THEN

            DO:

                IF NOT lgSkip THEN

                DO:

                    IF docText = ? THEN

                    DO:

                        docText = container:AddText().

                        textPattern:Apply(docText).

                    END.



                    docText:AddContent(' ', style, hyperlink).

                    lgSkip = TRUE.

                END.

            END. /*Infragistics.Documents.HTML.ElementType.WhiteSpace*/



            ELSE IF Progress.Util.EnumHelper:AreEqual(element:Type,Infragistics.Documents.Reports.HTML.ElementType:StartTag) THEN

            DO:

                tag = CAST(element,Infragistics.Documents.Reports.HTML.StartTag).



                newName = LC(tag:NAME).



                IF symbols:Contains(newName) THEN

                DO:

                    symbol = symbols[newName].



                    CASE symbol:

                        WHEN 1 THEN /*"b"*/

                        DO: 

                            fontStyle = Infragistics.Documents.Reports.Graphics.FontStyle:Bold.

                            style = GetStyle(GetFont(fontName, fontSize, fontStyle), style:Brush).

                        END.



                        WHEN 2 THEN /*"i"*/

                        DO:

                            fontStyle = Infragistics.Documents.Reports.Graphics.FontStyle:Italic.

                            style = GetStyle(GetFont(fontName, fontSize, fontStyle), style:Brush).

                        END.



                        WHEN 3 THEN /*"u"*/ 

                        DO:

                            fontStyle = Infragistics.Documents.Reports.Graphics.FontStyle:Underline.

                            style = GetStyle(GetFont(fontName, fontSize, fontStyle), style:Brush).

                        END.



                        WHEN 4 THEN /*"font"*/

                        DO:

                            fontStates:Push(new Infragistics.Documents.Reports.HTML.FontState(fontName, fontSize, fontColor)).



                            fontName = tag:GetAttribute("face", fontName).

                            fontName = tag:GetAttribute("name", fontName).



                            IF fontName = "" OR fontName = "Symbol" OR fontName = "System" THEN

                                fontName = "Arial".



                            charSize = tag:GetAttribute("size", "").



                            IF NOT System.String:IsNullOrEmpty(charSize) THEN

                            DO:

                                CASE SUBSTRING(charSize,1,1):

                                    WHEN '+' THEN

                                    DO:

                                        IF LENGTH(charSize) > 1 THEN

                                        DO: 

                                            charSize = SUBSTRING(charSize,1, LENGTH(charSize) - 1).

                                            fontSize = baseFontSize + INT(charSize).

                                        END.

                                    END.



                                    WHEN '-' THEN

                                    DO:

                                        IF LENGTH(charSize) > 1 THEN

                                        DO:

                                            charSize = SUBSTRING(charSize, 1, LENGTH(charSize) - 1).

                                            fontSize = baseFontSize - INT(charSize).

                                        END.

                                    END.



                                    OTHERWISE DO:

                                        fontSize = INT(charSize).

                                    END.

                                 END CASE.

                            END. /*IF NOT System.String:IsNullOrEmpty(newize)) THEN*/



                            fontColor = tag:GetAttribute("color", fontColor).

                            style = GetStyle(GetFont(fontName, fontSize, fontStyle), GetBrush(fontColor)).

                       END. /*when 4 */ 



                       WHEN 5 THEN /*"a"*/

                           hyperlink = new Infragistics.Documents.Reports.Report.Text.Hyperlink(tag:GetAttribute("href", "")).



                       WHEN 6 THEN /*"br"*/

                       DO:

                           IF docText = ? THEN

                           DO:

                               docText = container:AddText().

                               textPattern:Apply(docText).

                           END.

                           docText:AddContent("\n", style, hyperlink).

                           lgSkip = TRUE.

                       END.



                       WHEN 7 /*"p"*/ OR

                       WHEN 8 THEN /*"div"*/

                       DO:

                           fontStyles:Push(fontStyle).

                           hyperlink = ?.

                           docText = ?.

                           lgSkip = TRUE.

                       END.



                       WHEN 9 THEN /*"img"*/

                       DO:

                           src = tag:GetAttribute("src", "").

                           newImage = new Infragistics.Documents.Reports.Graphics.Image(src).



                           newWidth = Infragistics.Documents.Reports.Utils.Converter:PixelsToPoints(tag:GetAttribute("width", newImage:Width)).

                           newHeight = Infragistics.Documents.Reports.Utils.Converter:PixelsToPoints(tag:GetAttribute("height", newImage:Height)).

                           alignment = Infragistics.Documents.Reports.Report.ImageAlignment:Bottom.

                           align = tag:GetAttribute("align", "bottom").



                           IF align = "top"    THEN alignment = Infragistics.Documents.Reports.Report.ImageAlignment:TOP.

                           IF align = "middle" THEN alignment = Infragistics.Documents.Reports.Report.ImageAlignment:Middle.

                           IF align = "bottom" THEN alignment = Infragistics.Documents.Reports.Report.ImageAlignment:Bottom.

                           IF align = "left"   THEN alignment = Infragistics.Documents.Reports.Report.ImageAlignment:Left.

                           IF align = "right"  THEN alignment = Infragistics.Documents.Reports.Report.ImageAlignment:Right.



                           newImage:Preferences:Compressor = Infragistics.Documents.Reports.Graphics.ImageCompressors:JPEG.

                           docText:AddContent(newImage, new Infragistics.Documents.Reports.Graphics.Size(newWidth, newHeight), alignment, hyperlink).

                           lgSkip = FALSE.

                       END.



                       WHEN 10 THEN /*"ul"*/

                       DO:

                           list = container:AddList().

                           listPattern:Apply(list).

                           list:Bullets:Type = Infragistics.Documents.Reports.Report.BulletType:BlackCircle.

                           docText = ?.

                           lgSkip = TRUE.

                       END.



                       WHEN 11 THEN /*"ol"*/

                       DO:

                           list = container:AddList().

                           listPattern:Apply(list).

                           list:Bullets:Type = Infragistics.Documents.Reports.Report.BulletType:Decimal.

                           list:Bullets:Template = CHR(123) + "0" + CHR(125) + ".".

                           docText = ?.

                           lgSkip = TRUE.

                       END.



                       WHEN 12 THEN /*"li"*/

                       DO:

                           IF list NE ? THEN

                           DO:

                               docText = list:AddItem():AddText().

                               textPattern:Apply(docText).

                               lgSkip = TRUE.

                           END.

                       END.

                    END CASE.

               END. /*IF symbols:Contains(newName) THEN*/

           END. /*Infragistics.Documents.HTML.ElementType.StartTag*/



           ELSE IF Progress.Util.EnumHelper:AreEqual(element:Type,Infragistics.Documents.Reports.HTML.ElementType:EndTag) THEN

           DO:

               endTag = CAST(element,Infragistics.Documents.Reports.HTML.EndTag).

               newName = LC(tag:Name).



               IF symbols:Contains(newName) THEN

               DO:

                   symbol = symbols[newName].



                   CASE symbol:

                       WHEN 1 THEN /*"b"*/

                       DO:

                           fontStyle = Infragistics.Documents.Reports.Graphics.FontStyle:Bold.

                           style = GetStyle(GetFont(fontName, fontSize, fontStyle), style:Brush).

                       END.



                       WHEN 2 THEN /*"i"*/

                       DO:

                           fontStyle = Infragistics.Documents.Reports.Graphics.FontStyle:Italic.

                           style = GetStyle(GetFont(fontName, fontSize, fontStyle), style:Brush).

                       END.



                       WHEN 3 THEN /*"u"*/

                       DO:

                           fontStyle = Infragistics.Documents.Reports.Graphics.FontStyle:Underline.

                           style = GetStyle(GetFont(fontName, fontSize, fontStyle), style:Brush).

                       END.



                       WHEN 4 THEN /*"font"*/

                       DO:

                            IF fontStates:Count > 0 THEN

                            DO:

                                fontState = CAST(fontStates:Pop(),"Infragistics.Documents.Reports.HTML.FontState").

                                fontName = fontState:Name.

                                fontSize = fontState:Size.

                                fontColor = fontState:Color.



                                style = GetStyle(GetFont(fontName, fontSize, fontStyle), GetBrush(fontColor)).

                            END.

                        END.



                        WHEN 5 THEN /*"a"*/

                        DO:

                            hyperlink = ?.

                        END.



                        WHEN 7 /*"p"*/ OR

                        WHEN 8 THEN /*"div"*/

                        DO:

                            IF fontStyles:Count > 0 THEN

                                fontStyle = CAST(fontStyles:Pop(),"Infragistics.Documents.Reports.Graphics.FontStyle").

                            ELSE

                                fontStyle = Infragistics.Documents.Reports.Graphics.FontStyle:Regular.



                            hyperlink = ?.

                            docText = ?.

                            lgSkip = TRUE.



                        END.



                        WHEN 10 /*"ul"*/ OR

                        WHEN 11 THEN /*"ol"*/

                        DO:

                            list = ?.

                            docText = ?.

                            lgSkip = TRUE.

                        END.

                   END CASE.

               END.

           END.

        END. /*repeat*/

    END METHOD.



    METHOD PUBLIC Infragistics.Documents.Reports.Report.Text.Style GetStyle(INPUT currentFont AS Infragistics.Documents.Reports.Graphics.Font, INPUT brush AS Infragistics.Documents.Reports.Graphics.Brush):

        DEFINE VARIABLE newKey AS Infragistics.Documents.Reports.Report.Text.ShortStyleHashKey NO-UNDO.

        DEFINE VARIABLE style  AS Infragistics.Documents.Reports.Report.Text.Style             NO-UNDO.



        newKey = new Infragistics.Documents.Reports.Report.Text.ShortStyleHashKey(currentFont, brush).

 

        IF styleHash:Contains(newKey) THEN

            RETURN CAST(styleHash:Item[newKey],"Infragistics.Documents.Reports.Report.Text.Style").

        ELSE DO:

            style = new Infragistics.Documents.Reports.Report.Text.Style(currentFont, brush).

            styleHash:Add(newKey, style).

            RETURN style.

        END.

    END METHOD.

    

    METHOD PUBLIC Infragistics.Documents.Reports.Graphics.Brush GetBrush(INPUT newColor AS Infragistics.Documents.Reports.Graphics.Color):

        DEFINE VARIABLE brush AS Infragistics.Documents.Reports.Graphics.SolidColorBrush NO-UNDO.



        IF brushHash:Contains(newColor) THEN

            RETURN CAST(brushHash:Item[newColor],"Infragistics.Documents.Reports.Graphics.Brush").

        ELSE DO:

            brush = new Infragistics.Documents.Reports.Graphics.SolidColorBrush(newColor).

            brushHash:Add(newColor, brush).

            RETURN brush.

        END.

    END METHOD.



    METHOD PUBLIC Infragistics.Documents.Reports.Graphics.Font GetFont(newName AS CHARACTER, newSize AS DECIMAL, style AS Infragistics.Documents.Reports.Graphics.FontStyle):

        DEFINE VARIABLE newKey  AS Infragistics.Documents.Reports.Graphics.FontHashKey NO-UNDO.

        DEFINE VARIABLE newFont AS Infragistics.Documents.Reports.Graphics.Font        NO-UNDO.



        IF newSize < 0 THEN newSize = 0.

        IF newSize > 7 THEN newSize = 7.



        newSize = fontSizes[INT(newSize)].



        newKey = new Infragistics.Documents.Reports.Graphics.FontHashKey(newName, newSize, style).



        IF fontHash:Contains(newKey) THEN

            RETURN CAST(fontHash[newKey],"Infragistics.Documents.Reports.Graphics.Font").

        ELSE DO:

            newFont = new Infragistics.Documents.Reports.Graphics.Font(newName, newSize, style).

            fontHash:Add(newKey, newFont).

            RETURN newFont.

        END.

    END METHOD.

END CLASS.