 

 /*------------------------------------------------------------------------

    File        : RTFExample

    Purpose     : 

    Syntax      : 

    Description : 

    Author(s)   : mferrant

    Created     : Tue Jul 01 10:33:15 EDT 2008

    Notes       : 

  ----------------------------------------------------------------------*/



USING Progress.Lang.*.

USING Infragistics.Documents.Reports.RTF.ICallback.



USING System.IO.*.



USING Infragistics.Documents.Reports.RTF.*.

USING Infragistics.Documents.Reports.Report.Text.*.

USING System.Collections.Specialized.HybridDictionary.



CLASS Documents.RTFExample IMPLEMENTS ICallback  : 

    DEFINE PRIVATE VARIABLE reader      AS Infragistics.Documents.Reports.RTF.Reader              NO-UNDO.

	DEFINE PRIVATE VARIABLE container   AS Infragistics.Documents.Reports.Report.IContainer       NO-UNDO.

	DEFINE PRIVATE VARIABLE docText     AS Infragistics.Documents.Reports.Report.Text.IText       NO-UNDO.

	DEFINE PRIVATE VARIABLE textPattern AS Infragistics.Documents.Reports.Report.Text.TextPattern NO-UNDO.

	DEFINE PRIVATE VARIABLE style       AS Infragistics.Documents.Reports.Report.Text.Style       NO-UNDO.

	DEFINE PRIVATE VARIABLE brushHash   AS HybridDictionary                               NO-UNDO.

    DEFINE PRIVATE VARIABLE fontHash    AS HybridDictionary                               NO-UNDO.

    DEFINE PRIVATE VARIABLE styleHash   AS HybridDictionary                               NO-UNDO.



    CONSTRUCTOR PUBLIC RTFExample():

        brushHash = new HybridDictionary(25).

	    fontHash  = new HybridDictionary(25).

		styleHash = new HybridDictionary(25).

		textPattern = new TextPattern().

		textPattern:Margins:All = 5.

		textPattern:Interval = 2.

    END CONSTRUCTOR.



    METHOD PUBLIC VOID Load(INPUT container AS Infragistics.Documents.Reports.Report.IContainer, INPUT fileStream AS  FileStream):

        THIS-OBJECT:container = container.

        reader = new Infragistics.Documents.Reports.RTF.Reader(fileStream, THIS-OBJECT).

        reader:Read().

    END METHOD.



    METHOD PUBLIC VOID OnStart():

    END METHOD.



    METHOD PUBLIC VOID OnEnd():

    END METHOD.

    

    METHOD PUBLIC VOID OnInfo(INPUT newInfo AS Infragistics.Documents.Reports.RTF.Info):

    END METHOD.



    METHOD PUBLIC VOID OnKeyword(INPUT newKeyword AS Infragistics.Documents.Reports.RTF.Keyword):

        IF newKeyword:Symbol = Infragistics.Documents.Reports.RTF.Defs.Symbols:PAR  OR

           newKeyword:Symbol = Infragistics.Documents.Reports.RTF.Defs.Symbols:CELL OR

           newKeyword:Symbol = Infragistics.Documents.Reports.RTF.Defs.Symbols:SECT THEN

            IF docText NE ? THEN docText = ?.

    END METHOD.



    METHOD PUBLIC VOID OnChar (INPUT ch AS SINGLE-CHARACTER):

        IF docText = ? THEN

        DO:

            docText = container:AddText().

            textPattern:Apply(docText).



            UpdateParagraph().

        END.



        CheckState().



        docText:AddContent(ch, style).

    END METHOD.



    METHOD PUBLIC VOID OnImage(INPUT newImage AS Infragistics.Documents.Reports.Graphics.Image, newWidth AS INTEGER, newHeight AS INTEGER):

        CheckState().

        newImage:Preferences:Compressor = Infragistics.Documents.Reports.Graphics.ImageCompressors:JPEG.

        docText:AddContent(newImage, new Infragistics.Documents.Reports.Graphics.Size(Infragistics.Documents.Reports.Utils.Converter:TwipsToPoints(newWidth), Infragistics.Documents.Reports.Utils.Converter:TwipsToPoints(newHeight))).

    END METHOD.



    METHOD PRIVATE VOID CheckState():

        IF reader:State:Changed THEN

        DO:

            UpdateDocument().

            UpdateSection().

            UpdateParagraph().

            UpdateCharacter().



            reader:State:Changed = FALSE.

        END.

        ELSE DO:

            IF reader:State:Document:Changed  THEN UpdateDocument().

            IF reader:State:Section:Changed   THEN UpdateSection().

            IF reader:State:Paragraph:Changed THEN UpdateParagraph().

            IF reader:State:Character:Changed THEN UpdateCharacter().

        END.

    END METHOD.



    METHOD PRIVATE VOID UpdateDocument():

        DEFINE VARIABLE document AS Infragistics.Documents.Reports.RTF.Document NO-UNDO.

        document = reader:State:Document.

        document:Changed = FALSE.

    END METHOD.



    METHOD PRIVATE VOID UpdateSection():

        DEFINE VARIABLE localSection AS Infragistics.Documents.Reports.RTF.Section NO-UNDO.

        localSection = reader:State:Section.

        localSection:Changed = FALSE.

    END METHOD.



    METHOD PRIVATE VOID UpdateParagraph():

        DEFINE VARIABLE paragraph AS Infragistics.Documents.Reports.RTF.Paragraph NO-UNDO.



        paragraph = reader:State:Paragraph.



        IF docText NE ? THEN

        DO:

            docText:Alignment = Infragistics.Documents.Reports.Report.TextAlignment:Left.



            IF Progress.Util.EnumHelper:AreEqual(paragraph:Alignment,ParagraphAlignment:LeftAligned) THEN

                docText:Alignment = Infragistics.Documents.Reports.Report.TextAlignment:Left.



            ELSE IF Progress.Util.EnumHelper:AreEqual(paragraph:Alignment,ParagraphAlignment:RightAligned) THEN

                docText:Alignment = Infragistics.Documents.Reports.Report.TextAlignment:RIGHT.



            ELSE IF Progress.Util.EnumHelper:AreEqual(paragraph:Alignment,ParagraphAlignment:Centered) THEN

                docText:Alignment = Infragistics.Documents.Reports.Report.TextAlignment:CENTER.



            ELSE IF Progress.Util.EnumHelper:AreEqual(paragraph:Alignment,ParagraphAlignment:Justified) THEN

                docText:Alignment = Infragistics.Documents.Reports.Report.TextAlignment:Justify.



            ELSE IF Progress.Util.EnumHelper:AreEqual(paragraph:Alignment,ParagraphAlignment:Distributed) THEN

                docText:Alignment = Infragistics.Documents.Reports.Report.TextAlignment:Justify.



            docText:Indents:First = Infragistics.Documents.Reports.Utils.Converter:TwipsToPoints(paragraph:FirstIndent).

            docText:Indents:Left  = Infragistics.Documents.Reports.Utils.Converter:TwipsToPoints(paragraph:LeftIndent).

            docText:Indents:Right = Infragistics.Documents.Reports.Utils.Converter:TwipsToPoints(paragraph:RightIndent).



            IF docText:Indents:First < 0 THEN docText:Indents:First = 0.

            IF docText:Indents:Left < 0  THEN docText:Indents:Left = 0.

            IF docText:Indents:Right < 0 THEN docText:Indents:Right = 0.

        END.



        paragraph:Changed = FALSE.

    END METHOD.



    METHOD PRIVATE VOID UpdateCharacter():

        DEFINE VARIABLE newCharacter AS Infragistics.Documents.Reports.RTF.Character NO-UNDO.

        DEFINE VARIABLE fontStyle    AS Infragistics.Documents.Reports.Graphics.FontStyle  NO-UNDO.



        newCharacter = reader:State:Character.



        fontStyle = Infragistics.Documents.Reports.Graphics.FontStyle:Regular.

        IF newCharacter:Bold      THEN fontStyle = Infragistics.Documents.Reports.Graphics.FontStyle:Bold.

        IF newCharacter:Italic    THEN fontStyle = Infragistics.Documents.Reports.Graphics.FontStyle:Italic.

        IF newCharacter:UNDERLINE THEN fontStyle = Infragistics.Documents.Reports.Graphics.FontStyle:Underline.



        style = GetStyle(GetFont(newCharacter:FontIndex, newCharacter:FontSize / 2, fontStyle), GetBrush(newCharacter:ColorIndex)).



        newCHARACTER:Changed = FALSE.

    END METHOD.



    METHOD PUBLIC Infragistics.Documents.Reports.Report.Text.Style GetStyle(newFont AS Infragistics.Documents.Reports.Graphics.Font, brush AS Infragistics.Documents.Reports.Graphics.Brush):

        DEFINE VARIABLE newKey AS Infragistics.Documents.Reports.Report.Text.ShortStyleHashKey NO-UNDO.

        DEFINE VARIABLE newStyle  AS Infragistics.Documents.Reports.Report.Text.Style NO-UNDO.



        newKey = new Infragistics.Documents.Reports.Report.Text.ShortStyleHashKey(newFont, brush).



        IF styleHash:Contains(newKey) THEN

            RETURN CAST(styleHash[newKey], "Infragistics.Documents.Reports.Report.Text.Style").

        ELSE DO:

            newStyle = new Infragistics.Documents.Reports.Report.Text.Style(newFont, brush).

            styleHash:Add(newKey, newStyle).

            RETURN newStyle.

        END.

    END METHOD.



    METHOD PRIVATE Infragistics.Documents.Reports.Graphics.Brush GetBrush(indx AS INTEGER):

        DEFINE VARIABLE newColor AS Infragistics.Documents.Reports.RTF.Color NO-UNDO.

        DEFINE VARIABLE newBrush AS Infragistics.Documents.Reports.Graphics.Brush NO-UNDO.

        IF indx = - 1 THEN indx = reader:DefaultColorIndex.



        RETURN Infragistics.Documents.Reports.Graphics.Brushes:Black.

    END.



    METHOD PRIVATE Infragistics.Documents.Reports.Graphics.Font GetFont(indx AS INTEGER, newSize AS DECIMAL , newStyle AS Infragistics.Documents.Reports.Graphics.FontStyle):

        DEFINE VARIABLE newName AS CHARACTER NO-UNDO.

        DEFINE VARIABLE newKey AS Infragistics.Documents.Reports.Graphics.FontHashKey NO-UNDO.

        DEFINE VARIABLE newFont AS Infragistics.Documents.Reports.Graphics.Font NO-UNDO.

        IF indx = - 1 THEN indx = reader:DefaultFontIndex.



        newName = ?.

        IF System.String:IsNullOrEmpty(newName) OR  newName = "Symbol" OR newName = "System" THEN newName = "Arial".



        IF newSize <= 0 THEN newSize = 12.



        newKey = new Infragistics.Documents.Reports.Graphics.FontHashKey(newName, newSize, newStyle).



        IF fontHash:Contains(newKey) THEN

            RETURN CAST(fontHash[newKey],"Infragistics.Documents.Reports.Graphics.Font").

        ELSE DO:

           newFont = new Infragistics.Documents.Reports.Graphics.Font(newName, newSize, newStyle).

           fontHash:Add(newKey, newFont).

           RETURN newFont.

        END.

    END METHOD.

END CLASS.