 

 /*------------------------------------------------------------------------

    File        : ThumbnailsExample

    Purpose     : 

    Syntax      : 

    Description : 

    Author(s)   : mferrant

    Created     : Mon Jun 30 15:13:42 EDT 2008

    Notes       : 

  ----------------------------------------------------------------------*/



USING Progress.Lang.*.



USING System.Drawing.*.

USING System.Drawing.Imaging.*.

USING System.Drawing.Graphics.*.

USING Infragistics.Documents.Reports.Utils.*.

USING Infragistics.Documents.Reports.Utils.Converter.*.

USING Infragistics.Documents.Reports.Report.Projection.*.

USING Infragistics.Documents.Reports.Graphics.*.





CLASS Documents.ThumbnailsExample   :  

    METHOD PUBLIC STATIC VOID SavePNG(currentPage AS IProjectionPage, scale AS DECIMAL, pageNumber AS INTEGER):

        DEFINE VARIABLE imgWidth  AS INTEGER NO-UNDO.

        DEFINE VARIABLE imgHeight AS INTEGER NO-UNDO.

        DEFINE VARIABLE bmp       AS System.Drawing.Bitmap NO-UNDO.

        DEFINE VARIABLE g         AS System.Drawing.Graphics NO-UNDO.

        DEFINE VARIABLE graphics  AS Infragistics.Documents.Reports.Graphics.Graphics NO-UNDO.

        DEFINE VARIABLE FILENAME  AS CHARACTER NO-UNDO.



        ASSIGN imgWidth  = Converter:PointsToPixels(INT(currentPage:Width) * scale)

               imgHeight = Converter:PointsToPixels(currentPage:Height * scale)

               bmp       = new Bitmap(imgWidth, imgHeight, PixelFormat:Format24bppRgb)

               g         = System.Drawing.Graphics:FromImage(bmp).



            graphics = new Infragistics.Documents.Reports.Graphics.Graphics(g).

            graphics:Scale(scale, scale).

            currentPage:Draw(graphics).

            graphics:Flush().



            fileName = "image" + STRING(pageNumber) + ".png".

            bmp:Save(fileName, ImageFormat:Png).



            g:Dispose().

            bmp:Dispose().

    END METHOD.



    METHOD PUBLIC STATIC VOID SaveEMF(currentPage AS IProjectionPage, scale AS DECIMAL, pageNumber AS INTEGER):

        DEFINE VARIABLE imgWidth  AS INTEGER NO-UNDO.

        DEFINE VARIABLE imgHeight AS INTEGER NO-UNDO.

        DEFINE VARIABLE ms AS System.IO.MemoryStream NO-UNDO.

        DEFINE VARIABLE bmp       AS System.Drawing.Bitmap NO-UNDO.

        DEFINE VARIABLE g         AS System.Drawing.Graphics NO-UNDO.

        DEFINE VARIABLE hdc       AS System.IntPtr           NO-UNDO. 

        DEFINE VARIABLE metafile  AS System.Drawing.Imaging.Metafile NO-UNDO.

        DEFINE VARIABLE gm        AS System.Drawing.Graphics NO-UNDO.

        DEFINE VARIABLE graphics  AS Infragistics.Documents.Reports.Graphics.Graphics NO-UNDO.

        DEFINE VARIABLE fileName AS CHARACTER NO-UNDO.

        DEFINE VARIABLE fs        AS System.IO.FileStream NO-UNDO.

        

       ASSIGN imgWidth  = Converter:PointsToPixels(currentPage:Width * scale)

              imgHeight = Converter:PointsToPixels(currentPage:Height * scale)

              ms        = new System.IO.MemoryStream().



       bmp = new Bitmap(1, 1, PixelFormat:Format24bppRgb).

       g = System.Drawing.Graphics:FromImage(bmp).

       hdc = g:GetHdc().

       metafile = new Metafile(ms, hdc, new System.Drawing.Rectangle(0, 0, imgWidth, imgHeight), MetafileFrameUnit:Pixel, EmfType:EmfPlusDual).

       g:ReleaseHdc(hdc).

       g:Dispose().

       bmp:Dispose().



       gm = System.Drawing.Graphics:FromImage(metafile).



       graphics = new Infragistics.Documents.Reports.Graphics.Graphics(gm).

       graphics:Scale(scale, scale).

       currentPage:Draw(graphics).

       graphics:Flush().



       gm:Dispose().

       metafile:Dispose().



       fileName = "image" + STRING(pageNumber) + ".emf".

       fs = new System.IO.FileStream(fileName, System.IO.FileMode:Create, System.IO.FileAccess:Write).

       fs:Write(ms:ToArray(), 0, INT(ms:Length)).

       fs:Close().

        

    END.



END CLASS.