 
 /*------------------------------------------------------------------------
    File        : DateTimeAxis
    Purpose     : 
    Syntax      : 
    Description : 
    Author(s)   : mferrant
    Created     : Sun Sep 07 11:19:53 EDT 2008
    Notes       : 
  ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING Progress.Windows.Form.

USING Infragistics.UltraChart.Shared.Styles.*.

CLASS WinChart.Axis.DateTimeAxis INHERITS Form   : 
	
	DEFINE PRIVATE VARIABLE components AS System.ComponentModel.IContainer.

	DEFINE PRIVATE VARIABLE label4 AS System.Windows.Forms.Label NO-UNDO.
	DEFINE PRIVATE VARIABLE tickIntervalTypeEditor AS Infragistics.Win.UltraWinEditors.UltraComboEditor NO-UNDO.
	DEFINE PRIVATE VARIABLE tickPercentageEditor AS Infragistics.Win.UltraWinEditors.UltraNumericEditor NO-UNDO.
	DEFINE PRIVATE VARIABLE ultraChart1 AS Infragistics.Win.UltraWinChart.UltraChart NO-UNDO.
	DEFINE PRIVATE VARIABLE label3 AS System.Windows.Forms.Label NO-UNDO.
	DEFINE PRIVATE VARIABLE splitter2 AS System.Windows.Forms.Splitter NO-UNDO.
	DEFINE PRIVATE VARIABLE ultraExpandableGroupBox1 AS Infragistics.Win.Misc.UltraExpandableGroupBox NO-UNDO.
	DEFINE PRIVATE VARIABLE ultraExpandableGroupBoxPanel1 AS Infragistics.Win.Misc.UltraExpandableGroupBoxPanel NO-UNDO.
	DEFINE PRIVATE VARIABLE ultraLabel1 AS Infragistics.Win.Misc.UltraLabel NO-UNDO.
	DEFINE PRIVATE VARIABLE axisBox AS Infragistics.Win.Misc.UltraGroupBox NO-UNDO.
	DEFINE PRIVATE VARIABLE tickIntervalEditor AS Infragistics.Win.UltraWinEditors.UltraNumericEditor NO-UNDO.
	DEFINE PRIVATE VARIABLE label2 AS System.Windows.Forms.Label NO-UNDO.
	DEFINE PRIVATE VARIABLE tickmarkStyleEditor AS Infragistics.Win.UltraWinEditors.UltraComboEditor NO-UNDO.
	DEFINE PRIVATE VARIABLE label1 AS System.Windows.Forms.Label NO-UNDO.
	DEFINE PRIVATE VARIABLE splitter1 AS System.Windows.Forms.Splitter NO-UNDO.

    DEFINE PRIVATE VARIABLE fOrderService AS DataServices.OrdersByDateData NO-UNDO.
    DEFINE PRIVATE VARIABLE OrderDT       AS System.Data.DataTable     NO-UNDO.

	CONSTRUCTOR PUBLIC DateTimeAxis (  ):
		SUPER().
		InitializeComponent().
		InitializeDataSource().
	END CONSTRUCTOR.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID DateTimeAxis_Load( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
   	    /* retrieve the dataset table as a DataTable */
        OrderDT = fOrderService:DataTable().

        ultraChart1:Data:DataSource = OrderDT.
        ultraChart1:Data:SwapRowsAndColumns = TRUE.
        ultraChart1:Data:DataBind().
        ultraChart1:BackgroundImage = System.Drawing.Image:FromFile(SEARCH("WinChart/images/chart_gray_bg.jpg")).

        SetTicksStyle().
	END METHOD.


   	/*------------------------------------------------------------------------------
			Purpose:
			Notes:
	------------------------------------------------------------------------------*/
	METHOD PUBLIC VOID InitializeDataSource():
        fOrderService = NEW DataServices.OrdersByDateData().                  
        fOrderService:fetchData().
	END METHOD.
	
	METHOD PRIVATE VOID InitializeComponent(  ):
		
/*		NOTE: The following method is generated by the OpenEdge Advanced GUI Visual Designer.

		We strongly suggest that the contents of this method only be modified using the
		Visual Designer to avoid any incompatible modifications.

		Modifying the contents of this method using a code editor will invalidate any support for this file.*/

		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE valueListItem1 AS Infragistics.Win.ValueListItem NO-UNDO.
		valueListItem1 = NEW Infragistics.Win.ValueListItem().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE valueListItem2 AS Infragistics.Win.ValueListItem NO-UNDO.
		valueListItem2 = NEW Infragistics.Win.ValueListItem().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE valueListItem3 AS Infragistics.Win.ValueListItem NO-UNDO.
		valueListItem3 = NEW Infragistics.Win.ValueListItem().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE valueListItem4 AS Infragistics.Win.ValueListItem NO-UNDO.
		valueListItem4 = NEW Infragistics.Win.ValueListItem().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE valueListItem5 AS Infragistics.Win.ValueListItem NO-UNDO.
		valueListItem5 = NEW Infragistics.Win.ValueListItem().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE valueListItem6 AS Infragistics.Win.ValueListItem NO-UNDO.
		valueListItem6 = NEW Infragistics.Win.ValueListItem().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE valueListItem7 AS Infragistics.Win.ValueListItem NO-UNDO.
		valueListItem7 = NEW Infragistics.Win.ValueListItem().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE valueListItem8 AS Infragistics.Win.ValueListItem NO-UNDO.
		valueListItem8 = NEW Infragistics.Win.ValueListItem().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE valueListItem9 AS Infragistics.Win.ValueListItem NO-UNDO.
		valueListItem9 = NEW Infragistics.Win.ValueListItem().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE valueListItem10 AS Infragistics.Win.ValueListItem NO-UNDO.
		valueListItem10 = NEW Infragistics.Win.ValueListItem().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE appearance1 AS Infragistics.Win.Appearance NO-UNDO.
		appearance1 = NEW Infragistics.Win.Appearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE paintElement1 AS Infragistics.UltraChart.Resources.Appearance.PaintElement NO-UNDO.
		paintElement1 = NEW Infragistics.UltraChart.Resources.Appearance.PaintElement().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE paintElement2 AS Infragistics.UltraChart.Resources.Appearance.PaintElement NO-UNDO.
		paintElement2 = NEW Infragistics.UltraChart.Resources.Appearance.PaintElement().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE paintElement3 AS Infragistics.UltraChart.Resources.Appearance.PaintElement NO-UNDO.
		paintElement3 = NEW Infragistics.UltraChart.Resources.Appearance.PaintElement().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE paintElement4 AS Infragistics.UltraChart.Resources.Appearance.PaintElement NO-UNDO.
		paintElement4 = NEW Infragistics.UltraChart.Resources.Appearance.PaintElement().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE paintElement5 AS Infragistics.UltraChart.Resources.Appearance.PaintElement NO-UNDO.
		paintElement5 = NEW Infragistics.UltraChart.Resources.Appearance.PaintElement().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE paintElement6 AS Infragistics.UltraChart.Resources.Appearance.PaintElement NO-UNDO.
		paintElement6 = NEW Infragistics.UltraChart.Resources.Appearance.PaintElement().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE gradientEffect1 AS Infragistics.UltraChart.Resources.Appearance.GradientEffect NO-UNDO.
		gradientEffect1 = NEW Infragistics.UltraChart.Resources.Appearance.GradientEffect().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE lineChartAppearance1 AS Infragistics.UltraChart.Resources.Appearance.LineChartAppearance NO-UNDO.
		lineChartAppearance1 = NEW Infragistics.UltraChart.Resources.Appearance.LineChartAppearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE resources AS System.Resources.ResXResourceSet NO-UNDO.
		resources = Progress.Util.ResourceHelper:Load("WinChart\Axis\DateTimeAxis.resx", PROPATH).
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE appearance2 AS Infragistics.Win.Appearance NO-UNDO.
		appearance2 = NEW Infragistics.Win.Appearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE valueListItem11 AS Infragistics.Win.ValueListItem NO-UNDO.
		valueListItem11 = NEW Infragistics.Win.ValueListItem().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE valueListItem12 AS Infragistics.Win.ValueListItem NO-UNDO.
		valueListItem12 = NEW Infragistics.Win.ValueListItem().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		DEFINE VARIABLE valueListItem13 AS Infragistics.Win.ValueListItem NO-UNDO.
		valueListItem13 = NEW Infragistics.Win.ValueListItem().
		THIS-OBJECT:label4 = NEW System.Windows.Forms.Label().
		THIS-OBJECT:tickIntervalTypeEditor = NEW Infragistics.Win.UltraWinEditors.UltraComboEditor().
		THIS-OBJECT:tickPercentageEditor = NEW Infragistics.Win.UltraWinEditors.UltraNumericEditor().
		THIS-OBJECT:ultraChart1 = NEW Infragistics.Win.UltraWinChart.UltraChart().
		THIS-OBJECT:label3 = NEW System.Windows.Forms.Label().
		THIS-OBJECT:splitter2 = NEW System.Windows.Forms.Splitter().
		THIS-OBJECT:ultraExpandableGroupBox1 = NEW Infragistics.Win.Misc.UltraExpandableGroupBox().
		THIS-OBJECT:ultraExpandableGroupBoxPanel1 = NEW Infragistics.Win.Misc.UltraExpandableGroupBoxPanel().
		THIS-OBJECT:ultraLabel1 = NEW Infragistics.Win.Misc.UltraLabel().
		THIS-OBJECT:axisBox = NEW Infragistics.Win.Misc.UltraGroupBox().
		THIS-OBJECT:tickIntervalEditor = NEW Infragistics.Win.UltraWinEditors.UltraNumericEditor().
		THIS-OBJECT:label2 = NEW System.Windows.Forms.Label().
		THIS-OBJECT:tickmarkStyleEditor = NEW Infragistics.Win.UltraWinEditors.UltraComboEditor().
		THIS-OBJECT:label1 = NEW System.Windows.Forms.Label().
		THIS-OBJECT:splitter1 = NEW System.Windows.Forms.Splitter().
		CAST(THIS-OBJECT:tickIntervalTypeEditor, System.ComponentModel.ISupportInitialize):BeginInit().
		CAST(THIS-OBJECT:tickPercentageEditor, System.ComponentModel.ISupportInitialize):BeginInit().
		CAST(THIS-OBJECT:ultraChart1, System.ComponentModel.ISupportInitialize):BeginInit().
		CAST(THIS-OBJECT:ultraExpandableGroupBox1, System.ComponentModel.ISupportInitialize):BeginInit().
		THIS-OBJECT:ultraExpandableGroupBox1:SuspendLayout().
		THIS-OBJECT:ultraExpandableGroupBoxPanel1:SuspendLayout().
		CAST(THIS-OBJECT:axisBox, System.ComponentModel.ISupportInitialize):BeginInit().
		THIS-OBJECT:axisBox:SuspendLayout().
		CAST(THIS-OBJECT:tickIntervalEditor, System.ComponentModel.ISupportInitialize):BeginInit().
		CAST(THIS-OBJECT:tickmarkStyleEditor, System.ComponentModel.ISupportInitialize):BeginInit().
		THIS-OBJECT:SuspendLayout().
		/*  */
		/* label4 */
		/*  */
		THIS-OBJECT:label4:Location = NEW System.Drawing.Point(10, 120).
		THIS-OBJECT:label4:Name = "label4".
		THIS-OBJECT:label4:Size = NEW System.Drawing.Size(132, 14).
		THIS-OBJECT:label4:TabIndex = 29.
		THIS-OBJECT:label4:Text = "Tickmark Percentage".
		THIS-OBJECT:label4:UseCompatibleTextRendering = TRUE.
		/*  */
		/* tickIntervalTypeEditor */
		/*  */
		THIS-OBJECT:tickIntervalTypeEditor:DropDownStyle = Infragistics.Win.DropDownStyle:DropDownList.
		valueListItem1:DataValue = "NotSet".
		valueListItem1:DisplayText = "NotSet".
		valueListItem2:DataValue = "Ticks".
		valueListItem2:DisplayText = "Ticks".
		valueListItem3:DataValue = "Milliseconds".
		valueListItem3:DisplayText = "Milliseconds".
		valueListItem4:DataValue = "Seconds".
		valueListItem4:DisplayText = "Seconds".
		valueListItem5:DataValue = "Minutes".
		valueListItem5:DisplayText = "Minutes".
		valueListItem6:DataValue = "Hours".
		valueListItem6:DisplayText = "Hours".
		valueListItem7:DataValue = "Days".
		valueListItem7:DisplayText = "Days".
		valueListItem8:DataValue = "Weeks".
		valueListItem8:DisplayText = "Weeks".
		valueListItem9:DataValue = "Months".
		valueListItem9:DisplayText = "Months".
		valueListItem10:DataValue = "Years".
		valueListItem10:DisplayText = "Years".
		@VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
		DEFINE VARIABLE arrayvar0 AS Infragistics.Win.ValueListItem EXTENT 10 NO-UNDO.
		arrayvar0[1] = valueListItem1.
		arrayvar0[2] = valueListItem2.
		arrayvar0[3] = valueListItem3.
		arrayvar0[4] = valueListItem4.
		arrayvar0[5] = valueListItem5.
		arrayvar0[6] = valueListItem6.
		arrayvar0[7] = valueListItem7.
		arrayvar0[8] = valueListItem8.
		arrayvar0[9] = valueListItem9.
		arrayvar0[10] = valueListItem10.
		THIS-OBJECT:tickIntervalTypeEditor:Items:AddRange(arrayvar0).
		THIS-OBJECT:tickIntervalTypeEditor:Location = NEW System.Drawing.Point(108, 88).
		THIS-OBJECT:tickIntervalTypeEditor:Name = "tickIntervalTypeEditor".
		THIS-OBJECT:tickIntervalTypeEditor:Nullable = FALSE.
		THIS-OBJECT:tickIntervalTypeEditor:Size = NEW System.Drawing.Size(104, 21).
		THIS-OBJECT:tickIntervalTypeEditor:SyncWithCurrencyManager = FALSE.
		THIS-OBJECT:tickIntervalTypeEditor:TabIndex = 0.
		THIS-OBJECT:tickIntervalTypeEditor:Text = "NotSet".
		THIS-OBJECT:tickIntervalTypeEditor:ValueChanged:SUBSCRIBE(THIS-OBJECT:tickEditors_ValueChanged).
		/*  */
		/* tickPercentageEditor */
		/*  */
		appearance1:BackColor = System.Drawing.Color:White.
		THIS-OBJECT:tickPercentageEditor:Appearance = appearance1.
		THIS-OBJECT:tickPercentageEditor:BackColor = System.Drawing.Color:White.
		THIS-OBJECT:tickPercentageEditor:Location = NEW System.Drawing.Point(120, 116).
		THIS-OBJECT:tickPercentageEditor:Name = "tickPercentageEditor".
		THIS-OBJECT:tickPercentageEditor:NumericType = Infragistics.Win.UltraWinEditors.NumericType:Double.
		THIS-OBJECT:tickPercentageEditor:Size = NEW System.Drawing.Size(92, 21).
		THIS-OBJECT:tickPercentageEditor:TabIndex = 5.
		THIS-OBJECT:tickPercentageEditor:ValueChanged:SUBSCRIBE(THIS-OBJECT:tickEditors_ValueChanged).
		/* 
			'UltraChart' properties's serialization: Since 'ChartType' changes the way axes look,
			'ChartType' must be persisted ahead of any Axes change made in design time.
		 */
		THIS-OBJECT:ultraChart1:ChartType = Infragistics.UltraChart.Shared.Styles.ChartType:LineChart.
		/*  */
		/* ultraChart1 */
		/*  */
		THIS-OBJECT:ultraChart1:Anchor = CAST(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).
		THIS-OBJECT:ultraChart1:Axis:BackColor = System.Drawing.Color:FromArgb(Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(255)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(248)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(220))).
		paintElement1:ElementType = Infragistics.UltraChart.Shared.Styles.PaintElementType:None.
		paintElement1:Fill = System.Drawing.Color:FromArgb(Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(255)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(248)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(220))).
		THIS-OBJECT:ultraChart1:Axis:PE = paintElement1.
		THIS-OBJECT:ultraChart1:Axis:X:Labels:Font = NEW System.Drawing.Font("Verdana", 7).
		THIS-OBJECT:ultraChart1:Axis:X:Labels:HorizontalAlign = System.Drawing.StringAlignment:Near.
		THIS-OBJECT:ultraChart1:Axis:X:Labels:ItemFormatString = "<ITEM_LABEL>".
		THIS-OBJECT:ultraChart1:Axis:X:Labels:Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation:VerticalLeftFacing.
		THIS-OBJECT:ultraChart1:Axis:X:Labels:SeriesLabels:FormatString = "".
		THIS-OBJECT:ultraChart1:Axis:X:Labels:SeriesLabels:HorizontalAlign = System.Drawing.StringAlignment:Near.
		THIS-OBJECT:ultraChart1:Axis:X:Labels:SeriesLabels:Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation:VerticalLeftFacing.
		THIS-OBJECT:ultraChart1:Axis:X:Labels:SeriesLabels:VerticalAlign = System.Drawing.StringAlignment:Center.
		THIS-OBJECT:ultraChart1:Axis:X:Labels:VerticalAlign = System.Drawing.StringAlignment:Center.
		THIS-OBJECT:ultraChart1:Axis:X:LineThickness = 1.
		THIS-OBJECT:ultraChart1:Axis:X:MajorGridLines:AlphaLevel = Progress.Util.CastUtil:ToByte(255).
		THIS-OBJECT:ultraChart1:Axis:X:MajorGridLines:Color = System.Drawing.Color:Transparent.
		THIS-OBJECT:ultraChart1:Axis:X:MajorGridLines:DrawStyle = Infragistics.UltraChart.Shared.Styles.LineDrawStyle:Dot.
		THIS-OBJECT:ultraChart1:Axis:X:MajorGridLines:Visible = TRUE.
		THIS-OBJECT:ultraChart1:Axis:X:MinorGridLines:AlphaLevel = Progress.Util.CastUtil:ToByte(255).
		THIS-OBJECT:ultraChart1:Axis:X:MinorGridLines:Color = System.Drawing.Color:LightGray.
		THIS-OBJECT:ultraChart1:Axis:X:MinorGridLines:DrawStyle = Infragistics.UltraChart.Shared.Styles.LineDrawStyle:Dot.
		THIS-OBJECT:ultraChart1:Axis:X:MinorGridLines:Visible = FALSE.
		THIS-OBJECT:ultraChart1:Axis:X:TickmarkInterval = 1.
		THIS-OBJECT:ultraChart1:Axis:X:TickmarkIntervalType = Infragistics.UltraChart.Shared.Styles.AxisIntervalType:Weeks.
		THIS-OBJECT:ultraChart1:Axis:X:TickmarkStyle = Infragistics.UltraChart.Shared.Styles.AxisTickStyle:Smart.
		THIS-OBJECT:ultraChart1:Axis:X:Visible = TRUE.
		THIS-OBJECT:ultraChart1:Axis:X2:Labels:Font = NEW System.Drawing.Font("Verdana", 7).
		THIS-OBJECT:ultraChart1:Axis:X2:Labels:HorizontalAlign = System.Drawing.StringAlignment:Far.
		THIS-OBJECT:ultraChart1:Axis:X2:Labels:ItemFormatString = "<ITEM_LABEL>".
		THIS-OBJECT:ultraChart1:Axis:X2:Labels:Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation:VerticalLeftFacing.
		THIS-OBJECT:ultraChart1:Axis:X2:Labels:SeriesLabels:FormatString = "".
		THIS-OBJECT:ultraChart1:Axis:X2:Labels:SeriesLabels:HorizontalAlign = System.Drawing.StringAlignment:Far.
		THIS-OBJECT:ultraChart1:Axis:X2:Labels:SeriesLabels:Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation:VerticalLeftFacing.
		THIS-OBJECT:ultraChart1:Axis:X2:Labels:SeriesLabels:VerticalAlign = System.Drawing.StringAlignment:Center.
		THIS-OBJECT:ultraChart1:Axis:X2:Labels:VerticalAlign = System.Drawing.StringAlignment:Center.
		THIS-OBJECT:ultraChart1:Axis:X2:MajorGridLines:AlphaLevel = Progress.Util.CastUtil:ToByte(255).
		THIS-OBJECT:ultraChart1:Axis:X2:MajorGridLines:Color = System.Drawing.Color:Gainsboro.
		THIS-OBJECT:ultraChart1:Axis:X2:MajorGridLines:DrawStyle = Infragistics.UltraChart.Shared.Styles.LineDrawStyle:Dot.
		THIS-OBJECT:ultraChart1:Axis:X2:MajorGridLines:Visible = TRUE.
		THIS-OBJECT:ultraChart1:Axis:X2:MinorGridLines:AlphaLevel = Progress.Util.CastUtil:ToByte(255).
		THIS-OBJECT:ultraChart1:Axis:X2:MinorGridLines:Color = System.Drawing.Color:LightGray.
		THIS-OBJECT:ultraChart1:Axis:X2:MinorGridLines:DrawStyle = Infragistics.UltraChart.Shared.Styles.LineDrawStyle:Dot.
		THIS-OBJECT:ultraChart1:Axis:X2:MinorGridLines:Visible = FALSE.
		THIS-OBJECT:ultraChart1:Axis:X2:Visible = FALSE.
		THIS-OBJECT:ultraChart1:Axis:Y:Extent = 30.
		THIS-OBJECT:ultraChart1:Axis:Y:Labels:Font = NEW System.Drawing.Font("Verdana", 7).
		THIS-OBJECT:ultraChart1:Axis:Y:Labels:HorizontalAlign = System.Drawing.StringAlignment:Far.
		THIS-OBJECT:ultraChart1:Axis:Y:Labels:ItemFormatString = "<DATA_VALUE:00.##>".
		THIS-OBJECT:ultraChart1:Axis:Y:Labels:Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation:Horizontal.
		THIS-OBJECT:ultraChart1:Axis:Y:Labels:SeriesLabels:FormatString = "".
		THIS-OBJECT:ultraChart1:Axis:Y:Labels:SeriesLabels:HorizontalAlign = System.Drawing.StringAlignment:Far.
		THIS-OBJECT:ultraChart1:Axis:Y:Labels:SeriesLabels:Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation:Horizontal.
		THIS-OBJECT:ultraChart1:Axis:Y:Labels:SeriesLabels:VerticalAlign = System.Drawing.StringAlignment:Center.
		THIS-OBJECT:ultraChart1:Axis:Y:Labels:VerticalAlign = System.Drawing.StringAlignment:Center.
		THIS-OBJECT:ultraChart1:Axis:Y:LineThickness = 1.
		THIS-OBJECT:ultraChart1:Axis:Y:MajorGridLines:AlphaLevel = Progress.Util.CastUtil:ToByte(255).
		THIS-OBJECT:ultraChart1:Axis:Y:MajorGridLines:Color = System.Drawing.Color:Gainsboro.
		THIS-OBJECT:ultraChart1:Axis:Y:MajorGridLines:DrawStyle = Infragistics.UltraChart.Shared.Styles.LineDrawStyle:Dot.
		THIS-OBJECT:ultraChart1:Axis:Y:MajorGridLines:Visible = TRUE.
		THIS-OBJECT:ultraChart1:Axis:Y:MinorGridLines:AlphaLevel = Progress.Util.CastUtil:ToByte(255).
		THIS-OBJECT:ultraChart1:Axis:Y:MinorGridLines:Color = System.Drawing.Color:LightGray.
		THIS-OBJECT:ultraChart1:Axis:Y:MinorGridLines:DrawStyle = Infragistics.UltraChart.Shared.Styles.LineDrawStyle:Dot.
		THIS-OBJECT:ultraChart1:Axis:Y:MinorGridLines:Visible = FALSE.
		THIS-OBJECT:ultraChart1:Axis:Y:TickmarkInterval = 1.
		THIS-OBJECT:ultraChart1:Axis:Y:TickmarkStyle = Infragistics.UltraChart.Shared.Styles.AxisTickStyle:Smart.
		THIS-OBJECT:ultraChart1:Axis:Y:Visible = TRUE.
		THIS-OBJECT:ultraChart1:Axis:Y2:Labels:Font = NEW System.Drawing.Font("Verdana", 7).
		THIS-OBJECT:ultraChart1:Axis:Y2:Labels:HorizontalAlign = System.Drawing.StringAlignment:Near.
		THIS-OBJECT:ultraChart1:Axis:Y2:Labels:ItemFormatString = "<DATA_VALUE:00.##>".
		THIS-OBJECT:ultraChart1:Axis:Y2:Labels:Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation:Horizontal.
		THIS-OBJECT:ultraChart1:Axis:Y2:Labels:SeriesLabels:FormatString = "".
		THIS-OBJECT:ultraChart1:Axis:Y2:Labels:SeriesLabels:HorizontalAlign = System.Drawing.StringAlignment:Near.
		THIS-OBJECT:ultraChart1:Axis:Y2:Labels:SeriesLabels:Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation:Horizontal.
		THIS-OBJECT:ultraChart1:Axis:Y2:Labels:SeriesLabels:VerticalAlign = System.Drawing.StringAlignment:Center.
		THIS-OBJECT:ultraChart1:Axis:Y2:Labels:VerticalAlign = System.Drawing.StringAlignment:Center.
		THIS-OBJECT:ultraChart1:Axis:Y2:MajorGridLines:AlphaLevel = Progress.Util.CastUtil:ToByte(255).
		THIS-OBJECT:ultraChart1:Axis:Y2:MajorGridLines:Color = System.Drawing.Color:Gainsboro.
		THIS-OBJECT:ultraChart1:Axis:Y2:MajorGridLines:DrawStyle = Infragistics.UltraChart.Shared.Styles.LineDrawStyle:Dot.
		THIS-OBJECT:ultraChart1:Axis:Y2:MajorGridLines:Visible = TRUE.
		THIS-OBJECT:ultraChart1:Axis:Y2:MinorGridLines:AlphaLevel = Progress.Util.CastUtil:ToByte(255).
		THIS-OBJECT:ultraChart1:Axis:Y2:MinorGridLines:Color = System.Drawing.Color:LightGray.
		THIS-OBJECT:ultraChart1:Axis:Y2:MinorGridLines:DrawStyle = Infragistics.UltraChart.Shared.Styles.LineDrawStyle:Dot.
		THIS-OBJECT:ultraChart1:Axis:Y2:MinorGridLines:Visible = FALSE.
		THIS-OBJECT:ultraChart1:Axis:Y2:Visible = FALSE.
		THIS-OBJECT:ultraChart1:Axis:Z:Labels:Font = NEW System.Drawing.Font("Verdana", 7).
		THIS-OBJECT:ultraChart1:Axis:Z:Labels:HorizontalAlign = System.Drawing.StringAlignment:Near.
		THIS-OBJECT:ultraChart1:Axis:Z:Labels:ItemFormatString = "".
		THIS-OBJECT:ultraChart1:Axis:Z:Labels:Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation:Horizontal.
		THIS-OBJECT:ultraChart1:Axis:Z:Labels:SeriesLabels:HorizontalAlign = System.Drawing.StringAlignment:Near.
		THIS-OBJECT:ultraChart1:Axis:Z:Labels:SeriesLabels:Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation:Horizontal.
		THIS-OBJECT:ultraChart1:Axis:Z:Labels:SeriesLabels:VerticalAlign = System.Drawing.StringAlignment:Center.
		THIS-OBJECT:ultraChart1:Axis:Z:Labels:VerticalAlign = System.Drawing.StringAlignment:Center.
		THIS-OBJECT:ultraChart1:Axis:Z:MajorGridLines:AlphaLevel = Progress.Util.CastUtil:ToByte(255).
		THIS-OBJECT:ultraChart1:Axis:Z:MajorGridLines:Color = System.Drawing.Color:Gainsboro.
		THIS-OBJECT:ultraChart1:Axis:Z:MajorGridLines:DrawStyle = Infragistics.UltraChart.Shared.Styles.LineDrawStyle:Dot.
		THIS-OBJECT:ultraChart1:Axis:Z:MajorGridLines:Visible = TRUE.
		THIS-OBJECT:ultraChart1:Axis:Z:MinorGridLines:AlphaLevel = Progress.Util.CastUtil:ToByte(255).
		THIS-OBJECT:ultraChart1:Axis:Z:MinorGridLines:Color = System.Drawing.Color:LightGray.
		THIS-OBJECT:ultraChart1:Axis:Z:MinorGridLines:DrawStyle = Infragistics.UltraChart.Shared.Styles.LineDrawStyle:Dot.
		THIS-OBJECT:ultraChart1:Axis:Z:MinorGridLines:Visible = FALSE.
		THIS-OBJECT:ultraChart1:Axis:Z:Visible = FALSE.
		THIS-OBJECT:ultraChart1:Axis:Z2:Labels:Font = NEW System.Drawing.Font("Verdana", 7).
		THIS-OBJECT:ultraChart1:Axis:Z2:Labels:HorizontalAlign = System.Drawing.StringAlignment:Near.
		THIS-OBJECT:ultraChart1:Axis:Z2:Labels:ItemFormatString = "".
		THIS-OBJECT:ultraChart1:Axis:Z2:Labels:Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation:Horizontal.
		THIS-OBJECT:ultraChart1:Axis:Z2:Labels:SeriesLabels:HorizontalAlign = System.Drawing.StringAlignment:Near.
		THIS-OBJECT:ultraChart1:Axis:Z2:Labels:SeriesLabels:Orientation = Infragistics.UltraChart.Shared.Styles.TextOrientation:Horizontal.
		THIS-OBJECT:ultraChart1:Axis:Z2:Labels:SeriesLabels:VerticalAlign = System.Drawing.StringAlignment:Center.
		THIS-OBJECT:ultraChart1:Axis:Z2:Labels:VerticalAlign = System.Drawing.StringAlignment:Center.
		THIS-OBJECT:ultraChart1:Axis:Z2:MajorGridLines:AlphaLevel = Progress.Util.CastUtil:ToByte(255).
		THIS-OBJECT:ultraChart1:Axis:Z2:MajorGridLines:Color = System.Drawing.Color:Gainsboro.
		THIS-OBJECT:ultraChart1:Axis:Z2:MajorGridLines:DrawStyle = Infragistics.UltraChart.Shared.Styles.LineDrawStyle:Dot.
		THIS-OBJECT:ultraChart1:Axis:Z2:MajorGridLines:Visible = TRUE.
		THIS-OBJECT:ultraChart1:Axis:Z2:MinorGridLines:AlphaLevel = Progress.Util.CastUtil:ToByte(255).
		THIS-OBJECT:ultraChart1:Axis:Z2:MinorGridLines:Color = System.Drawing.Color:LightGray.
		THIS-OBJECT:ultraChart1:Axis:Z2:MinorGridLines:DrawStyle = Infragistics.UltraChart.Shared.Styles.LineDrawStyle:Dot.
		THIS-OBJECT:ultraChart1:Axis:Z2:MinorGridLines:Visible = FALSE.
		THIS-OBJECT:ultraChart1:Axis:Z2:Visible = FALSE.
		THIS-OBJECT:ultraChart1:BackgroundImageLayout = System.Windows.Forms.ImageLayout:Center.
		THIS-OBJECT:ultraChart1:Border:CornerRadius = 5.
		THIS-OBJECT:ultraChart1:ColorModel:AlphaLevel = Progress.Util.CastUtil:ToByte(150).
		THIS-OBJECT:ultraChart1:ColorModel:ModelStyle = Infragistics.UltraChart.Shared.Styles.ColorModels:CustomSkin.
		paintElement2:ElementType = Infragistics.UltraChart.Shared.Styles.PaintElementType:Gradient.
		paintElement2:Fill = System.Drawing.Color:FromArgb(Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(108)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(162)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(36))).
		paintElement2:FillGradientStyle = Infragistics.UltraChart.Shared.Styles.GradientStyle:Horizontal.
		paintElement2:FillStopColor = System.Drawing.Color:FromArgb(Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(148)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(244)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(17))).
		paintElement2:Stroke = System.Drawing.Color:Transparent.
		paintElement3:ElementType = Infragistics.UltraChart.Shared.Styles.PaintElementType:Gradient.
		paintElement3:Fill = System.Drawing.Color:FromArgb(Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(7)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(108)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(176))).
		paintElement3:FillGradientStyle = Infragistics.UltraChart.Shared.Styles.GradientStyle:Horizontal.
		paintElement3:FillStopColor = System.Drawing.Color:FromArgb(Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(53)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(200)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(255))).
		paintElement3:Stroke = System.Drawing.Color:Transparent.
		paintElement4:ElementType = Infragistics.UltraChart.Shared.Styles.PaintElementType:Gradient.
		paintElement4:Fill = System.Drawing.Color:FromArgb(Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(215)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(0)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(5))).
		paintElement4:FillGradientStyle = Infragistics.UltraChart.Shared.Styles.GradientStyle:Horizontal.
		paintElement4:FillStopColor = System.Drawing.Color:FromArgb(Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(254)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(117)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(16))).
		paintElement4:Stroke = System.Drawing.Color:Transparent.
		paintElement5:ElementType = Infragistics.UltraChart.Shared.Styles.PaintElementType:Gradient.
		paintElement5:Fill = System.Drawing.Color:FromArgb(Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(230)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(190)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(2))).
		paintElement5:FillGradientStyle = Infragistics.UltraChart.Shared.Styles.GradientStyle:Horizontal.
		paintElement5:FillStopColor = System.Drawing.Color:FromArgb(Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(255)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(255)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(81))).
		paintElement5:Stroke = System.Drawing.Color:Transparent.
		paintElement6:ElementType = Infragistics.UltraChart.Shared.Styles.PaintElementType:Gradient.
		paintElement6:Fill = System.Drawing.Color:FromArgb(Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(252)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(122)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(10))).
		paintElement6:FillGradientStyle = Infragistics.UltraChart.Shared.Styles.GradientStyle:Horizontal.
		paintElement6:FillStopColor = System.Drawing.Color:FromArgb(Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(255)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(208)), Progress.Util.CastUtil:ToInt32(Progress.Util.CastUtil:ToByte(66))).
		paintElement6:Stroke = System.Drawing.Color:Transparent.
		@VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
		DEFINE VARIABLE arrayvar1 AS Infragistics.UltraChart.Resources.Appearance.PaintElement EXTENT 5 NO-UNDO.
		arrayvar1[1] = paintElement2.
		arrayvar1[2] = paintElement3.
		arrayvar1[3] = paintElement4.
		arrayvar1[4] = paintElement5.
		arrayvar1[5] = paintElement6.
		THIS-OBJECT:ultraChart1:ColorModel:Skin:PEs:AddRange(arrayvar1).
		THIS-OBJECT:ultraChart1:Data:EmptyStyle:LineStyle:DrawStyle = Infragistics.UltraChart.Shared.Styles.LineDrawStyle:Dash.
		THIS-OBJECT:ultraChart1:Effects:Effects:Add(gradientEffect1).
		THIS-OBJECT:ultraChart1:ForeColor = System.Drawing.SystemColors:ControlText.
		lineChartAppearance1:TreatDateTimeAsString = FALSE.
		THIS-OBJECT:ultraChart1:LineChart = lineChartAppearance1.
		THIS-OBJECT:ultraChart1:Location = NEW System.Drawing.Point(5, 112).
		THIS-OBJECT:ultraChart1:Name = "ultraChart1".
		THIS-OBJECT:ultraChart1:Size = NEW System.Drawing.Size(432, 400).
		THIS-OBJECT:ultraChart1:TabIndex = 22.
		THIS-OBJECT:ultraChart1:TitleBottom:Visible = FALSE.
		THIS-OBJECT:ultraChart1:Tooltips:Font = NEW System.Drawing.Font("Microsoft Sans Serif", 7.8000002).
		THIS-OBJECT:ultraChart1:Tooltips:HighlightDataPoint = FALSE.
		/*  */
		/* label3 */
		/*  */
		THIS-OBJECT:label3:Location = NEW System.Drawing.Point(10, 92).
		THIS-OBJECT:label3:Name = "label3".
		THIS-OBJECT:label3:Size = NEW System.Drawing.Size(102, 14).
		THIS-OBJECT:label3:TabIndex = 28.
		THIS-OBJECT:label3:Text = "Interval Type".
		THIS-OBJECT:label3:UseCompatibleTextRendering = TRUE.
		/*  */
		/* splitter2 */
		/*  */
		THIS-OBJECT:splitter2:Dock = System.Windows.Forms.DockStyle:Top.
		THIS-OBJECT:splitter2:Location = NEW System.Drawing.Point(0, 0).
		THIS-OBJECT:splitter2:Name = "splitter2".
		THIS-OBJECT:splitter2:Size = NEW System.Drawing.Size(664, 3).
		THIS-OBJECT:splitter2:TabIndex = 26.
		THIS-OBJECT:splitter2:TabStop = FALSE.
		/*  */
		/* ultraExpandableGroupBox1 */
		/*  */
		THIS-OBJECT:ultraExpandableGroupBox1:Anchor = CAST(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).
		THIS-OBJECT:ultraExpandableGroupBox1:ContentPadding:Bottom = 5.
		THIS-OBJECT:ultraExpandableGroupBox1:ContentPadding:Left = 5.
		THIS-OBJECT:ultraExpandableGroupBox1:ContentPadding:Right = 5.
		THIS-OBJECT:ultraExpandableGroupBox1:ContentPadding:Top = 5.
		THIS-OBJECT:ultraExpandableGroupBox1:Controls:Add(THIS-OBJECT:ultraExpandableGroupBoxPanel1).
		THIS-OBJECT:ultraExpandableGroupBox1:ExpandedSize = NEW System.Drawing.Size(664, 96).
		THIS-OBJECT:ultraExpandableGroupBox1:HeaderClickAction = Infragistics.Win.Misc.GroupBoxHeaderClickAction:None.
		THIS-OBJECT:ultraExpandableGroupBox1:HeaderPosition = Infragistics.Win.Misc.GroupBoxHeaderPosition:TopOutsideBorder.
		THIS-OBJECT:ultraExpandableGroupBox1:Location = NEW System.Drawing.Point(5, 8).
		THIS-OBJECT:ultraExpandableGroupBox1:Name = "ultraExpandableGroupBox1".
		THIS-OBJECT:ultraExpandableGroupBox1:Size = NEW System.Drawing.Size(664, 96).
		THIS-OBJECT:ultraExpandableGroupBox1:TabIndex = 23.
		THIS-OBJECT:ultraExpandableGroupBox1:Text = "DateTime Axis".
		THIS-OBJECT:ultraExpandableGroupBox1:ViewStyle = Infragistics.Win.Misc.GroupBoxViewStyle:Office2003.
		/*  */
		/* ultraExpandableGroupBoxPanel1 */
		/*  */
		THIS-OBJECT:ultraExpandableGroupBoxPanel1:Controls:Add(THIS-OBJECT:ultraLabel1).
		THIS-OBJECT:ultraExpandableGroupBoxPanel1:Dock = System.Windows.Forms.DockStyle:Fill.
		THIS-OBJECT:ultraExpandableGroupBoxPanel1:Location = NEW System.Drawing.Point(7, 31).
		THIS-OBJECT:ultraExpandableGroupBoxPanel1:Name = "ultraExpandableGroupBoxPanel1".
		THIS-OBJECT:ultraExpandableGroupBoxPanel1:Size = NEW System.Drawing.Size(650, 58).
		THIS-OBJECT:ultraExpandableGroupBoxPanel1:TabIndex = 0.
		/*  */
		/* ultraLabel1 */
		/*  */
		THIS-OBJECT:ultraLabel1:Dock = System.Windows.Forms.DockStyle:Fill.
		THIS-OBJECT:ultraLabel1:Location = NEW System.Drawing.Point(0, 0).
		THIS-OBJECT:ultraLabel1:Name = "ultraLabel1".
		THIS-OBJECT:ultraLabel1:Size = NEW System.Drawing.Size(650, 58).
		THIS-OBJECT:ultraLabel1:TabIndex = 1.
		THIS-OBJECT:ultraLabel1:Text = resources:GetString("ultraLabel1.Text").
		/*  */
		/* axisBox */
		/*  */
		THIS-OBJECT:axisBox:Anchor = CAST(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).
		THIS-OBJECT:axisBox:Controls:Add(THIS-OBJECT:tickPercentageEditor).
		THIS-OBJECT:axisBox:Controls:Add(THIS-OBJECT:label4).
		THIS-OBJECT:axisBox:Controls:Add(THIS-OBJECT:tickIntervalTypeEditor).
		THIS-OBJECT:axisBox:Controls:Add(THIS-OBJECT:label3).
		THIS-OBJECT:axisBox:Controls:Add(THIS-OBJECT:tickIntervalEditor).
		THIS-OBJECT:axisBox:Controls:Add(THIS-OBJECT:label2).
		THIS-OBJECT:axisBox:Controls:Add(THIS-OBJECT:tickmarkStyleEditor).
		THIS-OBJECT:axisBox:Controls:Add(THIS-OBJECT:label1).
		THIS-OBJECT:axisBox:Location = NEW System.Drawing.Point(445, 112).
		THIS-OBJECT:axisBox:Name = "axisBox".
		THIS-OBJECT:axisBox:Size = NEW System.Drawing.Size(224, 400).
		THIS-OBJECT:axisBox:TabIndex = 24.
		THIS-OBJECT:axisBox:Text = "DateTime (X) Axis Settings".
		/*  */
		/* tickIntervalEditor */
		/*  */
		appearance2:BackColor = System.Drawing.Color:White.
		THIS-OBJECT:tickIntervalEditor:Appearance = appearance2.
		THIS-OBJECT:tickIntervalEditor:BackColor = System.Drawing.Color:White.
		THIS-OBJECT:tickIntervalEditor:Location = NEW System.Drawing.Point(108, 62).
		THIS-OBJECT:tickIntervalEditor:Name = "tickIntervalEditor".
		THIS-OBJECT:tickIntervalEditor:NumericType = Infragistics.Win.UltraWinEditors.NumericType:Double.
		THIS-OBJECT:tickIntervalEditor:Size = NEW System.Drawing.Size(104, 21).
		THIS-OBJECT:tickIntervalEditor:TabIndex = 5.
		THIS-OBJECT:tickIntervalEditor:ValueChanged:SUBSCRIBE(THIS-OBJECT:tickEditors_ValueChanged).
		/*  */
		/* label2 */
		/*  */
		THIS-OBJECT:label2:Location = NEW System.Drawing.Point(10, 66).
		THIS-OBJECT:label2:Name = "label2".
		THIS-OBJECT:label2:Size = NEW System.Drawing.Size(100, 14).
		THIS-OBJECT:label2:TabIndex = 27.
		THIS-OBJECT:label2:Text = "Tickmark Interval".
		THIS-OBJECT:label2:UseCompatibleTextRendering = TRUE.
		/*  */
		/* tickmarkStyleEditor */
		/*  */
		THIS-OBJECT:tickmarkStyleEditor:DropDownStyle = Infragistics.Win.DropDownStyle:DropDownList.
		valueListItem11:DataValue = "Smart".
		valueListItem11:DisplayText = "Smart".
		valueListItem12:DataValue = "Percentage".
		valueListItem12:DisplayText = "Percentage".
		valueListItem13:DataValue = "DataInterval".
		valueListItem13:DisplayText = "DataInterval".
		@VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").
		DEFINE VARIABLE arrayvar2 AS Infragistics.Win.ValueListItem EXTENT 3 NO-UNDO.
		arrayvar2[1] = valueListItem11.
		arrayvar2[2] = valueListItem12.
		arrayvar2[3] = valueListItem13.
		THIS-OBJECT:tickmarkStyleEditor:Items:AddRange(arrayvar2).
		THIS-OBJECT:tickmarkStyleEditor:Location = NEW System.Drawing.Point(94, 22).
		THIS-OBJECT:tickmarkStyleEditor:Name = "tickmarkStyleEditor".
		THIS-OBJECT:tickmarkStyleEditor:Nullable = FALSE.
		THIS-OBJECT:tickmarkStyleEditor:Size = NEW System.Drawing.Size(120, 21).
		THIS-OBJECT:tickmarkStyleEditor:SyncWithCurrencyManager = FALSE.
		THIS-OBJECT:tickmarkStyleEditor:TabIndex = 0.
		THIS-OBJECT:tickmarkStyleEditor:Text = "Smart".
		THIS-OBJECT:tickmarkStyleEditor:ValueChanged:SUBSCRIBE(THIS-OBJECT:tickmarkStyleEditor_ValueChanged).
		/*  */
		/* label1 */
		/*  */
		THIS-OBJECT:label1:Location = NEW System.Drawing.Point(12, 26).
		THIS-OBJECT:label1:Name = "label1".
		THIS-OBJECT:label1:Size = NEW System.Drawing.Size(100, 14).
		THIS-OBJECT:label1:TabIndex = 26.
		THIS-OBJECT:label1:Text = "Tickmark Style".
		THIS-OBJECT:label1:UseCompatibleTextRendering = TRUE.
		/*  */
		/* splitter1 */
		/*  */
		THIS-OBJECT:splitter1:Dock = System.Windows.Forms.DockStyle:Right.
		THIS-OBJECT:splitter1:Location = NEW System.Drawing.Point(664, 0).
		THIS-OBJECT:splitter1:Name = "splitter1".
		THIS-OBJECT:splitter1:Size = NEW System.Drawing.Size(3, 540).
		THIS-OBJECT:splitter1:TabIndex = 25.
		THIS-OBJECT:splitter1:TabStop = FALSE.
		/*  */
		/* DateTimeAxis */
		/*  */
		THIS-OBJECT:ClientSize = NEW System.Drawing.Size(667, 540).
		THIS-OBJECT:Controls:Add(THIS-OBJECT:ultraChart1).
		THIS-OBJECT:Controls:Add(THIS-OBJECT:splitter2).
		THIS-OBJECT:Controls:Add(THIS-OBJECT:ultraExpandableGroupBox1).
		THIS-OBJECT:Controls:Add(THIS-OBJECT:axisBox).
		THIS-OBJECT:Controls:Add(THIS-OBJECT:splitter1).
		THIS-OBJECT:Name = "DateTimeAxis".
		THIS-OBJECT:Text = "DateTimeAxis".
		THIS-OBJECT:Load:SUBSCRIBE(THIS-OBJECT:DateTimeAxis_Load).
		CAST(THIS-OBJECT:tickIntervalTypeEditor, System.ComponentModel.ISupportInitialize):EndInit().
		CAST(THIS-OBJECT:tickPercentageEditor, System.ComponentModel.ISupportInitialize):EndInit().
		CAST(THIS-OBJECT:ultraChart1, System.ComponentModel.ISupportInitialize):EndInit().
		CAST(THIS-OBJECT:ultraExpandableGroupBox1, System.ComponentModel.ISupportInitialize):EndInit().
		THIS-OBJECT:ultraExpandableGroupBox1:ResumeLayout(FALSE).
		THIS-OBJECT:ultraExpandableGroupBoxPanel1:ResumeLayout(FALSE).
		CAST(THIS-OBJECT:axisBox, System.ComponentModel.ISupportInitialize):EndInit().
		THIS-OBJECT:axisBox:ResumeLayout(FALSE).
		THIS-OBJECT:axisBox:PerformLayout().
		CAST(THIS-OBJECT:tickIntervalEditor, System.ComponentModel.ISupportInitialize):EndInit().
		CAST(THIS-OBJECT:tickmarkStyleEditor, System.ComponentModel.ISupportInitialize):EndInit().
		THIS-OBJECT:ResumeLayout(FALSE).
	END METHOD.

	DESTRUCTOR PUBLIC DateTimeAxis ( ):
		IF VALID-OBJECT(components) THEN DO:
			CAST(components, System.IDisposable):Dispose().
		END.
	END DESTRUCTOR.
	
	METHOD PUBLIC VOID SetTicksStyle():
	    CASE tickmarkStyleEditor:Text:
		    WHEN "Percentage" THEN
            DO:
			    ultraChart1:Axis:X:TickmarkStyle = AxisTickStyle:Percentage.
				tickIntervalTypeEditor:Enabled = false.
				tickIntervalEditor:Enabled = false.
				tickPercentageEditor:Enabled = true.
			END.
		    WHEN "DataInterval" THEN
            DO:
			    ultraChart1:Axis:X:TickmarkStyle = AxisTickStyle:DataInterval.
				tickIntervalTypeEditor:Enabled = true.
				tickIntervalEditor:Enabled = true.
				tickPercentageEditor:Enabled = false.
			END.
			WHEN "Smart" THEN
            DO:
			    ultraChart1:Axis:X:TickmarkStyle = AxisTickStyle:Smart.
				tickIntervalTypeEditor:Enabled = false.
				tickIntervalEditor:Enabled = false.
				tickPercentageEditor:Enabled = false.
			END.
		END CASE.
	END METHOD.

 	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID tickmarkStyleEditor_ValueChanged( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		SetTicksStyle().
	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID tickEditors_ValueChanged( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
        ultraChart1:Axis:X:TickmarkInterval   = UNBOX(tickIntervalEditor:Value).
        ultraChart1:Axis:X:TickmarkPercentage = UNBOX(tickPercentageEditor:Value).

        CASE tickIntervalTypeEditor:TEXT:
            WHEN "Ticks"        THEN ultraChart1:Axis:X:TickmarkIntervalType = AxisIntervalType:Ticks.
        	WHEN "Milliseconds" THEN ultraChart1:Axis:X:TickmarkIntervalType = AxisIntervalType:Milliseconds.
            WHEN "Seconds"      THEN ultraChart1:Axis:X:TickmarkIntervalType = AxisIntervalType:Seconds.
            WHEN "Minutes"      THEN ultraChart1:Axis:X:TickmarkIntervalType = AxisIntervalType:Minutes.
        	WHEN "Hours"        THEN ultraChart1:Axis:X:TickmarkIntervalType = AxisIntervalType:Hours.
        	WHEN "Days"         THEN ultraChart1:Axis:X:TickmarkIntervalType = AxisIntervalType:Days.
        	WHEN "Weeks"        THEN ultraChart1:Axis:X:TickmarkIntervalType = AxisIntervalType:Weeks.
        	WHEN "Months"       THEN ultraChart1:Axis:X:TickmarkIntervalType = AxisIntervalType:Months.
        	WHEN "Years"        THEN ultraChart1:Axis:X:TickmarkIntervalType = AxisIntervalType:Years.
            OTHERWISE ultraChart1:Axis:X:TickmarkIntervalType = AxisIntervalType:NotSet.
       END CASE.
	END METHOD.
 
END CLASS.