 /* 
ABL example derived from Infragistics source, copyright 1992-2008 Infragistics, 
Inc., Windsor Corporate Park, 50 Millstone Road, Building 200 Suite 150, East 
Windsor, NJ 08520. All rights reserved.
*/
 /*------------------------------------------------------------------------
    File        : CustomColumnChooser
    Purpose     : 
    Syntax      : 
    Description : 
    Author(s)   : hdaniels  - copied/transformed from Infragistic sample
    Created     : Tue May 27 16:23:42 EDT 2008
    Notes       : 
  ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING Progress.Windows.Form.
 
using WinGrid.SamplesExplorer.NewColumnDialog.

CLASS WinGrid.SamplesExplorer.CustomColumnChooser INHERITS Form   : 
	
	DEFINE PRIVATE VARIABLE components AS System.ComponentModel.IContainer.


	define private variable ultraComboBandSelector as Infragistics.Win.UltraWinGrid.UltraCombo no-undo.
	define private variable ultraButtonDeleteColumn as Infragistics.Win.Misc.UltraButton no-undo.
	define private variable ultraButtonNewColumn as Infragistics.Win.Misc.UltraButton no-undo.
	define private variable ultraGridColumnChooser1 as Infragistics.Win.UltraWinGrid.UltraGridColumnChooser no-undo.

    define public property Grid as Infragistics.Win.UltraWinGrid.UltraGridBase no-undo
    get:
        return this-object:Grid.
    end.
	set(newGrid as Infragistics.Win.UltraWinGrid.UltraGridBase):
		if newGrid <> this-object:Grid then
        do:
			this-object:Grid = newGrid.

			ultraGridColumnChooser1:SourceGrid = this-object:Grid.
			InitializeBandsCombo( this-object:Grid ).

			/* Select the first band in the band selector. */
			if ultraComboBandSelector:Rows:Count > 0 then
				ultraComboBandSelector:SelectedRow = ultraComboBandSelector:Rows[0].
		end.
	end.

    /* Returns the column chooser control. */
	define public property ColumnChooserControl as Infragistics.Win.UltraWinGrid.UltraGridColumnChooser no-undo 
	get:
	    return ultraGridColumnChooser1.
	end.

	/* Gets or sets the band whose columns are being displayed. */
    define public property CurrentBand as Infragistics.Win.UltraWinGrid.UltraGridBand no-undo
	get:
		return ColumnChooserControl:CurrentBand.
	end.
	set(band as Infragistics.Win.UltraWinGrid.UltraGridBand):
	 	if valid-object(band) and (not valid-object(this-object:Grid) /*or this-object:Grid <> band:Layout:Grid )*/) then
			undo, throw new System.ArgumentException( ).

		ultraComboBandSelector:Value = band.
	end.
	
	CONSTRUCTOR PUBLIC CustomColumnChooser (  ):
		
		SUPER().
		InitializeComponent ( ).

	END CONSTRUCTOR.

	DESTRUCTOR PUBLIC CustomColumnChooser ( ):

		IF VALID-OBJECT(components) THEN DO:
			CAST(components, System.IDisposable):Dispose().
		END.

	END DESTRUCTOR.

	




	method private void InitializeComponent ( ):

/* 		NOTE: The following method is generated by the OpenEdge Advanced GUI Visual Designer.

		We strongly suggest that the contents of this method only be modified using the
		Visual Designer to avoid any incompatible modifications.

		Modifying the contents of this method using a code editor will invalidate any support for this file. */

		@VisualDesigner.FormMember (NeedsInitialize="true").
		define variable appearance1 as Infragistics.Win.Appearance no-undo.
		appearance1 = new Infragistics.Win.Appearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		define variable appearance2 as Infragistics.Win.Appearance no-undo.
		appearance2 = new Infragistics.Win.Appearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		define variable appearance3 as Infragistics.Win.Appearance no-undo.
		appearance3 = new Infragistics.Win.Appearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		define variable appearance4 as Infragistics.Win.Appearance no-undo.
		appearance4 = new Infragistics.Win.Appearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		define variable appearance5 as Infragistics.Win.Appearance no-undo.
		appearance5 = new Infragistics.Win.Appearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		define variable appearance6 as Infragistics.Win.Appearance no-undo.
		appearance6 = new Infragistics.Win.Appearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		define variable appearance7 as Infragistics.Win.Appearance no-undo.
		appearance7 = new Infragistics.Win.Appearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		define variable appearance8 as Infragistics.Win.Appearance no-undo.
		appearance8 = new Infragistics.Win.Appearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		define variable appearance9 as Infragistics.Win.Appearance no-undo.
		appearance9 = new Infragistics.Win.Appearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		define variable appearance10 as Infragistics.Win.Appearance no-undo.
		appearance10 = new Infragistics.Win.Appearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		define variable appearance11 as Infragistics.Win.Appearance no-undo.
		appearance11 = new Infragistics.Win.Appearance().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		define variable appearance12 as Infragistics.Win.Appearance no-undo.
		appearance12 = new Infragistics.Win.Appearance().
		this-object:ultraComboBandSelector = new Infragistics.Win.UltraWinGrid.UltraCombo().
		this-object:ultraButtonDeleteColumn = new Infragistics.Win.Misc.UltraButton().
		this-object:ultraButtonNewColumn = new Infragistics.Win.Misc.UltraButton().
		this-object:ultraGridColumnChooser1 = new Infragistics.Win.UltraWinGrid.UltraGridColumnChooser().
		cast(this-object:ultraComboBandSelector, System.ComponentModel.ISupportInitialize):BeginInit().
		cast(this-object:ultraGridColumnChooser1, System.ComponentModel.ISupportInitialize):BeginInit().
		this-object:SuspendLayout().
		/*  */
		/* ultraComboBandSelector */
		/*  */
		this-object:ultraComboBandSelector:CharacterCasing = System.Windows.Forms.CharacterCasing:Normal.
		appearance1:BackColor = System.Drawing.SystemColors:Window.
		appearance1:BorderColor = System.Drawing.SystemColors:InactiveCaption.
		this-object:ultraComboBandSelector:DisplayLayout:Appearance = appearance1.
		this-object:ultraComboBandSelector:DisplayLayout:BorderStyle = Infragistics.Win.UIElementBorderStyle:Solid.
		this-object:ultraComboBandSelector:DisplayLayout:CaptionVisible = Infragistics.Win.DefaultableBoolean:False.
		appearance2:BackColor = System.Drawing.SystemColors:ActiveBorder.
		appearance2:BackColor2 = System.Drawing.SystemColors:ControlDark.
		appearance2:BackGradientStyle = Infragistics.Win.GradientStyle:Vertical.
		appearance2:BorderColor = System.Drawing.SystemColors:Window.
		this-object:ultraComboBandSelector:DisplayLayout:GroupByBox:Appearance = appearance2.
		appearance3:ForeColor = System.Drawing.SystemColors:GrayText.
		this-object:ultraComboBandSelector:DisplayLayout:GroupByBox:BandLabelAppearance = appearance3.
		this-object:ultraComboBandSelector:DisplayLayout:GroupByBox:BorderStyle = Infragistics.Win.UIElementBorderStyle:Solid.
		appearance4:BackColor = System.Drawing.SystemColors:ControlLightLight.
		appearance4:BackColor2 = System.Drawing.SystemColors:Control.
		appearance4:BackGradientStyle = Infragistics.Win.GradientStyle:Horizontal.
		appearance4:ForeColor = System.Drawing.SystemColors:GrayText.
		this-object:ultraComboBandSelector:DisplayLayout:GroupByBox:PromptAppearance = appearance4.
		this-object:ultraComboBandSelector:DisplayLayout:MaxColScrollRegions = 1.
		this-object:ultraComboBandSelector:DisplayLayout:MaxRowScrollRegions = 1.
		appearance5:BackColor = System.Drawing.SystemColors:Window.
		appearance5:ForeColor = System.Drawing.SystemColors:ControlText.
		this-object:ultraComboBandSelector:DisplayLayout:Override:ActiveCellAppearance = appearance5.
		appearance6:BackColor = System.Drawing.SystemColors:Highlight.
		appearance6:ForeColor = System.Drawing.SystemColors:HighlightText.
		this-object:ultraComboBandSelector:DisplayLayout:Override:ActiveRowAppearance = appearance6.
		this-object:ultraComboBandSelector:DisplayLayout:Override:BorderStyleCell = Infragistics.Win.UIElementBorderStyle:Dotted.
		this-object:ultraComboBandSelector:DisplayLayout:Override:BorderStyleRow = Infragistics.Win.UIElementBorderStyle:Dotted.
		appearance7:BackColor = System.Drawing.SystemColors:Window.
		this-object:ultraComboBandSelector:DisplayLayout:Override:CardAreaAppearance = appearance7.
		appearance8:BorderColor = System.Drawing.Color:Silver.
		appearance8:TextTrimming = Infragistics.Win.TextTrimming:EllipsisCharacter.
		this-object:ultraComboBandSelector:DisplayLayout:Override:CellAppearance = appearance8.
		this-object:ultraComboBandSelector:DisplayLayout:Override:CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction:EditAndSelectText.
		this-object:ultraComboBandSelector:DisplayLayout:Override:CellPadding = 0.
		appearance9:BackColor = System.Drawing.SystemColors:Control.
		appearance9:BackColor2 = System.Drawing.SystemColors:ControlDark.
		appearance9:BackGradientAlignment = Infragistics.Win.GradientAlignment:Client.
		appearance9:BackGradientStyle = Infragistics.Win.GradientStyle:Horizontal.
		appearance9:BorderColor = System.Drawing.SystemColors:Window.
		this-object:ultraComboBandSelector:DisplayLayout:Override:GroupByRowAppearance = appearance9.
		appearance10:TextHAlignAsString = "Left".
		this-object:ultraComboBandSelector:DisplayLayout:Override:HeaderAppearance = appearance10.
		this-object:ultraComboBandSelector:DisplayLayout:Override:HeaderClickAction = Infragistics.Win.UltraWinGrid.HeaderClickAction:SortMulti.
		this-object:ultraComboBandSelector:DisplayLayout:Override:HeaderStyle = Infragistics.Win.HeaderStyle:WindowsXPCommand.
		appearance11:BackColor = System.Drawing.SystemColors:Window.
		appearance11:BorderColor = System.Drawing.Color:Silver.
		this-object:ultraComboBandSelector:DisplayLayout:Override:RowAppearance = appearance11.
		this-object:ultraComboBandSelector:DisplayLayout:Override:RowSelectors = Infragistics.Win.DefaultableBoolean:False.
		appearance12:BackColor = System.Drawing.SystemColors:ControlLight.
		this-object:ultraComboBandSelector:DisplayLayout:Override:TemplateAddRowAppearance = appearance12.
		this-object:ultraComboBandSelector:DisplayLayout:ScrollBounds = Infragistics.Win.UltraWinGrid.ScrollBounds:ScrollToFill.
		this-object:ultraComboBandSelector:DisplayLayout:ScrollStyle = Infragistics.Win.UltraWinGrid.ScrollStyle:Immediate.
		this-object:ultraComboBandSelector:DisplayLayout:ViewStyleBand = Infragistics.Win.UltraWinGrid.ViewStyleBand:OutlookGroupBy.
		this-object:ultraComboBandSelector:DisplayStyle = Infragistics.Win.EmbeddableElementDisplayStyle:Default.
		this-object:ultraComboBandSelector:DropDownStyle = Infragistics.Win.UltraWinGrid.UltraComboStyle:DropDownList.
		this-object:ultraComboBandSelector:Location = new System.Drawing.Point(1, 1).
		this-object:ultraComboBandSelector:Name = "ultraComboBandSelector".
		this-object:ultraComboBandSelector:Size = new System.Drawing.Size(190, 22).
		this-object:ultraComboBandSelector:TabIndex = 4.
		this-object:ultraComboBandSelector:RowSelected:subscribe(this-object:ultraComboBandSelector_RowSelected).
		/*  */
		/* ultraButtonDeleteColumn */
		/*  */
		this-object:ultraButtonDeleteColumn:Location = new System.Drawing.Point(98, 269).
		this-object:ultraButtonDeleteColumn:Name = "ultraButtonDeleteColumn".
		this-object:ultraButtonDeleteColumn:Size = new System.Drawing.Size(92, 23).
		this-object:ultraButtonDeleteColumn:TabIndex = 7.
		this-object:ultraButtonDeleteColumn:Text = "Delete Column".
		this-object:ultraButtonDeleteColumn:Click:subscribe(this-object:ultraButtonDeleteColumn_Click).
		/*  */
		/* ultraButtonNewColumn */
		/*  */
		this-object:ultraButtonNewColumn:Location = new System.Drawing.Point(2, 269).
		this-object:ultraButtonNewColumn:Name = "ultraButtonNewColumn".
		this-object:ultraButtonNewColumn:Size = new System.Drawing.Size(92, 23).
		this-object:ultraButtonNewColumn:TabIndex = 6.
		this-object:ultraButtonNewColumn:Text = "New Column".
		this-object:ultraButtonNewColumn:Click:subscribe(this-object:ultraButtonNewColumn_Click).
		/*  */
		/* ultraGridColumnChooser1 */
		/*  */
		this-object:ultraGridColumnChooser1:DisplayLayout:AutoFitStyle = Infragistics.Win.UltraWinGrid.AutoFitStyle:ResizeAllColumns.
		this-object:ultraGridColumnChooser1:DisplayLayout:CaptionVisible = Infragistics.Win.DefaultableBoolean:False.
		this-object:ultraGridColumnChooser1:DisplayLayout:MaxColScrollRegions = 1.
		this-object:ultraGridColumnChooser1:DisplayLayout:MaxRowScrollRegions = 1.
		this-object:ultraGridColumnChooser1:DisplayLayout:Override:AllowColMoving = Infragistics.Win.UltraWinGrid.AllowColMoving:NotAllowed.
		this-object:ultraGridColumnChooser1:DisplayLayout:Override:AllowColSizing = Infragistics.Win.UltraWinGrid.AllowColSizing:None.
		this-object:ultraGridColumnChooser1:DisplayLayout:Override:AllowRowLayoutCellSizing = Infragistics.Win.UltraWinGrid.RowLayoutSizing:None.
		this-object:ultraGridColumnChooser1:DisplayLayout:Override:AllowRowLayoutLabelSizing = Infragistics.Win.UltraWinGrid.RowLayoutSizing:None.
		this-object:ultraGridColumnChooser1:DisplayLayout:Override:CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction:RowSelect.
		this-object:ultraGridColumnChooser1:DisplayLayout:Override:CellPadding = 2.
		this-object:ultraGridColumnChooser1:DisplayLayout:Override:ExpansionIndicator = Infragistics.Win.UltraWinGrid.ShowExpansionIndicator:Never.
		this-object:ultraGridColumnChooser1:DisplayLayout:Override:HeaderClickAction = Infragistics.Win.UltraWinGrid.HeaderClickAction:Select.
		this-object:ultraGridColumnChooser1:DisplayLayout:Override:RowSelectors = Infragistics.Win.DefaultableBoolean:False.
		this-object:ultraGridColumnChooser1:DisplayLayout:Override:RowSizing = Infragistics.Win.UltraWinGrid.RowSizing:AutoFixed.
		this-object:ultraGridColumnChooser1:DisplayLayout:Override:SelectTypeCell = Infragistics.Win.UltraWinGrid.SelectType:None.
		this-object:ultraGridColumnChooser1:DisplayLayout:Override:SelectTypeCol = Infragistics.Win.UltraWinGrid.SelectType:None.
		this-object:ultraGridColumnChooser1:DisplayLayout:Override:SelectTypeRow = Infragistics.Win.UltraWinGrid.SelectType:None.
		this-object:ultraGridColumnChooser1:DisplayLayout:RowConnectorStyle = Infragistics.Win.UltraWinGrid.RowConnectorStyle:None.
		this-object:ultraGridColumnChooser1:DisplayLayout:ScrollBounds = Infragistics.Win.UltraWinGrid.ScrollBounds:ScrollToFill.
		this-object:ultraGridColumnChooser1:DisplayLayout:ScrollStyle = Infragistics.Win.UltraWinGrid.ScrollStyle:Immediate.
		this-object:ultraGridColumnChooser1:Location = new System.Drawing.Point(0, 23).
		this-object:ultraGridColumnChooser1:MultipleBandSupport = Infragistics.Win.UltraWinGrid.MultipleBandSupport:SingleBandOnly.
		this-object:ultraGridColumnChooser1:Name = "ultraGridColumnChooser1".
		this-object:ultraGridColumnChooser1:Size = new System.Drawing.Size(192, 244).
		this-object:ultraGridColumnChooser1:Style = Infragistics.Win.UltraWinGrid.ColumnChooserStyle:AllColumnsWithCheckBoxes.
		this-object:ultraGridColumnChooser1:StyleLibraryName = "".
		this-object:ultraGridColumnChooser1:StyleSetName = "".
		this-object:ultraGridColumnChooser1:TabIndex = 5.
		this-object:ultraGridColumnChooser1:Text = "ultraGridColumnChooser1".
		/*  */
		/* CustomColumnChooser */
		/*  */
		this-object:ClientSize = new System.Drawing.Size(192, 294).
		this-object:Controls:Add(this-object:ultraButtonDeleteColumn).
		this-object:Controls:Add(this-object:ultraButtonNewColumn).
		this-object:Controls:Add(this-object:ultraGridColumnChooser1).
		this-object:Controls:Add(this-object:ultraComboBandSelector).
		this-object:Name = "CustomColumnChooser".
		this-object:Text = "CustomColumnChooser".
		cast(this-object:ultraComboBandSelector, System.ComponentModel.ISupportInitialize):EndInit().
		cast(this-object:ultraGridColumnChooser1, System.ComponentModel.ISupportInitialize):EndInit().
		this-object:ResumeLayout(false).
		this-object:PerformLayout().

	end method.

    method private void InitializeBandsCombo(grid as Infragistics.Win.UltraWinGrid.UltraGridBase ):
		define variable bandsUDS as Infragistics.Win.UltraWinDataSource.UltraDataSource no-undo.
		define variable bands as Infragistics.Win.UltraWinGrid.BandsCollection no-undo.
		define variable oBand as Infragistics.Win.UltraWinGrid.UltraGridBand no-undo.
        define variable iBand as integer no-undo.
        define variable dsRow as Infragistics.Win.UltraWinDataSource.UltraDataRow no-undo.
                
		ultraComboBandSelector:SetDataBinding( ?, ? ).
		if not valid-object(grid) then
			return.

		/* Create the data source that we can bind to UltraCombo for displaying */
		/* list of bands. The datasource will have two columns. One that contains */ 
		/* the instances of UltraGridBand and the other that contains the text */
		/* representation of the bands. */
		bandsUDS = new Infragistics.Win.UltraWinDataSource.UltraDataSource().
		bandsUDS:Band:Columns:Add( "Band", Progress.Util.TypeHelper:GetType("Infragistics.Win.UltraWinGrid.UltraGridBand")).
		bandsUDS:Band:Columns:Add( "DisplayText", Progress.Util.TypeHelper:GetType("System.String")).

        bands = this-object:Grid:DisplayLayout:Bands.
		do iBand = 0 to bands:Count - 1:
		    oBand = cast(bands:getItem(iBand),Infragistics.Win.UltraWinGrid.UltraGridBand).
		    if this-object:IsBandExcluded(oBand) = false then
            do:
               dsRow = bandsUDS:Rows:Add().  
               dsRow:SetCellValue("Band",oBand).
               dsRow:SetCellValue("DisplayText",oband:Header:Caption).
            end. 
		end. 
         
		ultraComboBandSelector:DisplayMember = "DisplayText".
		ultraComboBandSelector:ValueMember= "Band".
		ultraComboBandSelector:SetDataBinding( bandsUDS, ? ).

		/* Hide the Band column. */
 		ultraComboBandSelector:DisplayLayout:Bands[0]:Columns["Band"]:Hidden = true. 
		
		/* Hide the column headers. */
		ultraComboBandSelector:DisplayLayout:Bands[0]:ColHeadersVisible = false.

		/* Set some properties to improve the look & feel of the ultra combo. */
		ultraComboBandSelector:DropDownWidth = 0.
		ultraComboBandSelector:DisplayLayout:Override:HotTrackRowAppearance:BackColor = System.Drawing.Color:LightYellow.
		ultraComboBandSelector:DisplayLayout:AutoFitStyle = Infragistics.Win.UltraWinGrid.AutoFitStyle:ResizeAllColumns.
		ultraComboBandSelector:DisplayLayout:BorderStyle = Infragistics.Win.UIElementBorderStyle:Solid.
		ultraComboBandSelector:DisplayLayout:Appearance:BorderColor = System.Drawing.SystemColors:Highlight.
	end method.
      
	method private logical IsBandExcluded(band as Infragistics.Win.UltraWinGrid.UltraGridBand):
	    do while valid-object(band):
			if Progress.Util.EnumHelper:AreEqual(Infragistics.Win.UltraWinGrid.ExcludeFromColumnChooser:True,band:ExcludeFromColumnChooser) then
				return true.

			band = band:ParentBand.
        end.
		return false.
	end method.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID ultraComboBandSelector_RowSelected( INPUT sender AS System.Object, INPUT e AS Infragistics.Win.UltraWinGrid.RowSelectedEventArgs ):
		define variable selectedBand as Infragistics.Win.UltraWinGrid.UltraGridBand no-undo. 
		if not valid-object(this-object:Grid) or this-object:Grid:IsDisposed then
			return.

		selectedBand = cast(ultraComboBandSelector:Value,Infragistics.Win.UltraWinGrid.UltraGridBand).
		if not valid-object(selectedBand) then
        do:			 
			System.Diagnostics.Debug:Assert( false ).
			selectedBand = Grid:DisplayLayout:Bands[0].
			ultraComboBandSelector:Value = selectedBand.
		end.

		ultraGridColumnChooser1:CurrentBand = selectedBand.
		
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID ultraButtonDeleteColumn_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		/* Delete the column that's currently selected in the column chooser control. */
		
        define variable gridColumn as Infragistics.Win.UltraWinGrid.UltraGridColumn no-undo.
        define variable dlgResult  as System.Windows.Forms.DialogResult  no-undo.
        
        gridColumn = cast(ultraGridColumnChooser1:CurrentSelectedItem,Infragistics.Win.UltraWinGrid.UltraGridColumn).
		
		if not valid-object(gridColumn) then
        do:
            System.Windows.Forms.MessageBox:Show( this-object, "Please select a column to delete.", this-object:Text, System.Windows.Forms.MessageBoxButtons:OK, System.Windows.Forms.MessageBoxIcon:Information ). 
  		    return.
        end.
             
		if gridColumn:IsBound then
		do:
            System.Windows.Forms.MessageBox:Show( this-object, "Only unbound columns can be deleted.", this-object:Text, System.Windows.Forms.MessageBoxButtons:OK, System.Windows.Forms.MessageBoxIcon:Information ). 
 			return.
		end.
    	dlgResult  = System.Windows.Forms.MessageBox:Show(this-object,                                                                                
		"Deleting " + gridColumn:Header:Caption + " column. Continue?",
		this-object:Text,
		System.Windows.Forms.MessageBoxButtons:OKCancel,
		System.Windows.Forms.MessageBoxIcon:Question).

 		if  Progress.Util.EnumHelper:AreEqual(System.Windows.Forms.DialogResult:OK,dlgResult) then   
			gridColumn:Band:Columns:Remove( gridColumn ).
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID ultraButtonNewColumn_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		define variable selectedBand as Infragistics.Win.UltraWinGrid.UltraGridBand no-undo.
	    define variable dlg          as NewColumnDialog no-undo. 
		selectedBand = ultraGridColumnChooser1:CurrentBand.
		if not valid-object(selectedBand) then
			return.
		session:system-alert-boxes = true.
		dlg = new NewColumnDialog().
		dlg:Band = selectedBand.
	  	wait-for dlg:ShowDialog().
		RETURN.

	END METHOD.


 

 

 	
END CLASS.