 /* 
ABL example derived from Infragistics source, copyright 1992-2008 Infragistics, 
Inc., Windsor Corporate Park, 50 Millstone Road, Building 200 Suite 150, East 
Windsor, NJ 08520. All rights reserved.
*/
 /*------------------------------------------------------------------------
    File        : frmAlphaBlend
    Purpose     : 
    Syntax      : 
    Description : 
    Author(s)   : hdaniels - copied/transformed from Infragistic sample
    Created     : Thu May 22 19:29:17 EDT 2008
    Notes       : 
  ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING Progress.Windows.Form.
using Utils.*.
using WinGrid.SamplesExplorer.*.

CLASS WinGrid.SamplesExplorer.frmAlphaBlend INHERITS Form implements ISamplesBase : 
	
	DEFINE PRIVATE VARIABLE components AS System.ComponentModel.IContainer.


	define public variable btnTitle as System.Windows.Forms.Button no-undo.
	define public variable tbrCellAlphaLevel as System.Windows.Forms.TrackBar no-undo.
	define public variable lblDescriptionParagraph2 as System.Windows.Forms.Label no-undo.
	define public variable Label1 as System.Windows.Forms.Label no-undo.
	define public variable Label2 as System.Windows.Forms.Label no-undo.
	define public variable tbrAlphaLevel as System.Windows.Forms.TrackBar no-undo.
	define public variable lblDescription as System.Windows.Forms.Label no-undo.

	 /* manual defs */
	define private variable fDeptEmployeeDataSource as DataServices.IDataService no-undo.

		/* Provides a description for the sample. */
	define public property Description as character no-undo 
	get:
	    return lblDescription:Text.
	end.
	
    /* Name of the sample. */
	define public property SampleName as character no-undo
    get:
        return btnTitle:Text. 
    end.
	
    /* Type of sample. */
	define public property SampleType as character  no-undo
	get:
	    return "Feature".
	end.    

	/* Preview Picture for Sample */
	define public property PreviewPicture as System.Drawing.Image no-undo
    get:
        return System.Drawing.Image:FromFile(SamplesPath:GraphicsPath + "/Previews/AlphaBlending.png").
    end.   
		

	define public variable UltraGrid1 as Infragistics.Win.UltraWinGrid.UltraGrid no-undo.
	CONSTRUCTOR PUBLIC frmAlphaBlend (  ):
		
		SUPER().
		SESSION:SYSTEM-alert-boxes = true.
		InitializeComponent ( ).
        InitializeForm().
	END CONSTRUCTOR.

	DESTRUCTOR PUBLIC frmAlphaBlend ( ):

		IF VALID-OBJECT(components) THEN DO:
			CAST(components, System.IDisposable):Dispose().
		END.

	END DESTRUCTOR.


	method private void InitializeComponent ( ):

/* 		NOTE: The following method is generated by the OpenEdge Advanced GUI Visual Designer.

		We strongly suggest that the contents of this method only be modified using the
		Visual Designer to avoid any incompatible modifications.

		Modifying the contents of this method using a code editor will invalidate any support for this file. */
  
		@VisualDesigner.FormMember (NeedsInitialize="true").
		define variable resources as System.Resources.ResXResourceSet no-undo.
		resources = Progress.Util.ResourceHelper:Load("WinGrid/SamplesExplorer/frmAlphaBlend.resx", PROPATH).
		this-object:btnTitle = new System.Windows.Forms.Button().
		this-object:tbrCellAlphaLevel = new System.Windows.Forms.TrackBar().
		this-object:lblDescriptionParagraph2 = new System.Windows.Forms.Label().
		this-object:Label1 = new System.Windows.Forms.Label().
		this-object:Label2 = new System.Windows.Forms.Label().
		this-object:tbrAlphaLevel = new System.Windows.Forms.TrackBar().
		this-object:lblDescription = new System.Windows.Forms.Label().
		this-object:UltraGrid1 = new Infragistics.Win.UltraWinGrid.UltraGrid().
		cast(this-object:tbrCellAlphaLevel, System.ComponentModel.ISupportInitialize):BeginInit().
		cast(this-object:tbrAlphaLevel, System.ComponentModel.ISupportInitialize):BeginInit().
		cast(this-object:UltraGrid1, System.ComponentModel.ISupportInitialize):BeginInit().
		this-object:SuspendLayout().
		/*  */
		/* btnTitle */
		/*  */
		this-object:btnTitle:Anchor = cast(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).
		this-object:btnTitle:FlatStyle = System.Windows.Forms.FlatStyle:Flat.
		this-object:btnTitle:Font = new System.Drawing.Font("Arial", 14.25, System.Drawing.FontStyle:Bold, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).
		this-object:btnTitle:Location = new System.Drawing.Point(4, 4).
		this-object:btnTitle:Name = "btnTitle".
		this-object:btnTitle:Size = new System.Drawing.Size(720, 32).
		this-object:btnTitle:TabIndex = 7.
		this-object:btnTitle:Text = "Alpha Blending ".
		this-object:btnTitle:TextAlign = System.Drawing.ContentAlignment:MiddleLeft.
		this-object:btnTitle:UseCompatibleTextRendering = true.
		this-object:btnTitle:Click:subscribe(this-object:btnTitle_Click).
		this-object:btnTitle:MouseUp:subscribe(this-object:btnTitle_MouseUp).
		/*  */
		/* tbrCellAlphaLevel */
		/*  */
		this-object:tbrCellAlphaLevel:AutoSize = false.
		this-object:tbrCellAlphaLevel:Location = new System.Drawing.Point(4, 124).
		this-object:tbrCellAlphaLevel:Name = "tbrCellAlphaLevel".
		this-object:tbrCellAlphaLevel:Size = new System.Drawing.Size(176, 42).
		this-object:tbrCellAlphaLevel:TabIndex = 9.
		this-object:tbrCellAlphaLevel:Scroll:subscribe(this-object:tbrCellAlphaLevel_Scroll).
		/*  */
		/* lblDescriptionParagraph2 */
		/*  */
		this-object:lblDescriptionParagraph2:Anchor = cast(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).
		this-object:lblDescriptionParagraph2:Location = new System.Drawing.Point(188, 108).
		this-object:lblDescriptionParagraph2:Name = "lblDescriptionParagraph2".
		this-object:lblDescriptionParagraph2:Size = new System.Drawing.Size(536, 56).
		this-object:lblDescriptionParagraph2:TabIndex = 13.
		this-object:lblDescriptionParagraph2:Text = "If Cell AlphaLevel is not changed from (default), it will inherit the Row AlphaLevel. Try Setting both to 60 (25% opacity).".
		this-object:lblDescriptionParagraph2:UseCompatibleTextRendering = true.
		/*  */
		/* Label1 */
		/*  */
		this-object:Label1:AutoSize = true.
		this-object:Label1:Location = new System.Drawing.Point(4, 48).
		this-object:Label1:Name = "Label1".
		this-object:Label1:Size = new System.Drawing.Size(177, 17).
		this-object:Label1:TabIndex = 11.
		this-object:Label1:Text = "Choose a Row/Global AlphaLevel:".
		this-object:Label1:UseCompatibleTextRendering = true.
		/*  */
		/* Label2 */
		/*  */
		this-object:Label2:AutoSize = true.
		this-object:Label2:Location = new System.Drawing.Point(4, 108).
		this-object:Label2:Name = "Label2".
		this-object:Label2:Size = new System.Drawing.Size(138, 17).
		this-object:Label2:TabIndex = 10.
		this-object:Label2:Text = "Choose a Cell AlphaLevel:".
		this-object:Label2:UseCompatibleTextRendering = true.
		/*  */
		/* tbrAlphaLevel */
		/*  */
		this-object:tbrAlphaLevel:AutoSize = false.
		this-object:tbrAlphaLevel:Location = new System.Drawing.Point(4, 64).
		this-object:tbrAlphaLevel:Name = "tbrAlphaLevel".
		this-object:tbrAlphaLevel:Size = new System.Drawing.Size(176, 42).
		this-object:tbrAlphaLevel:TabIndex = 8.
		this-object:tbrAlphaLevel:Scroll:subscribe(this-object:tbrAlphaLevel_Scroll).
		/*  */
		/* lblDescription */
		/*  */
		this-object:lblDescription:Anchor = cast(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).
		this-object:lblDescription:Location = new System.Drawing.Point(188, 40).
		this-object:lblDescription:Name = "lblDescription".
		this-object:lblDescription:Size = new System.Drawing.Size(536, 64).
		this-object:lblDescription:TabIndex = 12.
		this-object:lblDescription:Text = resources:GetString("lblDescription.Text").
		this-object:lblDescription:UseCompatibleTextRendering = true.
		/*  */
		/* UltraGrid1 */
		/*  */
		this-object:UltraGrid1:Anchor = cast(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).
		this-object:UltraGrid1:DisplayLayout:ScrollStyle = Infragistics.Win.UltraWinGrid.ScrollStyle:Immediate.
		this-object:UltraGrid1:Location = new System.Drawing.Point(4, 169).
		this-object:UltraGrid1:Name = "UltraGrid1".
		this-object:UltraGrid1:Size = new System.Drawing.Size(720, 280).
		this-object:UltraGrid1:TabIndex = 14.
		this-object:UltraGrid1:Text = "UltraWinGrid AlphaBlending".
		/*  */
		/* frmAlphaBlend */
		/*  */
		this-object:ClientSize = new System.Drawing.Size(728, 449).
		this-object:Controls:Add(this-object:UltraGrid1).
		this-object:Controls:Add(this-object:tbrCellAlphaLevel).
		this-object:Controls:Add(this-object:lblDescriptionParagraph2).
		this-object:Controls:Add(this-object:Label1).
		this-object:Controls:Add(this-object:Label2).
		this-object:Controls:Add(this-object:tbrAlphaLevel).
		this-object:Controls:Add(this-object:lblDescription).
		this-object:Controls:Add(this-object:btnTitle).
		this-object:Name = "frmAlphaBlend".
		this-object:Text = "AlphaBlend".
		this-object:Load:subscribe(this-object:frmAlphaBlend_Load).
		this-object:FormClosing:subscribe(this-object:frmAlphaBlend_FormClosing).
		cast(this-object:tbrCellAlphaLevel, System.ComponentModel.ISupportInitialize):EndInit().
		cast(this-object:tbrAlphaLevel, System.ComponentModel.ISupportInitialize):EndInit().
		cast(this-object:UltraGrid1, System.ComponentModel.ISupportInitialize):EndInit().
		this-object:ResumeLayout(false).
		this-object:PerformLayout().

	end method.



    method private void InitializeForm():
 		assign
 		    tbrCellAlphaLevel:Minimum = 1
 		    tbrAlphaLevel:Minimum = 1
		    tbrCellAlphaLevel:Maximum = 255 
		    tbrAlphaLevel:Maximum = 255
		    tbrAlphaLevel:Value = 255
		    tbrCellAlphaLevel:Value = 255.
		UltraGrid1:DataSource = GetDeptEmployeeSource(). 
		/*  Hide parent columns */
		UltraGrid1:DisplayLayout:Bands[1]:Columns["DeptCode"]:Hidden = true.
		UltraGrid1:DisplayLayout:Bands[2]:Columns["EmpNum"]:Hidden = true.   
    end method.
    
    method private void UpdateDisplay():
		define variable dl as Infragistics.Win.UltraWinGrid.UltraGridLayout no-undo.
		dl = UltraGrid1:DisplayLayout.	
		dl:Override:RowAppearance:AlphaLevel = GetAlphaLevel().
		dl:Override:HeaderAppearance:AlphaLevel = GetAlphaLevel().
		dl:Override:CellAppearance:AlphaLevel = GetCellAlphaLevel().
	end method.

	method private short GetAlphaLevel():
		return tbrAlphaLevel:Value.
	end method.

    method private short GetCellAlphaLevel():
		return tbrCellAlphaLevel:Value.
	end method.
     
    method protected Progress.Data.BindingSource GetDeptEmployeeSource():   
        if not valid-object(fDeptEmployeeDataSource) then
        do:
            fDeptEmployeeDataSource = new DataServices.DeptEmployeeService().                  
            fDeptEmployeeDataSource:fetchData().                                                 
        end.
        return new Progress.Data.BindingSource(fDeptEmployeeDataSource:DataSetHandle).
    end method. 
    
     /* implements ISamplesBase interface  */
    method public void ShowMe( owner as System.Windows.Forms.Form  ):
/*		InitializeForm().*/
	    if (owner <> ?) then
			this-object:Owner = owner.
		this-object:Show().
	    this-object:CancelButton = btnTitle.
        this-object:CenterToScreen(). 
		this-object:MaximizeBox = true.
	end.	

    /* implements ISamplesBase interface  */
    method public void HideMe( ):
        this-object:Hide().   
    end.
    
	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID btnTitle_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
        if valid-object(this-object:Owner) then
            HideMe().
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID frmAlphaBlend_Load( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		define variable dl as Infragistics.Win.UltraWinGrid.UltraGridLayout no-undo.
		dl = UltraGrid1:DisplayLayout.	
		dl:Appearance:ImageBackground = System.Drawing.Image:FromFile(SamplesPath:GraphicsPath + "/Backgrounds/nasa_eagle_wide.jpg").
		dl:Appearance:ImageBackgroundStyle = Infragistics.Win.ImageBackgroundStyle:Tiled.
		

		dl:Override:RowAppearance:BackColorAlpha = Infragistics.Win.Alpha:UseAlphaLevel.
        dl:Override:RowAppearance:ImageBackgroundAlpha = Infragistics.Win.Alpha:UseAlphaLevel.
        dl:Override:RowAppearance:BorderAlpha = Infragistics.Win.Alpha:UseAlphaLevel.
        dl:Override:RowAppearance:ImageAlpha = Infragistics.Win.Alpha:UseAlphaLevel.
        dl:Override:RowAppearance:ForegroundAlpha = Infragistics.Win.Alpha:UseAlphaLevel.

        /* Explicitly set these to maximize performance and minimize context switches */
        dl:Override:CellAppearance:BackColorAlpha = Infragistics.Win.Alpha:UseAlphaLevel.
        dl:Override:CellAppearance:ImageBackgroundAlpha = Infragistics.Win.Alpha:UseAlphaLevel.
        dl:Override:CellAppearance:BorderAlpha = Infragistics.Win.Alpha:UseAlphaLevel.
        dl:Override:CellAppearance:ImageAlpha = Infragistics.Win.Alpha:UseAlphaLevel.
        dl:Override:CellAppearance:ForegroundAlpha = Infragistics.Win.Alpha:UseAlphaLevel.

        /* Explicitly set these to maximize performance and minimize context switches */
        dl:Override:HeaderAppearance:BackColorAlpha = Infragistics.Win.Alpha:UseAlphaLevel.
        dl:Override:HeaderAppearance:ImageBackgroundAlpha = Infragistics.Win.Alpha:UseAlphaLevel.
        dl:Override:HeaderAppearance:BorderAlpha = Infragistics.Win.Alpha:UseAlphaLevel.
        dl:Override:HeaderAppearance:ImageAlpha = Infragistics.Win.Alpha:UseAlphaLevel.
        dl:Override:HeaderAppearance:ForegroundAlpha = Infragistics.Win.Alpha:UseAlphaLevel.

        dl:Override:CellPadding = 10.
        dl:Override:CellSpacing = 10.
        dl:Override:CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction:RowSelect.

        dl:RowConnectorStyle = Infragistics.Win.UltraWinGrid.RowConnectorStyle:Solid.
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID tbrAlphaLevel_Scroll( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		UpdateDisplay().
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID tbrCellAlphaLevel_Scroll( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		UpdateDisplay().
		RETURN.

	END METHOD.
	
	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID frmAlphaBlend_FormClosing( INPUT sender AS System.Object, INPUT e AS System.Windows.Forms.FormClosingEventArgs ):
		if valid-object(this-object:Owner) then 
	    do:
	        e:Cancel = true.
		    this-object:Visible = false.
		end.
		RETURN. 
	END METHOD.
	
	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID btnTitle_MouseUp( INPUT sender AS System.Object, INPUT e AS System.Windows.Forms.MouseEventArgs ):
		if valid-object(this-object:Owner) then
		    (cast (this-object:Owner,frmMain)):Navigation(e:Button).
		RETURN.

	END METHOD.
 
END CLASS.