/* 
ABL example derived from Infragistics source, copyright 1992-2008 Infragistics, 
Inc., Windsor Corporate Park, 50 Millstone Road, Building 200 Suite 150, East 
Windsor, NJ 08520. All rights reserved.
*/ 
 /*------------------------------------------------------------------------
    File        : frmUltraDropDown
    Purpose     : 
    Syntax      : 
    Description : 
    Author(s)   : hdaniels - copied/transformed from Infragistic sample
    Created     : Mon May 19 14:57:19 EDT 2008
    Notes       : 
  ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING Progress.Windows.Form.

using WinGrid.SamplesExplorer.*. 

CLASS WinGrid.SamplesExplorer.frmUltraDropDown INHERITS Form implements ISamplesBase : 
	
	DEFINE PRIVATE VARIABLE components AS System.ComponentModel.IContainer.


		
	CONSTRUCTOR PUBLIC frmUltraDropDown (  ):
		
		SUPER().
		InitializeComponent ( ).
        InitializeDataSources().
	END CONSTRUCTOR.

	DESTRUCTOR PUBLIC frmUltraDropDown ( ):

		IF VALID-OBJECT(components) THEN DO:
			CAST(components, System.IDisposable):Dispose().
		END.

	END DESTRUCTOR.

	define public variable btnTitle as System.Windows.Forms.Button no-undo.


	define public variable Panel1 as System.Windows.Forms.Panel no-undo.
	define public variable chkEnableAlphaBlending as System.Windows.Forms.CheckBox no-undo.
	define public variable lblDescription as System.Windows.Forms.Label no-undo.
    
    /** manual code */
    define private variable fCustOrderBindingSource as Progress.Data.BindingSource no-undo.    
    define private variable fCustOrderDataSource as DataServices.IDataService no-undo.
  
    define private variable fItemBindingSource as Progress.Data.BindingSource no-undo.    
    define private variable fItemDataSource as DataServices.IDataService no-undo.
    
    	/* Provides a description for the sample. */
	define public property Description as character no-undo 
	get:
	    return lblDescription:Text.
	end.
	
    /* Name of the sample. */
	define public property SampleName as character no-undo
    get:
        return btnTitle:Text. 
    end.
	
    /* Type of sample. */
	define public property SampleType as character no-undo
	get:
	    return "Feature".
	end.    

	/* Preview Picture for Sample */
	define public property PreviewPicture as System.Drawing.Image no-undo
    get:
        /* TODO: store path in static */
        return System.Drawing.Image:FromFile(SamplesPath:GraphicsPath + "/Previews/GRID.png").
    end.   


	define public variable ultraGrid1 as Infragistics.Win.UltraWinGrid.UltraGrid no-undo.
	define public variable UltraDropDown1 as Infragistics.Win.UltraWinGrid.UltraDropDown no-undo.


	method private void InitializeComponent ( ):

/* 		NOTE: The following method is generated by the OpenEdge Advanced GUI Visual Designer.

		We strongly suggest that the contents of this method only be modified using the
		Visual Designer to avoid any incompatible modifications.

		Modifying the contents of this method using a code editor will invalidate any support for this file. */

		this-object:Panel1 = new System.Windows.Forms.Panel().
		this-object:chkEnableAlphaBlending = new System.Windows.Forms.CheckBox().
		this-object:lblDescription = new System.Windows.Forms.Label().
		this-object:btnTitle = new System.Windows.Forms.Button().
		this-object:ultraGrid1 = new Infragistics.Win.UltraWinGrid.UltraGrid().
		this-object:UltraDropDown1 = new Infragistics.Win.UltraWinGrid.UltraDropDown().
		this-object:Panel1:SuspendLayout().
		cast(this-object:ultraGrid1, System.ComponentModel.ISupportInitialize):BeginInit().
		cast(this-object:UltraDropDown1, System.ComponentModel.ISupportInitialize):BeginInit().
		this-object:SuspendLayout().
		/*  */
		/* Panel1 */
		/*  */
		this-object:Panel1:Controls:Add(this-object:chkEnableAlphaBlending).
		this-object:Panel1:Controls:Add(this-object:lblDescription).
		this-object:Panel1:Controls:Add(this-object:btnTitle).
		this-object:Panel1:Dock = System.Windows.Forms.DockStyle:Top.
		this-object:Panel1:Location = new System.Drawing.Point(0, 0).
		this-object:Panel1:Name = "Panel1".
		this-object:Panel1:Size = new System.Drawing.Size(790, 112).
		this-object:Panel1:TabIndex = 23.
		/*  */
		/* chkEnableAlphaBlending */
		/*  */
		this-object:chkEnableAlphaBlending:Location = new System.Drawing.Point(9, 75).
		this-object:chkEnableAlphaBlending:Name = "chkEnableAlphaBlending".
		this-object:chkEnableAlphaBlending:Size = new System.Drawing.Size(122, 28).
		this-object:chkEnableAlphaBlending:TabIndex = 15.
		this-object:chkEnableAlphaBlending:Text = "AlphaBlending".
		this-object:chkEnableAlphaBlending:UseCompatibleTextRendering = true.
		this-object:chkEnableAlphaBlending:CheckedChanged:subscribe(this-object:chkEnableAlphaBlending_CheckedChanged).
		/*  */
		/* lblDescription */
		/*  */
		this-object:lblDescription:Dock = System.Windows.Forms.DockStyle:Top.
		this-object:lblDescription:Location = new System.Drawing.Point(0, 37).
		this-object:lblDescription:Name = "lblDescription".
		this-object:lblDescription:Size = new System.Drawing.Size(790, 28).
		this-object:lblDescription:TabIndex = 14.
		this-object:lblDescription:Text = "Demonstrates how the UltraDropDown control can be used to provide the end user with multi-column dropdown lists. Hover Mouse over 'Item' column on the third band.".
		this-object:lblDescription:UseCompatibleTextRendering = true.
		/*  */
		/* btnTitle */
		/*  */
		this-object:btnTitle:Dock = System.Windows.Forms.DockStyle:Top.
		this-object:btnTitle:FlatStyle = System.Windows.Forms.FlatStyle:Flat.
		this-object:btnTitle:Font = new System.Drawing.Font("Arial", 14.25, System.Drawing.FontStyle:Bold, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).
		this-object:btnTitle:Location = new System.Drawing.Point(0, 0).
		this-object:btnTitle:Name = "btnTitle".
		this-object:btnTitle:Size = new System.Drawing.Size(790, 37).
		this-object:btnTitle:TabIndex = 13.
		this-object:btnTitle:Text = "UltraDropDown Control ".
		this-object:btnTitle:TextAlign = System.Drawing.ContentAlignment:MiddleLeft.
		this-object:btnTitle:UseCompatibleTextRendering = true.
		this-object:btnTitle:Click:subscribe(this-object:btnTitle_Click).
		this-object:btnTitle:MouseUp:subscribe(this-object:btnTitle_MouseUp).
		/*  */
		/* ultraGrid1 */
		/*  */
		this-object:ultraGrid1:Anchor = cast(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).
		this-object:ultraGrid1:DisplayLayout:AddNewBox:Hidden = false.
		this-object:ultraGrid1:Location = new System.Drawing.Point(0, 118).
		this-object:ultraGrid1:Name = "ultraGrid1".
		this-object:ultraGrid1:Size = new System.Drawing.Size(790, 349).
		this-object:ultraGrid1:TabIndex = 24.
		this-object:ultraGrid1:Text = "UltraGrid1".
		this-object:ultraGrid1:InitializeLayout:subscribe(this-object:ultraGrid1_InitializeLayout).
		/*  */
		/* UltraDropDown1 */
		/*  */
		this-object:UltraDropDown1:Location = new System.Drawing.Point(26, 208).
		this-object:UltraDropDown1:Name = "UltraDropDown1".
		this-object:UltraDropDown1:Size = new System.Drawing.Size(424, 80).
		this-object:UltraDropDown1:TabIndex = 16.
		this-object:UltraDropDown1:Visible = false.
		/*  */
		/* frmUltraDropDown */
		/*  */
		this-object:ClientSize = new System.Drawing.Size(790, 494).
		this-object:Controls:Add(this-object:UltraDropDown1).
		this-object:Controls:Add(this-object:ultraGrid1).
		this-object:Controls:Add(this-object:Panel1).
		this-object:Name = "frmUltraDropDown".
		this-object:Text = "UltraDropDown".
		this-object:Load:subscribe(this-object:frmUltraDropDown_Load).
		this-object:FormClosing:subscribe(this-object:frmUltraDropDown_FormClosing).
		this-object:Panel1:ResumeLayout(false).
		cast(this-object:ultraGrid1, System.ComponentModel.ISupportInitialize):EndInit().
		cast(this-object:UltraDropDown1, System.ComponentModel.ISupportInitialize):EndInit().
		this-object:ResumeLayout(false).

	end method.


    method private void InitializeDataSources():   
        fCustOrderDataSource = new DataServices.CustOrderService().                  
        fCustOrderDataSource:fetchData().                                                 
       
        fCustOrderBindingSource = new Progress.Data.BindingSource().
        fCustOrderBindingSource:Handle = fCustOrderDataSource:DataSetHandle. 
        
        fItemDataSource = new DataServices.ItemService().                  
        fItemDataSource:fetchData().                                                 
       
        fItemBindingSource = new Progress.Data.BindingSource().
        fItemBindingSource:Handle = fItemDataSource:DataSetHandle.          
    end.   
   
    method private void ConfigureUltraDropDown():
		 
		/*   Set the UltraDropDown control//s DataSource */
	 	UltraDropDown1:DataSource = fItemBindingSource.
 
		/*   Hide columns */
		UltraDropDown1:DisplayLayout:Bands[0]:Columns["ItemNum"]:Hidden = true.
		UltraDropDown1:DisplayLayout:Bands[0]:Columns["OnOrder"]:Hidden = true.
	    UltraDropDown1:DisplayLayout:Bands[0]:Columns["Category1"]:Hidden = true.
	    UltraDropDown1:DisplayLayout:Bands[0]:Columns["Allocated"]:Hidden = true.

		/*   Adjust the column widths */
		UltraDropDown1:DisplayLayout:Bands[0]:Columns["ItemName"]:Width = 200.
		UltraDropDown1:DisplayLayout:Bands[0]:Columns["CatDescription"]:Width = 300.


		/*   Set the Format property of the Price column  */
		UltraDropDown1:DisplayLayout:Bands[0]:Columns["Price"]:Format = "#,###,###.00".

		/*   Set the ValueMember property to the ItemNum field of the products */
		/*   table. The ValueMember property specifies the column in the UltraDropDown control */
		/*   that will supply the value to the UltraGrid cell, analogous to a ValueListItem//s DataValue */
		UltraDropDown1:ValueMember = "ItemNum".

		/*   Set the DisplayMember property to the Name field of the products */
		/*   table. The DisplayMember property specifies the column in the UltraDropDown control */
		/*   that will supply the display text to the UltraGrid cell, analogous to a ValueListItem//s DisplayText */
		UltraDropDown1:DisplayMember = "ItemName".

		/*   Assign the column's ValueList property to this instance of the UltraDropDown control. Note that */
		/*   from the grid's perspective, the UltraDropDown control appears to be a ValueList */
		ultraGrid1:DisplayLayout:Bands[2]:Columns["ItemNum"]:ValueList = UltraDropDown1.

    end method.	 

     /* implements ISamplesBase interface  */
    method public void ShowMe( owner as System.Windows.Forms.Form  ):
/*		InitializeForm().*/
	    if (owner <> ?) then
			this-object:Owner = owner.
		this-object:Show().
	    this-object:CancelButton = btnTitle.
        this-object:CenterToScreen().
		this-object:MaximizeBox = true.
	end.	

    /* implements ISamplesBase interface  */
    method public void HideMe( ):
        this-object:Hide().   
    end.
    
	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID btnTitle_MouseUp( INPUT sender AS System.Object, INPUT e AS System.Windows.Forms.MouseEventArgs ):	
		if valid-object(this-object:Owner) then
		    (cast (this-object:Owner,frmMain)):Navigation(e:Button).
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID btnTitle_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
        if valid-object(this-object:Owner) then
            HideMe().
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID frmUltraDropDown_Load( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		define variable oRow as Infragistics.Win.UltraWinGrid.UltraGridRow no-undo.
		
		/* Hide the grid caption by setting the Text to empty string.*/
		ultraGrid1:Text = "".

		ultraGrid1:DataSource = fCustOrderBindingSource.
		ultraGrid1:AlphaBlendMode = Infragistics.Win.AlphaBlendMode:Disabled.

		/*   Configure the UltraDropDown control to display Products */
		/*   when the user clicks the dropdown arrow in the //Products// cell in */
		/*   the InvoiceDetails band */
 		ConfigureUltraDropDown(). 

		/*   Expand the first row in the grid */
		oRow = ultraGrid1:GetRow(Infragistics.Win.UltraWinGrid.ChildRow:First).
		oRow:Expanded = true.

		/*   Make the first row's first child the active row */
		oRow = oRow:GetChild(Infragistics.Win.UltraWinGrid.ChildRow:First).
		if not valid-object(oRow) then
			return.

		ultraGrid1:ActiveRow = oRow.

		/*   Add a new row to the InvoiceDetails band */
		ultraGrid1:DisplayLayout:Bands[2]:AddNew().
		
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID ultraGrid1_InitializeLayout( INPUT sender AS System.Object, INPUT e AS Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs ):
		
		/*  Hide some key and parent columns */
		e:Layout:Bands[1]:Columns["CustNum"]:Hidden = true.

		e:Layout:Bands[2]:Columns["OrderNum"]:Hidden = true.
		
		e:Layout:Bands[2]:Columns["LineNum"]:Hidden = true.
		
		/*  Display the ItemNum column. We will use an UltraDropDown control */
		/*  so that the user can see the product name, price and */
		/*  category description as well */
		e:Layout:Bands[2]:Columns["ItemNum"]:Header:VisiblePosition = 0.
		e:Layout:Bands[2]:Columns["ItemNum"]:Header:Caption = "Item".

		/*   Make the column a little wider so the item name can be displayed */
		e:Layout:Bands[2]:Columns["ItemNum"]:Width = 200.
		
		/*   Set the Format property of the Price columns  */
 		e:Layout:Bands[2]:Columns["Price"]:Format = "#,###,###.00".         
		e:Layout:Bands[2]:Columns["ExtendedPrice"]:Format = "#,###,###.00".	
		
		/*   Set the Format property of the Discount column  */
/* 		e:Layout:Bands[2]:Columns["Discount"]:Format = "00%".*/
	 	 
		e:Layout:Override:RowAppearance:AlphaLevel = 192.
		e:Layout:Override:RowAppearance:BackColorAlpha = Infragistics.Win.Alpha:UseAlphaLevel.

		/* use the same appearance for alternate rows and the autopreview area */
		e:Layout:Override:RowAlternateAppearance = e:Layout:Override:RowAppearance.
		e:Layout:Override:RowPreviewAppearance:BackColor = System.Drawing.SystemColors:Window.
		e:Layout:Override:RowPreviewAppearance:ForeColor = System.Drawing.SystemColors:WindowText.

		e:Layout:Override:CellAppearance:BackColorAlpha = Infragistics.Win.Alpha:UseAlphaLevel.
		e:Layout:Override:CellAppearance:AlphaLevel = 192.

		e:Layout:Override:HeaderAppearance:AlphaLevel = 192.
		e:Layout:Override:HeaderAppearance:BackColorAlpha = Infragistics.Win.Alpha:UseAlphaLevel. 
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID chkEnableAlphaBlending_CheckedChanged( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		/*	enable/disable alphablending */
		if chkEnableAlphaBlending:Checked then
        do: 
		    /*string strGraphicsPath = clsSamplesPath.GraphicsPath; */
			ultraGrid1:DisplayLayout:Appearance:ImageBackground = System.Drawing.Image:FromFile(SamplesPath:GraphicsPath + "/Backgrounds/globe.jpg").
			ultraGrid1:DisplayLayout:Appearance:ImageBackgroundOrigin = Infragistics.Win.ImageBackgroundOrigin:Form.
			ultraGrid1:DisplayLayout:Appearance:ImageBackgroundStyle = Infragistics.Win.ImageBackgroundStyle:Tiled.
            ultraGrid1:AlphaBlendMode = Infragistics.Win.AlphaBlendMode:Optimized.
		end.
		else 
		do:
			ultraGrid1:AlphaBlendMode = Infragistics.Win.AlphaBlendMode:Disabled.
			ultraGrid1:DisplayLayout:Appearance:ImageBackground = ?.
		end.	
		RETURN.

	END METHOD.
	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID frmUltraDropDown_FormClosing( INPUT sender AS System.Object, INPUT e AS System.Windows.Forms.FormClosingEventArgs ):
		if valid-object(this-object:Owner) then 
	    do:
	        e:Cancel = true.
		    this-object:Visible = false.
		end.
		RETURN.

	END METHOD.


 


 
 
END CLASS.