 /* 
ABL example derived from Infragistics source, copyright 1992-2008 Infragistics, 
Inc., Windsor Corporate Park, 50 Millstone Road, Building 200 Suite 150, East 
Windsor, NJ 08520. All rights reserved.
*/
 /*------------------------------------------------------------------------
    File        : frmValueLists
    Purpose     : 
    Syntax      : 
    Description : 
    Author(s)   : hdaniels - copied/transformed from Infragistic sample
    Created     : Wed May 14 18:32:04 EDT 2008
    Notes       : 
  ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING Progress.Windows.Form.

using WinGrid.SamplesExplorer.*.

CLASS WinGrid.SamplesExplorer.frmValueLists INHERITS Form implements ISamplesBase : 
	
	DEFINE PRIVATE VARIABLE components AS System.ComponentModel.IContainer.


	define public variable btnTitle as System.Windows.Forms.Button no-undo.


	define public variable lblDescription as System.Windows.Forms.Label no-undo.
	define public variable chkEnableAlphaBlending as System.Windows.Forms.CheckBox no-undo.
	define public variable chkUseValueLists as System.Windows.Forms.CheckBox no-undo.
		

	define public variable gridValueLists as Infragistics.Win.UltraWinGrid.UltraGrid no-undo.

	define public variable imgSpaceLines as System.Windows.Forms.ImageList no-undo.
	
	/** manual properties */
   	define private variable fSpaceShipData as DataServices.IDataService no-undo.
    define private variable fBindingSourceSpaceShip as Progress.Data.BindingSource no-undo.    
 
	/** ISamplesBase properties */
	
	/* Provides a description for the sample. */
	define public property Description as character no-undo 
	get:
	    return lblDescription:Text.
	end.
	
    /* Name of the sample. */
	define public property SampleName as character no-undo
    get:
        return btnTitle:Text. 
    end.
	
    /* Type of sample. */
	define public property SampleType as character no-undo
	get:
	    return "Feature".
	end.    

	/* Preview Picture for Sample */
	define public property PreviewPicture as System.Drawing.Image no-undo
    get:
        /* TODO: store path in static */
        return System.Drawing.Image:FromFile( SamplesPath:GraphicsPath + "/Previews/GRID.png").
    end.     
	
	
	CONSTRUCTOR PUBLIC frmValueLists (  ):
		
		SUPER().
		InitializeComponent ( ).
        InitializeDataSources().
	END CONSTRUCTOR.

	DESTRUCTOR PUBLIC frmValueLists ( ):

		IF VALID-OBJECT(components) THEN DO:
			CAST(components, System.IDisposable):Dispose().
		END.

	END DESTRUCTOR.

	method private void InitializeComponent ( ):

/* 		NOTE: The following method is generated by the OpenEdge Advanced GUI Visual Designer.

		We strongly suggest that the contents of this method only be modified using the
		Visual Designer to avoid any incompatible modifications.

		Modifying the contents of this method using a code editor will invalidate any support for this file. */

		this-object:components = new System.ComponentModel.Container().
		@VisualDesigner.FormMember (NeedsInitialize="true").
		define variable resources as System.Resources.ResXResourceSet no-undo.
		resources = Progress.Util.ResourceHelper:Load("WinGrid/SamplesExplorer/frmValueLists.resx", PROPATH).
		this-object:btnTitle = new System.Windows.Forms.Button().
		this-object:lblDescription = new System.Windows.Forms.Label().
		this-object:chkEnableAlphaBlending = new System.Windows.Forms.CheckBox().
		this-object:chkUseValueLists = new System.Windows.Forms.CheckBox().
		this-object:gridValueLists = new Infragistics.Win.UltraWinGrid.UltraGrid().
		this-object:imgSpaceLines = new System.Windows.Forms.ImageList(this-object:components).
		cast(this-object:gridValueLists, System.ComponentModel.ISupportInitialize):BeginInit().
		this-object:SuspendLayout().
		/*  */
		/* btnTitle */
		/*  */
		this-object:btnTitle:Dock = System.Windows.Forms.DockStyle:Top.
		this-object:btnTitle:FlatStyle = System.Windows.Forms.FlatStyle:Flat.
		this-object:btnTitle:Font = new System.Drawing.Font("Arial", 14.25, System.Drawing.FontStyle:Bold, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).
		this-object:btnTitle:Location = new System.Drawing.Point(0, 0).
		this-object:btnTitle:Name = "btnTitle".
		this-object:btnTitle:Size = new System.Drawing.Size(667, 32).
		this-object:btnTitle:TabIndex = 14.
		this-object:btnTitle:Text = "ValueLists".
		this-object:btnTitle:TextAlign = System.Drawing.ContentAlignment:MiddleLeft.
		this-object:btnTitle:UseCompatibleTextRendering = true.
		this-object:btnTitle:Click:subscribe(this-object:btnTitle_Click).
		this-object:btnTitle:MouseUp:subscribe(this-object:btnTitle_MouseUp).
		/*  */
		/* lblDescription */
		/*  */
		this-object:lblDescription:Dock = System.Windows.Forms.DockStyle:Top.
		this-object:lblDescription:Location = new System.Drawing.Point(0, 32).
		this-object:lblDescription:Name = "lblDescription".
		this-object:lblDescription:Size = new System.Drawing.Size(667, 40).
		this-object:lblDescription:TabIndex = 15.
		this-object:lblDescription:Text = "Demonstrates ValueLists. Value lists can be used to provide drop-down selection of pre-determined items from the cells in a particular column.".
		this-object:lblDescription:UseCompatibleTextRendering = true.
		/*  */
		/* chkEnableAlphaBlending */
		/*  */
		this-object:chkEnableAlphaBlending:Location = new System.Drawing.Point(8, 80).
		this-object:chkEnableAlphaBlending:Name = "chkEnableAlphaBlending".
		this-object:chkEnableAlphaBlending:Size = new System.Drawing.Size(104, 24).
		this-object:chkEnableAlphaBlending:TabIndex = 16.
		this-object:chkEnableAlphaBlending:Text = "AlphaBlending".
		this-object:chkEnableAlphaBlending:UseCompatibleTextRendering = true.
		this-object:chkEnableAlphaBlending:CheckedChanged:subscribe(this-object:chkEnableAlphaBlending_CheckedChanged).
		/*  */
		/* chkUseValueLists */
		/*  */
		this-object:chkUseValueLists:Location = new System.Drawing.Point(120, 80).
		this-object:chkUseValueLists:Name = "chkUseValueLists".
		this-object:chkUseValueLists:Size = new System.Drawing.Size(112, 24).
		this-object:chkUseValueLists:TabIndex = 17.
		this-object:chkUseValueLists:Text = "Use ValueLists".
		this-object:chkUseValueLists:UseCompatibleTextRendering = true.
		this-object:chkUseValueLists:CheckedChanged:subscribe(this-object:chkUseValueLists_CheckedChanged).
		/*  */
		/* gridValueLists */
		/*  */
		this-object:gridValueLists:Anchor = cast(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).
		this-object:gridValueLists:DisplayLayout:ScrollStyle = Infragistics.Win.UltraWinGrid.ScrollStyle:Immediate.
		this-object:gridValueLists:Location = new System.Drawing.Point(0, 110).
		this-object:gridValueLists:Name = "gridValueLists".
		this-object:gridValueLists:Size = new System.Drawing.Size(672, 250).
		this-object:gridValueLists:TabIndex = 22.
		this-object:gridValueLists:InitializeLayout:subscribe(this-object:gridValueLists_InitializeLayout).
		/*  */
		/* imgSpaceLines */
		/*  */
		this-object:imgSpaceLines:ImageStream = cast(resources:GetObject("imgSpaceLines.ImageStream"), System.Windows.Forms.ImageListStreamer).
		this-object:imgSpaceLines:TransparentColor = System.Drawing.Color:Black.
		this-object:imgSpaceLines:Images:SetKeyName(0, "").
		this-object:imgSpaceLines:Images:SetKeyName(1, "").
		this-object:imgSpaceLines:Images:SetKeyName(2, "").
		this-object:imgSpaceLines:Images:SetKeyName(3, "").
		this-object:imgSpaceLines:Images:SetKeyName(4, "").
		this-object:imgSpaceLines:Images:SetKeyName(5, "").
		/*  */
		/* frmValueLists */
		/*  */
		this-object:ClientSize = new System.Drawing.Size(667, 354).
		this-object:Controls:Add(this-object:gridValueLists).
		this-object:Controls:Add(this-object:chkUseValueLists).
		this-object:Controls:Add(this-object:chkEnableAlphaBlending).
		this-object:Controls:Add(this-object:lblDescription).
		this-object:Controls:Add(this-object:btnTitle).
		this-object:Name = "frmValueLists".
		this-object:Text = "frmValueLists".
		this-object:Load:subscribe(this-object:frmValueLists_Load).
		this-object:FormClosing:subscribe(this-object:frmValueLists_FormClosing).
		cast(this-object:gridValueLists, System.ComponentModel.ISupportInitialize):EndInit().
		this-object:ResumeLayout(false).

	end method.

    /* implements ISamplesBase interface  */
    method public void ShowMe( owner as System.Windows.Forms.Form  ):
 	    if (owner <> ?) then
			this-object:Owner = owner.
		this-object:Show().
	    this-object:CancelButton = btnTitle.
        this-object:CenterToScreen().
		this-object:MaximizeBox = true.
	end.	

    /* implements ISamplesBase interface  */
    method public void HideMe( ):
        this-object:Hide().   
    end.
      
    method private void InitializeDataSources():  
        fSpaceShipData = new DataServices.SpaceFlightData().                  
        fSpaceShipData:fetchData().                                           
 
        fBindingSourceSpaceShip = new Progress.Data.BindingSource().
        fBindingSourceSpaceShip:Handle = fSpaceShipData:DataSetHandle.        
    end. 
    
    method private void PopulateSpacePortsValueList():
	    define variable lists as Infragistics.Win.ValueListsCollection no-undo.
		define variable valueList as Infragistics.Win.ValueList no-undo.
		
        if (gridValueLists:DisplayLayout:ValueLists:Exists("SpacePorts") ) then
			return.
         
		lists = gridValueLists:DisplayLayout:ValueLists.   
		valueList = fSpaceShipData:ValueList("eSpacePort","SpacePortId","SpacePortName").
        valueList:Key = "SpacePorts".  
        lists:Add(valueList).
    end method.    

    method private void PopulateStatusValueList():
	    define variable lists as Infragistics.Win.ValueListsCollection no-undo.
		define variable valueList as Infragistics.Win.ValueList no-undo.
		
        if (gridValueLists:DisplayLayout:ValueLists:Exists("Status") ) then
			return.
         
		lists = gridValueLists:DisplayLayout:ValueLists.
		valueList = fSpaceShipData:ValueList("eStatus","StatusId","StatusDesc").
        valueList:Key = "Status".  
        lists:Add(valueList).
    end method.  
    
    method private void PopulateSpacelinesValueList():
	    define variable lists as Infragistics.Win.ValueListsCollection no-undo.
		define variable valueList as Infragistics.Win.ValueList no-undo.
		define variable i as int no-undo.
        
        if (gridValueLists:DisplayLayout:ValueLists:Exists("Status") ) then
			return.
         
		lists = gridValueLists:DisplayLayout:ValueLists.       
		valueList = fSpaceShipData:ValueList("eSpaceLine","SpaceLineId","SpaceLineName").
        valueList:Key = "SpaceLines".
        
        do i = 0 to valueList:ValueListItems:count - 1:
            valueList:ValueListItems[i]:Appearance:Image = imgSpaceLines:Images[i].
		end.  
        lists:Add(valueList).
    end method.    
    

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID gridValueLists_InitializeLayout( INPUT sender AS System.Object, INPUT e AS Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs ):
		e:Layout:Bands[0]:Columns["FlightID"]:Hidden = true.

        e:Layout:Override:RowAppearance:AlphaLevel = 150.
        e:Layout:Override:RowAppearance:BackColorAlpha = Infragistics.Win.Alpha:UseAlphaLevel.

        /*	use the same appearance for alternate rows and the autopreview area */
        e:Layout:Override:RowAlternateAppearance = e:Layout:Override:RowAppearance.
        e:Layout:Override:RowPreviewAppearance:BackColor = System.Drawing.SystemColors:Window.
        e:Layout:Override:RowPreviewAppearance:ForeColor = System.Drawing.SystemColors:WindowText.

        e:Layout:Override:CellAppearance:BackColorAlpha = Infragistics.Win.Alpha:UseAlphaLevel.
        e:Layout:Override:CellAppearance:AlphaLevel = 150.

        e:Layout:Override:HeaderAppearance:AlphaLevel = 150.
        e:Layout:Override:HeaderAppearance:BackColorAlpha = Infragistics.Win.Alpha:UseAlphaLevel.

		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID btnTitle_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
        if valid-object(this-object:Owner) then
            HideMe().
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD Protected VOID chkUseValueLists_CheckedChanged( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
	 
        if chkUseValueLists:Checked then 
        do:
            gridValueLists:DisplayLayout:Bands[0]:Columns["SpacelineID"]:ValueList = gridValueLists:DisplayLayout:ValueLists["Spacelines"].
            gridValueLists:DisplayLayout:Bands[0]:Columns["SpacelineID"]:Width = 200.
            gridValueLists:DisplayLayout:Bands[0]:Columns["SpacelineID"]:Header:Caption = "Spaceline".

			gridValueLists:DisplayLayout:Bands[0]:Columns["DepartureSpacePortID"]:ValueList = gridValueLists:DisplayLayout:ValueLists["SpacePorts"].
            gridValueLists:DisplayLayout:Bands[0]:Columns["DepartureSpacePortID"]:Width = 200.
            gridValueLists:DisplayLayout:Bands[0]:Columns["DepartureSpacePortID"]:Header:Caption = "Departure SpacePort".

			gridValueLists:DisplayLayout:Bands[0]:Columns["ArrivalSpacePortID"]:ValueList = gridValueLists:DisplayLayout:ValueLists["SpacePorts"].
            gridValueLists:DisplayLayout:Bands[0]:Columns["ArrivalSpacePortID"]:Width = 200.
            gridValueLists:DisplayLayout:Bands[0]:Columns["ArrivalSpacePortID"]:Header:Caption = "Arrival SpacePort".

			gridValueLists:DisplayLayout:Bands[0]:Columns["StatusId"]:ValueList = gridValueLists:DisplayLayout:ValueLists["Status"].

			gridValueLists:ActiveRow = gridValueLists:GetRow(Infragistics.Win.UltraWinGrid.ChildRow:First).
			gridValueLists:ActiveCell = gridValueLists:ActiveRow:Cells["SpacelineID"].
			gridValueLists:PerformAction(Infragistics.Win.UltraWinGrid.UltraGridAction:EnterEditModeAndDropdown, false, false).

		end.
		else
        do:
            gridValueLists:DisplayLayout:Bands[0]:Columns["SpacelineID"]:ValueList = ?.
            gridValueLists:DisplayLayout:Bands[0]:Columns["SpacelineID"]:Width = 100.
            gridValueLists:DisplayLayout:Bands[0]:Columns["SpacelineID"]:Header:Caption = gridValueLists:DisplayLayout:Bands[0]:Columns["SpacelineID"]:Key.

			gridValueLists:DisplayLayout:Bands[0]:Columns["DepartureSpacePortID"]:ValueList = ?.
            gridValueLists:DisplayLayout:Bands[0]:Columns["DepartureSpacePortID"]:Width = 100.
            gridValueLists:DisplayLayout:Bands[0]:Columns["DepartureSpacePortID"]:Header:Caption = gridValueLists:DisplayLayout:Bands[0]:Columns["DepartureSpacePortID"]:Key.

			gridValueLists:DisplayLayout:Bands[0]:Columns["ArrivalSpacePortID"]:ValueList = ?.
            gridValueLists:DisplayLayout:Bands[0]:Columns["ArrivalSpacePortID"]:Width = 100.
            gridValueLists:DisplayLayout:Bands[0]:Columns["ArrivalSpacePortID"]:Header:Caption = gridValueLists:DisplayLayout:Bands[0]:Columns["ArrivalSpacePortID"]:Key.

			gridValueLists:DisplayLayout:Bands[0]:Columns["StatusId"]:ValueList = ?.
	    end.
		 
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID frmValueLists_Load( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		/*   Set the grid properties */
		gridValueLists:Text = "".
		gridValueLists:DataSource = fBindingSourceSpaceShip.
		gridValueLists:DisplayLayout:Bands[0]:Columns["eta"]:Style = Infragistics.Win.UltraWinGrid.ColumnStyle:Time.
	    gridValueLists:DisplayLayout:Bands[0]:Columns["etd"]:Style = Infragistics.Win.UltraWinGrid.ColumnStyle:Time.
	    gridValueLists:AlphaBlendMode = Infragistics.Win.AlphaBlendMode:Disabled.
	    
	    /* Set up the value lists */
		PopulateSpacelinesValueList().
		PopulateStatusValueList().
		PopulateSpacePortsValueList().
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID chkEnableAlphaBlending_CheckedChanged( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		/*	enable/disable alphablending */
		if chkEnableAlphaBlending:Checked then
        do: 
		    /*string strGraphicsPath = clsSamplesPath.GraphicsPath; */
			gridValueLists:DisplayLayout:Appearance:ImageBackground = System.Drawing.Image:FromFile(SamplesPath:GraphicsPath + "/Backgrounds/nasa_saturn_montage.jpg").
			gridValueLists:DisplayLayout:Appearance:ImageBackgroundOrigin = Infragistics.Win.ImageBackgroundOrigin:Form.
			gridValueLists:DisplayLayout:Appearance:ImageBackgroundStyle = Infragistics.Win.ImageBackgroundStyle:Tiled.
            gridValueLists:AlphaBlendMode = Infragistics.Win.AlphaBlendMode:Optimized.
		end.
		else 
		do:
			gridValueLists:AlphaBlendMode = Infragistics.Win.AlphaBlendMode:Disabled.
			gridValueLists:DisplayLayout:Appearance:ImageBackground = ?.
		end.		
		RETURN.

	END METHOD.
	
	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID frmValueLists_FormClosing( INPUT sender AS System.Object, INPUT e AS System.Windows.Forms.FormClosingEventArgs ):
		if valid-object(this-object:Owner) then 
	    do:
	        e:Cancel = true.
		    this-object:Visible = false.
		end.
		RETURN.

	END METHOD.
	
	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID btnTitle_MouseUp( INPUT sender AS System.Object, INPUT e AS System.Windows.Forms.MouseEventArgs ):
		if valid-object(this-object:Owner) then
		    (cast (this-object:Owner,frmMain)):Navigation(e:Button).
		RETURN.
	END METHOD.

END CLASS.