/* 
ABL example derived from Infragistics source, copyright 1992-2008 Infragistics, 
Inc., Windsor Corporate Park, 50 Millstone Road, Building 200 Suite 150, East 
Windsor, NJ 08520. All rights reserved.
*/ 
 /*------------------------------------------------------------------------
    File        : frmViewStyles
    Purpose     : 
    Syntax      : 
    Description : 
    Author(s)   : hdaniels - copied/transformed from Infragistic sample
    Created     : Mon May 26 16:00:40 EDT 2008
    Notes       : 
  ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING Progress.Windows.Form.

using WinGrid.SamplesExplorer.*.

CLASS WinGrid.SamplesExplorer.frmViewStyles INHERITS Form implements ISamplesBase : 
	
	DEFINE PRIVATE VARIABLE components AS System.ComponentModel.IContainer.


	define private variable chkMergedCells as System.Windows.Forms.CheckBox no-undo.
	define private variable chkGroupByBoxCompactStyle as System.Windows.Forms.CheckBox no-undo.
	define private variable groupBox1 as System.Windows.Forms.GroupBox no-undo.
	define private variable chkBand2CardView as System.Windows.Forms.CheckBox no-undo.
	define private variable chkBand1CardView as System.Windows.Forms.CheckBox no-undo.
	define private variable chkBand0CardView as System.Windows.Forms.CheckBox no-undo.
	define private variable ultraGrid1 as Infragistics.Win.UltraWinGrid.UltraGrid no-undo.
	define public variable chkBackground as System.Windows.Forms.CheckBox no-undo.
	define public variable btnColor4 as System.Windows.Forms.Button no-undo.
	define public variable btnColor3 as System.Windows.Forms.Button no-undo.
	define public variable btnColor2 as System.Windows.Forms.Button no-undo.
	define public variable grpViewStyle as System.Windows.Forms.GroupBox no-undo.
	define public variable optMultiBand as System.Windows.Forms.RadioButton no-undo.
	define public variable optSingleBand as System.Windows.Forms.RadioButton no-undo.
	define public variable btnTitle as System.Windows.Forms.Button no-undo.
	define public variable lblDescription as System.Windows.Forms.Label no-undo.
	define public variable chkSpacing as System.Windows.Forms.CheckBox no-undo.
	define public variable chkBorders as System.Windows.Forms.CheckBox no-undo.
	define public variable grpViewStyleBand as System.Windows.Forms.GroupBox no-undo.
	define public variable optOutlookGroupBy as System.Windows.Forms.RadioButton no-undo.
	define public variable optVertical as System.Windows.Forms.RadioButton no-undo.
	define public variable optHorizontal as System.Windows.Forms.RadioButton no-undo.
	define public variable btnColor1 as System.Windows.Forms.Button no-undo.
	define public variable chkAlphaBlend as System.Windows.Forms.CheckBox no-undo.
	define public variable chkColors as System.Windows.Forms.CheckBox no-undo.
	define public variable lblDescriptionParagraph2 as System.Windows.Forms.Label no-undo.
    
    /* manual defs */
	define private variable fDeptEmployeeDataSource as DataServices.IDataService no-undo.

	/* Provides a description for the sample. */
	define public property Description as character no-undo 
	get:
	    return lblDescription:Text.
	end.
	
    /* Name of the sample. */
	define public property SampleName as character no-undo
    get:
        return btnTitle:Text. 
    end.
	
    /* Type of sample. */
	define public property SampleType as character no-undo
	get:
	    return "Feature".
	end.    

	/* Preview Picture for Sample */
	define public property PreviewPicture as System.Drawing.Image no-undo
    get:
        return System.Drawing.Image:FromFile( SamplesPath:GraphicsPath + "/Previews/ViewStyles.png").
    end.   
    
    define private property DisplayHorizontal as logical no-undo
	get:  
	    return optHorizontal:Checked.
	end.

	define private property DisplayVertical  as logical no-undo
	get:  
	    return optVertical:Checked.
	end.
	
	define private property DisplayOutlookGroupBy  as logical no-undo
	get:  
	    return optOutlookGroupBy:Checked.
	end.
	
	define private property DisplaySingleBand  as logical no-undo
	get:  
	    return optSingleBand:Checked.
	end.
	
	define private property DisplayMultiBand  as logical no-undo
	get:  
	    return optMultiBand:Checked.
	end.
	 
	CONSTRUCTOR PUBLIC frmViewStyles (  ):
		
		SUPER().
		session:system-alert-boxes = true.
		InitializeComponent ( ).
        InitializeForm().
        
	END CONSTRUCTOR.

	DESTRUCTOR PUBLIC frmViewStyles ( ):

		IF VALID-OBJECT(components) THEN DO:
			CAST(components, System.IDisposable):Dispose().
		END.

	END DESTRUCTOR.

	

























	method private void InitializeComponent ( ):

/* 		NOTE: The following method is generated by the OpenEdge Advanced GUI Visual Designer.

		We strongly suggest that the contents of this method only be modified using the
		Visual Designer to avoid any incompatible modifications.

		Modifying the contents of this method using a code editor will invalidate any support for this file. */

		this-object:chkMergedCells = new System.Windows.Forms.CheckBox().
		this-object:chkGroupByBoxCompactStyle = new System.Windows.Forms.CheckBox().
		this-object:groupBox1 = new System.Windows.Forms.GroupBox().
		this-object:chkBand2CardView = new System.Windows.Forms.CheckBox().
		this-object:chkBand1CardView = new System.Windows.Forms.CheckBox().
		this-object:chkBand0CardView = new System.Windows.Forms.CheckBox().
		this-object:ultraGrid1 = new Infragistics.Win.UltraWinGrid.UltraGrid().
		this-object:chkBackground = new System.Windows.Forms.CheckBox().
		this-object:btnColor4 = new System.Windows.Forms.Button().
		this-object:btnColor3 = new System.Windows.Forms.Button().
		this-object:btnColor2 = new System.Windows.Forms.Button().
		this-object:grpViewStyle = new System.Windows.Forms.GroupBox().
		this-object:optMultiBand = new System.Windows.Forms.RadioButton().
		this-object:optSingleBand = new System.Windows.Forms.RadioButton().
		this-object:btnTitle = new System.Windows.Forms.Button().
		this-object:lblDescription = new System.Windows.Forms.Label().
		this-object:chkSpacing = new System.Windows.Forms.CheckBox().
		this-object:chkBorders = new System.Windows.Forms.CheckBox().
		this-object:grpViewStyleBand = new System.Windows.Forms.GroupBox().
		this-object:optOutlookGroupBy = new System.Windows.Forms.RadioButton().
		this-object:optVertical = new System.Windows.Forms.RadioButton().
		this-object:optHorizontal = new System.Windows.Forms.RadioButton().
		this-object:btnColor1 = new System.Windows.Forms.Button().
		this-object:chkAlphaBlend = new System.Windows.Forms.CheckBox().
		this-object:chkColors = new System.Windows.Forms.CheckBox().
		this-object:lblDescriptionParagraph2 = new System.Windows.Forms.Label().
		this-object:groupBox1:SuspendLayout().
		cast(this-object:ultraGrid1, System.ComponentModel.ISupportInitialize):BeginInit().
		this-object:grpViewStyle:SuspendLayout().
		this-object:grpViewStyleBand:SuspendLayout().
		this-object:SuspendLayout().
		/*  */
		/* chkMergedCells */
		/*  */
		this-object:chkMergedCells:Location = new System.Drawing.Point(16, 146).
		this-object:chkMergedCells:Name = "chkMergedCells".
		this-object:chkMergedCells:Size = new System.Drawing.Size(112, 16).
		this-object:chkMergedCells:TabIndex = 29.
		this-object:chkMergedCells:Text = "Merged Cells".
		this-object:chkMergedCells:UseCompatibleTextRendering = true.
		this-object:chkMergedCells:CheckedChanged:subscribe(this-object:chkMergedCells_CheckedChanged).
		/*  */
		/* chkGroupByBoxCompactStyle */
		/*  */
		this-object:chkGroupByBoxCompactStyle:Location = new System.Drawing.Point(144, 146).
		this-object:chkGroupByBoxCompactStyle:Name = "chkGroupByBoxCompactStyle".
		this-object:chkGroupByBoxCompactStyle:Size = new System.Drawing.Size(144, 16).
		this-object:chkGroupByBoxCompactStyle:TabIndex = 28.
		this-object:chkGroupByBoxCompactStyle:Text = "Compact Group By Box".
		this-object:chkGroupByBoxCompactStyle:UseCompatibleTextRendering = true.
		this-object:chkGroupByBoxCompactStyle:CheckedChanged:subscribe(this-object:chkGroupByBoxCompactStyle_CheckedChanged).
		/*  */
		/* groupBox1 */
		/*  */
		this-object:groupBox1:Controls:Add(this-object:chkBand2CardView).
		this-object:groupBox1:Controls:Add(this-object:chkBand1CardView).
		this-object:groupBox1:Controls:Add(this-object:chkBand0CardView).
		this-object:groupBox1:Location = new System.Drawing.Point(288, 42).
		this-object:groupBox1:Name = "groupBox1".
		this-object:groupBox1:Size = new System.Drawing.Size(96, 96).
		this-object:groupBox1:TabIndex = 27.
		this-object:groupBox1:TabStop = false.
		this-object:groupBox1:Text = "CardView".
		this-object:groupBox1:UseCompatibleTextRendering = true.
		/*  */
		/* chkBand2CardView */
		/*  */
		this-object:chkBand2CardView:Location = new System.Drawing.Point(24, 64).
		this-object:chkBand2CardView:Name = "chkBand2CardView".
		this-object:chkBand2CardView:Size = new System.Drawing.Size(64, 16).
		this-object:chkBand2CardView:TabIndex = 2.
		this-object:chkBand2CardView:Text = "Band 2".
		this-object:chkBand2CardView:UseCompatibleTextRendering = true.
		this-object:chkBand2CardView:CheckedChanged:subscribe(this-object:chkBand2CardView_CheckedChanged).
		/*  */
		/* chkBand1CardView */
		/*  */
		this-object:chkBand1CardView:Location = new System.Drawing.Point(16, 40).
		this-object:chkBand1CardView:Name = "chkBand1CardView".
		this-object:chkBand1CardView:Size = new System.Drawing.Size(72, 16).
		this-object:chkBand1CardView:TabIndex = 1.
		this-object:chkBand1CardView:Text = "Band 1".
		this-object:chkBand1CardView:UseCompatibleTextRendering = true.
		this-object:chkBand1CardView:CheckedChanged:subscribe(this-object:chkBand1CardView_CheckedChanged).
		/*  */
		/* chkBand0CardView */
		/*  */
		this-object:chkBand0CardView:Location = new System.Drawing.Point(8, 16).
		this-object:chkBand0CardView:Name = "chkBand0CardView".
		this-object:chkBand0CardView:Size = new System.Drawing.Size(80, 16).
		this-object:chkBand0CardView:TabIndex = 0.
		this-object:chkBand0CardView:Text = "Band 0".
		this-object:chkBand0CardView:UseCompatibleTextRendering = true.
		this-object:chkBand0CardView:CheckedChanged:subscribe(this-object:chkBand0CardView_CheckedChanged).
		/*  */
		/* ultraGrid1 */
		/*  */
		this-object:ultraGrid1:Anchor = cast(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).
		this-object:ultraGrid1:Location = new System.Drawing.Point(4, 170).
		this-object:ultraGrid1:Name = "ultraGrid1".
		this-object:ultraGrid1:Size = new System.Drawing.Size(700, 240).
		this-object:ultraGrid1:TabIndex = 26.
		this-object:ultraGrid1:Text = "ViewStyles".
		/*  */
		/* chkBackground */
		/*  */
		this-object:chkBackground:Location = new System.Drawing.Point(392, 102).
		this-object:chkBackground:Name = "chkBackground".
		this-object:chkBackground:Size = new System.Drawing.Size(96, 16).
		this-object:chkBackground:TabIndex = 20.
		this-object:chkBackground:Text = "Background".
		this-object:chkBackground:UseCompatibleTextRendering = true.
		this-object:chkBackground:CheckedChanged:subscribe(this-object:chkBackground_CheckedChanged).
		/*  */
		/* btnColor4 */
		/*  */
		this-object:btnColor4:Location = new System.Drawing.Point(368, 146).
		this-object:btnColor4:Name = "btnColor4".
		this-object:btnColor4:Size = new System.Drawing.Size(16, 16).
		this-object:btnColor4:TabIndex = 13.
		this-object:btnColor4:UseCompatibleTextRendering = true.
		this-object:btnColor4:Click:subscribe(this-object:btnColor4_Click).
		/*  */
		/* btnColor3 */
		/*  */
		this-object:btnColor3:Location = new System.Drawing.Point(344, 146).
		this-object:btnColor3:Name = "btnColor3".
		this-object:btnColor3:Size = new System.Drawing.Size(16, 16).
		this-object:btnColor3:TabIndex = 15.
		this-object:btnColor3:UseCompatibleTextRendering = true.
		this-object:btnColor3:Click:subscribe(this-object:btnColor3_Click).
		/*  */
		/* btnColor2 */
		/*  */
		this-object:btnColor2:Location = new System.Drawing.Point(320, 146).
		this-object:btnColor2:Name = "btnColor2".
		this-object:btnColor2:Size = new System.Drawing.Size(16, 16).
		this-object:btnColor2:TabIndex = 14.
		this-object:btnColor2:UseCompatibleTextRendering = true.
		this-object:btnColor2:Click:subscribe(this-object:btnColor2_Click).
		/*  */
		/* grpViewStyle */
		/*  */
		this-object:grpViewStyle:Controls:Add(this-object:optMultiBand).
		this-object:grpViewStyle:Controls:Add(this-object:optSingleBand).
		this-object:grpViewStyle:Location = new System.Drawing.Point(4, 42).
		this-object:grpViewStyle:Name = "grpViewStyle".
		this-object:grpViewStyle:Size = new System.Drawing.Size(128, 96).
		this-object:grpViewStyle:TabIndex = 25.
		this-object:grpViewStyle:TabStop = false.
		this-object:grpViewStyle:Text = "ViewStyle".
		this-object:grpViewStyle:UseCompatibleTextRendering = true.
		/*  */
		/* optMultiBand */
		/*  */
		this-object:optMultiBand:Location = new System.Drawing.Point(24, 40).
		this-object:optMultiBand:Name = "optMultiBand".
		this-object:optMultiBand:Size = new System.Drawing.Size(96, 24).
		this-object:optMultiBand:TabIndex = 0.
		this-object:optMultiBand:Text = "Multi-Band".
		this-object:optMultiBand:UseCompatibleTextRendering = true.
		this-object:optMultiBand:CheckedChanged:subscribe(this-object:optMultiBand_CheckedChanged).
		/*  */
		/* optSingleBand */
		/*  */
		this-object:optSingleBand:Location = new System.Drawing.Point(24, 16).
		this-object:optSingleBand:Name = "optSingleBand".
		this-object:optSingleBand:Size = new System.Drawing.Size(96, 24).
		this-object:optSingleBand:TabIndex = 0.
		this-object:optSingleBand:Text = "Single Band".
		this-object:optSingleBand:UseCompatibleTextRendering = true.
		this-object:optSingleBand:CheckedChanged:subscribe(this-object:optSingleBand_CheckedChanged).
		/*  */
		/* btnTitle */
		/*  */
		this-object:btnTitle:Anchor = cast(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).
		this-object:btnTitle:FlatStyle = System.Windows.Forms.FlatStyle:Flat.
		this-object:btnTitle:Font = new System.Drawing.Font("Arial", 14.25, System.Drawing.FontStyle:Bold, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).
		this-object:btnTitle:Location = new System.Drawing.Point(4, 6).
		this-object:btnTitle:Name = "btnTitle".
		this-object:btnTitle:Size = new System.Drawing.Size(700, 32).
		this-object:btnTitle:TabIndex = 24.
		this-object:btnTitle:Text = "View Styles ".
		this-object:btnTitle:TextAlign = System.Drawing.ContentAlignment:MiddleLeft.
		this-object:btnTitle:UseCompatibleTextRendering = true.
		this-object:btnTitle:Click:subscribe(this-object:btnTitle_Click).
		this-object:btnTitle:MouseUp:subscribe(this-object:btnTitle_MouseUp).
		/*  */
		/* lblDescription */
		/*  */
		this-object:lblDescription:Anchor = cast(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).
		this-object:lblDescription:Location = new System.Drawing.Point(496, 42).
		this-object:lblDescription:Name = "lblDescription".
		this-object:lblDescription:Size = new System.Drawing.Size(208, 64).
		this-object:lblDescription:TabIndex = 22.
		this-object:lblDescription:Text = "This sample demontrates the ViewStyle and ViewStyleBand properties.".
		this-object:lblDescription:UseCompatibleTextRendering = true.
		/*  */
		/* chkSpacing */
		/*  */
		this-object:chkSpacing:Location = new System.Drawing.Point(392, 50).
		this-object:chkSpacing:Name = "chkSpacing".
		this-object:chkSpacing:Size = new System.Drawing.Size(96, 16).
		this-object:chkSpacing:TabIndex = 18.
		this-object:chkSpacing:Text = "Spacing".
		this-object:chkSpacing:UseCompatibleTextRendering = true.
		this-object:chkSpacing:CheckedChanged:subscribe(this-object:chkSpacing_CheckedChanged).
		/*  */
		/* chkBorders */
		/*  */
		this-object:chkBorders:Location = new System.Drawing.Point(392, 76).
		this-object:chkBorders:Name = "chkBorders".
		this-object:chkBorders:Size = new System.Drawing.Size(96, 16).
		this-object:chkBorders:TabIndex = 21.
		this-object:chkBorders:Text = "Borders".
		this-object:chkBorders:UseCompatibleTextRendering = true.
		this-object:chkBorders:CheckedChanged:subscribe(this-object:chkBorders_CheckedChanged).
		/*  */
		/* grpViewStyleBand */
		/*  */
		this-object:grpViewStyleBand:Controls:Add(this-object:optOutlookGroupBy).
		this-object:grpViewStyleBand:Controls:Add(this-object:optVertical).
		this-object:grpViewStyleBand:Controls:Add(this-object:optHorizontal).
		this-object:grpViewStyleBand:Location = new System.Drawing.Point(140, 42).
		this-object:grpViewStyleBand:Name = "grpViewStyleBand".
		this-object:grpViewStyleBand:Size = new System.Drawing.Size(144, 96).
		this-object:grpViewStyleBand:TabIndex = 17.
		this-object:grpViewStyleBand:TabStop = false.
		this-object:grpViewStyleBand:Text = "ViewStyleBand".
		this-object:grpViewStyleBand:UseCompatibleTextRendering = true.
		/*  */
		/* optOutlookGroupBy */
		/*  */
		this-object:optOutlookGroupBy:Location = new System.Drawing.Point(24, 64).
		this-object:optOutlookGroupBy:Name = "optOutlookGroupBy".
		this-object:optOutlookGroupBy:Size = new System.Drawing.Size(112, 24).
		this-object:optOutlookGroupBy:TabIndex = 0.
		this-object:optOutlookGroupBy:Text = "Outlook GroupBy".
		this-object:optOutlookGroupBy:UseCompatibleTextRendering = true.
		this-object:optOutlookGroupBy:Click:subscribe(this-object:optOutlookGroupBy_Click).
		/*  */
		/* optVertical */
		/*  */
		this-object:optVertical:Location = new System.Drawing.Point(24, 40).
		this-object:optVertical:Name = "optVertical".
		this-object:optVertical:Size = new System.Drawing.Size(96, 24).
		this-object:optVertical:TabIndex = 0.
		this-object:optVertical:Text = "Vertical".
		this-object:optVertical:UseCompatibleTextRendering = true.
		this-object:optVertical:Click:subscribe(this-object:optVertical_Click).
		/*  */
		/* optHorizontal */
		/*  */
		this-object:optHorizontal:Location = new System.Drawing.Point(24, 16).
		this-object:optHorizontal:Name = "optHorizontal".
		this-object:optHorizontal:Size = new System.Drawing.Size(96, 24).
		this-object:optHorizontal:TabIndex = 0.
		this-object:optHorizontal:Text = "Horizontal".
		this-object:optHorizontal:UseCompatibleTextRendering = true.
		this-object:optHorizontal:Click:subscribe(this-object:optHorizontal_Click).
		/*  */
		/* btnColor1 */
		/*  */
		this-object:btnColor1:Location = new System.Drawing.Point(296, 146).
		this-object:btnColor1:Name = "btnColor1".
		this-object:btnColor1:Size = new System.Drawing.Size(16, 16).
		this-object:btnColor1:TabIndex = 12.
		this-object:btnColor1:UseCompatibleTextRendering = true.
		this-object:btnColor1:Click:subscribe(this-object:btnColor1_Click).
		/*  */
		/* chkAlphaBlend */
		/*  */
		this-object:chkAlphaBlend:Location = new System.Drawing.Point(392, 128).
		this-object:chkAlphaBlend:Name = "chkAlphaBlend".
		this-object:chkAlphaBlend:Size = new System.Drawing.Size(96, 16).
		this-object:chkAlphaBlend:TabIndex = 19.
		this-object:chkAlphaBlend:Text = "AlphaBlending".
		this-object:chkAlphaBlend:UseCompatibleTextRendering = true.
		this-object:chkAlphaBlend:CheckedChanged:subscribe(this-object:chkAlphaBlend_CheckedChanged).
		/*  */
		/* chkColors */
		/*  */
		this-object:chkColors:Location = new System.Drawing.Point(392, 154).
		this-object:chkColors:Name = "chkColors".
		this-object:chkColors:Size = new System.Drawing.Size(80, 16).
		this-object:chkColors:TabIndex = 16.
		this-object:chkColors:Text = "Colors".
		this-object:chkColors:UseCompatibleTextRendering = true.
		this-object:chkColors:CheckedChanged:subscribe(this-object:chkColors_CheckedChanged).
		/*  */
		/* lblDescriptionParagraph2 */
		/*  */
		this-object:lblDescriptionParagraph2:Anchor = cast(Progress.Util.EnumHelper:Or(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).
		this-object:lblDescriptionParagraph2:Location = new System.Drawing.Point(496, 114).
		this-object:lblDescriptionParagraph2:Name = "lblDescriptionParagraph2".
		this-object:lblDescriptionParagraph2:Size = new System.Drawing.Size(208, 56).
		this-object:lblDescriptionParagraph2:TabIndex = 23.
		this-object:lblDescriptionParagraph2:UseCompatibleTextRendering = true.
		/*  */
		/* frmViewStyles */
		/*  */
		this-object:ClientSize = new System.Drawing.Size(708, 417).
		this-object:Controls:Add(this-object:chkMergedCells).
		this-object:Controls:Add(this-object:chkGroupByBoxCompactStyle).
		this-object:Controls:Add(this-object:groupBox1).
		this-object:Controls:Add(this-object:ultraGrid1).
		this-object:Controls:Add(this-object:chkBackground).
		this-object:Controls:Add(this-object:btnColor4).
		this-object:Controls:Add(this-object:btnColor3).
		this-object:Controls:Add(this-object:btnColor2).
		this-object:Controls:Add(this-object:grpViewStyle).
		this-object:Controls:Add(this-object:btnTitle).
		this-object:Controls:Add(this-object:lblDescription).
		this-object:Controls:Add(this-object:chkSpacing).
		this-object:Controls:Add(this-object:chkBorders).
		this-object:Controls:Add(this-object:grpViewStyleBand).
		this-object:Controls:Add(this-object:btnColor1).
		this-object:Controls:Add(this-object:chkAlphaBlend).
		this-object:Controls:Add(this-object:chkColors).
		this-object:Controls:Add(this-object:lblDescriptionParagraph2).
		this-object:Name = "frmViewStyles".
		this-object:Text = "ViewStyles".
		this-object:FormClosing:subscribe(this-object:frmViewStyles_FormClosing).
		this-object:groupBox1:ResumeLayout(false).
		cast(this-object:ultraGrid1, System.ComponentModel.ISupportInitialize):EndInit().
		this-object:grpViewStyle:ResumeLayout(false).
		this-object:grpViewStyleBand:ResumeLayout(false).
		this-object:ResumeLayout(false).

	end method.


    method private void InitializeForm():
        assign
    		optSingleBand:Checked = true
    		optOutlookGroupBy:Checked = true
    		chkAlphaBlend:Checked = false
    		chkBackground:Checked = false
    		chkBorders:Checked = false
    		chkColors:Checked = false
    		chkSpacing:Checked = false
    
    		btnColor1:BackColor = System.Drawing.Color:LightBlue
    		btnColor1:Enabled = false
    		btnColor2:BackColor = System.Drawing.Color:NavajoWhite
    		btnColor2:Enabled = false
    		btnColor3:BackColor = System.Drawing.Color:Thistle
    		btnColor3:Enabled = false
    		btnColor4:BackColor = System.Drawing.Color:LightCoral
    		btnColor4:Enabled = false.

		ultraGrid1:DataSource = GetDeptEmployeeSource().

		UpdateDisplay().
	end method.
	
	method private void UpdateDisplay():
	    define variable dl as Infragistics.Win.UltraWinGrid.UltraGridLayout no-undo.
	    
	    dl = ultraGrid1:DisplayLayout.

		/* Group by box only makes sense if the view style is outlook group by. */
		if optOutlookGroupBy:Checked then
		    chkGroupByBoxCompactStyle:Enabled = true.
		else
		    chkGroupByBoxCompactStyle:Enabled = false.

		if DisplayMultiBand then
			dl:ViewStyle = Infragistics.Win.UltraWinGrid.ViewStyle:MultiBand.
		else
			dl:ViewStyle = Infragistics.Win.UltraWinGrid.ViewStyle:SingleBand.
		
		if DisplayHorizontal then
            dl:ViewStyleBand = Infragistics.Win.UltraWinGrid.ViewStyleBand:Horizontal.
        else if DisplayVertical then
            dl:ViewStyleBand = Infragistics.Win.UltraWinGrid.ViewStyleBand:Vertical.
        else
		    dl:ViewStyleBand = Infragistics.Win.UltraWinGrid.ViewStyleBand:OutlookGroupBy.
        
        InitializeBandProperties(dl:ViewStyle).
		UpdateCardViewOptions(dl).
	end method.
	
	method private void InitializeBandProperties( mode as Infragistics.Win.UltraWinGrid.ViewStyle):
		define variable bands as Infragistics.Win.UltraWinGrid.BandsCollection no-undo.
		define variable bandColumns as Infragistics.Win.UltraWinGrid.ColumnsCollection no-undo.
        define variable oBand as Infragistics.Win.UltraWinGrid.UltraGridBand no-undo.
        define variable oColumn as Infragistics.Win.UltraWinGrid.UltraGridColumn no-undo.
        define variable iBand as integer no-undo.
        define variable iColumn as integer no-undo.
        define variable dl as Infragistics.Win.UltraWinGrid.UltraGridLayout no-undo.
	    
	    dl = ultraGrid1:DisplayLayout.
        
		/* first, make sure all columns are visible */
		bands = dl:Bands.
		do iBand = 0 to bands:Count - 1:
		    oBand = cast(bands:getItem(iBand),Infragistics.Win.UltraWinGrid.UltraGridBand).
		    bandColumns = oBand:Columns.
		    do iColumn = 0 to bandColumns:Count - 1:
		        oColumn = cast(bandColumns:getItem(iColumn),Infragistics.Win.UltraWinGrid.UltraGridColumn).
		        oColumn:Hidden = false.
		    end.
		end.
		/* then hide the columns we do not need. */
		if Progress.Util.EnumHelper:AreEqual(mode,Infragistics.Win.UltraWinGrid.ViewStyle:SingleBand) then
		do:
			/* do nothing */
		end.
		else if Progress.Util.EnumHelper:AreEqual(mode,Infragistics.Win.UltraWinGrid.ViewStyle:MultiBand) then
		do:
			if Progress.Util.EnumHelper:AreEqual(dl:ViewStyleBand,Infragistics.Win.UltraWinGrid.ViewStyleBand:Horizontal) then
		    do:
 				dl:Bands[0]:Columns[0]:Hidden = true.                   
                
                bandColumns = dl:Bands[1]:Columns.
                do iColumn = 0 to bandColumns:Count - 1:
		            oColumn = cast(bandColumns:getItem(iColumn),Infragistics.Win.UltraWinGrid.UltraGridColumn).		           
		            if not oColumn:Hidden and not (ocolumn:Key matches "*name") then
		                oColumn:Hidden = true.
		        end.
		        
		        bandColumns = dl:Bands[2]:Columns.
                do iColumn = 2 to bandColumns:Count - 1:
		            oColumn = cast(bandColumns:getItem(iColumn),Infragistics.Win.UltraWinGrid.UltraGridColumn).
		            oColumn:Hidden = true.
		        end.
			end.
		end.
	end method.
	
	method protected void UpdateCardViewOptions(dl as Infragistics.Win.UltraWinGrid.UltraGridLayout):
		if Progress.Util.EnumHelper:AreEqual(dl:ViewStyle,Infragistics.Win.UltraWinGrid.ViewStyle:MultiBand) then
        do:
		    assign
			    chkBand0CardView:Enabled = true
			    chkBand1CardView:Enabled = true
			    chkBand2CardView:Enabled = true.
			    
			if (not dl:Bands[0]:Expandable) or dl:Bands[0]:CardView then
            do:
                assign
				    chkBand1CardView:Enabled = false
				    chkBand2CardView:Enabled = false.
			end.
			else if (not dl:Bands[1]:Expandable) or dl:Bands[1]:CardView then
				chkBand2CardView:Enabled = false.
		end.
		else
		do:	
			assign
                chkBand1CardView:Enabled = false
			    chkBand2CardView:Enabled = false.
		end.
	end method.
	
    method private void SetCardView(bandIndex as int, showCards as log):
		ultraGrid1:DisplayLayout:Bands[bandIndex]:CardView = showCards.
		UpdateCardViewOptions(ultraGrid1:DisplayLayout).
	end method.	

	method private void SetAppearanceUseAlpha( app as Infragistics.Win.AppearanceBase, alphaLevel as int, useAlpha as Infragistics.Win.Alpha  ):
		assign
            app:AlphaLevel = alphaLevel
    		app:BackColorAlpha = useAlpha
    		app:BorderAlpha = useAlpha
    		app:ForegroundAlpha = useAlpha
    		app:ImageAlpha = useAlpha
    		app:ImageBackgroundAlpha = useAlpha.
	end method.
	
	method private void EnableColorButtons(isChecked as logical):
	    assign
            btnColor1:Enabled = isChecked
            btnColor2:Enabled = isChecked
            btnColor3:Enabled = isChecked   
			btnColor4:Enabled = isChecked.
        if isChecked = false then
			ultraGrid1:DisplayLayout:Appearance:ResetBackColor().
			
	end method.
	
	method	private void ColorChanged(sender as System.Object,e as System.EventArgs):
		if type-of(sender,System.Windows.Forms.Control) then
        do:
		    ultraGrid1:DisplayLayout:Appearance:BackColor = cast(sender,System.Windows.Forms.Control):BackColor.
		end.
	end method.
	
    method protected Progress.Data.BindingSource GetDeptEmployeeSource():   
        if not valid-object(fDeptEmployeeDataSource) then
        do:
            fDeptEmployeeDataSource = new DataServices.DeptEmployeeService().                  
            fDeptEmployeeDataSource:fetchData().                                                 
        end.
        return new Progress.Data.BindingSource(fDeptEmployeeDataSource:DataSetHandle).
    end method. 
    
    /* implements ISamplesBase interface  */
    method public void ShowMe( owner as System.Windows.Forms.Form  ):
/*		InitializeForm().*/
	    if (owner <> ?) then
			this-object:Owner = owner.
		this-object:Show().
	    this-object:CancelButton = btnTitle.
        this-object:CenterToScreen().
		this-object:MaximizeBox = true.
	end.	

    /* implements ISamplesBase interface  */
    method public void HideMe( ):
        this-object:Hide().   
    end.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID btnTitle_MouseUp( INPUT sender AS System.Object, INPUT e AS System.Windows.Forms.MouseEventArgs ):
		if valid-object(this-object:Owner) then
		    (cast (this-object:Owner,frmMain)):Navigation(e:Button).
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID btnTitle_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		if valid-object(this-object:Owner) then
		   HideMe().
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID optSingleBand_CheckedChanged( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		UpdateDisplay().
		RETURN.
	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID optMultiBand_CheckedChanged( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		UpdateDisplay().
		RETURN.
	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID chkMergedCells_CheckedChanged( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		if chkMergedCells:Checked then
        do:
            ultraGrid1:DisplayLayout:Override:MergedCellStyle = Infragistics.Win.UltraWinGrid.MergedCellStyle:Always.
			ultraGrid1:DisplayLayout:Override:MergedCellContentArea = Infragistics.Win.UltraWinGrid.MergedCellContentArea:VirtualRect.
			ultraGrid1:DisplayLayout:Override:MergedCellAppearance:TextVAlign = Infragistics.Win.VAlign:Middle.
		end.
		else
		do:
			ultraGrid1:DisplayLayout:Override:MergedCellStyle = Infragistics.Win.UltraWinGrid.MergedCellStyle:Never.
		end.
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID optHorizontal_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
	   	UpdateDisplay().
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID optVertical_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
	   	UpdateDisplay().
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID optOutlookGroupBy_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
	   	UpdateDisplay().
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID chkGroupByBoxCompactStyle_CheckedChanged( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		define variable sortedColumns as Infragistics.Win.UltraWinGrid.SortedColumnsCollection no-undo.
		define variable obj as System.Object no-undo.
		if chkGroupByBoxCompactStyle:Checked then
        do:
			ultraGrid1:DisplayLayout:GroupByBox:Style = Infragistics.Win.UltraWinGrid.GroupByBoxStyle:Compact.
			optMultiBand:Checked = true.
			sortedColumns = ultraGrid1:DisplayLayout:Bands[0]:SortedColumns.
            obj = ultraGrid1:DisplayLayout:Bands[0]:Columns[0]. 
			if not ( sortedColumns:Contains(obj)) then
 				sortedColumns:Add( ultraGrid1:DisplayLayout:Bands[0]:Columns[0], false, true ).    
			sortedColumns = ultraGrid1:DisplayLayout:Bands[1]:SortedColumns.
			obj = ultraGrid1:DisplayLayout:Bands[1]:Columns[0]. 
			if not ( sortedColumns:Contains(obj)) then
				sortedColumns:Add( ultraGrid1:DisplayLayout:Bands[1]:Columns[0], false, true ).
		end.
		else
		do:
			ultraGrid1:DisplayLayout:GroupByBox:Style = Infragistics.Win.UltraWinGrid.GroupByBoxStyle:Full.
		end.
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID chkColors_CheckedChanged( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		EnableColorButtons(chkColors:Checked).
		RETURN.
	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID chkAlphaBlend_CheckedChanged( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		define variable isChecked as logical no-undo.
		isChecked = chkAlphaBlend:Checked.
		SetAppearanceUseAlpha(ultraGrid1:DisplayLayout:Override:HeaderAppearance,  if isChecked then 192 else 0, if isChecked then Infragistics.Win.Alpha:UseAlphaLevel else Infragistics.Win.Alpha:Default).
		SetAppearanceUseAlpha(ultraGrid1:DisplayLayout:Override:RowSelectorAppearance, if isChecked then 192 else 0, if isChecked then Infragistics.Win.Alpha:UseAlphaLevel else Infragistics.Win.Alpha:Default).
		SetAppearanceUseAlpha(ultraGrid1:DisplayLayout:Override:RowAppearance, if isChecked then 128 else 0, if isChecked then Infragistics.Win.Alpha:UseAlphaLevel else Infragistics.Win.Alpha:Default).
		SetAppearanceUseAlpha(ultraGrid1:DisplayLayout:Override:CellAppearance, if isChecked then 128 else 0, if isChecked then Infragistics.Win.Alpha:UseAlphaLevel else Infragistics.Win.Alpha:Default).

 		ultraGrid1:DisplayLayout:Override:CellAppearance:ForegroundAlpha = if isChecked then Infragistics.Win.Alpha:Opaque else Infragistics.Win.Alpha:Default. 
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID chkBackground_CheckedChanged( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		if chkBackground:Checked then
        do:
		    ultraGrid1:DisplayLayout:Appearance:ImageBackground = System.Drawing.Image:FromFile(SamplesPath:GraphicsPath + "/Backgrounds/nasa_outer_montage_720.jpg").
		    ultraGrid1:DisplayLayout:Appearance:ImageBackgroundStyle = Infragistics.Win.ImageBackgroundStyle:Tiled.
		end.
	    else
        do:
		    ultraGrid1:DisplayLayout:Appearance:ImageBackground = ?. 
		    ultraGrid1:DisplayLayout:Appearance:ImageBackgroundStyle = Infragistics.Win.ImageBackgroundStyle:Default.
        end.    
	    
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID chkBorders_CheckedChanged( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		ultraGrid1:DisplayLayout:Override:BorderStyleCell = (if chkBorders:Checked then Infragistics.Win.UIElementBorderStyle:Inset else Infragistics.Win.UIElementBorderStyle:Default).
		ultraGrid1:DisplayLayout:Override:BorderStyleRow = (if chkBorders:Checked then Infragistics.Win.UIElementBorderStyle:RaisedSoft else Infragistics.Win.UIElementBorderStyle:Default).
		
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID chkSpacing_CheckedChanged( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		ultraGrid1:DisplayLayout:Override:CellPadding = (if chkSpacing:Checked then 10 else -1).
		ultraGrid1:DisplayLayout:Override:RowSpacingAfter = (if chkSpacing:Checked then 15 else -1).
		ultraGrid1:DisplayLayout:InterBandSpacing = (if chkSpacing:Checked then 20 else 5).
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID chkBand0CardView_CheckedChanged( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		SetCardView(0,chkBand0CardView:Checked).
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID chkBand1CardView_CheckedChanged( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		SetCardView(1,chkBand1CardView:Checked).
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID chkBand2CardView_CheckedChanged( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
        SetCardView(2,chkBand2CardView:Checked).
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID btnColor1_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		ColorChanged(sender,e).
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID btnColor2_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		ColorChanged(sender,e).
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID btnColor3_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		ColorChanged(sender,e).
		RETURN.

	END METHOD.

	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID btnColor4_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):
		ColorChanged(sender,e).
		RETURN.

	END METHOD.
	/*------------------------------------------------------------------------------
			Purpose:  																	  
			Notes:  																	  
	------------------------------------------------------------------------------*/
	@VisualDesigner.
	METHOD PRIVATE VOID frmViewStyles_FormClosing( INPUT sender AS System.Object, INPUT e AS System.Windows.Forms.FormClosingEventArgs ):
		if valid-object(this-object:Owner) then 
	    do:
	        e:Cancel = true.
		    this-object:Visible = false.
		end.
		RETURN.

	END METHOD.


 
 
END CLASS.