routine-level on error undo, throw.
using Progress.Lang.*.
using OpenEdge.DataAdmin.*.
using OpenEdge.DataAdmin.Error.*.

define variable service as DataAdminService no-undo.
define variable errorhandler as DataAdminErrorHandler no-undo.
define variable tenant as ITenant no-undo.
define variable authsystems as IAuthenticationSystemSet no-undo. 
define variable authsys as IAuthenticationSystem no-undo.
define variable domain as IDomain no-undo.
define variable tenantName as char init "theSuper" no-undo.

service = NEW DataAdminService(LDBNAME(1)).

tenant = service:NewTenant(tenantName).  
tenant:IsDataEnabled = true.
tenant:Type = "Super".
service:CreateTenant(tenant).

/********************************************/
/* Find a AuthenticationSystem         */
/********************************************/
authsystems = service:GetAuthenticationSystems().
IF authsystems:CanFind("internal") = NO THEN
DO:
    /**************************************************/
    /* Create a new AuthenticationSystemSet  */
    /**************************************************/
    authsys = service:NewAuthenticationSystem("internal").
      /* This is not part of the API yet but will default to False
     _PAM-plug-in = NO. /*should be YES for single sign on with some real plugin!*/
    */
    service:CreateAuthenticationSystem(authsys). 
END.

/*******************************/
/* Create a new Domain    */
/*******************************/
domain = service:NewDomain(tenantName).
domain:Tenant = service:GetTenant(tenantName).
domain:AuthenticationSystem = service:GetAuthenticationSystem("internal").
domain:AccessCode =  tenantName.
domain:IsEnabled = TRUE.
service:CreateDomain(domain). 

delete object service. 
catch e as  Error :
    errorHandler =  new DataAdminErrorHandler().
    errorHandler:Error(e).      
end catch.

