routine-level on error undo, throw.
using Progress.Lang.*.
using OpenEdge.DataAdmin.*.
using OpenEdge.DataAdmin.Error.*.
using OpenEdge.DataAdmin.Lang.Collections.*.


DO TRANSACTION:
  MESSAGE 'Creating tenants'.
  RUN tenantCreate.p ("EastSports").
  RUN tenantCreate.p ("WestSports").
  RUN tenantCreate.p ("NorthSports").
  RUN tenantCreate.p ("SouthSports").

  MESSAGE 'Creating super tenant'.
  RUN getsuperten.p.
END.
    
/*create a single group in item, with all tenants except NorthSports*/
do trans:
    MESSAGE 'Creating group'.
    RUN groupCreate.p("item","groupItem",8).
end.

MESSAGE 'Adding tenants to group'.
RUN groupTenantAdd.p("groupItem","EastSports").
RUN groupTenantAdd.p("groupItem","WestSports").
RUN groupTenantAdd.p("groupItem","SouthSports").

/* Now allocate private storage objects for the tenants */
define variable service as DataAdminService no-undo.
define variable errorhandler as DataAdminErrorHandler no-undo.
DEFINE VARIABLE tenants AS ITenantSet NO-UNDO.
DEFINE VARIABLE iterator AS IIterator NO-UNDO.

MESSAGE 'Allocating tenants'.

service = NEW DataAdminService(LDBNAME(1)).

tenants = service:GetTenants("IsAllocated = 'FALSE'  AND Type = 'Regular'  ").
iterator = tenants:Iterator().
DO WHILE iterator:HasNext():
     CAST(iterator:Next(), ITenant):Allocate(). 
END.
service:UpdateTenants(tenants).

delete object service. 
output close.
catch e as  Error :
    errorHandler =  new DataAdminErrorHandler().
    errorHandler:Error(e).      
end catch.

