DEFINE VARIABLE lStopped AS LOGICAL INIT TRUE.
DEFINE VARIABLE lError   AS LOGICAL NO-UNDO.

DO ON STOP UNDO, LEAVE
   ON QUIT UNDO, LEAVE.

    /* load basic schema */
    RUN loaddf.p.
    
    /* create domain, tenants, group, etc */
    RUN gettens.p.
    
    /* load data*/
    RUN loadalldata.p.

    lStopped = FALSE.

    CATCH e AS Progress.Lang.Error.
        lError = TRUE.
        MESSAGE "Error loading database:" e:GetMessage(1).
    END.
END.

IF NOT lError THEN DO:

    IF lStopped THEN
        MESSAGE "STOP condition raised. Failed to load database".
    ELSE
        MESSAGE "Database loaded successfully".
END.
