routine-level on error undo, throw.
using Progress.Lang.*.
using OpenEdge.DataAdmin.*.
using OpenEdge.DataAdmin.Error.*.

DEFINE INPUT PARAMETER tenantName AS CHAR.

define variable service as DataAdminService no-undo.
define variable errorhandler as DataAdminErrorHandler no-undo.
define variable tenant as ITenant no-undo.
define variable authsystems as IAuthenticationSystemSet no-undo. 
define variable authsys as IAuthenticationSystem no-undo.
define variable domain as IDomain no-undo.

service = NEW DataAdminService(LDBNAME(1)).

/***************************/
/* Create a new Tenant     */
/***************************/
tenant = service:NewTenant(tenantName).

tenant:name = tenantName.
tenant:Type = "Regular".
tenant:IsDataEnabled = TRUE.   /* enabled for access */

if substr(tenantName,1,3) = "NorthSports"
then
do:
   tenant:DefaultAllocation = "Immediate".
   tenant:DefaultDataArea  = service:GetArea("Area1").
   tenant:DefaultIndexArea = service:GetArea("Area1").
   tenant:DefaultLobArea   = service:GetArea("Area1").
end.
else
do:
   tenant:DefaultAllocation = "delayed".
   tenant:DefaultDataArea  = service:GetArea("Area2").
   tenant:DefaultIndexArea = service:GetArea("Area2").
   tenant:DefaultLobArea   = service:GetArea("Area2").
end.

service:CreateTenant(tenant).

/*********************************************/
/* Find a AuthenticationSystem           */
/*********************************************/
authsystems = service:GetAuthenticationSystems().
IF authsystems:CanFind("appauth") = NO THEN
DO:
    /*************************************************/
    /* Create a new AuthenticationSystemSet */
    /*************************************************/
    authsys = service:NewAuthenticationSystem("appauth").
   /* This is not part of the API yet but will default to False
     _PAM-plug-in = NO. /*should be YES for single sign on with some real plugin!
   */ */
    service:CreateAuthenticationSystem(authsys). 
END.

/********************************/
/* Create a new Domain     */
/********************************/
domain = service:NewDomain(tenantName).
domain:Tenant = service:GetTenant(tenantName).
domain:AuthenticationSystem = service:GetAuthenticationSystem("appauth").
domain:AccessCode =  tenantName.
domain:IsEnabled = TRUE.
service:CreateDomain(domain). 

delete object service. 
catch e as  Error :
    errorHandler =  new DataAdminErrorHandler().
    errorHandler:Error(e).      
end catch.

