routine-level on error undo, throw.

/*This routine takes the userid@domain and domain access code and
  creates a sealed client principal to access the database with*/

function xcheckuser returns logical (uname as char,udom as char, pswd as char):
  return true. /*normally there would be a real way to check the args to this*/
end.

define input parameter username_dom as char. /*userid@domain format*/
define input parameter dom_acc_code as char.  /*domain access code*/
define input parameter pswd as char.  /*user password, could be ignored here*/
define var username as char.
define var userdomain as char.
def var ok as log.
def var h as handle.

/*parse out the username and domain name*/
username = entry(1,username_dom, "@") no-error.
userdomain = entry(2,username_dom, "@") no-error.
 
/*NOTE!*/
/*do your OWN userid/passwd validation here internally using username and pswd*/
/* this is just a fake empty .p to simulate what a user would do */
ok = xcheckuser(username, userdomain, pswd).
if not ok then
do: 
    message "either password or domain do not match user" username.  
    delete object h.
    return. 
end.

create client-principal h.

/*since we have no _user records and are not using any legitimate
  _sec-authentication-system, we have to seal this here and now -- the
  set-db-client code over on the server will just look up the domain and
  see if the access-code matches or not -- it does not care about the userid.
  If it matches, we then get to be that tenant*/

h:initialize(username_dom, ? /*session id*/, ? /*expiration*/, "" /*pswd*/ ).

ok = h:seal(dom_acc_code /*domain passcode*/ ).
if not ok then
do: 
    message "user passcode failed seal for id" username.  
    delete object h.
    return. 
end.

ok = set-db-client(h).
if not ok then
do: 
    message "user auth failed for id" username.  
    delete object h.
    return. 
end.

delete object h.
return.

