
/* i-sax1dn.p - This example retrieves names and phone numbers with namespaces */
DEF VAR hParser as HANDLE. 
DEF VAR hHandler AS HANDLE. 
/* create the SAX-READER object */ 
CREATE SAX-READER hParser. 
/* run the persistent procedure that contains the callbacks */ 
RUN "i-sax1hn.p" PERSISTENT SET hHandler. 
/* give the SAX-READER the handle to the persistent procedure */ 
hParser:HANDLER = hHandler. 
/* Give the SAX-READER the info on the file to parse. 
   This XML file uses namespaces. */ 
hParser:SET-INPUT-SOURCE("FILE", "i-sax1n.xml"). 
hParser:SAX-PARSE( ) NO-ERROR. 
/* By the time SAX-PARSE returns, our callbacks have been called as many 
times as necessary and were done processing the XML document (or there 
was an error) */ 
IF ERROR-STATUS:ERROR THEN 
DO: 
  IF ERROR-STATUS:NUM-MESSAGES > 0 THEN 
    /* unable to begin the parse */ 
    MESSAGE ERROR-STATUS:GET-MESSAGE(1) VIEW-AS ALERT-BOX. 
  ELSE 
    /* error detected in a callback */ 
    MESSAGE RETURN-VALUE VIEW-AS ALERT-BOX. 
END. 
ELSE 
  MESSAGE "Document parsed successfully" VIEW-AS ALERT-BOX. 
DELETE OBJECT hParser. 
DELETE PROCEDURE hHandler. 
