/* This sample uses both the SAX-READER and the SAX-WRITER 
   objects. The SAX-READER is used to read in the .XML file 
   and the SAX-WRITER writes the data out to a new .XML file */
DEFINE VARIABLE hSAXWriter AS HANDLE NO-UNDO.
DEFINE VARIABLE hSAXReader AS HANDLE NO-UNDO.

CREATE SAX-WRITER hSAXWriter.
hSAXWriter:FORMATTED = TRUE.
hSAXWriter:STANDALONE = YES.
hSAXWriter:ENCODING = "UTF-8".
hSAXWriter:SET-OUTPUT-DESTINATION("file", "sax-readwrite.xml").
hSAXWriter:START-DOCUMENT().

CREATE SAX-READER hSAXReader.
hSAXReader:SET-INPUT-SOURCE("FILE", "sampledata.xml").
hSAXReader:SAX-PARSE().

hSAXWriter:END-DOCUMENT().
DELETE OBJECT hSAXWriter.
DELETE OBJECT hSAXReader.

/***********************************************/
/*         callbacks for SAX parser            */
/***********************************************/

PROCEDURE StartElement:
DEFINE INPUT PARAMETER namespaceURI AS CHARACTER.
DEFINE INPUT PARAMETER localName AS CHARACTER.
DEFINE INPUT PARAMETER qname AS CHARACTER.
DEFINE INPUT PARAMETER hAttributes AS HANDLE.
DEFINE VARIABLE i AS INTEGER.

hSAXWriter:START-ELEMENT(localName, namespaceURI).
IF hattributes:NUM-ITEMS > 0 THEN
    DO i = 1 TO hattributes:NUM-ITEMS:
        hSAXWriter:INSERT-ATTRIBUTE(hattributes:GET-QNAME-BY-INDEX(i), 
                                    hattributes:GET-VALUE-BY-INDEX(i)).
    END.
END.

PROCEDURE Characters:
DEFINE INPUT PARAMETER charData AS LONGCHAR.
DEFINE INPUT PARAMETER numChars AS INTEGER.

hSAXWriter:WRITE-CHARACTERS(charData).
END.


PROCEDURE EndElement:
DEFINE INPUT PARAMETER namespaceURI AS CHARACTER.
DEFINE INPUT PARAMETER localName AS CHARACTER.
DEFINE INPUT PARAMETER qName AS CHARACTER.

hSAXWriter:END-ELEMENT(localName, namespaceURI).
END.



