/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/************************************************************************************
	PROCEDURE: chardat1.p

	PURPOSE:   Converts a character date to DATE format

	SYNTAX:    "RUN samples/chardat1.p (INPUT in, OUTPUT out)".

	REMARKS:   This code will convert a character date to the DATE format.

	PARAMETERS:
              INPUT  in-date  - Character format to be converted
              OUTPUT out-date - DATE format variable

	AUTHORS:   Progress Software Consulting
	DATE:      February 1993

	LAST INSPECTED:
	INSPECTED BY:

 ************************************************************************************/
/*Code_Start*/

DEF INPUT  PARAMETER in-date  AS CHAR FORMAT "x(10)" NO-UNDO.
DEF OUTPUT PARAMETER out-date AS DATE NO-UNDO.
   
out-date = 
   DATE( 
     INTEGER(SUBSTR(in-date , 
       INDEX(STRING(DATE(2,1,1903)) , "02") ,2)),
     INTEGER(SUBSTR(in-date , 
       INDEX(STRING(DATE(2,1,1903)) , "01") ,2)),
     INTEGER(SUBSTR(in-date , 
       INDEX(STRING(DATE(2,1,1903)) , "03") ,2)) + 1900).




