/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/************************************************************************************
	PROCEDURE: chardat2.p

	PURPOSE:   Converts character date to DATE format regardless if
                      date if 99/99/99 or 99/99/9999 format

	SYNTAX:    "RUN samples/chardat2.p (INPUT in, OUTPUT out)".

	REMARKS:   This code will convert a date in a character field to DATE format
		   regardless of the DATE format being 99/99/99 or 99/99/9999.

	PARAMETERS:
              INPUT  in-date  - Character field to be converted
              OUTPUT out-date - Date formatted variable

	AUTHORS:   George Kassabgi
	DATE:      February 1993

	LAST INSPECTED:
	INSPECTED BY:

 ************************************************************************************/
/*Code_Start*/


DEF INPUT  PARAMETER in-date  AS CHAR FORMAT "x(10)" NO-UNDO.
DEF OUTPUT PARAMETER out-date AS DATE                NO-UNDO.

out-date = 
   DATE( INTEGER(SUBSTR(in-date,1,2)),
         INTEGER(SUBSTR(in-date,4,2)),
         IF INTEGER(SUBSTR(in-date,7)) < 100
            THEN INTEGER(SUBSTR(in-date,7)) + 1900
         ELSE INTEGER(SUBSTR(in-date,7))).



