/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/************************************************************************************
	PROCEDURE: datafmt.i

	PURPOSE:   Update section of the FORMAT PHRASES procedure

	SYNTAX:    {samples/datafmt.i &field = ""}

	REMARKS:   This code handles enabling the appropriate fields and displaying
		   the formatting field.
	
	PARAMETERS: &field

	AUTHORS:   Judy Rothermal
	DATE:      February 1993

	LAST INSPECTED:
	INSPECTED BY:

 ************************************************************************************/
/*Code_Start*/
 
DO:
   ENABLE bOK bQUIT WITH FRAME frm-{&field}.
   REPEAT:
      UPDATE {&field} fmt WITH FRAME frm-{&field}.    
      DISPLAY STRING({&field}, fmt) FORMAT "x(25)" 
         @ result WITH FRAME frm-{&field}.
   END.
   HIDE FRAME frm-{&field}.
END.


