/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/************************************************************************************
	PROCEDURE: fv.p

	PURPOSE:   Future Value

	SYNTAX:    "RUN samples/fv.p (INPUT pmt, INPUT int, INPUT life,
                                      OUTPUT result)"

	REMARKS:   This code handles menu options and selections within the selection
		   lists for topics and procedures.
		   Internal procedure on_off enables and disables widgets to handle
		   execution of modal subroutines.

	PARAMETERS:NONE, See loader.p for proclib.ini startup options.

	AUTHORS:   Progress Consulting
	DATE:      February 1993

	LAST INSPECTED:
	INSPECTED BY:

 ************************************************************************************/
/*Code_Start*/

/* fv.p            ******   Future Value Function  ******

   This function returns the future value of an annuity based on the
   payment amount, interest rate, and life (# of compounding periods).

     The formula used is as follows:

        FV = PAYMENT * (1 + INTEREST)^(LIFE) - 1
                      ---------------------------
                                INTEREST
*/

DEFINE INPUT  PARAMETER payment  AS DECIMAL DECIMALS 10.
DEFINE INPUT  PARAMETER interest AS DECIMAL DECIMALS 10.
DEFINE INPUT  PARAMETER life     AS INTEGER.
DEFINE OUTPUT PARAMETER result   AS DECIMAL DECIMALS 10.

result = payment * ((exp(1 + interest, life) - 1) / interest).

