/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/* menuhndl.p

   Per Ekman 93-08-20.

   Returns the widget-handle for a specific menu-item or sub-menu.   
   For a description, see menuex.p.
*/
/*Code_Start*/

def input  param menu_handle as widget-handle no-undo.
def input  param menu_item   as cha           no-undo.
def output param menu_hndl   as widget-handle no-undo.

def var lbl as cha no-undo.
def var i   as int no-undo.

menu_hndl = ?.
run scan(menu_handle,"/").

procedure scan:
  def input param parent_handle as widget-handle no-undo.
  def input param menu_path     as cha           no-undo.
  
  def var ih  as widget-handle no-undo.
  
  ih = parent_handle:first-child.
  do while ih <> ?:
    lbl = ih:label.
    i = index(lbl,"&").
    if i > 0 then substr(lbl,i,1) = "".
    if menu_item = lbl or
       menu_item = menu_path + lbl 
    then do:
      menu_hndl = ih.
      return "Found".
    end.
    if can-query(ih,"first-child") then do:
      run scan(ih,menu_path + lbl + "/").
      if return-value = "Found" then return "Found".
    end.
    ih = ih:next-sibling.
  end.
end.

if menu_hndl = ?
then message "The requested item was not found."
             view-as alert-box message buttons ok. 
