/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/* menusens.p

   Per Ekman 93-08-20.
   
   For a description, see menuex.p.
*/
/*Code_Start*/

def input param menu_handle as widget-handle no-undo.
def input param menu_items  as cha           no-undo.
def input param menu_sens   as log           no-undo.

def var lbl as cha no-undo.
def var i   as int no-undo.

run scan(menu_handle,"/").

procedure scan:
  def input param parent_handle as widget-handle no-undo.
  def input param menu_path     as cha           no-undo.
  
  def var ih  as widget-handle no-undo.
  
  ih = parent_handle:first-child.
  do while ih <> ?:
    lbl = ih:label.
    i = index(lbl,"&").
    if i > 0 then substr(lbl,i,1) = "".
    if can-do(menu_items,lbl) or
       can-do(menu_items,menu_path + lbl)
    then ih:sensitive = menu_sens.
    if can-query(ih,"first-child")
       then run scan(ih,menu_path + lbl + "/").
    ih = ih:next-sibling.
  end.
end.
