/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/************************************************************************************
	PROCEDURE: monthend.p

	PURPOSE:   Calculates the last day of the month

	SYNTAX:    RUN samples/monthend.p (INPUT in, OUTPUT out).

	REMARKS:   This code calculates the last day of the month
		 

	PARAMETERS:
            INPUT:  date
            OUTPUT: date of the last day of the month

	AUTHORS:   Judy Rothermal
	DATE:      February 1993

	LAST INSPECTED:
	INSPECTED BY:

 ************************************************************************************/
 /*Code_Start*/
 
DEF INPUT  PARAMETER in-date  AS DATE NO-UNDO.
DEF OUTPUT PARAMETER out-date AS DATE NO-UNDO.

out-date = 
        ((DATE(MONTH(in-date),28,YEAR(in-date)) + 4) - 
          DAY(DATE(MONTH(in-date),28,YEAR(in-date)) + 4)).



