/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/************************************************************************************
	PROCEDURE: newbase.p

	PURPOSE:   Converts a base 10 number to a different base

	SYNTAX:    RUN samples/newbase.p (INPUT in, OUTPUT out).

	REMARKS:   This code converts a base 10 number to a given base.
	
	PARAMETERS:
            INPUT:  base 10 number
            INPUT:  base to be converted to
            OUTPUT: converted number

	AUTHORS:   Judy Rothermal
	DATE:      February 1993

	LAST INSPECTED:
	INSPECTED BY:

 ************************************************************************************/
/*Code_Start*/


DEFINE INPUT  PARAMETER  dnumber AS INTEGER   NO-UNDO.
DEFINE INPUT  PARAMETER  newbase AS INTEGER   NO-UNDO.
DEFINE OUTPUT PARAMETE   nstring AS CHARACTER NO-UNDO.
DEFINE VARIABLE  r       AS INTEGER   NO-UNDO.
DEFINE VARIABLE  s       AS LOGICAL   NO-UNDO.

/* Take the remainder to find the value of the current position. */
/* If the result is less than ten, return a digit (0..9). */
/* Otherwise, return a letter (A..Z). */

IF newbase < 2 OR newbase > 36 OR 
   newbase = ? OR dnumber = ? THEN
   nstring = ?.
ELSE DO:
   ASSIGN
       nstring = ""
       s       =  dnumber < 0
       dnumber = (IF s THEN - dnumber ELSE dnumber).

   DO WHILE dnumber > 0:
      ASSIGN
         r       = dnumber MODULO newbase
         nstring = CHR(r + IF r < 10 THEN 48 ELSE 55) + nstring
         dnumber = TRUNCATE(dnumber /  newbase,0).
   END.
   IF s THEN nstring = "-" + nstring.
   IF nstring = "" THEN nstring = "0".
END.


