/* StaticDS.p  -  Returns static DataSet. 

    Last Updated- KM 10/23/05 */

   



DEFINE TEMP-TABLE ttOrder LIKE Order

   INDEX OrderNum IS UNIQUE PRIMARY OrderNum.

DEFINE TEMP-TABLE ttOLine LIKE OrderLine

   BEFORE-TABLE ttOlineBefore

   INDEX orderline IS UNIQUE PRIMARY Ordernum Linenum.



DEFINE DATASET dsOrder FOR ttOrder, ttOLine

    DATA-RELATION OrderLine FOR ttOrder, ttOLine

      RELATION-FIELDS (OrderNum, OrderNum).



DEFINE INPUT  PARAMETER piGE        AS INTEGER    NO-UNDO.

DEFINE INPUT  PARAMETER piLE        AS INTEGER    NO-UNDO.

DEFINE OUTPUT PARAMETER DATASET FOR dsOrder.



DEFINE VARIABLE hdsOrder AS HANDLE     NO-UNDO.

DEFINE VARIABLE iBuff     AS INTEGER    NO-UNDO.



DEFINE QUERY qOrder FOR Order.

DEFINE DATA-SOURCE srcOrder FOR QUERY qOrder Order KEYS (OrderNum).

DEFINE DATA-SOURCE srcOline FOR OrderLine.



OUTPUT TO "StaticDSOutput.txt".

MESSAGE "START StaticDS.p" SKIP.

MESSAGE "piGE = " piGE SKIP. 

MESSAGE "piLE = " piLE SKIP. 

hdsOrder = DATASET dsOrder:HANDLE.

 

/* Prepare the query */

QUERY qOrder:QUERY-PREPARE("FOR EACH Order NO-LOCK WHERE " +

                           "Order.OrderNum GE " + STRING(piGE) + " AND " + 

                           "Order.OrderNum LE " + STRING(piLE)).



/* Attach datasources before fill */

BUFFER ttOrder:ATTACH-DATA-SOURCE(DATA-SOURCE srcOrder:HANDLE).

BUFFER ttOLine:ATTACH-DATA-SOURCE(DATA-SOURCE srcOline:HANDLE).



hDSOrder:FILL().



/*Detach datasources after fill */

DO iBuff = 1 TO DATASET dsOrder:NUM-BUFFERS:

     DATASET dsOrder:GET-BUFFER-HANDLE(iBuff):DETACH-DATA-SOURCE().

END.

    

OUTPUT CLOSE. 





    

