/* UpdateDS.p  -  Update the DataSet. 

    Last Updated- KM 10/23/05 */



DEFINE TEMP-TABLE ttOrder LIKE Order

   INDEX OrderNum IS UNIQUE PRIMARY OrderNum.

DEFINE TEMP-TABLE ttOLine LIKE OrderLine

   BEFORE-TABLE ttOlineBefore

   INDEX orderline IS UNIQUE PRIMARY Ordernum Linenum.



DEFINE DATASET dsOrder FOR ttOrder, ttOLine

    DATA-RELATION OrderLine FOR ttOrder, ttOLine

      RELATION-FIELDS (OrderNum, OrderNum).



DEFINE INPUT PARAMETER pIgnDBChg AS LOGICAL NO-UNDO.

DEFINE INPUT PARAMETER pMrgFld AS LOGICAL NO-UNDO.

DEFINE INPUT-OUTPUT PARAMETER DATASET FOR dsOrder.



DEFINE DATA-SOURCE srcOline FOR Orderline.

DEFINE VARIABLE returnValue AS LOGICAL NO-UNDO.

DEFINE VARIABLE hSrcOline  AS HANDLE NO-UNDO.



OUTPUT TO "UpdateDSOutput.txt".

MESSAGE "START UpdateDS.p 2" SKIP.

MESSAGE "pIgnDBChg = " pIgnDBChg SKIP. 

MESSAGE "pMrgFld = " pMrgFld SKIP. 



hSrcOline = DATA-SOURCE srcOline:HANDLE. 

hSrcOline:PREFER-DATASET = pIgnDBChg.  

hSrcOline:MERGE-BY-FIELD = pMrgFld.



BUFFER ttOLine:ATTACH-DATA-SOURCE(hSrcOline). 



FOR EACH ttOlineBefore TRANSACTION:

    returnValue = BUFFER ttOlineBefore:SAVE-ROW-CHANGES("Orderline") NO-ERROR. 

    IF NOT returnValue THEN DO:

        MESSAGE "ERROR-STATUS:GET-NUMBER(1) = " ERROR-STATUS:GET-NUMBER(1) SKIP. 

        MESSAGE "ERROR-STATUS:GET-MESSAGE(1) = " ERROR-STATUS:GET-MESSAGE(1) SKIP. 

        BUFFER ttOlineBefore:ERROR-STRING = ERROR-STATUS:GET-MESSAGE(1).

    END.

END.               



DELETE OBJECT hSrcOline. 

OUTPUT CLOSE. 

RETURN.

