/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/************************************************************************************
	PROCEDURE: pmt.p

	PURPOSE:   Calculates payment amount for paying off loan

	SYNTAX:    "RUN samples/pmt.p"

	REMARKS:   This code handles menu options and selections within the selection
		   lists for topics and procedures.
		   Internal procedure on_off enables and disables widgets to handle
		   execution of modal subroutines.

	PARAMETERS:NONE, See loader.p for proclib.ini startup options.

	AUTHORS:   Progress Consulting
	DATE:      February 1993

	LAST INSPECTED:
	INSPECTED BY:

 ************************************************************************************/
/*Code_Start*/


/* pmt.p

   This function returns the amount of payment needed to pay off the
   principal based of the life (# of periods) and interest rate.

   The formula used to determine payment is as follows:

       PMT =              PRINCIPAL * INTEREST
			--------------------------
			1 - (1 + INTEREST)^(-LIFE)
*/
/* Code Start */
DEFINE INPUT  PARAMETER principal AS DECIMAL DECIMALS 10.
DEFINE INPUT  PARAMETER interest  AS DECIMAL DECIMALS 10.
DEFINE INPUT  PARAMETER life      AS INTEGER.
DEFINE OUTPUT PARAMETER pmt       AS DECIMAL DECIMALS 10.

pmt = (principal * interest) / (1 - exp((interest + 1),(life * -1))).


