&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME Dialog-Frame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Dialog-Frame 
/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/*------------------------------------------------------------------------
 * June, 1997
 * Version 1.0
 
  File: import.w

  Description: Displays a dialog box to import profiling data into the database

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE DIALOG-BOX
&Scoped-define DB-AWARE no

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME Dialog-Frame

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS Input-file Btn_files Prof-desc ~
toggle-import-listings Btn_OK Btn_Cancel 
&Scoped-Define DISPLAYED-OBJECTS import-status Input-file Prof-desc ~
toggle-import-listings 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
DEFINE BUTTON Btn_Cancel AUTO-END-KEY 
     LABEL "Cancel" 
     SIZE 12 BY 1.1
     BGCOLOR 8 .

DEFINE BUTTON Btn_files 
     LABEL "Files..." 
     SIZE 12 BY 1.1
     BGCOLOR 8 .

DEFINE BUTTON Btn_OK AUTO-GO 
     LABEL "OK" 
     SIZE 12 BY 1.1
     BGCOLOR 8 .

DEFINE VARIABLE Prof-desc AS CHARACTER 
     VIEW-AS EDITOR SCROLLBAR-VERTICAL
     SIZE 86 BY 5.24 TOOLTIP "What was the Profile taken of?" NO-UNDO.

DEFINE VARIABLE import-status AS CHARACTER FORMAT "X(256)":U 
      VIEW-AS TEXT 
     SIZE 56 BY .62 NO-UNDO.

DEFINE VARIABLE Input-file AS CHARACTER FORMAT "X(256)":U INITIAL "prof.out" 
     VIEW-AS FILL-IN 
     SIZE 76 BY 1 NO-UNDO.

DEFINE VARIABLE toggle-import-listings AS LOGICAL INITIAL yes 
     LABEL "Import Source Listings" 
     VIEW-AS TOGGLE-BOX
     SIZE 27 BY .81 NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME Dialog-Frame
     import-status AT ROW 10.76 COL 3 COLON-ALIGNED NO-LABEL
     Input-file AT ROW 1.48 COL 13 COLON-ALIGNED NO-LABEL
     Btn_files AT ROW 1.48 COL 95
     Prof-desc AT ROW 5.29 COL 5 NO-LABEL
     toggle-import-listings AT ROW 2.91 COL 15
     Btn_OK AT ROW 2.91 COL 95
     Btn_Cancel AT ROW 4.33 COL 95
     "Input File" VIEW-AS TEXT
          SIZE 10 BY 1 AT ROW 1.48 COL 5
     "Description of Profiling Run" VIEW-AS TEXT
          SIZE 27 BY 1 AT ROW 3.86 COL 15
     SPACE(67.39) SKIP(7.32)
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER 
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         TITLE "Import New Profiling Data"
         DEFAULT-BUTTON Btn_OK CANCEL-BUTTON Btn_Cancel.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: DIALOG-BOX
   Allow: Basic,Browse,DB-Fields,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX Dialog-Frame
   FRAME-NAME Custom                                                    */
ASSIGN 
       FRAME Dialog-Frame:SCROLLABLE       = FALSE
       FRAME Dialog-Frame:HIDDEN           = TRUE.

/* SETTINGS FOR FILL-IN import-status IN FRAME Dialog-Frame
   NO-ENABLE                                                            */
ASSIGN 
       Prof-desc:RETURN-INSERTED IN FRAME Dialog-Frame  = TRUE.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME Dialog-Frame
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Dialog-Frame Dialog-Frame
ON WINDOW-CLOSE OF FRAME Dialog-Frame /* Import New Profiling Data */
DO:
  APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_files
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_files Dialog-Frame
ON CHOOSE OF Btn_files IN FRAME Dialog-Frame /* Files... */
DO:
  def var inpfil as char no-undo.
  def var retstat as logical no-undo.

  inpfil = input-file.

  system-dialog get-file inpfil
         title "Profile Data File"
         filters "Profile files (*.out)" "*.out",
                 "All files (*.*)" "*.*"
         initial-dir "."
         return-to-start-dir
         update retstat.
         
  if retstat then do:
     Input-file = inpfil.
     display input-file with frame Dialog-Frame.
  end.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_OK
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_OK Dialog-Frame
ON CHOOSE OF Btn_OK IN FRAME Dialog-Frame /* OK */
DO:
  assign input-file toggle-import-listings prof-desc.
  file-info:file-name = input-file.
  if file-info:file-type EQ ?
     OR NOT file-info:file-type BEGINS "F"
     OR NOT file-info:file-type MATCHES "*R*" THEN
  DO:
     message "Could not find or open file" input-file "for reading."
              view-as alert-box.
     return no-apply.
  END.
  
  run adecomm/_setcurs.p ("WAIT").

  RUN import-data (input-file, prof-desc, toggle-import-listings).
  
  run adecomm/_setcurs.p ("").

  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Dialog-Frame 


/* ***************************  Main Block  *************************** */

/* Parent the dialog-box to the ACTIVE-WINDOW, if there is no parent.   */
IF VALID-HANDLE(ACTIVE-WINDOW) AND FRAME {&FRAME-NAME}:PARENT eq ?
THEN FRAME {&FRAME-NAME}:PARENT = ACTIVE-WINDOW.


/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  WAIT-FOR GO OF FRAME {&FRAME-NAME}.
END.
RUN disable_UI.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI Dialog-Frame  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME Dialog-Frame.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI Dialog-Frame  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY import-status Input-file Prof-desc toggle-import-listings 
      WITH FRAME Dialog-Frame.
  ENABLE Input-file Btn_files Prof-desc toggle-import-listings Btn_OK 
         Btn_Cancel 
      WITH FRAME Dialog-Frame.
  VIEW FRAME Dialog-Frame.
  {&OPEN-BROWSERS-IN-QUERY-Dialog-Frame}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE import-data Dialog-Frame 
PROCEDURE import-data :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
define input parameter inpfile as char no-undo.
define input parameter description as char no-undo.
define input parameter import-listings as logical no-undo.
define buffer sessionsource for source.
define buffer parentsource for source.
define buffer lsource for source.
define var parentname as char no-undo.
define var sname as char no-undo.
define var sid as int no-undo.
define var versno as int no-undo.
def var savedateformat as char no-undo.
define var prof_sess_not_created as logical.

input from value(inpfile).


prof_sess_not_created = true.
repeat:
  if prof_sess_not_created 
  then  do:
   create profile-session.
   profile-session.session-id = next-value(sessionid).
   savedateformat = session:date-format.
   session:date-format = "mdy".
   prof_sess_not_created = false.
  end.
  import versno Profile-Session.session-date
                Profile-Session.Session-Desc
                Profile-Session.Session-Time
                Profile-Session.Session-User.
  session:date-format = savedateformat.
  if versno NE 0 AND versno GT 2 then do:
     message "Cannot load data. Don't know how to load data for version" versno
           view-as alert-box.
     undo, return.
  end.
  session-notes = description.
  create sessionsource. /* create source id 0 -- the session "source" */
  assign sessionsource.session-id = profile-session.session-id
         sessionsource.srcid = 0
         sessionsource.srcname = "Session"
         sessionsource.callcnt = 1
         sessionsource.listname = "".
   
end.

import-status = "Reading Source Data...".
display import-status with frame Dialog-Frame.

/* read in all the source information */
repeat:
  create source.
  source.session-id = profile-session.session-id.
  import source.srcid source.srcname source.listname source.CRC-Val.
end.

import-status = "Reading Call-Tree Data...".
display import-status with frame Dialog-Frame.

/* now read in all the calltree information */
repeat:
  create calltreedata.
  calltreedata.session-id = profile-session.session-id.
  import calltreedata.caller calltreedata.callerlineno
         calltreedata.callee calltreedata.callcnt.
end.

for each calltreedata of profile-session:
   find first calltree of calltreedata no-error.
   if not available(calltree) then
      buffer-copy calltreedata to calltree.
   else
      calltree.callcnt = calltree.callcnt + calltreedata.callcnt.
end.

import-status = "Reading Executable Line Summaries Data...".
display import-status with frame Dialog-Frame.

/* now read in all the summary statements */
repeat:
  create sumstmt.
  sumstmt.session-id = profile-session.session-id.
  import sumstmt.srcid sumstmt.lineno sumstmt.stmtcnt
         sumstmt.tot_acttime sumstmt.cumtime.
  assign sumstmt.acttime = sumstmt.tot_acttime / sumstmt.stmtcnt
         sumstmt.cumtime = sumstmt.cumtime / sumstmt.stmtcnt.
end.

if versno GE 1 then do:
  /* for version 0, we didn't have this information */

  /* read tracing information */
  import-status = "Reading Execution Tracing Data...".
  display import-status with frame Dialog-Frame.
  repeat:
    create traceinfo.
    traceinfo.session-id = profile-session.session-id.
    import traceinfo.srcid    traceinfo.line-no
           traceinfo.acttime  traceinfo.starttime.
  end.
  /* read coverage analysis information */
  import-status = "Reading Coverage Analysis Data...".
  display import-status with frame Dialog-Frame.
   coverblk:
  repeat:
    import sid sname ^.
    if sname NE "" then do:
        /* we've got a procedure, function, or trigger -- find it's parent */
        find parentsource where
                parentsource.session-id = profile-session.session-id
            AND parentsource.srcid = sid NO-ERROR.
        if not available(parentsource) then do:
           run skipcoverage.
           undo coverblk, next coverblk.
        end.

        sname = parentsource.srcname + " " + sname.
        find source where source.session-id = profile-session.session-id
                AND source.srcname EQ sname NO-ERROR.
        if not available(source) then do:
           /* this source was not executed during this profiling session */
           find last lsource where
                     lsource.session-id = profile-session.session-id.
           create source.
           assign source.srcid = lsource.srcid + 1
                  source.session-id = lsource.session-id
                  source.srcname = sname.
        end.
        sid = source.srcid.
    end.
    /* now read in what executable lines there are for this source */
    repeat:
      create executable-line.
      assign executable-line.session-id = profile-session.session-id
             executable-line.srcid = sid.
      import executable-line.line-no.
    end.
  end.

  /* read any user data */
  import-status = "Reading User Defined Data...".
  display import-status with frame Dialog-Frame.
  repeat:
    create user-data.
    user-data.session-id = profile-session.session-id.
    import user-data.event-time user-data.data.
  end.
end. /* end if versno GE 1 */

input close.

import-status = "Analyzing Source and Call-Tree Data...".
display import-status with frame Dialog-Frame.

/* now massage the data */
for each source of profile-session:
  /* establish how many times this source was called */
  for each calltree where calltree.session-id = profile-session.session-id
                          AND calltree.callee = source.srcid:
    source.callcnt = source.callcnt + calltree.callcnt.
  end.
  
  /* establish what the "parent" procedure is, if there is one */
  parentname = entry(2, source.srcname, " ") no-error.
  if NOT error-status:error then
  do:
    find first parentsource
         where parentsource.session-id = profile-session.session-id
               AND parentsource.srcname = parentname no-error.
    if available parentsource then
      assign source.parent = parentsource.srcid
             source.listname = parentsource.listname.
  end.
  
  /* compute the total actual time and average actual time for the procedure */
  for each sumstmt of source:
    assign
      source.tot_acttime = source.tot_acttime + sumstmt.tot_acttime
      sumstmt.parent = if source.parent EQ 0 then source.srcid else source.parent.
  end.
  if source.callcnt GT 0 then /* may be zero if only have coverage analysis
                               * info on the source, but no execution during
                               * this profiling session */
    source.avg_acttime = source.tot_acttime / source.callcnt.
end.

/* figure out the total session time so we can compute percentages */
do transaction:
  find sumstmt where sumstmt.session-id = profile-session.session-id
                  AND sumstmt.srcid = 0
                  AND sumstmt.lineno = 0 no-error.
  if not available(sumstmt) then
    find sumstmt where sumstmt.session-id = profile-session.session-id
                  AND sumstmt.srcid = 1
                  AND sumstmt.lineno = 0 no-error.
  if not available(sumstmt) then
  do:
    message "Can't summarize data. Cannot locate summary statement for the Session."
            view-as alert-box.
    return.
  end.
  
  profile-session.tot_acttime = sumstmt.cumtime.
end.

import-status = "Computing Percentages...".
display import-status with frame Dialog-Frame.

FOR EACH source of profile-session:
   ASSIGN
      source.session-percent = 
         source.tot_acttime * 100.0 / profile-session.tot_acttime
      source.percall-percent = 
         source.avg_acttime * 100.0 / profile-session.tot_acttime.
   FOR EACH sumstmt OF source:
     sumstmt.session-percent = 
        sumstmt.acttime * 100.0 / profile-session.tot_acttime.
     IF source.avg_acttime GT 0 THEN
        sumstmt.perprocedure-percent =
           sumstmt.tot_acttime * 100.0 / source.callcnt / source.avg_acttime.
   END.
   FIND FIRST sumstmt where sumstmt.session-id = source.session-id
                        AND sumstmt.srcid = source.srcid
                        AND sumstmt.lineno GE 0 no-error.
   IF avail(sumstmt) and sumstmt.lineno EQ 0 THEN DO:
      source.overhead_time = sumstmt.acttime.
      FIND NEXT sumstmt where sumstmt.session-id = source.session-id
                          AND sumstmt.srcid = source.srcid
                          AND sumstmt.lineno GE 0 NO-ERROR.
   END.
   if available(sumstmt) then
      source.first-line = sumstmt.lineno.
   else source.first-line = 1.
END.

if import-listings then 
   run import-listing-files.
   
import-status = "Done Importing " + inpfile + ".".
display import-status with frame Dialog-Frame.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE import-listing-files Dialog-Frame 
PROCEDURE import-listing-files :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
define var listidx as int no-undo.
define var listcount as int no-undo.


  /* first count how many listing files there are */
  for each source where profile-session.session-id = source.session-id
                    AND source.parent = 0 AND source.listname NE "":
     listcount = listcount + 1.
  end.
  for each source where profile-session.session-id = source.session-id
                    AND source.parent = 0 AND source.listname NE ""
                    ON ERROR UNDO, NEXT:
     /* see if we can open the listing file */
     file-info:file-name = source.listname.
     if file-info:file-type EQ ?
        OR NOT file-info:file-type BEGINS "F"
        OR NOT file-info:file-type MATCHES "*R*" THEN
     do:
        assign
           listidx = listidx + 1
           import-status = "Could not read Listing File '" + source.listname
                           + "' for " + source.srcname + "...".
        display import-status with frame Dialog-Frame.
        next.
     end.

     assign
         listidx = listidx + 1
         import-status = "Importing Listing File " + string(listidx)
                         + " of " + string(listcount) + " for "
                         + source.srcname + "...".
     display import-status with frame Dialog-Frame.
     run imp_lst.p (buffer source, buffer profile-session).
  end.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

