&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/*------------------------------------------------------------------------

  File: profile.p

  Description: PRO*Tool to control profile session

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME DEFAULT-FRAME

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS prof_rd profdesc enabled-tgl outpfilename ~
filesbtn listing-tgl coverage-tgl directory Tracing-tgl writebtn ~
filter-fillin 
&Scoped-Define DISPLAYED-OBJECTS prof_rd profdesc enabled-tgl outpfilename ~
listing-tgl coverage-tgl directory Tracing-tgl filter-fillin 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON filesbtn 
     LABEL "&Files" 
     SIZE 15 BY 1.14.

DEFINE BUTTON writebtn 
     LABEL "&Write Data" 
     SIZE 15 BY 1.14.

DEFINE VARIABLE directory AS CHARACTER FORMAT "X(60)":U 
     VIEW-AS FILL-IN 
     SIZE 36 BY 1 TOOLTIP "Enter the name of the directory of profiler listing files." NO-UNDO.

DEFINE VARIABLE filter-fillin AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 36 BY 1 TOOLTIP "Enter a comma separated list of filters for tracing." NO-UNDO.

DEFINE VARIABLE outpfilename AS CHARACTER FORMAT "X(60)":U 
     VIEW-AS FILL-IN 
     SIZE 36 BY 1 TOOLTIP "Enter the output file name for the Profiling data." NO-UNDO.

DEFINE VARIABLE profdesc AS CHARACTER FORMAT "X(256)":U 
     VIEW-AS FILL-IN 
     SIZE 52 BY 1 TOOLTIP "Enter the description of the profiling session" NO-UNDO.

DEFINE VARIABLE prof_rd AS LOGICAL 
     VIEW-AS RADIO-SET VERTICAL
     RADIO-BUTTONS 
          "Profiling On", yes,
"Profiling Off", no
     SIZE 18 BY 2.62 TOOLTIP "Start/Stop generating profiling data." NO-UNDO.

DEFINE VARIABLE coverage-tgl AS LOGICAL INITIAL no 
     LABEL "Coverage" 
     VIEW-AS TOGGLE-BOX
     SIZE 14 BY .81 TOOLTIP "Generate coverage analysis information." NO-UNDO.

DEFINE VARIABLE enabled-tgl AS LOGICAL INITIAL no 
     LABEL "Enable" 
     VIEW-AS TOGGLE-BOX
     SIZE 12 BY .81 TOOLTIP "Enable profiling capability but do not begin collecting data." NO-UNDO.

DEFINE VARIABLE listing-tgl AS LOGICAL INITIAL no 
     LABEL "Listings" 
     VIEW-AS TOGGLE-BOX
     SIZE 12 BY .81 TOOLTIP "Generate listing files." NO-UNDO.

DEFINE VARIABLE Tracing-tgl AS LOGICAL INITIAL no 
     LABEL "Tracing" 
     VIEW-AS TOGGLE-BOX
     SIZE 13.4 BY .81 TOOLTIP "Generate procedure tracing information." NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     prof_rd AT ROW 1.24 COL 20 RIGHT-ALIGNED NO-LABEL
     profdesc AT ROW 1.95 COL 21 COLON-ALIGNED NO-LABEL
     enabled-tgl AT ROW 3.86 COL 4
     outpfilename AT ROW 3.86 COL 21 COLON-ALIGNED NO-LABEL
     filesbtn AT ROW 3.86 COL 60
     listing-tgl AT ROW 4.81 COL 4
     coverage-tgl AT ROW 5.76 COL 4
     directory AT ROW 5.76 COL 21 COLON-ALIGNED NO-LABEL
     Tracing-tgl AT ROW 6.71 COL 4
     writebtn AT ROW 7.67 COL 2
     filter-fillin AT ROW 7.67 COL 21 COLON-ALIGNED NO-LABEL
     "Profile Description" VIEW-AS TEXT
          SIZE 22 BY .62 AT ROW 1.24 COL 23
     "Output File" VIEW-AS TEXT
          SIZE 18 BY .62 AT ROW 3.14 COL 23
     "Listing Files Directory" VIEW-AS TEXT
          SIZE 25 BY .62 AT ROW 5.05 COL 23
     "Filter for Tracing" VIEW-AS TEXT
          SIZE 24 BY .62 AT ROW 6.95 COL 23
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 75.4 BY 8.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "Profile Control Tool"
         HEIGHT             = 7.86
         WIDTH              = 75.4
         MAX-HEIGHT         = 16
         MAX-WIDTH          = 90.6
         VIRTUAL-HEIGHT     = 16
         VIRTUAL-WIDTH      = 90.6
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***************  Runtime Attributes and UIB Settings  ************** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
                                                                        */
/* SETTINGS FOR RADIO-SET prof_rd IN FRAME DEFAULT-FRAME
   ALIGN-R                                                              */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* Profile Control Tool */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* Profile Control Tool */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME coverage-tgl
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL coverage-tgl C-Win
ON VALUE-CHANGED OF coverage-tgl IN FRAME DEFAULT-FRAME /* Coverage */
DO:
  assign coverage-tgl.
  profiler:coverage = coverage-tgl.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME directory
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL directory C-Win
ON LEAVE OF directory IN FRAME DEFAULT-FRAME
DO:
  assign directory.
  if directory eq ? OR directory = "" then
      directory = ".".
  profiler:directory = directory.
  display profiler:directory @ directory with frame {&FRAME-NAME}.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME enabled-tgl
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL enabled-tgl C-Win
ON VALUE-CHANGED OF enabled-tgl IN FRAME DEFAULT-FRAME /* Enable */
DO:
  assign enabled-tgl.
  profiler:enabled = enabled-tgl.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME filesbtn
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL filesbtn C-Win
ON CHOOSE OF filesbtn IN FRAME DEFAULT-FRAME /* Files */
DO:
  def var outpfil as char no-undo.
  def var retstat as logical no-undo.
  def var oldval as char no-undo.

  outpfil = profiler:file-name.

  system-dialog get-file outpfil
         title "Profile Data File"
         filters "Profile files (*.out)" "*.out",
                 "All files (*.*)" "*.*"
         initial-dir "."
         create-test-file
         return-to-start-dir
         update retstat.
         
  if retstat then do:
     oldval = profiler:file-name.
     outpfilename = outpfil.
     if outpfilename eq ? OR outpfilename = "" then
        outpfilename = oldval.
     profiler:file-name = outpfilename.
     display profiler:file-name @ outpfilename with frame {&FRAME-NAME}.
  end.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME filter-fillin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL filter-fillin C-Win
ON LEAVE OF filter-fillin IN FRAME DEFAULT-FRAME
DO:
  assign filter-fillin.
  if filter-fillin eq ? then
    filter-fillin eq "".
  if filter-fillin eq "" then
     tracing-tgl = no.
  profiler:trace-filter = filter-fillin.
  display tracing-tgl 
          profiler:trace-filter @ filter-fillin with frame {&FRAME-NAME}.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME listing-tgl
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL listing-tgl C-Win
ON VALUE-CHANGED OF listing-tgl IN FRAME DEFAULT-FRAME /* Listings */
DO:
  assign listing-tgl.
  profiler:listings = listing-tgl.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME outpfilename
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL outpfilename C-Win
ON LEAVE OF outpfilename IN FRAME DEFAULT-FRAME
DO:
  def var oldval as char no-undo.         
     oldval = profiler:file-name.
  assign outpfilename.
  if outpfilename eq ? OR outpfilename = "" then
    outpfilename = oldval.
  profiler:file-name = outpfilename.
  display profiler:file-name @ outpfilename with frame {&FRAME-NAME}.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME profdesc
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL profdesc C-Win
ON LEAVE OF profdesc IN FRAME DEFAULT-FRAME
DO:
  def var oldval as char no-undo.
  oldval = profiler:description.
  assign profdesc.
  if profdesc eq ? OR profdesc = "" then
    profdesc = oldval.
  profiler:description = profdesc.
  display profiler:description @ profdesc with frame {&FRAME-NAME}.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME prof_rd
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL prof_rd C-Win
ON VALUE-CHANGED OF prof_rd IN FRAME DEFAULT-FRAME
DO:
  assign prof_rd.
  profiler:profiling = prof_rd.
  enabled-tgl = profiler:enabled.
  display enabled-tgl with frame {&frame-name}.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Tracing-tgl
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Tracing-tgl C-Win
ON VALUE-CHANGED OF Tracing-tgl IN FRAME DEFAULT-FRAME /* Tracing */
DO:
  assign tracing-tgl.
  if NOT tracing-tgl then
     profiler:trace-filter = "".
  else if profiler:trace-filter EQ "" then
     profiler:trace-filter = "*".
     
  display profiler:trace-filter @ filter-fillin with frame {&frame-name}.

     
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME writebtn
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL writebtn C-Win
ON CHOOSE OF writebtn IN FRAME DEFAULT-FRAME /* Write Data */
DO:
  def var wrote_it as logical no-undo.
  def var msg as char no-undo.
  def var i as int no-undo.
  
  run adecomm/_setcurs.p ("WAIT").

  wrote_it = profiler:write-data() no-error.
  
  if wrote_it then do:
     run adecomm/_setcurs.p ("").
     message "Profiling data written to" outpfilename skip
        "Advise that you update 'Output File' so that" skip
        " your data does not get overwritten by the" skip
        "  next 'Write Data' or by the session end."
         view-as alert-box information.
     apply "entry" to outpfilename.
   end.
   else do:
     repeat i = 1 to error-status:num-messages:
       msg = msg + error-status:get-message(i).
     end.
     if i EQ 1 then msg = "No data to write?".
     message msg skip "Failed to write profiling data to" outpfilename skip
             "Profiling session data unchanged." 
             view-as alert-box warning.
     run adecomm/_setcurs.p ("").
   end.
     
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

if profiler:file-name = ? then
   assign profiler:file-name = "prof.out".
if profiler:directory = "" then
   profiler:directory = session:temp-dir.
   
assign prof_rd = profiler:profiling
       enabled-tgl = profiler:enabled
       listing-tgl = profiler:listings
       coverage-tgl = profiler:coverage
       directory = profiler:directory
       tracing-tgl = if profiler:trace-filter EQ "" then no else yes
       filter-fillin = profiler:trace-filter
       outpfilename = profiler:file-name
       profdesc = profiler:description.

          
/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

procedure ADEPersistent:
return "OK".
end.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY prof_rd profdesc enabled-tgl outpfilename listing-tgl coverage-tgl 
          directory Tracing-tgl filter-fillin 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE prof_rd profdesc enabled-tgl outpfilename filesbtn listing-tgl 
         coverage-tgl directory Tracing-tgl writebtn filter-fillin 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

