&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI
&ANALYZE-RESUME
/* Connected Databases 
          prof             PROGRESS
*/
&Scoped-define WINDOW-NAME C-Win

/* Temp-Table and Buffer definitions                                    */
DEFINE BUFFER callee_source FOR prof.source.
DEFINE BUFFER caller_source FOR prof.source.
DEFINE BUFFER calltree2 FOR prof.calltree.
DEFINE BUFFER joinedstmt FOR prof.sumstmt.


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*********************************************************************
* Copyright (C) 2000,2009 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/*------------------------------------------------------------------------
 * June, 1997
 * Version 1.0

  File: c-dotp.w

  Description: This program dislays detailed profiling information for a
               given .p or .w procedure.

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

def var mainsrcid as int no-undo.
def var sessionid as int no-undo.
def var brokerhdl as handle no-undo.

if false then
  find first source.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME DEFAULT-FRAME
&Scoped-define BROWSE-NAME BROWSE-1

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES source calltree caller_source calltree2 ~
callee_source Listing-Lines sumstmt

/* Definitions for BROWSE BROWSE-1                                      */
&Scoped-define FIELDS-IN-QUERY-BROWSE-1 source.session-percent ~
source.srcname 
&Scoped-define ENABLED-FIELDS-IN-QUERY-BROWSE-1 
&Scoped-define FIELD-PAIRS-IN-QUERY-BROWSE-1
&Scoped-define OPEN-QUERY-BROWSE-1 OPEN QUERY BROWSE-1 FOR EACH source ~
      WHERE source.session-id = sessionid AND ~
((mainsrcid GT 0 AND source.parent = mainsrcid) ~
 OR source.srcid = mainsrcid) NO-LOCK ~
    BY source.session-percent DESCENDING.
&Scoped-define TABLES-IN-QUERY-BROWSE-1 source
&Scoped-define FIRST-TABLE-IN-QUERY-BROWSE-1 source


/* Definitions for BROWSE BROWSE-2                                      */
&Scoped-define FIELDS-IN-QUERY-BROWSE-2 calltree.callcnt ~
caller_source.session-percent caller_source.srcname 
&Scoped-define ENABLED-FIELDS-IN-QUERY-BROWSE-2 
&Scoped-define FIELD-PAIRS-IN-QUERY-BROWSE-2
&Scoped-define OPEN-QUERY-BROWSE-2 OPEN QUERY BROWSE-2 FOR EACH calltree ~
      WHERE calltree.session-id = sessionid ~
and calltree.callee = source.srcid NO-LOCK, ~
      EACH caller_source WHERE caller_source.session-id = calltree.session-id ~
  AND caller_source.srcid = calltree.caller NO-LOCK ~
    BY calltree.callcnt DESCENDING.
&Scoped-define TABLES-IN-QUERY-BROWSE-2 calltree caller_source
&Scoped-define FIRST-TABLE-IN-QUERY-BROWSE-2 calltree


/* Definitions for BROWSE BROWSE-3                                      */
&Scoped-define FIELDS-IN-QUERY-BROWSE-3 callee_source.callcnt ~
callee_source.session-percent callee_source.srcname 
&Scoped-define ENABLED-FIELDS-IN-QUERY-BROWSE-3 
&Scoped-define FIELD-PAIRS-IN-QUERY-BROWSE-3
&Scoped-define OPEN-QUERY-BROWSE-3 OPEN QUERY BROWSE-3 FOR EACH calltree2 ~
      WHERE calltree2.session-id = sessionid ~
and calltree2.caller = source.srcid NO-LOCK, ~
      EACH callee_source WHERE callee_source.session-id = calltree2.session-id ~
  AND callee_source.srcid = calltree2.callee NO-LOCK ~
    BY calltree2.callcnt DESCENDING.
&Scoped-define TABLES-IN-QUERY-BROWSE-3 calltree2 callee_source
&Scoped-define FIRST-TABLE-IN-QUERY-BROWSE-3 calltree2


/* Definitions for BROWSE BROWSE-4                                      */
&Scoped-define FIELDS-IN-QUERY-BROWSE-4 Listing-Lines.avg-acttime ~
Listing-Lines.stmtcnt Listing-Lines.line-text 
&Scoped-define ENABLED-FIELDS-IN-QUERY-BROWSE-4 
&Scoped-define FIELD-PAIRS-IN-QUERY-BROWSE-4
&Scoped-define OPEN-QUERY-BROWSE-4 OPEN QUERY BROWSE-4 FOR EACH Listing-Lines ~
      WHERE listing-lines.session-id = sessionid ~
and listing-lines.srcid = mainsrcid NO-LOCK INDEXED-REPOSITION.
&Scoped-define TABLES-IN-QUERY-BROWSE-4 Listing-Lines
&Scoped-define FIRST-TABLE-IN-QUERY-BROWSE-4 Listing-Lines


/* Definitions for BROWSE BROWSE-5                                      */
&Scoped-define FIELDS-IN-QUERY-BROWSE-5 sumstmt.lineno sumstmt.tot_acttime 
&Scoped-define ENABLED-FIELDS-IN-QUERY-BROWSE-5 
&Scoped-define FIELD-PAIRS-IN-QUERY-BROWSE-5
&Scoped-define OPEN-QUERY-BROWSE-5 OPEN QUERY BROWSE-5 FOR EACH sumstmt ~
      WHERE sumstmt.session-id = sessionid ~
and sumstmt.srcid = source.srcid NO-LOCK ~
    BY sumstmt.tot_acttime DESCENDING.
&Scoped-define TABLES-IN-QUERY-BROWSE-5 sumstmt
&Scoped-define FIRST-TABLE-IN-QUERY-BROWSE-5 sumstmt


/* Definitions for FRAME DEFAULT-FRAME                                  */
&Scoped-define OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME ~
    ~{&OPEN-QUERY-BROWSE-1}~
    ~{&OPEN-QUERY-BROWSE-2}~
    ~{&OPEN-QUERY-BROWSE-3}~
    ~{&OPEN-QUERY-BROWSE-4}~
    ~{&OPEN-QUERY-BROWSE-5}

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS RECT-1 summarybtn BROWSE-1 allsessionsbtn ~
dupbtn Btn_Done reuse_toggle BROWSE-5 BROWSE-4 BROWSE-2 BROWSE-3 
&Scoped-Define DISPLAYED-FIELDS source.session-percent ~
source.percall-percent source.callcnt source.overhead_time ~
source.avg_acttime 
&Scoped-Define DISPLAYED-OBJECTS reuse_toggle this-srcname 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD resetlisting C-Win 
FUNCTION resetlisting RETURNS LOGICAL
  ( input id as int /* parameter-definitions */ )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON allsessionsbtn 
     LABEL "&AllSessions" 
     SIZE 19 BY 1 TOOLTIP "Get Summary Window of All Sessions".

DEFINE BUTTON Btn_Done DEFAULT 
     LABEL "&Close Window" 
     SIZE 19 BY 1
     BGCOLOR 8 .

DEFINE BUTTON dupbtn 
     LABEL "&Duplicate" 
     SIZE 19 BY 1 TOOLTIP "Make a copy of this window".

DEFINE BUTTON summarybtn 
     LABEL "&SessionSummary" 
     SIZE 19 BY 1 TOOLTIP "Get Session Summary Window".

DEFINE VARIABLE this-srcname AS CHARACTER FORMAT "x(40)" 
      VIEW-AS TEXT 
     SIZE 23 BY .62
     FONT 6.

DEFINE RECTANGLE RECT-1
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE 39 BY 4.76.

DEFINE VARIABLE reuse_toggle AS LOGICAL INITIAL no 
     LABEL "ReUse Window" 
     VIEW-AS TOGGLE-BOX
     SIZE 19 BY .81 TOOLTIP "Don't Auto Spawn New Windows" NO-UNDO.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY BROWSE-1 FOR 
      source SCROLLING.

DEFINE QUERY BROWSE-2 FOR 
      calltree, 
      caller_source SCROLLING.

DEFINE QUERY BROWSE-3 FOR 
      calltree2, 
      callee_source SCROLLING.

DEFINE QUERY BROWSE-4 FOR 
      Listing-Lines SCROLLING.

DEFINE QUERY BROWSE-5 FOR 
      sumstmt SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE BROWSE-1
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS BROWSE-1 C-Win _STRUCTURED
  QUERY BROWSE-1 DISPLAY
      source.session-percent COLUMN-LABEL "% of Session" FORMAT " >>>9.9999%"
      source.srcname COLUMN-LABEL "" FORMAT "x(100)"
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-LABELS NO-ROW-MARKERS SIZE 62 BY 4.76
         TITLE "Code Blocks in this .R by % of Session" TOOLTIP "Double Click to Focus on a Code Block".

DEFINE BROWSE BROWSE-2
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS BROWSE-2 C-Win _STRUCTURED
  QUERY BROWSE-2 NO-LOCK DISPLAY
      calltree.callcnt COLUMN-LABEL "Times!Calling" FORMAT ">>>,>>9"
      caller_source.session-percent COLUMN-LABEL "% of!Session" FORMAT ">>>9.9999"
      caller_source.srcname COLUMN-LABEL "Calling Code Blocks" FORMAT "x(100)"
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SIZE 60 BY 5
         TITLE "Calling Code (Callers)" TOOLTIP "Double-click to Go to the Code".

DEFINE BROWSE BROWSE-3
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS BROWSE-3 C-Win _STRUCTURED
  QUERY BROWSE-3 NO-LOCK DISPLAY
      callee_source.callcnt COLUMN-LABEL "Times!Called" FORMAT ">>>,>>9"
      callee_source.session-percent COLUMN-LABEL "% of!Session" FORMAT ">>>9.9999"
      callee_source.srcname COLUMN-LABEL "Called Code Blocks" FORMAT "x(100)"
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SIZE 60 BY 5
         TITLE "Called Code (Callees)" TOOLTIP "Double-click to Go to the Code".

DEFINE BROWSE BROWSE-4
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS BROWSE-4 C-Win _STRUCTURED
  QUERY BROWSE-4 NO-LOCK DISPLAY
      Listing-Lines.avg-acttime COLUMN-LABEL "Avg Exec!Time" FORMAT ">>>>9.999999"
      Listing-Lines.stmtcnt COLUMN-LABEL "Exec'd!Count" FORMAT ">>>,>>9"
      Listing-Lines.line-text COLUMN-LABEL "Listing Text" FORMAT "x(200)"
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SIZE 97 BY 10
         TITLE "Listing File".

DEFINE BROWSE BROWSE-5
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS BROWSE-5 C-Win _STRUCTURED
  QUERY BROWSE-5 DISPLAY
      sumstmt.lineno COLUMN-LABEL "Line!Number" FORMAT ">>,>>9"
      sumstmt.tot_acttime COLUMN-LABEL "Total!Time" FORMAT ">>>>9.999999"
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SIZE 24 BY 10
         TITLE "Lines by Time" TOOLTIP "Double-click to Go to the Line".


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     summarybtn AT ROW 1.24 COL 41
     BROWSE-1 AT ROW 1.24 COL 61
     allsessionsbtn AT ROW 2.19 COL 41
     dupbtn AT ROW 3.14 COL 41
     Btn_Done AT ROW 4.1 COL 41
     reuse_toggle AT ROW 5.29 COL 41
     BROWSE-5 AT ROW 6.24 COL 1
     BROWSE-4 AT ROW 6.24 COL 26
     BROWSE-2 AT ROW 16.48 COL 2
     BROWSE-3 AT ROW 16.48 COL 63
     this-srcname AT ROW 1.48 COL 16 NO-LABEL
     source.session-percent AT ROW 2.19 COL 15 COLON-ALIGNED
          LABEL "% of Session"
           VIEW-AS TEXT 
          SIZE 13.2 BY .62
     source.percall-percent AT ROW 2.91 COL 15 COLON-ALIGNED
          LABEL "Per Call %"
           VIEW-AS TEXT 
          SIZE 13.2 BY .62
     source.callcnt AT ROW 3.62 COL 15 COLON-ALIGNED
           VIEW-AS TEXT 
          SIZE 14.6 BY .62
     source.overhead_time AT ROW 4.33 COL 15 COLON-ALIGNED
          LABEL "Avg Overhead"
           VIEW-AS TEXT 
          SIZE 16 BY .62
     source.avg_acttime AT ROW 5.05 COL 15 COLON-ALIGNED
          LABEL "Avg Time"
           VIEW-AS TEXT 
          SIZE 17 BY .62
     RECT-1 AT ROW 1.24 COL 1
     "Profile Focus:" VIEW-AS TEXT
          SIZE 14 BY .62 AT ROW 1.48 COL 2
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 123 BY 20.52
         DEFAULT-BUTTON Btn_Done.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
   Temp-Tables and Buffers:
      TABLE: callee_source B "?" ? prof source
      TABLE: caller_source B "?" ? prof source
      TABLE: calltree2 B "?" ? prof calltree
      TABLE: joinedstmt B "?" ? prof sumstmt
   END-TABLES.
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "<insert window title>"
         HEIGHT             = 20.67
         WIDTH              = 122.6
         MAX-HEIGHT         = 25.48
         MAX-WIDTH          = 154.6
         VIRTUAL-HEIGHT     = 25.48
         VIRTUAL-WIDTH      = 154.6
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME


/* ***************  Runtime Attributes and UIB Settings  ************** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
                                                                        */
/* BROWSE-TAB BROWSE-1 summarybtn DEFAULT-FRAME */
/* BROWSE-TAB BROWSE-5 reuse_toggle DEFAULT-FRAME */
/* BROWSE-TAB BROWSE-4 BROWSE-5 DEFAULT-FRAME */
/* BROWSE-TAB BROWSE-2 BROWSE-4 DEFAULT-FRAME */
/* BROWSE-TAB BROWSE-3 BROWSE-2 DEFAULT-FRAME */
/* SETTINGS FOR FILL-IN source.avg_acttime IN FRAME DEFAULT-FRAME
   NO-ENABLE EXP-LABEL                                                  */
ASSIGN 
       BROWSE-4:MAX-DATA-GUESS IN FRAME DEFAULT-FRAME     = 30000.

/* SETTINGS FOR FILL-IN source.callcnt IN FRAME DEFAULT-FRAME
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN source.overhead_time IN FRAME DEFAULT-FRAME
   NO-ENABLE EXP-LABEL                                                  */
/* SETTINGS FOR FILL-IN source.percall-percent IN FRAME DEFAULT-FRAME
   NO-ENABLE EXP-LABEL                                                  */
/* SETTINGS FOR FILL-IN source.session-percent IN FRAME DEFAULT-FRAME
   NO-ENABLE EXP-LABEL                                                  */
/* SETTINGS FOR FILL-IN this-srcname IN FRAME DEFAULT-FRAME
   NO-ENABLE ALIGN-L                                                    */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE BROWSE-1
/* Query rebuild information for BROWSE BROWSE-1
     _TblList          = "prof.source"
     _OrdList          = "prof.source.session-percent|no"
     _Where[1]         = "prof.source.session-id = sessionid AND
((mainsrcid GT 0 AND prof.source.parent = mainsrcid)
 OR prof.source.srcid = mainsrcid)"
     _FldNameList[1]   > prof.source.session-percent
"source.session-percent" "% of Session" " >>>9.9999%" "decimal" ? ? ? ? ? ? no ?
     _FldNameList[2]   > prof.source.srcname
"source.srcname" "" "x(100)" "character" ? ? ? ? ? ? no ?
     _Query            is OPENED
*/  /* BROWSE BROWSE-1 */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE BROWSE-2
/* Query rebuild information for BROWSE BROWSE-2
     _TblList          = "prof.calltree,prof.caller_source WHERE prof.calltree ..."
     _Options          = "NO-LOCK"
     _OrdList          = "prof.calltree.callcnt|no"
     _Where[1]         = "calltree.session-id = sessionid
and calltree.callee = source.srcid"
     _JoinCode[2]      = "caller_source.session-id = prof.calltree.session-id
  AND caller_source.srcid = prof.calltree.caller"
     _FldNameList[1]   > prof.calltree.callcnt
"calltree.callcnt" "Times!Calling" ">>>,>>9" "integer" ? ? ? ? ? ? no ?
     _FldNameList[2]   > Temp-Tables.caller_source.session-percent
"caller_source.session-percent" "% of!Session" ">>>9.9999" "decimal" ? ? ? ? ? ? no ?
     _FldNameList[3]   > Temp-Tables.caller_source.srcname
"caller_source.srcname" "Calling Code Blocks" "x(100)" "character" ? ? ? ? ? ? no ?
     _Query            is OPENED
*/  /* BROWSE BROWSE-2 */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE BROWSE-3
/* Query rebuild information for BROWSE BROWSE-3
     _TblList          = "prof.calltree2,prof.callee_source WHERE prof.calltree2 ..."
     _Options          = "NO-LOCK"
     _OrdList          = "prof.calltree2.callcnt|no"
     _Where[1]         = "calltree2.session-id = sessionid
and calltree2.caller = source.srcid"
     _JoinCode[2]      = "callee_source.session-id = calltree2.session-id
  AND callee_source.srcid = calltree2.callee"
     _FldNameList[1]   > Temp-Tables.callee_source.callcnt
"callee_source.callcnt" "Times!Called" ">>>,>>9" "integer" ? ? ? ? ? ? no ?
     _FldNameList[2]   > Temp-Tables.callee_source.session-percent
"callee_source.session-percent" "% of!Session" ">>>9.9999" "decimal" ? ? ? ? ? ? no ?
     _FldNameList[3]   > Temp-Tables.callee_source.srcname
"callee_source.srcname" "Called Code Blocks" "x(100)" "character" ? ? ? ? ? ? no ?
     _Query            is OPENED
*/  /* BROWSE BROWSE-3 */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE BROWSE-4
/* Query rebuild information for BROWSE BROWSE-4
     _TblList          = "prof.Listing-Lines"
     _Options          = "NO-LOCK INDEXED-REPOSITION"
     _Where[1]         = "listing-lines.session-id = sessionid
and listing-lines.srcid = mainsrcid"
     _FldNameList[1]   > prof.Listing-Lines.avg-acttime
"Listing-Lines.avg-acttime" "Avg Exec!Time" ">>>>9.999999" "decimal" ? ? ? ? ? ? no ?
     _FldNameList[2]   > prof.Listing-Lines.stmtcnt
"Listing-Lines.stmtcnt" "Exec'd!Count" ">>>,>>9" "integer" ? ? ? ? ? ? no ?
     _FldNameList[3]   > prof.Listing-Lines.line-text
"Listing-Lines.line-text" "Listing Text" "x(200)" "character" ? ? ? ? ? ? no ?
     _Query            is OPENED
*/  /* BROWSE BROWSE-4 */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE BROWSE-5
/* Query rebuild information for BROWSE BROWSE-5
     _TblList          = "prof.sumstmt"
     _OrdList          = "prof.sumstmt.tot_acttime|no"
     _Where[1]         = "sumstmt.session-id = sessionid
and sumstmt.srcid = source.srcid"
     _FldNameList[1]   > prof.sumstmt.lineno
"sumstmt.lineno" "Line!Number" ">>,>>9" "integer" ? ? ? ? ? ? no ?
     _FldNameList[2]   > prof.sumstmt.tot_acttime
"sumstmt.tot_acttime" "Total!Time" ">>>>9.999999" "decimal" ? ? ? ? ? ? no ?
     _Query            is OPENED
*/  /* BROWSE BROWSE-5 */
&ANALYZE-RESUME

 




/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* <insert window title> */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* <insert window title> */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME allsessionsbtn
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL allsessionsbtn C-Win
ON CHOOSE OF allsessionsbtn IN FRAME DEFAULT-FRAME /* AllSessions */
DO:
  if valid-handle(brokerhdl) then
    run viewall_sessions in brokerhdl.
  return no-apply.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BROWSE-1
&Scoped-define SELF-NAME BROWSE-1
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BROWSE-1 C-Win
ON MOUSE-SELECT-DBLCLICK OF BROWSE-1 IN FRAME DEFAULT-FRAME /* Code Blocks in this .R by % of Session */
DO:
  run dispview.
  {&OPEN-QUERY-BROWSE-2}
  {&OPEN-QUERY-BROWSE-3}
  {&OPEN-QUERY-BROWSE-5}
  resetlisting(source.first-line).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BROWSE-2
&Scoped-define SELF-NAME BROWSE-2
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BROWSE-2 C-Win
ON MOUSE-SELECT-DBLCLICK OF BROWSE-2 IN FRAME DEFAULT-FRAME /* Calling Code (Callers) */
DO:
  def buffer ct_data for calltreedata.
  def buffer ct_data1 for calltreedata.
  def var caller_lineno as int no-undo.
  
  if not available(caller_source) then
     return.
  find first ct_data where ct_data.session-id = caller_source.session-id
                       and ct_data.caller = caller_source.srcid
                       and ct_data.callee = source.srcid.
  /* see if there are more than one calls in the callee */
  find ct_data1 where recid(ct_data1) = recid(ct_data).
  find next ct_data where ct_data.session-id = source.session-id
                       and ct_data.caller = caller_source.srcid
                       and ct_data.callee = source.srcid
                           no-error.
  if not available ct_data then
     caller_lineno = ct_data1.callerlineno.
  else do:
     run c2-dialg.w (input source.session-id, input ct_data.caller,
                     input ct_data.callee, output caller_lineno).
     if caller_lineno = 0 then
        return.
  end.
  
  if (caller_source.parent eq mainsrcid
      OR caller_source.srcid eq mainsrcid)
     AND mainsrcid GT 0 then
       run view_source in this-procedure (caller_source.srcid, caller_lineno).
  else if valid-handle(brokerhdl) THEN DO:
     if reuse_toggle then
        run reuse_me in brokerhdl (mainsrcid, this-procedure,
                                   caller_source.srcid, caller_lineno).
     else 
        run view_source in brokerhdl (caller_source.srcid, caller_lineno).
  end.
  return no-apply.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BROWSE-3
&Scoped-define SELF-NAME BROWSE-3
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BROWSE-3 C-Win
ON MOUSE-SELECT-DBLCLICK OF BROWSE-3 IN FRAME DEFAULT-FRAME /* Called Code (Callees) */
DO:
  if not available(callee_source) then return.
  
  if (callee_source.parent eq mainsrcid
      OR callee_source.srcid eq mainsrcid)
     AND mainsrcid GT 0 then
       run view_source in this-procedure (callee_source.srcid, 0).
  else if valid-handle(brokerhdl) THEN DO:
     if reuse_toggle then
        run reuse_me in brokerhdl (mainsrcid, this-procedure,
                                   callee_source.srcid, 0).
     else 
     run view_source in brokerhdl (callee_source.srcid, 0).
  end.
  return no-apply.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BROWSE-4
&Scoped-define SELF-NAME BROWSE-4
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BROWSE-4 C-Win
ON MOUSE-SELECT-DBLCLICK OF BROWSE-4 IN FRAME DEFAULT-FRAME /* Listing File */
DO:
  def buffer ct_data for calltreedata.
  def buffer ct_data1 for calltreedata.
  def buffer sstmt for sumstmt.
  def buffer callee for source.
  def var calledsrcid as int no-undo.
  
  if not available listing-lines then
     return.
  find first sstmt where sstmt.session-id = source.session-id
                     and sstmt.lineno = listing-lines.line-no no-error.
  if not available sstmt then
     return. 
  find first ct_data where ct_data.session-id = source.session-id
                       and ct_data.caller = sstmt.srcid
                       and ct_data.callerlineno = listing-lines.line-no
                           no-error.
  if not available ct_data then
     return.
  /* see if there are more than one callee's */
  find ct_data1 where recid(ct_data1) = recid(ct_data).
  find next ct_data where ct_data.session-id = source.session-id
                       and ct_data.caller = sstmt.srcid
                       and ct_data.callerlineno = listing-lines.line-no
                           no-error.
  if available ct_data then do:
     run cc-dialg.w (input source.session-id, input ct_data.caller,
                     input ct_data.callerlineno, output calledsrcid).
     if calledsrcid = 0 then
        return.
     find ct_data1 where ct_data1.session-id = source.session-id
                     and ct_data1.caller = ct_data.caller
                     and ct_data1.callerlineno = ct_data.callerlineno
                     and ct_data1.callee = calledsrcid.
  end.
  
  find callee where ct_data1.session-id = callee.session-id
                and ct_data1.callee = callee.srcid.
  
  if (callee.parent eq mainsrcid
      OR callee.srcid eq mainsrcid)
     AND mainsrcid GT 0 then
       run view_source in this-procedure (callee.srcid, 0).
  else if valid-handle(brokerhdl) THEN DO:
     if reuse_toggle then
        run reuse_me in brokerhdl (mainsrcid, this-procedure,
                                   callee.srcid, 0).
     else 
     run view_source in brokerhdl (callee.srcid, 0).
  end.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BROWSE-5
&Scoped-define SELF-NAME BROWSE-5
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BROWSE-5 C-Win
ON MOUSE-SELECT-DBLCLICK OF BROWSE-5 IN FRAME DEFAULT-FRAME /* Lines by Time */
DO:
  if not available(sumstmt) then return.
  resetlisting(sumstmt.lineno).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_Done
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_Done C-Win
ON CHOOSE OF Btn_Done IN FRAME DEFAULT-FRAME /* Close Window */
DO:
  &IF DEFINED (adm-panel) <> 0 &THEN
      RUN dispatch IN THIS-PROCEDURE ('exit').
  &ELSE
      APPLY "CLOSE":U TO THIS-PROCEDURE.
  &ENDIF
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME dupbtn
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL dupbtn C-Win
ON CHOOSE OF dupbtn IN FRAME DEFAULT-FRAME /* Duplicate */
DO:
  if valid-handle(brokerhdl) then
    run dup_dotp in brokerhdl (INPUT (if source.parent eq 0 then source.srcid
                                      else source.parent),
                               INPUT source.srcid, 0).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME reuse_toggle
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL reuse_toggle C-Win
ON VALUE-CHANGED OF reuse_toggle IN FRAME DEFAULT-FRAME /* ReUse Window */
DO:
  assign reuse_toggle.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME summarybtn
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL summarybtn C-Win
ON CHOOSE OF summarybtn IN FRAME DEFAULT-FRAME /* SessionSummary */
DO:
  if valid-handle(brokerhdl) then
    run session_summary in brokerhdl.
  return no-apply.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BROWSE-1
&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:

&if DEFINED(UIB_IS_RUNNING) NE 0 &then
  def buffer tmpsess for profile-session.
  def buffer tmpsrc for source.
  find last tmpsess.
  find first tmpsrc of tmpsess where tmpsrc.parent = 0 and tmpsrc.srcid NE 0.
  run initializeself (?, tmpsess.session-id, tmpsrc.srcid).
&endif

  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE dispview C-Win 
PROCEDURE dispview :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
if not available(source) then
  return.

entry(2, source.srcname, " ") no-error.

if error-status:error then /* only one entry... must be main .p name */
  this-srcname = source.srcname.
else this-srcname = entry(1, source.srcname, " ").

DISPLAY this-srcname source.session-percent source.percall-percent 
        source.callcnt source.overhead_time source.avg_acttime 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY reuse_toggle this-srcname 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  IF AVAILABLE source THEN 
    DISPLAY source.session-percent source.percall-percent source.callcnt 
          source.overhead_time source.avg_acttime 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE RECT-1 summarybtn BROWSE-1 allsessionsbtn dupbtn Btn_Done reuse_toggle 
         BROWSE-5 BROWSE-4 BROWSE-2 BROWSE-3 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeself C-Win 
PROCEDURE initializeself :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
def input parameter phdl as handle no-undo.
def input parameter sessid as int no-undo.
def input parameter dotpsrcid as int no-undo.
def var cw as widget-handle no-undo.
def buffer tmpsrc for source.

assign brokerhdl = phdl
       sessionid = sessid
       mainsrcid = dotpsrcid.

find first tmpsrc where tmpsrc.session-id = sessionid
                    and tmpsrc.srcid = mainsrcid.

assign
   cw = this-procedure:current-window
   cw:title = "Profile of """ + tmpsrc.srcname + """ (Session id: " 
               + string(sessid) + ")"
   this-srcname = tmpsrc.srcname.

run enable_UI.

/* enable_ui will open browse-1 which will make it's current record the 1st
 * record in the browse (which is not necessarily the target record, since
 * it's sorted descending by % of session)
 */
if tmpsrc.srcid NE source.srcid then
do:
  /* reset the current record for the source buffer */
  reposition BROWSE-1 to recid recid(tmpsrc).
  if recid(source) ne recid(tmpsrc) then
     get next BROWSE-1.
end.
apply "mouse-select-dblclick" to BROWSE-1 in frame DEFAULT-FRAME.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE view_source C-Win 
PROCEDURE view_source :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
define input parameter inpsrcid as int no-undo.
define input parameter inplineno as int no-undo.
def buffer tmpsrc for source.
find tmpsrc where sessionid = tmpsrc.session-id
              and tmpsrc.srcid = inpsrcid no-error.
if not available(tmpsrc) then
   return.
if tmpsrc.srcid NE source.srcid then
do:
   reposition BROWSE-1 to recid recid(tmpsrc).
   if recid(source) NE recid(tmpsrc) then
     get next BROWSE-1.
   apply "mouse-select-dblclick" to BROWSE-1 in frame default-frame.
end.
if (inplineno GT 0) then
     resetlisting(inplineno).
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION resetlisting C-Win 
FUNCTION resetlisting RETURNS LOGICAL
  ( input id as int /* parameter-definitions */ ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
  def buffer tmplstline for listing-line.
  
  if id eq 0 then
    return false.
  
  find tmplstline where tmplstline.session-id = sessionid
                    and tmplstline.srcid = listing-line.srcid
                    and tmplstline.line-no eq id no-error.
  if not available(tmplstline) then
     return false.

  reposition BROWSE-4 to recid recid(tmplstline).
  if recid(tmplstline) NE recid(listing-line) then
    get next BROWSE-4.

  RETURN TRUE.   /* Function return value. */

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


