 

 /*------------------------------------------------------------------------

    File        : functionInformation

    Purpose     : Provide UI to view functions/procedure infromations

    Syntax      : 

    Description : implement UI for functions/procedures

    Author(s)   : hmariwa

    Created     : Tue Jan 06 17:27:47 EST 2009

    Notes       : 

  ----------------------------------------------------------------------*/



/*********************************************************************

* Copyright (C) 2009 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

USING Progress.Lang.*.

USING Progress.Windows.Form.

USING System.Windows.Forms.*.



CLASS functionInformation INHERITS Form   : 

	

	DEFINE PRIVATE VARIABLE components AS System.ComponentModel.IContainer.



	DEFINE PRIVATE VARIABLE tabControl1 AS System.Windows.Forms.TabControl NO-UNDO.

	DEFINE PRIVATE VARIABLE tabPage2 AS System.Windows.Forms.TabPage NO-UNDO.



	DEFINE PRIVATE VARIABLE Operators AS System.Windows.Forms.TabPage NO-UNDO.



	DEFINE PRIVATE VARIABLE operatorsGridView AS System.Windows.Forms.DataGridView NO-UNDO.

	DEFINE PRIVATE VARIABLE sessionID AS  INTEGER NO-UNDO.

	DEFINE PRIVATE VARIABLE srcid AS  INTEGER NO-UNDO.

    DEFINE PRIVATE VARIABLE operatorsBind AS Progress.Data.BindingSource NO-UNDO.

    DEFINE PUBLIC VARIABLE  operatorshdqry AS HANDLE.   



    DEFINE PRIVATE VARIABLE moduledetailGridView1 AS System.Windows.Forms.DataGridView NO-UNDO.

    DEFINE PRIVATE VARIABLE moduledetailBind AS Progress.Data.BindingSource NO-UNDO.

    DEFINE PUBLIC VARIABLE  moduledetailhdqry AS HANDLE.  

	

	DEFINE TEMP-TABLE ttmodedetail  FIELD nm  AS CHARACTER COLUMN-LABEL "detail description"

                                    FIELD vl AS CHARACTER COLUMN-LABEL "description value".

                                    

    DEFINE PRIVATE VARIABLE src-name AS CHARACTER NO-UNDO. 

                                    

	CONSTRUCTOR PUBLIC functionInformation (  ):

		

		

        SUPER().

        sessionID = 1.

		srcid = 1.

		src-name = "".

        InitializeComponent().

        initializeQueriesBinds().

        CATCH e AS Progress.Lang.Error:

            UNDO, THROW e.

        END CATCH.



	END CONSTRUCTOR.

    

    CONSTRUCTOR PUBLIC functionInformation ( INPUT sid AS INT, INPUT sessid AS INT, INPUT srcnam AS CHAR ):

		

		

        SUPER().

        sessionID = sessid.

		srcid = sid.

		src-name = srcnam.

        InitializeComponent().

        initializeQueriesBinds().

        CATCH e AS Progress.Lang.Error:

            UNDO, THROW e.

        END CATCH.



	END CONSTRUCTOR.

	

	METHOD PRIVATE VOID InitializeComponent(  ):

		

        /* NOTE: The following method is generated by the OpenEdge Advanced GUI Visual Designer.

        

        We strongly suggest that the contents of this method only be modified using the

        Visual Designer to avoid any incompatible modifications.

        

        Modifying the contents of this method using a code editor will invalidate any support for this file. */

        THIS-OBJECT:tabControl1 = NEW System.Windows.Forms.TabControl().

        THIS-OBJECT:Operators = NEW System.Windows.Forms.TabPage().

        THIS-OBJECT:operatorsGridView = NEW System.Windows.Forms.DataGridView().

        THIS-OBJECT:tabPage2 = NEW System.Windows.Forms.TabPage().

        THIS-OBJECT:moduledetailGridView1 = NEW System.Windows.Forms.DataGridView().

        THIS-OBJECT:tabControl1:SuspendLayout().

        THIS-OBJECT:Operators:SuspendLayout().

        CAST(THIS-OBJECT:operatorsGridView, System.ComponentModel.ISupportInitialize):BeginInit().

        THIS-OBJECT:tabPage2:SuspendLayout().

        CAST(THIS-OBJECT:moduledetailGridView1, System.ComponentModel.ISupportInitialize):BeginInit().

        THIS-OBJECT:SuspendLayout().

        /*  */

        /* tabControl1 */

        /*  */

        THIS-OBJECT:tabControl1:Anchor = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:tabControl1:Controls:Add(THIS-OBJECT:Operators).

        THIS-OBJECT:tabControl1:Controls:Add(THIS-OBJECT:tabPage2).

        THIS-OBJECT:tabControl1:HotTrack = TRUE.

        THIS-OBJECT:tabControl1:Location = NEW System.Drawing.Point(12, 32).

        THIS-OBJECT:tabControl1:Name = "tabControl1".

        THIS-OBJECT:tabControl1:SelectedIndex = 0.

        THIS-OBJECT:tabControl1:Size = NEW System.Drawing.Size(583, 464).

        THIS-OBJECT:tabControl1:TabIndex = 0.

        /*  */

        /* Operators */

        /*  */

        THIS-OBJECT:Operators:Controls:Add(THIS-OBJECT:operatorsGridView).

        THIS-OBJECT:Operators:Location = NEW System.Drawing.Point(4, 22).

        THIS-OBJECT:Operators:Name = "Operators".

        THIS-OBJECT:Operators:Padding = NEW System.Windows.Forms.Padding(3).

        THIS-OBJECT:Operators:Size = NEW System.Drawing.Size(575, 438).

        THIS-OBJECT:Operators:TabIndex = 0.

        THIS-OBJECT:Operators:Text = "Operators".

        THIS-OBJECT:Operators:UseVisualStyleBackColor = TRUE.

        /*  */

        /* operatorsGridView */

        /*  */

        THIS-OBJECT:operatorsGridView:AllowUserToAddRows = FALSE.

        THIS-OBJECT:operatorsGridView:AllowUserToDeleteRows = FALSE.

        THIS-OBJECT:operatorsGridView:Anchor = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:operatorsGridView:AutoSizeColumnsMode = System.Windows.Forms.DataGridViewAutoSizeColumnsMode:Fill.

        THIS-OBJECT:operatorsGridView:AutoSizeRowsMode = System.Windows.Forms.DataGridViewAutoSizeRowsMode:AllCells.

        THIS-OBJECT:operatorsGridView:BackgroundColor = System.Drawing.SystemColors:ActiveBorder.

        THIS-OBJECT:operatorsGridView:ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode:AutoSize.

        THIS-OBJECT:operatorsGridView:GridColor = System.Drawing.SystemColors:Desktop.

        THIS-OBJECT:operatorsGridView:Location = NEW System.Drawing.Point(17, 29).

        THIS-OBJECT:operatorsGridView:Name = "operatorsGridView".

        THIS-OBJECT:operatorsGridView:Size = NEW System.Drawing.Size(539, 390).

        THIS-OBJECT:operatorsGridView:TabIndex = 0.

        /*  */

        /* tabPage2 */

        /*  */

        THIS-OBJECT:tabPage2:Controls:Add(THIS-OBJECT:moduledetailGridView1).

        THIS-OBJECT:tabPage2:Location = NEW System.Drawing.Point(4, 22).

        THIS-OBJECT:tabPage2:Name = "tabPage2".

        THIS-OBJECT:tabPage2:Padding = NEW System.Windows.Forms.Padding(3).

        THIS-OBJECT:tabPage2:Size = NEW System.Drawing.Size(575, 438).

        THIS-OBJECT:tabPage2:TabIndex = 1.

        THIS-OBJECT:tabPage2:Text = "Module Detail".

        THIS-OBJECT:tabPage2:UseVisualStyleBackColor = TRUE.

        /*  */

        /* moduledetailGridView1 */

        /*  */

        THIS-OBJECT:moduledetailGridView1:AllowUserToAddRows = FALSE.

        THIS-OBJECT:moduledetailGridView1:AllowUserToDeleteRows = FALSE.

        THIS-OBJECT:moduledetailGridView1:AutoSizeColumnsMode = System.Windows.Forms.DataGridViewAutoSizeColumnsMode:Fill.

        THIS-OBJECT:moduledetailGridView1:AutoSizeRowsMode = System.Windows.Forms.DataGridViewAutoSizeRowsMode:AllCells.

        THIS-OBJECT:moduledetailGridView1:BackgroundColor = System.Drawing.SystemColors:ActiveBorder.

        THIS-OBJECT:moduledetailGridView1:ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode:AutoSize.

        THIS-OBJECT:moduledetailGridView1:GridColor = System.Drawing.SystemColors:Desktop.

        THIS-OBJECT:moduledetailGridView1:Location = NEW System.Drawing.Point(6, 6).

        THIS-OBJECT:moduledetailGridView1:MultiSelect = FALSE.

        THIS-OBJECT:moduledetailGridView1:Name = "moduledetailGridView1".

        THIS-OBJECT:moduledetailGridView1:ReadOnly = TRUE.

        THIS-OBJECT:moduledetailGridView1:Size = NEW System.Drawing.Size(563, 426).

        THIS-OBJECT:moduledetailGridView1:TabIndex = 0.

        /*  */

        /* functionInformation */

        /*  */

        THIS-OBJECT:BackColor = System.Drawing.SystemColors:InactiveCaptionText.

        THIS-OBJECT:ClientSize = NEW System.Drawing.Size(618, 586).

        THIS-OBJECT:Controls:Add(THIS-OBJECT:tabControl1).

        THIS-OBJECT:Name = "functionInformation".

        THIS-OBJECT:Text = "SOURCE:".

        THIS-OBJECT:tabControl1:ResumeLayout(FALSE).

        THIS-OBJECT:Operators:ResumeLayout(FALSE).

        CAST(THIS-OBJECT:operatorsGridView, System.ComponentModel.ISupportInitialize):EndInit().

        THIS-OBJECT:tabPage2:ResumeLayout(FALSE).

        CAST(THIS-OBJECT:moduledetailGridView1, System.ComponentModel.ISupportInitialize):EndInit().

        THIS-OBJECT:ResumeLayout(FALSE).

        CATCH e AS Progress.Lang.Error:

            UNDO, THROW e.

        END CATCH.

	END METHOD.

	

    /*------------------------------------------------------------------------------

			Purpose:  Initialize all queriesand data binds														  

			Notes:  																	  

------------------------------------------------------------------------------*/

   METHOD PRIVATE VOID initializeQueriesBinds( ):

     /* set operators info*/

    CREATE QUERY operatorshdqry.

    operatorshdqry:SET-BUFFERS(BUFFER operators:HANDLE).

    operatorshdqry:QUERY-PREPARE("FOR EACH operators WHERE operators.SESSION-ID = " + STRING(sessionID)

                             + " AND operators.src-id = " + STRING(srcid)

                             + " AND operators.count > 0 "). 

                             

    operatorshdqry:QUERY-OPEN. 

    operatorsBind = NEW Progress.Data.BindingSource(operatorshdqry, "name,count", " "). 

    operatorsBind:AutoSort = TRUE.

    operatorsGridView:DataSource = operatorsBind.

    

  

    /*:::::::::::::::::: set module detail ::::::::::::::::::::::::::::::::::::::*/

     DEFINE VARIABLE bh AS HANDLE  NO-UNDO.

     DEFINE VARIABLE qh AS HANDLE  NO-UNDO.

     DEFINE VARIABLE fh AS HANDLE  NO-UNDO.

     DEFINE VARIABLE i AS INT.

     

     CREATE BUFFER bh FOR TABLE "moduledetail".

     CREATE QUERY qh. 

     qh:SET-BUFFERS(bh). 

     qh:QUERY-PREPARE("FOR EACH  moduledetail WHERE moduledetail.SESSION-ID = " + STRING(sessionID) 

                                              + " AND src-id = " + STRING(srcid)).

     qh:QUERY-OPEN() NO-ERROR.

     IF ERROR-STATUS:ERROR

      THEN DO:

       MESSAGE "NO RECORDS AVAILABLE.." VIEW-AS ALERT-BOX.

       RETURN.

      END.

     qh:GET-FIRST(). 

    

     FOR EACH  _FIELD, _FILE  WHERE _FILE._FILE-NAME = "moduledetail"

      AND _FIELD._FILE-recid = RECID(_FILE)  BY _Col-label  ON ERROR UNDO,LEAVE:

       

       

       fh = bh:BUFFER-FIELD(_FIELD-NAME) NO-ERROR.

       i = fh:BUFFER-VALUE NO-ERROR.

       IF _FIELD-NAME = "isclass" OR ( _FIELD-NAME <> "session-id" AND i > 0) THEN 

       DO:

         CREATE ttmodedetail.

         ttmodedetail.nm = CAPS(_Col-label).

         IF fh:NAME = "isclass" THEN

          DO:

              IF i = 1 THEN

              DO:

               ttmodedetail.vl = "yes".

              END.

              ELSE DO:

               ttmodedetail.vl = "no".

              END.

          END.

          ELSE DO:

              ttmodedetail.vl = STRING(i).

          END.

        END. /*end IF _FIELD-NAME*/

     END. /*end for each*/

     qh:QUERY-CLOSE(). 

     bh:BUFFER-RELEASE(). 

     DELETE OBJECT bh. 

     DELETE OBJECT qh.

     

    CREATE QUERY moduledetailhdqry.

    moduledetailhdqry:SET-BUFFERS(BUFFER ttmodedetail:HANDLE).

    moduledetailhdqry:QUERY-PREPARE("FOR EACH ttmodedetail").

                             

    moduledetailhdqry:QUERY-OPEN. 

    moduledetailBind = NEW Progress.Data.BindingSource(moduledetailhdqry, "nm,vl", " "). 

    moduledetailBind:AutoSort = TRUE.

    moduledetailGridView1:DataSource = moduledetailBind.

    THIS-OBJECT:Text = "SOURCE: " + src-name.

   /*:::::::::::::::::: end of set module detail ::::::::::::::::::::::::::::::::::::::*/

	

   END METHOD.

   

   

METHOD PUBLIC VOID Wait ( ): 

    WAIT-FOR Application:Run ( THIS-OBJECT ). 

 END METHOD. 



DESTRUCTOR PUBLIC functionInformation ( ):



		IF VALID-OBJECT(components) THEN DO:

			CAST(components, System.IDisposable):Dispose().

		END.



	END DESTRUCTOR.



END CLASS.

