 

 /*------------------------------------------------------------------------

    File        : profiler_extension

    Purpose     : implement the UI for the profiler extension

    Syntax      : 

    Description : 

    Author(s)   : hmariwa

    Created     : Fri Jan 02 16:48:59 EST 2009

    Notes       : 

  ----------------------------------------------------------------------*/

/*********************************************************************

* Copyright (C) 2009 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/

USING Progress.Lang.*.

USING Progress.Windows.Form.

USING System.Windows.Forms.*.





CLASS profiler_extension INHERITS Form   : 

	

	DEFINE PRIVATE VARIABLE components AS System.ComponentModel.IContainer.





	DEFINE PRIVATE VARIABLE SeesionInformation AS System.Windows.Forms.GroupBox NO-UNDO.



	DEFINE PRIVATE VARIABLE label1 AS System.Windows.Forms.Label NO-UNDO.



	DEFINE PRIVATE VARIABLE sessdetail AS System.Windows.Forms.Button NO-UNDO.



	DEFINE PRIVATE VARIABLE tableLayoutPanel1 AS System.Windows.Forms.TableLayoutPanel NO-UNDO.





    /* added members*/

    DEFINE PRIVATE VARIABLE sessionID AS  INTEGER NO-UNDO.

    DEFINE PUBLIC VARIABLE hsrcqry AS HANDLE.

    DEFINE PUBLIC VARIABLE srcBind  AS Progress.Data.BindingSource NO-UNDO.



    DEFINE PRIVATE VARIABLE sessionInfoTable AS System.Windows.Forms.TableLayoutPanel NO-UNDO.



    DEFINE PRIVATE VARIABLE sessWaterMark AS System.Windows.Forms.DataGridView NO-UNDO.

    

    DEFINE PRIVATE VARIABLE sessWMBind AS Progress.Data.BindingSource NO-UNDO.

    DEFINE PUBLIC VARIABLE sessWMhdqry AS HANDLE.   

         

    DEFINE PRIVATE VARIABLE databaseBind AS Progress.Data.BindingSource NO-UNDO.

    DEFINE PUBLIC VARIABLE databasehdqry AS HANDLE.   



    DEFINE PRIVATE VARIABLE databaseConnections AS System.Windows.Forms.DataGridView NO-UNDO.



    DEFINE PRIVATE VARIABLE sessWMBox AS System.Windows.Forms.GroupBox NO-UNDO.



    DEFINE PRIVATE VARIABLE databaseBox AS System.Windows.Forms.GroupBox NO-UNDO.



    DEFINE PRIVATE VARIABLE parametersBox1 AS System.Windows.Forms.GroupBox NO-UNDO.



    DEFINE PRIVATE VARIABLE ParametertextBox1 AS System.Windows.Forms.TextBox NO-UNDO.



    DEFINE PRIVATE VARIABLE functionListBox2 AS System.Windows.Forms.GroupBox NO-UNDO.

    DEFINE PRIVATE VARIABLE functionList AS System.Windows.Forms.DataGridView NO-UNDO.

    DEFINE PRIVATE VARIABLE sessDesc  AS CHARACTER NO-UNDO.



    DEFINE PRIVATE VARIABLE helpProvider1 AS System.Windows.Forms.HelpProvider NO-UNDO.





    DEFINE PRIVATE VARIABLE file_menuStrip1 AS System.Windows.Forms.MenuStrip NO-UNDO.

    DEFINE PRIVATE VARIABLE fileToolStripMenuItem1 AS System.Windows.Forms.ToolStripMenuItem NO-UNDO.

    DEFINE PRIVATE VARIABLE toolStripSeparator AS System.Windows.Forms.ToolStripSeparator NO-UNDO.

    DEFINE PRIVATE VARIABLE toolStripSeparator1 AS System.Windows.Forms.ToolStripSeparator NO-UNDO.

    DEFINE PRIVATE VARIABLE toolStripSeparator2 AS System.Windows.Forms.ToolStripSeparator NO-UNDO.

    DEFINE PRIVATE VARIABLE exitToolStripMenuItem AS System.Windows.Forms.ToolStripMenuItem NO-UNDO.

    DEFINE PRIVATE VARIABLE helpToolStripMenuItem AS System.Windows.Forms.ToolStripMenuItem NO-UNDO.

    DEFINE PRIVATE VARIABLE toolStripSeparator5 AS System.Windows.Forms.ToolStripSeparator NO-UNDO.

    DEFINE PRIVATE VARIABLE aboutToolStripMenuItem AS System.Windows.Forms.ToolStripMenuItem NO-UNDO.



    DEFINE PRIVATE VARIABLE functionListCelltoolTip1 AS System.Windows.Forms.ToolTip NO-UNDO.





    DEFINE PRIVATE VARIABLE helpContentsToolStripMenuItem AS System.Windows.Forms.ToolStripMenuItem NO-UNDO.





	CONSTRUCTOR PUBLIC profiler_extension (  ):

		

		

        SUPER().

        sessionID = 1.

        InitializeComponent().

        initializeQueriesBinds().

        CATCH e AS Progress.Lang.Error:

            UNDO, THROW e.

        END CATCH.



	END CONSTRUCTOR.



	CONSTRUCTOR PUBLIC profiler_extension ( INPUT sessid AS INT ):

		

		

        SUPER().

        sessionID = sessid.

        InitializeComponent().

        initializeQueriesBinds().

        CATCH e AS Progress.Lang.Error:

            UNDO, THROW e.

        END CATCH.



	END CONSTRUCTOR.

	



	/*------------------------------------------------------------------------------

			Purpose:  																	  

			Notes:  																	  

	------------------------------------------------------------------------------*/

	@VisualDesigner.

	METHOD PRIVATE VOID aboutToolStripMenuItem_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):

		MessageBox:Show("Profiler Viewer 1.1 to view 10.2B profiler output").

		RETURN.



	END METHOD.





 	/*------------------------------------------------------------------------------

			Purpose:  																	  

			Notes:  																	  

	------------------------------------------------------------------------------*/

	@VisualDesigner.

	METHOD PRIVATE VOID exitToolStripMenuItem_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):

		

		THIS-OBJECT:Close().

		RETURN.



	END METHOD.





 	/*------------------------------------------------------------------------------

			Purpose:  																	  

			Notes:  																	  

	------------------------------------------------------------------------------*/

	@VisualDesigner.

	METHOD PRIVATE VOID functionList_CellMouseDoubleClick( INPUT sender AS System.Object, INPUT e AS System.Windows.Forms.DataGridViewCellMouseEventArgs ):

        DEFINE VARIABLE functinfo  AS functionInformation  NO-UNDO. 

        functinfo = NEW functionInformation(source.srcid, sessionID,source.srcname).

        WAIT-FOR functinfo:ShowDialog().

		RETURN.

	END METHOD.





	/*------------------------------------------------------------------------------

			Purpose:  																	  

			Notes:  																	  

	------------------------------------------------------------------------------*/

	@VisualDesigner.

	METHOD PRIVATE VOID helpContentsToolStripMenuItem_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):

		

		SYSTEM-HELP "help/profilerHelp.chm" CONTENTS.

		RETURN.



	END METHOD.





   	METHOD PRIVATE VOID InitializeComponent(  ):

		

        /* NOTE: The following method is generated by the OpenEdge Advanced GUI Visual Designer.

        

        We strongly suggest that the contents of this method only be modified using the

        Visual Designer to avoid any incompatible modifications.

        

        Modifying the contents of this method using a code editor will invalidate any support for this file. */

        THIS-OBJECT:components = NEW System.ComponentModel.Container().

        @VisualDesigner.FormMember (NeedsInitialize="true").

        DEFINE VARIABLE dataGridViewCellStyle1 AS System.Windows.Forms.DataGridViewCellStyle NO-UNDO.

        dataGridViewCellStyle1 = NEW System.Windows.Forms.DataGridViewCellStyle().

        @VisualDesigner.FormMember (NeedsInitialize="true").

        DEFINE VARIABLE dataGridViewCellStyle2 AS System.Windows.Forms.DataGridViewCellStyle NO-UNDO.

        dataGridViewCellStyle2 = NEW System.Windows.Forms.DataGridViewCellStyle().

        @VisualDesigner.FormMember (NeedsInitialize="true").

        DEFINE VARIABLE dataGridViewCellStyle3 AS System.Windows.Forms.DataGridViewCellStyle NO-UNDO.

        dataGridViewCellStyle3 = NEW System.Windows.Forms.DataGridViewCellStyle().

        @VisualDesigner.FormMember (NeedsInitialize="true").

        DEFINE VARIABLE dataGridViewCellStyle4 AS System.Windows.Forms.DataGridViewCellStyle NO-UNDO.

        dataGridViewCellStyle4 = NEW System.Windows.Forms.DataGridViewCellStyle().

        @VisualDesigner.FormMember (NeedsInitialize="true").

        DEFINE VARIABLE dataGridViewCellStyle5 AS System.Windows.Forms.DataGridViewCellStyle NO-UNDO.

        dataGridViewCellStyle5 = NEW System.Windows.Forms.DataGridViewCellStyle().

        @VisualDesigner.FormMember (NeedsInitialize="true").

        DEFINE VARIABLE dataGridViewCellStyle6 AS System.Windows.Forms.DataGridViewCellStyle NO-UNDO.

        dataGridViewCellStyle6 = NEW System.Windows.Forms.DataGridViewCellStyle().

        @VisualDesigner.FormMember (NeedsInitialize="true").

        DEFINE VARIABLE dataGridViewCellStyle7 AS System.Windows.Forms.DataGridViewCellStyle NO-UNDO.

        dataGridViewCellStyle7 = NEW System.Windows.Forms.DataGridViewCellStyle().

        @VisualDesigner.FormMember (NeedsInitialize="true").

        DEFINE VARIABLE resources AS System.Resources.ResXResourceSet NO-UNDO.

        resources = Progress.Util.ResourceHelper:Load("profiler_extension.resx", PROPATH).

        THIS-OBJECT:SeesionInformation = NEW System.Windows.Forms.GroupBox().

        THIS-OBJECT:sessdetail = NEW System.Windows.Forms.Button().

        THIS-OBJECT:label1 = NEW System.Windows.Forms.Label().

        THIS-OBJECT:tableLayoutPanel1 = NEW System.Windows.Forms.TableLayoutPanel().

        THIS-OBJECT:sessionInfoTable = NEW System.Windows.Forms.TableLayoutPanel().

        THIS-OBJECT:parametersBox1 = NEW System.Windows.Forms.GroupBox().

        THIS-OBJECT:ParametertextBox1 = NEW System.Windows.Forms.TextBox().

        THIS-OBJECT:databaseBox = NEW System.Windows.Forms.GroupBox().

        THIS-OBJECT:databaseConnections = NEW System.Windows.Forms.DataGridView().

        THIS-OBJECT:sessWMBox = NEW System.Windows.Forms.GroupBox().

        THIS-OBJECT:sessWaterMark = NEW System.Windows.Forms.DataGridView().

        THIS-OBJECT:functionListBox2 = NEW System.Windows.Forms.GroupBox().

        THIS-OBJECT:functionList = NEW System.Windows.Forms.DataGridView().

        THIS-OBJECT:helpProvider1 = NEW System.Windows.Forms.HelpProvider().

        THIS-OBJECT:file_menuStrip1 = NEW System.Windows.Forms.MenuStrip().

        THIS-OBJECT:fileToolStripMenuItem1 = NEW System.Windows.Forms.ToolStripMenuItem().

        THIS-OBJECT:toolStripSeparator = NEW System.Windows.Forms.ToolStripSeparator().

        THIS-OBJECT:toolStripSeparator1 = NEW System.Windows.Forms.ToolStripSeparator().

        THIS-OBJECT:toolStripSeparator2 = NEW System.Windows.Forms.ToolStripSeparator().

        THIS-OBJECT:exitToolStripMenuItem = NEW System.Windows.Forms.ToolStripMenuItem().

        THIS-OBJECT:helpToolStripMenuItem = NEW System.Windows.Forms.ToolStripMenuItem().

        THIS-OBJECT:toolStripSeparator5 = NEW System.Windows.Forms.ToolStripSeparator().

        THIS-OBJECT:aboutToolStripMenuItem = NEW System.Windows.Forms.ToolStripMenuItem().

        THIS-OBJECT:helpContentsToolStripMenuItem = NEW System.Windows.Forms.ToolStripMenuItem().

        THIS-OBJECT:functionListCelltoolTip1 = NEW System.Windows.Forms.ToolTip(THIS-OBJECT:components).

        THIS-OBJECT:SeesionInformation:SuspendLayout().

        THIS-OBJECT:tableLayoutPanel1:SuspendLayout().

        THIS-OBJECT:sessionInfoTable:SuspendLayout().

        THIS-OBJECT:parametersBox1:SuspendLayout().

        THIS-OBJECT:databaseBox:SuspendLayout().

        CAST(THIS-OBJECT:databaseConnections, System.ComponentModel.ISupportInitialize):BeginInit().

        THIS-OBJECT:sessWMBox:SuspendLayout().

        CAST(THIS-OBJECT:sessWaterMark, System.ComponentModel.ISupportInitialize):BeginInit().

        THIS-OBJECT:functionListBox2:SuspendLayout().

        CAST(THIS-OBJECT:functionList, System.ComponentModel.ISupportInitialize):BeginInit().

        THIS-OBJECT:file_menuStrip1:SuspendLayout().

        THIS-OBJECT:SuspendLayout().

        /*  */

        /* SeesionInformation */

        /*  */

        THIS-OBJECT:SeesionInformation:Anchor = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:SeesionInformation:AutoSize = TRUE.

        THIS-OBJECT:SeesionInformation:BackColor = System.Drawing.SystemColors:Control.

        THIS-OBJECT:SeesionInformation:Controls:Add(THIS-OBJECT:sessdetail).

        THIS-OBJECT:SeesionInformation:Controls:Add(THIS-OBJECT:label1).

        THIS-OBJECT:SeesionInformation:Font = NEW System.Drawing.Font("Tahoma", 9.75, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).

        THIS-OBJECT:SeesionInformation:Location = NEW System.Drawing.Point(10, 10).

        THIS-OBJECT:SeesionInformation:Name = "SeesionInformation".

        THIS-OBJECT:SeesionInformation:Size = NEW System.Drawing.Size(912, 94).

        THIS-OBJECT:SeesionInformation:TabIndex = 0.

        THIS-OBJECT:SeesionInformation:TabStop = FALSE.

        THIS-OBJECT:SeesionInformation:Text = "<<Session>>".

        THIS-OBJECT:SeesionInformation:UseCompatibleTextRendering = TRUE.

        THIS-OBJECT:SeesionInformation:Enter:SUBSCRIBE(THIS-OBJECT:SeesionInformation_Enter).

        /*  */

        /* sessdetail */

        /*  */

        THIS-OBJECT:sessdetail:BackColor = System.Drawing.SystemColors:GradientActiveCaption.

        THIS-OBJECT:sessdetail:Font = NEW System.Drawing.Font("Tahoma", 9.75, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).

        THIS-OBJECT:sessdetail:Location = NEW System.Drawing.Point(24, 49).

        THIS-OBJECT:sessdetail:Name = "sessdetail".

        THIS-OBJECT:sessdetail:Size = NEW System.Drawing.Size(150, 23).

        THIS-OBJECT:sessdetail:TabIndex = 1.

        THIS-OBJECT:sessdetail:Text = "hide sess. details".

        THIS-OBJECT:sessdetail:UseCompatibleTextRendering = TRUE.

        THIS-OBJECT:sessdetail:UseVisualStyleBackColor = FALSE.

        THIS-OBJECT:sessdetail:Click:SUBSCRIBE(THIS-OBJECT:sessdetail_Click).

        /*  */

        /* label1 */

        /*  */

        THIS-OBJECT:label1:Anchor = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:label1:AutoSize = TRUE.

        THIS-OBJECT:label1:BackColor = System.Drawing.SystemColors:InactiveCaption.

        THIS-OBJECT:label1:BorderStyle = System.Windows.Forms.BorderStyle:FixedSingle.

        THIS-OBJECT:label1:Font = NEW System.Drawing.Font("Tahoma", 9.75, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).

        THIS-OBJECT:label1:Location = NEW System.Drawing.Point(24, 18).

        THIS-OBJECT:label1:Name = "label1".

        THIS-OBJECT:label1:Size = NEW System.Drawing.Size(158, 24).

        THIS-OBJECT:label1:TabIndex = 0.

        THIS-OBJECT:label1:Text = "name: [[somesessname]]".

        THIS-OBJECT:label1:UseCompatibleTextRendering = TRUE.

        /*  */

        /* tableLayoutPanel1 */

        /*  */

        THIS-OBJECT:tableLayoutPanel1:AllowDrop = TRUE.

        THIS-OBJECT:tableLayoutPanel1:Anchor = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:tableLayoutPanel1:AutoScroll = TRUE.

        THIS-OBJECT:tableLayoutPanel1:AutoSize = TRUE.

        THIS-OBJECT:tableLayoutPanel1:BackColor = System.Drawing.Color:Tan.

        THIS-OBJECT:tableLayoutPanel1:CellBorderStyle = System.Windows.Forms.TableLayoutPanelCellBorderStyle:Outset.

        THIS-OBJECT:tableLayoutPanel1:ColumnCount = 1.

        THIS-OBJECT:tableLayoutPanel1:ColumnStyles:Add(NEW System.Windows.Forms.ColumnStyle()).

        THIS-OBJECT:tableLayoutPanel1:Controls:Add(THIS-OBJECT:sessionInfoTable, 0, 3).

        THIS-OBJECT:tableLayoutPanel1:Controls:Add(THIS-OBJECT:SeesionInformation, 0, 0).

        THIS-OBJECT:tableLayoutPanel1:Controls:Add(THIS-OBJECT:functionListBox2, 0, 4).

        THIS-OBJECT:tableLayoutPanel1:Location = NEW System.Drawing.Point(8, 40).

        THIS-OBJECT:tableLayoutPanel1:MinimumSize = NEW System.Drawing.Size(800, 200).

        THIS-OBJECT:tableLayoutPanel1:Name = "tableLayoutPanel1".

        THIS-OBJECT:tableLayoutPanel1:Padding = NEW System.Windows.Forms.Padding(5).

        THIS-OBJECT:tableLayoutPanel1:RowCount = 5.

        THIS-OBJECT:tableLayoutPanel1:RowStyles:Add(NEW System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType:Absolute, 100)).

        THIS-OBJECT:tableLayoutPanel1:RowStyles:Add(NEW System.Windows.Forms.RowStyle()).

        THIS-OBJECT:tableLayoutPanel1:RowStyles:Add(NEW System.Windows.Forms.RowStyle()).

        THIS-OBJECT:tableLayoutPanel1:RowStyles:Add(NEW System.Windows.Forms.RowStyle()).

        THIS-OBJECT:tableLayoutPanel1:RowStyles:Add(NEW System.Windows.Forms.RowStyle()).

        THIS-OBJECT:tableLayoutPanel1:RowStyles:Add(NEW System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType:Absolute, 20)).

        THIS-OBJECT:tableLayoutPanel1:Size = NEW System.Drawing.Size(932, 608).

        THIS-OBJECT:tableLayoutPanel1:TabIndex = 1.

        THIS-OBJECT:tableLayoutPanel1:Paint:SUBSCRIBE(THIS-OBJECT:tableLayoutPanel1_Paint).

        /*  */

        /* sessionInfoTable */

        /*  */

        THIS-OBJECT:sessionInfoTable:AutoScroll = TRUE.

        THIS-OBJECT:sessionInfoTable:AutoSizeMode = System.Windows.Forms.AutoSizeMode:GrowAndShrink.

        THIS-OBJECT:sessionInfoTable:BackColor = System.Drawing.Color:Peru.

        THIS-OBJECT:sessionInfoTable:ColumnCount = 2.

        THIS-OBJECT:sessionInfoTable:ColumnStyles:Add(NEW System.Windows.Forms.ColumnStyle()).

        THIS-OBJECT:sessionInfoTable:ColumnStyles:Add(NEW System.Windows.Forms.ColumnStyle()).

        THIS-OBJECT:sessionInfoTable:Controls:Add(THIS-OBJECT:parametersBox1, 0, 1).

        THIS-OBJECT:sessionInfoTable:Controls:Add(THIS-OBJECT:databaseBox, 1, 0).

        THIS-OBJECT:sessionInfoTable:Controls:Add(THIS-OBJECT:sessWMBox, 0, 0).

        THIS-OBJECT:sessionInfoTable:Dock = System.Windows.Forms.DockStyle:Fill.

        THIS-OBJECT:sessionInfoTable:Font = NEW System.Drawing.Font("Microsoft Sans Serif", 9.75, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).

        THIS-OBJECT:sessionInfoTable:Location = NEW System.Drawing.Point(10, 116).

        THIS-OBJECT:sessionInfoTable:MinimumSize = NEW System.Drawing.Size(0, 50).

        THIS-OBJECT:sessionInfoTable:Name = "sessionInfoTable".

        THIS-OBJECT:sessionInfoTable:Padding = NEW System.Windows.Forms.Padding(1).

        THIS-OBJECT:sessionInfoTable:RowCount = 2.

        THIS-OBJECT:sessionInfoTable:RowStyles:Add(NEW System.Windows.Forms.RowStyle()).

        THIS-OBJECT:sessionInfoTable:RowStyles:Add(NEW System.Windows.Forms.RowStyle()).

        THIS-OBJECT:sessionInfoTable:Size = NEW System.Drawing.Size(912, 225).

        THIS-OBJECT:sessionInfoTable:TabIndex = 2.

        /*  */

        /* parametersBox1 */

        /*  */

        THIS-OBJECT:parametersBox1:AutoSize = TRUE.

        THIS-OBJECT:parametersBox1:BackColor = System.Drawing.SystemColors:ControlLight.

        THIS-OBJECT:sessionInfoTable:SetColumnSpan(THIS-OBJECT:parametersBox1, 2).

        THIS-OBJECT:parametersBox1:Controls:Add(THIS-OBJECT:ParametertextBox1).

        THIS-OBJECT:parametersBox1:Dock = System.Windows.Forms.DockStyle:Bottom.

        THIS-OBJECT:parametersBox1:FlatStyle = System.Windows.Forms.FlatStyle:Popup.

        THIS-OBJECT:parametersBox1:Font = NEW System.Drawing.Font("Microsoft Sans Serif", 9.75, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).

        THIS-OBJECT:parametersBox1:Location = NEW System.Drawing.Point(4, 131).

        THIS-OBJECT:parametersBox1:MaximumSize = NEW System.Drawing.Size(0, 90).

        THIS-OBJECT:parametersBox1:MinimumSize = NEW System.Drawing.Size(0, 90).

        THIS-OBJECT:parametersBox1:Name = "parametersBox1".

        THIS-OBJECT:parametersBox1:Size = NEW System.Drawing.Size(904, 90).

        THIS-OBJECT:parametersBox1:TabIndex = 4.

        THIS-OBJECT:parametersBox1:TabStop = FALSE.

        THIS-OBJECT:parametersBox1:Text = "<<Session's parameters>>".

        THIS-OBJECT:parametersBox1:UseCompatibleTextRendering = TRUE.

        /*  */

        /* ParametertextBox1 */

        /*  */

        THIS-OBJECT:ParametertextBox1:Anchor = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:ParametertextBox1:BackColor = System.Drawing.SystemColors:ActiveCaptionText.

        THIS-OBJECT:ParametertextBox1:BorderStyle = System.Windows.Forms.BorderStyle:FixedSingle.

        THIS-OBJECT:ParametertextBox1:Font = NEW System.Drawing.Font("Microsoft Sans Serif", 8.25, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).

        THIS-OBJECT:ParametertextBox1:Location = NEW System.Drawing.Point(6, 14).

        THIS-OBJECT:ParametertextBox1:Margin = NEW System.Windows.Forms.Padding(12).

        THIS-OBJECT:ParametertextBox1:Multiline = TRUE.

        THIS-OBJECT:ParametertextBox1:Name = "ParametertextBox1".

        THIS-OBJECT:ParametertextBox1:ReadOnly = TRUE.

        THIS-OBJECT:ParametertextBox1:ScrollBars = System.Windows.Forms.ScrollBars:Vertical.

        THIS-OBJECT:ParametertextBox1:Size = NEW System.Drawing.Size(883, 57).

        THIS-OBJECT:ParametertextBox1:TabIndex = 0.

        THIS-OBJECT:ParametertextBox1:Text = "parameters information entered herexxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx".

        /*  */

        /* databaseBox */

        /*  */

        THIS-OBJECT:databaseBox:Anchor = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:databaseBox:AutoSize = TRUE.

        THIS-OBJECT:databaseBox:BackColor = System.Drawing.SystemColors:ControlLight.

        THIS-OBJECT:databaseBox:Controls:Add(THIS-OBJECT:databaseConnections).

        THIS-OBJECT:databaseBox:FlatStyle = System.Windows.Forms.FlatStyle:Popup.

        THIS-OBJECT:databaseBox:Font = NEW System.Drawing.Font("Microsoft Sans Serif", 9.75, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).

        THIS-OBJECT:databaseBox:Location = NEW System.Drawing.Point(360, 4).

        THIS-OBJECT:databaseBox:MinimumSize = NEW System.Drawing.Size(530, 109).

        THIS-OBJECT:databaseBox:Name = "databaseBox".

        THIS-OBJECT:databaseBox:Padding = NEW System.Windows.Forms.Padding(3, 7, 3, 3).

        THIS-OBJECT:databaseBox:Size = NEW System.Drawing.Size(548, 117).

        THIS-OBJECT:databaseBox:TabIndex = 3.

        THIS-OBJECT:databaseBox:TabStop = FALSE.

        THIS-OBJECT:databaseBox:Text = "<<Session's databases>>".

        THIS-OBJECT:databaseBox:UseCompatibleTextRendering = TRUE.

        /*  */

        /* databaseConnections */

        /*  */

        THIS-OBJECT:databaseConnections:AccessibleRole = System.Windows.Forms.AccessibleRole:None.

        THIS-OBJECT:databaseConnections:AllowUserToAddRows = FALSE.

        THIS-OBJECT:databaseConnections:AllowUserToDeleteRows = FALSE.

        THIS-OBJECT:databaseConnections:Anchor = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:databaseConnections:AutoSizeColumnsMode = System.Windows.Forms.DataGridViewAutoSizeColumnsMode:Fill.

        THIS-OBJECT:databaseConnections:AutoSizeRowsMode = System.Windows.Forms.DataGridViewAutoSizeRowsMode:AllCells.

        THIS-OBJECT:databaseConnections:BackgroundColor = System.Drawing.SystemColors:ControlLight.

        THIS-OBJECT:databaseConnections:ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode:AutoSize.

        dataGridViewCellStyle1:Alignment = System.Windows.Forms.DataGridViewContentAlignment:MiddleLeft.

        dataGridViewCellStyle1:BackColor = System.Drawing.SystemColors:Window.

        dataGridViewCellStyle1:Font = NEW System.Drawing.Font("Microsoft Sans Serif", 9.75, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).

        dataGridViewCellStyle1:ForeColor = System.Drawing.SystemColors:ControlText.

        dataGridViewCellStyle1:SelectionBackColor = System.Drawing.SystemColors:Window.

        dataGridViewCellStyle1:SelectionForeColor = System.Drawing.SystemColors:ControlText.

        dataGridViewCellStyle1:WrapMode = System.Windows.Forms.DataGridViewTriState:False.

        THIS-OBJECT:databaseConnections:DefaultCellStyle = dataGridViewCellStyle1.

        THIS-OBJECT:databaseConnections:Location = NEW System.Drawing.Point(20, 25).

        THIS-OBJECT:databaseConnections:Margin = NEW System.Windows.Forms.Padding(5).

        THIS-OBJECT:databaseConnections:MultiSelect = FALSE.

        THIS-OBJECT:databaseConnections:Name = "databaseConnections".

        THIS-OBJECT:databaseConnections:ReadOnly = TRUE.

        dataGridViewCellStyle2:Font = NEW System.Drawing.Font("Microsoft Sans Serif", 8.25, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).

        THIS-OBJECT:databaseConnections:RowsDefaultCellStyle = dataGridViewCellStyle2.

        THIS-OBJECT:databaseConnections:Size = NEW System.Drawing.Size(520, 75).

        THIS-OBJECT:databaseConnections:TabIndex = 1.

        /*  */

        /* sessWMBox */

        /*  */

        THIS-OBJECT:sessWMBox:Anchor = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:sessWMBox:AutoSize = TRUE.

        THIS-OBJECT:sessWMBox:BackColor = System.Drawing.SystemColors:ControlLight.

        THIS-OBJECT:sessWMBox:Controls:Add(THIS-OBJECT:sessWaterMark).

        THIS-OBJECT:sessWMBox:FlatStyle = System.Windows.Forms.FlatStyle:Popup.

        THIS-OBJECT:sessWMBox:Font = NEW System.Drawing.Font("Microsoft Sans Serif", 9.75, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).

        THIS-OBJECT:sessWMBox:Location = NEW System.Drawing.Point(4, 4).

        THIS-OBJECT:sessWMBox:MinimumSize = NEW System.Drawing.Size(350, 0).

        THIS-OBJECT:sessWMBox:Name = "sessWMBox".

        THIS-OBJECT:sessWMBox:Padding = NEW System.Windows.Forms.Padding(3, 7, 3, 3).

        THIS-OBJECT:sessWMBox:Size = NEW System.Drawing.Size(350, 117).

        THIS-OBJECT:sessWMBox:TabIndex = 2.

        THIS-OBJECT:sessWMBox:TabStop = FALSE.

        THIS-OBJECT:sessWMBox:Text = "<<Session's Water Marks>>".

        THIS-OBJECT:sessWMBox:UseCompatibleTextRendering = TRUE.

        /*  */

        /* sessWaterMark */

        /*  */

        THIS-OBJECT:sessWaterMark:AllowUserToAddRows = FALSE.

        THIS-OBJECT:sessWaterMark:AllowUserToDeleteRows = FALSE.

        THIS-OBJECT:sessWaterMark:Anchor = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:sessWaterMark:AutoSizeColumnsMode = System.Windows.Forms.DataGridViewAutoSizeColumnsMode:Fill.

        THIS-OBJECT:sessWaterMark:AutoSizeRowsMode = System.Windows.Forms.DataGridViewAutoSizeRowsMode:AllCells.

        THIS-OBJECT:sessWaterMark:BackgroundColor = System.Drawing.SystemColors:ControlLight.

        THIS-OBJECT:sessWaterMark:ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode:AutoSize.

        dataGridViewCellStyle3:Alignment = System.Windows.Forms.DataGridViewContentAlignment:MiddleLeft.

        dataGridViewCellStyle3:BackColor = System.Drawing.SystemColors:Window.

        dataGridViewCellStyle3:Font = NEW System.Drawing.Font("Microsoft Sans Serif", 9.75, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).

        dataGridViewCellStyle3:ForeColor = System.Drawing.SystemColors:ControlText.

        dataGridViewCellStyle3:NullValue = "0".

        dataGridViewCellStyle3:SelectionBackColor = System.Drawing.SystemColors:ActiveCaptionText.

        dataGridViewCellStyle3:SelectionForeColor = System.Drawing.SystemColors:ControlText.

        dataGridViewCellStyle3:WrapMode = System.Windows.Forms.DataGridViewTriState:False.

        THIS-OBJECT:sessWaterMark:DefaultCellStyle = dataGridViewCellStyle3.

        THIS-OBJECT:sessWaterMark:Location = NEW System.Drawing.Point(6, 25).

        THIS-OBJECT:sessWaterMark:MultiSelect = FALSE.

        THIS-OBJECT:sessWaterMark:Name = "sessWaterMark".

        THIS-OBJECT:sessWaterMark:ReadOnly = TRUE.

        dataGridViewCellStyle4:BackColor = System.Drawing.SystemColors:Control.

        dataGridViewCellStyle4:Font = NEW System.Drawing.Font("Microsoft Sans Serif", 9.75, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).

        dataGridViewCellStyle4:ForeColor = System.Drawing.SystemColors:WindowText.

        dataGridViewCellStyle4:SelectionBackColor = System.Drawing.SystemColors:Highlight.

        dataGridViewCellStyle4:SelectionForeColor = System.Drawing.SystemColors:HighlightText.

        dataGridViewCellStyle4:WrapMode = System.Windows.Forms.DataGridViewTriState:True.

        THIS-OBJECT:sessWaterMark:RowHeadersDefaultCellStyle = dataGridViewCellStyle4.

        dataGridViewCellStyle5:Font = NEW System.Drawing.Font("Microsoft Sans Serif", 8.25, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).

        THIS-OBJECT:sessWaterMark:RowsDefaultCellStyle = dataGridViewCellStyle5.

        THIS-OBJECT:sessWaterMark:ShowCellErrors = FALSE.

        THIS-OBJECT:sessWaterMark:ShowRowErrors = FALSE.

        THIS-OBJECT:sessWaterMark:Size = NEW System.Drawing.Size(332, 71).

        THIS-OBJECT:sessWaterMark:TabIndex = 0.

        THIS-OBJECT:sessWaterMark:CellContentClick:SUBSCRIBE(THIS-OBJECT:sessWaterMark_CellContentClick).

        /*  */

        /* functionListBox2 */

        /*  */

        THIS-OBJECT:functionListBox2:Anchor = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:functionListBox2:AutoSize = TRUE.

        THIS-OBJECT:functionListBox2:BackColor = System.Drawing.Color:Silver.

        THIS-OBJECT:functionListBox2:Controls:Add(THIS-OBJECT:functionList).

        THIS-OBJECT:functionListBox2:Location = NEW System.Drawing.Point(10, 349).

        THIS-OBJECT:functionListBox2:MinimumSize = NEW System.Drawing.Size(0, 100).

        THIS-OBJECT:functionListBox2:Name = "functionListBox2".

        THIS-OBJECT:functionListBox2:Size = NEW System.Drawing.Size(912, 249).

        THIS-OBJECT:functionListBox2:TabIndex = 4.

        THIS-OBJECT:functionListBox2:TabStop = FALSE.

        THIS-OBJECT:functionListBox2:Text = "<<Session's functions/procedures>>".

        THIS-OBJECT:functionListBox2:UseCompatibleTextRendering = TRUE.

        /*  */

        /* functionList */

        /*  */

        THIS-OBJECT:functionList:AllowUserToAddRows = FALSE.

        THIS-OBJECT:functionList:AllowUserToDeleteRows = FALSE.

        THIS-OBJECT:functionList:AutoSizeColumnsMode = System.Windows.Forms.DataGridViewAutoSizeColumnsMode:Fill.

        THIS-OBJECT:functionList:AutoSizeRowsMode = System.Windows.Forms.DataGridViewAutoSizeRowsMode:AllCellsExceptHeaders.

        THIS-OBJECT:functionList:BackgroundColor = System.Drawing.SystemColors:ButtonFace.

        THIS-OBJECT:functionList:ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode:AutoSize.

        dataGridViewCellStyle6:Alignment = System.Windows.Forms.DataGridViewContentAlignment:MiddleLeft.

        dataGridViewCellStyle6:BackColor = System.Drawing.SystemColors:Window.

        dataGridViewCellStyle6:Font = NEW System.Drawing.Font("Microsoft Sans Serif", 8.25, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).

        dataGridViewCellStyle6:ForeColor = System.Drawing.SystemColors:ControlText.

        dataGridViewCellStyle6:Padding = NEW System.Windows.Forms.Padding(3).

        dataGridViewCellStyle6:SelectionBackColor = System.Drawing.SystemColors:Highlight.

        dataGridViewCellStyle6:SelectionForeColor = System.Drawing.SystemColors:HighlightText.

        dataGridViewCellStyle6:WrapMode = System.Windows.Forms.DataGridViewTriState:False.

        THIS-OBJECT:functionList:DefaultCellStyle = dataGridViewCellStyle6.

        THIS-OBJECT:functionList:Dock = System.Windows.Forms.DockStyle:Fill.

        THIS-OBJECT:functionList:Location = NEW System.Drawing.Point(3, 16).

        THIS-OBJECT:functionList:Margin = NEW System.Windows.Forms.Padding(5).

        THIS-OBJECT:functionList:MultiSelect = FALSE.

        THIS-OBJECT:functionList:Name = "functionList".

        THIS-OBJECT:functionList:ReadOnly = TRUE.

        dataGridViewCellStyle7:Format = "N2".

        dataGridViewCellStyle7:NullValue = ?.

        dataGridViewCellStyle7:SelectionBackColor = System.Drawing.Color:Olive.

        THIS-OBJECT:functionList:RowsDefaultCellStyle = dataGridViewCellStyle7.

        THIS-OBJECT:functionList:SelectionMode = System.Windows.Forms.DataGridViewSelectionMode:FullRowSelect.

        THIS-OBJECT:functionList:Size = NEW System.Drawing.Size(906, 230).

        THIS-OBJECT:functionList:TabIndex = 1.

        THIS-OBJECT:functionList:CellMouseDoubleClick:SUBSCRIBE(THIS-OBJECT:functionList_CellMouseDoubleClick).

        /*  */

        /* file_menuStrip1 */

        /*  */

        THIS-OBJECT:file_menuStrip1:BackColor = System.Drawing.Color:DarkGray.

        THIS-OBJECT:file_menuStrip1:BackgroundImage = CAST(resources:GetObject("file_menuStrip1.BackgroundImage"), System.Drawing.Image).

        @VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").

        DEFINE VARIABLE arrayvar0 AS System.Windows.Forms.ToolStripItem EXTENT 2 NO-UNDO.

        arrayvar0[1] = THIS-OBJECT:fileToolStripMenuItem1.

        arrayvar0[2] = THIS-OBJECT:helpToolStripMenuItem.

        THIS-OBJECT:file_menuStrip1:Items:AddRange(arrayvar0).

        THIS-OBJECT:file_menuStrip1:Location = NEW System.Drawing.Point(5, 5).

        THIS-OBJECT:file_menuStrip1:Name = "file_menuStrip1".

        THIS-OBJECT:file_menuStrip1:Size = NEW System.Drawing.Size(933, 24).

        THIS-OBJECT:file_menuStrip1:TabIndex = 2.

        THIS-OBJECT:file_menuStrip1:Text = "FILE".

        /*  */

        /* fileToolStripMenuItem1 */

        /*  */

        @VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").

        DEFINE VARIABLE arrayvar1 AS System.Windows.Forms.ToolStripItem EXTENT 4 NO-UNDO.

        arrayvar1[1] = THIS-OBJECT:toolStripSeparator.

        arrayvar1[2] = THIS-OBJECT:toolStripSeparator1.

        arrayvar1[3] = THIS-OBJECT:toolStripSeparator2.

        arrayvar1[4] = THIS-OBJECT:exitToolStripMenuItem.

        THIS-OBJECT:fileToolStripMenuItem1:DropDownItems:AddRange(arrayvar1).

        THIS-OBJECT:fileToolStripMenuItem1:Name = "fileToolStripMenuItem1".

        THIS-OBJECT:fileToolStripMenuItem1:Size = NEW System.Drawing.Size(35, 20).

        THIS-OBJECT:fileToolStripMenuItem1:Text = "&File".

        /*  */

        /* toolStripSeparator */

        /*  */

        THIS-OBJECT:toolStripSeparator:Name = "toolStripSeparator".

        THIS-OBJECT:toolStripSeparator:Size = NEW System.Drawing.Size(100, 6).

        /*  */

        /* toolStripSeparator1 */

        /*  */

        THIS-OBJECT:toolStripSeparator1:Name = "toolStripSeparator1".

        THIS-OBJECT:toolStripSeparator1:Size = NEW System.Drawing.Size(100, 6).

        /*  */

        /* toolStripSeparator2 */

        /*  */

        THIS-OBJECT:toolStripSeparator2:Name = "toolStripSeparator2".

        THIS-OBJECT:toolStripSeparator2:Size = NEW System.Drawing.Size(100, 6).

        /*  */

        /* exitToolStripMenuItem */

        /*  */

        THIS-OBJECT:exitToolStripMenuItem:Name = "exitToolStripMenuItem".

        THIS-OBJECT:exitToolStripMenuItem:Size = NEW System.Drawing.Size(103, 22).

        THIS-OBJECT:exitToolStripMenuItem:Text = "E&xit".

        THIS-OBJECT:exitToolStripMenuItem:Click:SUBSCRIBE(THIS-OBJECT:exitToolStripMenuItem_Click).

        /*  */

        /* helpToolStripMenuItem */

        /*  */

        @VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").

        DEFINE VARIABLE arrayvar2 AS System.Windows.Forms.ToolStripItem EXTENT 3 NO-UNDO.

        arrayvar2[1] = THIS-OBJECT:toolStripSeparator5.

        arrayvar2[2] = THIS-OBJECT:aboutToolStripMenuItem.

        arrayvar2[3] = THIS-OBJECT:helpContentsToolStripMenuItem.

        THIS-OBJECT:helpToolStripMenuItem:DropDownItems:AddRange(arrayvar2).

        THIS-OBJECT:helpToolStripMenuItem:Name = "helpToolStripMenuItem".

        THIS-OBJECT:helpToolStripMenuItem:Size = NEW System.Drawing.Size(40, 20).

        THIS-OBJECT:helpToolStripMenuItem:Text = "&Help".

        /*  */

        /* toolStripSeparator5 */

        /*  */

        THIS-OBJECT:toolStripSeparator5:Name = "toolStripSeparator5".

        THIS-OBJECT:toolStripSeparator5:Size = NEW System.Drawing.Size(183, 6).

        /*  */

        /* aboutToolStripMenuItem */

        /*  */

        THIS-OBJECT:aboutToolStripMenuItem:Name = "aboutToolStripMenuItem".

        THIS-OBJECT:aboutToolStripMenuItem:Size = NEW System.Drawing.Size(186, 22).

        THIS-OBJECT:aboutToolStripMenuItem:Text = "&About profiler viewer".

        THIS-OBJECT:aboutToolStripMenuItem:Click:SUBSCRIBE(THIS-OBJECT:aboutToolStripMenuItem_Click).

        /*  */

        /* helpContentsToolStripMenuItem */

        /*  */

        THIS-OBJECT:helpContentsToolStripMenuItem:Name = "helpContentsToolStripMenuItem".

        THIS-OBJECT:helpContentsToolStripMenuItem:Size = NEW System.Drawing.Size(186, 22).

        THIS-OBJECT:helpContentsToolStripMenuItem:Text = "Help Contents".

        THIS-OBJECT:helpContentsToolStripMenuItem:Click:SUBSCRIBE(THIS-OBJECT:helpContentsToolStripMenuItem_Click).

        /*  */

        /* profiler_extension */

        /*  */

        THIS-OBJECT:AutoScroll = TRUE.

        THIS-OBJECT:AutoSize = TRUE.

        THIS-OBJECT:BackColor = System.Drawing.Color:Silver.

        THIS-OBJECT:BackgroundImage = CAST(resources:GetObject("$this.BackgroundImage"), System.Drawing.Image).

        THIS-OBJECT:ClientSize = NEW System.Drawing.Size(943, 656).

        THIS-OBJECT:Controls:Add(THIS-OBJECT:tableLayoutPanel1).

        THIS-OBJECT:Controls:Add(THIS-OBJECT:file_menuStrip1).

        THIS-OBJECT:MainMenuStrip = THIS-OBJECT:file_menuStrip1.

        THIS-OBJECT:Name = "profiler_extension".

        THIS-OBJECT:Padding = NEW System.Windows.Forms.Padding(5).

        THIS-OBJECT:helpProvider1:SetShowHelp(THIS-OBJECT, TRUE).

        THIS-OBJECT:SizeGripStyle = System.Windows.Forms.SizeGripStyle:Show.

        THIS-OBJECT:Text = "EXTENDED PROFILER VIEWER".

        THIS-OBJECT:Load:SUBSCRIBE(THIS-OBJECT:profiler_extension_Load).

        THIS-OBJECT:SeesionInformation:ResumeLayout(FALSE).

        THIS-OBJECT:SeesionInformation:PerformLayout().

        THIS-OBJECT:tableLayoutPanel1:ResumeLayout(FALSE).

        THIS-OBJECT:tableLayoutPanel1:PerformLayout().

        THIS-OBJECT:sessionInfoTable:ResumeLayout(FALSE).

        THIS-OBJECT:sessionInfoTable:PerformLayout().

        THIS-OBJECT:parametersBox1:ResumeLayout(FALSE).

        THIS-OBJECT:parametersBox1:PerformLayout().

        THIS-OBJECT:databaseBox:ResumeLayout(FALSE).

        CAST(THIS-OBJECT:databaseConnections, System.ComponentModel.ISupportInitialize):EndInit().

        THIS-OBJECT:sessWMBox:ResumeLayout(FALSE).

        CAST(THIS-OBJECT:sessWaterMark, System.ComponentModel.ISupportInitialize):EndInit().

        THIS-OBJECT:functionListBox2:ResumeLayout(FALSE).

        CAST(THIS-OBJECT:functionList, System.ComponentModel.ISupportInitialize):EndInit().

        THIS-OBJECT:file_menuStrip1:ResumeLayout(FALSE).

        THIS-OBJECT:file_menuStrip1:PerformLayout().

        THIS-OBJECT:ResumeLayout(FALSE).

        THIS-OBJECT:PerformLayout().

        CATCH e AS Progress.Lang.Error:

            UNDO, THROW e.

        END CATCH.

	END METHOD.











	/*------------------------------------------------------------------------------

			Purpose:  																	  

			Notes:  																	  

	------------------------------------------------------------------------------*/

	@VisualDesigner.

	METHOD PRIVATE VOID profiler_extension_Load( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):

		

		RETURN.



	END METHOD.





   	/*------------------------------------------------------------------------------

			Purpose:  																	  

			Notes:  																	  

	------------------------------------------------------------------------------*/

	@VisualDesigner.

	METHOD PRIVATE VOID SeesionInformation_Enter( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):

		

		RETURN.



	END METHOD.







   /*------------------------------------------------------------------------------

			Purpose:  Initialize all queriesand data binds														  

			Notes:  																	  

------------------------------------------------------------------------------*/

   METHOD PRIVATE VOID initializeQueriesBinds( ):

     /* source -func list*/

    CREATE QUERY hsrcqry.

    hsrcqry:SET-BUFFERS(BUFFER source:HANDLE).

    hsrcqry:QUERY-PREPARE("FOR EACH SOURCE WHERE SOURCE.SESSION-ID = " + STRING(sessionID)

                           + " AND SOURCE.srcid > 0 AND SOURCE.callcnt > 0 "). 

    hsrcqry:QUERY-OPEN. 

    srcBind = NEW Progress.Data.BindingSource(hsrcqry, "srcid,srcname,callcnt,tot_acttime,session-percent", " "). 

    srcBind:AutoSort = TRUE.

    functionList:DataSource = srcBind.

	

	/*session watermark*/

	CREATE QUERY sessWMhdqry.

	sessWMhdqry:SET-BUFFERS(BUFFER watermark:HANDLE).

    sessWMhdqry:QUERY-PREPARE("FOR EACH watermark WHERE watermark.SESSION-ID = " + STRING(sessionID)). 

	sessWMBind = NEW Progress.Data.BindingSource(sessWMhdqry, "nested-blocks, pers-proc-class,accessed-ttabs", " "). 

    sessWaterMark:DataSource = sessWMBind.

    

    /*database connections */

    CREATE QUERY databasehdqry.

	databasehdqry:SET-BUFFERS(BUFFER databases:HANDLE).

    databasehdqry:QUERY-PREPARE("FOR EACH databases WHERE databases.SESSION-ID = " + STRING(sessionID)). 

	databaseBind = NEW Progress.Data.BindingSource(databasehdqry, "name,num-tables", " "). 

    databaseConnections:DataSource = databaseBind.

    

    /*session's parameters*/

     FIND parameters WHERE parameters.session-id = sessionID NO-ERROR.

     IF AVAILABLE parameters THEN  DO:

      THIS-OBJECT:ParametertextBox1:Text = parameters.paraminfo.

     END.

     ELSE DO:

      THIS-OBJECT:ParametertextBox1:Text = "".

     END.

     

     sessionInfoTable:Visible = TRUE.

     

     /*get & set the session name*/

     FIND Profile-Session WHERE Profile-Session.session-id = sessionID NO-ERROR.

     IF AVAILABLE Profile-Session THEN  DO:

      sessDesc =  Profile-Session.Session-Desc.

     END.

     ELSE DO:

      sessDesc = "".

     END.

     THIS-OBJECT:label1:Text = "Session Description::" + sessDesc.

   END METHOD.

   

   

	/*------------------------------------------------------------------------------

			Purpose:  																	  

			Notes:  																	  

	------------------------------------------------------------------------------*/

	@VisualDesigner.

	METHOD PRIVATE VOID sessdetail_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):

		DEFINE VAR buttnam AS CHAR.

		buttnam = THIS-OBJECT:sessdetail:Text.

		IF COMPARE(buttnam, "=", "view sess. details","CASE-INSENSITIVE") THEN DO:

		  THIS-OBJECT:sessdetail:Text = "hide sess. details".

		  sessionInfoTable:Visible = TRUE.

		END.

		ELSE DO:

		  THIS-OBJECT:sessdetail:Text = "view sess. details".

		  sessionInfoTable:Visible = FALSE.

	    END.

		

		RETURN.



	END METHOD.



	/*------------------------------------------------------------------------------

			Purpose:  																	  

			Notes:  																	  

	------------------------------------------------------------------------------*/

	@VisualDesigner.

	METHOD PRIVATE VOID sessWaterMark_CellContentClick( INPUT sender AS System.Object, INPUT e AS System.Windows.Forms.DataGridViewCellEventArgs ):

		

		RETURN.



	END METHOD.





 	/*------------------------------------------------------------------------------

			Purpose:  																	  

			Notes:  																	  

	------------------------------------------------------------------------------*/

	@VisualDesigner.

	METHOD PRIVATE VOID tableLayoutPanel1_Paint( INPUT sender AS System.Object, INPUT e AS System.Windows.Forms.PaintEventArgs ):

		

		RETURN.



	END METHOD.







   METHOD PUBLIC VOID Wait ( ): 

      

    WAIT-FOR Application:Run ( THIS-OBJECT ). 

 END METHOD. 

 



	DESTRUCTOR PUBLIC profiler_extension ( ):



		IF VALID-OBJECT(components) THEN DO:

			CAST(components, System.IDisposable):Dispose().

		END.



	END DESTRUCTOR.



END CLASS.







