 

 /*------------------------------------------------------------------------

    File        : profiler_extension2

    Purpose     : Provide the main entrace for profiler extension GUI

    Syntax      : 

    Description : main profiler extension  GUI 

    Author(s)   : hmariwa

    Created     : Fri Jan 30 17:58:50 EST 2009

    Notes       : 

  ----------------------------------------------------------------------*/

  

/*********************************************************************

* Copyright (C) 2009 by Progress Software Corporation ("PSC"),       *

* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *

* below.  All Rights Reserved.                                       *

*                                                                    *

* The Initial Developer of the Original Code is PSC.  The Original   *

* Code is Progress IDE code released to open source December 1, 2000.*

*                                                                    *

* The contents of this file are subject to the Possenet Public       *

* License Version 1.0 (the "License"); you may not use this file     *

* except in compliance with the License.  A copy of the License is   *

* available as of the date of this notice at                         *

* http://www.possenet.org/license.html                               *

*                                                                    *

* Software distributed under the License is distributed on an "AS IS"*

* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*

* should refer to the License for the specific language governing    *

* rights and limitations under the License.                          *

*                                                                    *

* Contributors:                                                      *

*                                                                    *

*********************************************************************/



USING Progress.Lang.*.

USING Progress.Windows.Form.

USING System.Windows.Forms.*.

USING System.*.

USING System.Array.*.

USING System.Collections.*.





CLASS profiler_extension2 INHERITS Form   : 

	

	DEFINE PRIVATE VARIABLE components AS System.ComponentModel.IContainer.





	DEFINE PRIVATE VARIABLE menuStrip1 AS System.Windows.Forms.MenuStrip NO-UNDO.

	DEFINE PRIVATE VARIABLE fileToolStripMenuItem AS System.Windows.Forms.ToolStripMenuItem NO-UNDO.

	DEFINE PRIVATE VARIABLE newToolStripMenuItem AS System.Windows.Forms.ToolStripMenuItem NO-UNDO.

    DEFINE PRIVATE VARIABLE OperatorsdataGridView AS System.Windows.Forms.DataGridView NO-UNDO.

    DEFINE PRIVATE VARIABLE OperatorsSummarydataPage AS System.Windows.Forms.TabPage NO-UNDO.

    DEFINE PRIVATE VARIABLE SessionData AS System.Windows.Forms.TabControl NO-UNDO.

    DEFINE PRIVATE VARIABLE sessStatsdataGridView1 AS System.Windows.Forms.DataGridView NO-UNDO.

    DEFINE PRIVATE VARIABLE sessStatstabPage1 AS System.Windows.Forms.TabPage NO-UNDO.

	DEFINE PRIVATE VARIABLE toolStripSeparator2 AS System.Windows.Forms.ToolStripSeparator NO-UNDO.

	DEFINE PRIVATE VARIABLE exitToolStripMenuItem AS System.Windows.Forms.ToolStripMenuItem NO-UNDO.

	DEFINE PRIVATE VARIABLE helpToolStripMenuItem AS System.Windows.Forms.ToolStripMenuItem NO-UNDO.

	DEFINE PRIVATE VARIABLE contentsToolStripMenuItem AS System.Windows.Forms.ToolStripMenuItem NO-UNDO.

	DEFINE PRIVATE VARIABLE toolStripSeparator5 AS System.Windows.Forms.ToolStripSeparator NO-UNDO.

	DEFINE PRIVATE VARIABLE aboutToolStripMenuItem AS System.Windows.Forms.ToolStripMenuItem NO-UNDO.





	DEFINE PRIVATE VARIABLE SesInfotableLayout AS System.Windows.Forms.TableLayoutPanel NO-UNDO.



	DEFINE PRIVATE VARIABLE SessInfopanel1 AS System.Windows.Forms.Panel NO-UNDO.



	DEFINE PRIVATE VARIABLE SessWMgroupBox1 AS System.Windows.Forms.GroupBox NO-UNDO.



	DEFINE PRIVATE VARIABLE SessDatabasegroupBox1 AS System.Windows.Forms.GroupBox NO-UNDO.



	DEFINE PRIVATE VARIABLE ParamtableLayout AS System.Windows.Forms.TableLayoutPanel NO-UNDO.



	DEFINE PRIVATE VARIABLE ParmgroupBox1 AS System.Windows.Forms.GroupBox NO-UNDO.



	DEFINE PRIVATE VARIABLE SessWMdataGridView AS System.Windows.Forms.DataGridView NO-UNDO.



    /* added members*/

    DEFINE PRIVATE VARIABLE sessionID AS  INTEGER NO-UNDO.

    DEFINE PUBLIC VARIABLE hsrcqry AS HANDLE.

    DEFINE PUBLIC VARIABLE srcBind  AS Progress.Data.BindingSource NO-UNDO.

    DEFINE PRIVATE VARIABLE sessWMBind AS Progress.Data.BindingSource NO-UNDO.

    DEFINE PUBLIC VARIABLE sessWMhdqry AS HANDLE.   

    DEFINE PRIVATE VARIABLE databaseBind AS Progress.Data.BindingSource NO-UNDO.

    DEFINE PUBLIC VARIABLE databasehdqry AS HANDLE.   

    DEFINE PRIVATE VARIABLE sessDesc  AS CHARACTER NO-UNDO.

    DEFINE PUBLIC VARIABLE hmodqry AS HANDLE.

    DEFINE PUBLIC VARIABLE modBind  AS Progress.Data.BindingSource NO-UNDO.

    DEFINE PUBLIC VARIABLE operatorsqry AS HANDLE.

    DEFINE PUBLIC VARIABLE operatorsBind  AS Progress.Data.BindingSource NO-UNDO.

    DEFINE PUBLIC VARIABLE sessModqry AS HANDLE.

    DEFINE PUBLIC VARIABLE sessModBind  AS Progress.Data.BindingSource NO-UNDO.

    DEFINE PUBLIC VARIABLE sessStatsqry AS HANDLE.

    DEFINE PUBLIC VARIABLE sessStatsBind  AS Progress.Data.BindingSource NO-UNDO.

    DEFINE TEMP-TABLE ttOperatorsData  FIELD nm  AS CHARACTER    COLUMN-LABEL "Operator/Action Name"

                                       FIELD totalc AS INTEGER   COLUMN-LABEL "Total Count"

                                       FIELD descpt AS CHARACTER COLUMN-LABEL "E-CODE/ACTION-CODE". 

                                                             

    DEFINE TEMP-TABLE ttSessionDataSummary  FIELD fld  AS CHARACTER COLUMN-LABEL "DESCRIPTIONS"

                                            FIELD val  AS CHARACTER COLUMN-LABEL "VALUE".

                                            

    DEFINE TEMP-TABLE ttSessionStats        FIELD fld       AS CHARACTER COLUMN-LABEL "DESCRIPTIONS"

                                            FIELD totv      AS CHARACTER INITIAL "N/A" COLUMN-LABEL "TOTAL"

                                            FIELD avgv      AS CHARACTER INITIAL "N/A" COLUMN-LABEL "AVERAGE"

                                            FIELD maxv      AS CHARACTER INITIAL "N/A" COLUMN-LABEL "MAXIMUM"

                                            FIELD minv      AS CHARACTER INITIAL "N/A" COLUMN-LABEL "MINIMUM"

                                            FIELD medianv   AS CHARACTER INITIAL "N/A" COLUMN-LABEL "MEDIAN".

                                            

    DEFINE PRIVATE VARIABLE databasedataGrid AS System.Windows.Forms.DataGridView NO-UNDO.



    DEFINE PRIVATE VARIABLE parmtextBox1 AS System.Windows.Forms.TextBox NO-UNDO.



    DEFINE PRIVATE VARIABLE ProcedureListpanel1 AS System.Windows.Forms.Panel NO-UNDO.



    DEFINE PRIVATE VARIABLE ProcedureTimetabPage1 AS System.Windows.Forms.TabPage NO-UNDO.



    DEFINE PRIVATE VARIABLE ProcedureDetailstabPage2 AS System.Windows.Forms.TabPage NO-UNDO.



    DEFINE PRIVATE VARIABLE ProcedureTimedataGrid AS System.Windows.Forms.DataGridView NO-UNDO.



    DEFINE PRIVATE VARIABLE moduleDetailsdataGrid AS System.Windows.Forms.DataGridView NO-UNDO.

    

		

	CONSTRUCTOR PUBLIC profiler_extension2 (  ):

		

		

        SUPER().

        sessionID = 1.

        InitializeComponent().

        initializeQueriesBinds().

        CATCH e AS Progress.Lang.Error:

            UNDO, THROW e.

        END CATCH.



	END CONSTRUCTOR.

    

    CONSTRUCTOR PUBLIC profiler_extension2 ( INPUT sessid AS INT ):

		

		

        SUPER().

        sessionID = sessid.

        InitializeComponent().

        initializeQueriesBinds().

        CATCH e AS Progress.Lang.Error:

            UNDO, THROW e.

        END CATCH.



	END CONSTRUCTOR.

	

	/*------------------------------------------------------------------------------

			Purpose:  																	  

			Notes:  																	  

	------------------------------------------------------------------------------*/

	@VisualDesigner.

	METHOD PRIVATE VOID aboutToolStripMenuItem_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):

		

		MessageBox:Show("Profiler Viewer 1.1 (2009) to view extended 10.2B profiler output").

		RETURN.



	END METHOD.





 	/*------------------------------------------------------------------------------

			Purpose:  																	  

			Notes:  																	  

	------------------------------------------------------------------------------*/

	@VisualDesigner.

	METHOD PRIVATE VOID contentsToolStripMenuItem_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):

		

		SYSTEM-HELP "help/profilerHelp.chm" CONTENTS.

		RETURN.



	END METHOD.





	/*------------------------------------------------------------------------------

			Purpose:  																	  

			Notes:  																	  

	------------------------------------------------------------------------------*/

	@VisualDesigner.

	METHOD PRIVATE VOID exitToolStripMenuItem_Click( INPUT sender AS System.Object, INPUT e AS System.EventArgs ):

		

		THIS-OBJECT:Close().

		RETURN.



	END METHOD.





  	METHOD PRIVATE VOID InitializeComponent(  ):

		

        /* NOTE: The following method is generated by the OpenEdge Advanced GUI Visual Designer.

        

        We strongly suggest that the contents of this method only be modified using the

        Visual Designer to avoid any incompatible modifications.

        

        Modifying the contents of this method using a code editor will invalidate any support for this file. */

        @VisualDesigner.FormMember (NeedsInitialize="true").

        DEFINE VARIABLE dataGridViewCellStyle1 AS System.Windows.Forms.DataGridViewCellStyle NO-UNDO.

        dataGridViewCellStyle1 = NEW System.Windows.Forms.DataGridViewCellStyle().

        @VisualDesigner.FormMember (NeedsInitialize="true").

        DEFINE VARIABLE dataGridViewCellStyle2 AS System.Windows.Forms.DataGridViewCellStyle NO-UNDO.

        dataGridViewCellStyle2 = NEW System.Windows.Forms.DataGridViewCellStyle().

        @VisualDesigner.FormMember (NeedsInitialize="true").

        DEFINE VARIABLE dataGridViewCellStyle3 AS System.Windows.Forms.DataGridViewCellStyle NO-UNDO.

        dataGridViewCellStyle3 = NEW System.Windows.Forms.DataGridViewCellStyle().

        @VisualDesigner.FormMember (NeedsInitialize="true").

        DEFINE VARIABLE resources AS Progress.Util.ResourceManager NO-UNDO.

        resources = NEW Progress.Util.ResourceManager("profiler_extension2").

        @VisualDesigner.FormMember (NeedsInitialize="true").

        DEFINE VARIABLE dataGridViewCellStyle4 AS System.Windows.Forms.DataGridViewCellStyle NO-UNDO.

        dataGridViewCellStyle4 = NEW System.Windows.Forms.DataGridViewCellStyle().

        @VisualDesigner.FormMember (NeedsInitialize="true").

        DEFINE VARIABLE dataGridViewCellStyle5 AS System.Windows.Forms.DataGridViewCellStyle NO-UNDO.

        dataGridViewCellStyle5 = NEW System.Windows.Forms.DataGridViewCellStyle().

        @VisualDesigner.FormMember (NeedsInitialize="true").

        DEFINE VARIABLE dataGridViewCellStyle6 AS System.Windows.Forms.DataGridViewCellStyle NO-UNDO.

        dataGridViewCellStyle6 = NEW System.Windows.Forms.DataGridViewCellStyle().

        @VisualDesigner.FormMember (NeedsInitialize="true").

        DEFINE VARIABLE dataGridViewCellStyle7 AS System.Windows.Forms.DataGridViewCellStyle NO-UNDO.

        dataGridViewCellStyle7 = NEW System.Windows.Forms.DataGridViewCellStyle().

        @VisualDesigner.FormMember (NeedsInitialize="true").

        DEFINE VARIABLE dataGridViewCellStyle8 AS System.Windows.Forms.DataGridViewCellStyle NO-UNDO.

        dataGridViewCellStyle8 = NEW System.Windows.Forms.DataGridViewCellStyle().

        THIS-OBJECT:SessInfopanel1 = NEW System.Windows.Forms.Panel().

        THIS-OBJECT:ParamtableLayout = NEW System.Windows.Forms.TableLayoutPanel().

        THIS-OBJECT:ParmgroupBox1 = NEW System.Windows.Forms.GroupBox().

        THIS-OBJECT:parmtextBox1 = NEW System.Windows.Forms.TextBox().

        THIS-OBJECT:SesInfotableLayout = NEW System.Windows.Forms.TableLayoutPanel().

        THIS-OBJECT:SessWMgroupBox1 = NEW System.Windows.Forms.GroupBox().

        THIS-OBJECT:SessWMdataGridView = NEW System.Windows.Forms.DataGridView().

        THIS-OBJECT:SessDatabasegroupBox1 = NEW System.Windows.Forms.GroupBox().

        THIS-OBJECT:databasedataGrid = NEW System.Windows.Forms.DataGridView().

        THIS-OBJECT:menuStrip1 = NEW System.Windows.Forms.MenuStrip().

        THIS-OBJECT:fileToolStripMenuItem = NEW System.Windows.Forms.ToolStripMenuItem().

        THIS-OBJECT:newToolStripMenuItem = NEW System.Windows.Forms.ToolStripMenuItem().

        THIS-OBJECT:toolStripSeparator2 = NEW System.Windows.Forms.ToolStripSeparator().

        THIS-OBJECT:exitToolStripMenuItem = NEW System.Windows.Forms.ToolStripMenuItem().

        THIS-OBJECT:helpToolStripMenuItem = NEW System.Windows.Forms.ToolStripMenuItem().

        THIS-OBJECT:contentsToolStripMenuItem = NEW System.Windows.Forms.ToolStripMenuItem().

        THIS-OBJECT:toolStripSeparator5 = NEW System.Windows.Forms.ToolStripSeparator().

        THIS-OBJECT:aboutToolStripMenuItem = NEW System.Windows.Forms.ToolStripMenuItem().

        THIS-OBJECT:ProcedureListpanel1 = NEW System.Windows.Forms.Panel().

        THIS-OBJECT:SessionData = NEW System.Windows.Forms.TabControl().

        THIS-OBJECT:ProcedureTimetabPage1 = NEW System.Windows.Forms.TabPage().

        THIS-OBJECT:ProcedureTimedataGrid = NEW System.Windows.Forms.DataGridView().

        THIS-OBJECT:ProcedureDetailstabPage2 = NEW System.Windows.Forms.TabPage().

        THIS-OBJECT:moduleDetailsdataGrid = NEW System.Windows.Forms.DataGridView().

        THIS-OBJECT:OperatorsSummarydataPage = NEW System.Windows.Forms.TabPage().

        THIS-OBJECT:OperatorsdataGridView = NEW System.Windows.Forms.DataGridView().

        THIS-OBJECT:sessStatstabPage1 = NEW System.Windows.Forms.TabPage().

        THIS-OBJECT:sessStatsdataGridView1 = NEW System.Windows.Forms.DataGridView().

        THIS-OBJECT:SessInfopanel1:SuspendLayout().

        THIS-OBJECT:ParamtableLayout:SuspendLayout().

        THIS-OBJECT:ParmgroupBox1:SuspendLayout().

        THIS-OBJECT:SesInfotableLayout:SuspendLayout().

        THIS-OBJECT:SessWMgroupBox1:SuspendLayout().

        CAST(THIS-OBJECT:SessWMdataGridView, System.ComponentModel.ISupportInitialize):BeginInit().

        THIS-OBJECT:SessDatabasegroupBox1:SuspendLayout().

        CAST(THIS-OBJECT:databasedataGrid, System.ComponentModel.ISupportInitialize):BeginInit().

        THIS-OBJECT:menuStrip1:SuspendLayout().

        THIS-OBJECT:ProcedureListpanel1:SuspendLayout().

        THIS-OBJECT:SessionData:SuspendLayout().

        THIS-OBJECT:ProcedureTimetabPage1:SuspendLayout().

        CAST(THIS-OBJECT:ProcedureTimedataGrid, System.ComponentModel.ISupportInitialize):BeginInit().

        THIS-OBJECT:ProcedureDetailstabPage2:SuspendLayout().

        CAST(THIS-OBJECT:moduleDetailsdataGrid, System.ComponentModel.ISupportInitialize):BeginInit().

        THIS-OBJECT:OperatorsSummarydataPage:SuspendLayout().

        CAST(THIS-OBJECT:OperatorsdataGridView, System.ComponentModel.ISupportInitialize):BeginInit().

        THIS-OBJECT:sessStatstabPage1:SuspendLayout().

        CAST(THIS-OBJECT:sessStatsdataGridView1, System.ComponentModel.ISupportInitialize):BeginInit().

        THIS-OBJECT:SuspendLayout().

        /*  */

        /* SessInfopanel1 */

        /*  */

        DEFINE VARIABLE nestedvar0 AS System.Windows.Forms.AnchorStyles NO-UNDO.

        nestedvar0 = CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:SessInfopanel1:Anchor = CAST(Progress.Util.EnumHelper:Or(nestedvar0, System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:SessInfopanel1:AutoScroll = TRUE.

        THIS-OBJECT:SessInfopanel1:BorderStyle = System.Windows.Forms.BorderStyle:FixedSingle.

        THIS-OBJECT:SessInfopanel1:Controls:Add(THIS-OBJECT:ParamtableLayout).

        THIS-OBJECT:SessInfopanel1:Controls:Add(THIS-OBJECT:SesInfotableLayout).

        THIS-OBJECT:SessInfopanel1:Location = NEW System.Drawing.Point(24, 48).

        THIS-OBJECT:SessInfopanel1:Name = "SessInfopanel1".

        THIS-OBJECT:SessInfopanel1:Size = NEW System.Drawing.Size(699, 256).

        THIS-OBJECT:SessInfopanel1:TabIndex = 0.

        /*  */

        /* ParamtableLayout */

        /*  */

        DEFINE VARIABLE nestedvar1 AS System.Windows.Forms.AnchorStyles NO-UNDO.

        nestedvar1 = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:ParamtableLayout:Anchor = CAST(Progress.Util.EnumHelper:Or(nestedvar1, System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:ParamtableLayout:AutoScroll = TRUE.

        THIS-OBJECT:ParamtableLayout:CellBorderStyle = System.Windows.Forms.TableLayoutPanelCellBorderStyle:Outset.

        THIS-OBJECT:ParamtableLayout:ColumnCount = 1.

        THIS-OBJECT:ParamtableLayout:ColumnStyles:Add(NEW System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType:Percent, 50)).

        THIS-OBJECT:ParamtableLayout:ColumnStyles:Add(NEW System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType:Percent, 50)).

        THIS-OBJECT:ParamtableLayout:Controls:Add(THIS-OBJECT:ParmgroupBox1, 0, 0).

        THIS-OBJECT:ParamtableLayout:Location = NEW System.Drawing.Point(18, 148).

        THIS-OBJECT:ParamtableLayout:Name = "ParamtableLayout".

        THIS-OBJECT:ParamtableLayout:RowCount = 1.

        THIS-OBJECT:ParamtableLayout:RowStyles:Add(NEW System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType:Percent, 50)).

        THIS-OBJECT:ParamtableLayout:RowStyles:Add(NEW System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType:Percent, 50)).

        THIS-OBJECT:ParamtableLayout:Size = NEW System.Drawing.Size(664, 94).

        THIS-OBJECT:ParamtableLayout:TabIndex = 1.

        /*  */

        /* ParmgroupBox1 */

        /*  */

        DEFINE VARIABLE nestedvar2 AS System.Windows.Forms.AnchorStyles NO-UNDO.

        nestedvar2 = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:ParmgroupBox1:Anchor = CAST(Progress.Util.EnumHelper:Or(nestedvar2, System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:ParmgroupBox1:Controls:Add(THIS-OBJECT:parmtextBox1).

        THIS-OBJECT:ParmgroupBox1:Font = NEW System.Drawing.Font("Tahoma", 8.25, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, System.Convert:ToByte(0)).

        THIS-OBJECT:ParmgroupBox1:ForeColor = System.Drawing.Color:RoyalBlue.

        THIS-OBJECT:ParmgroupBox1:Location = NEW System.Drawing.Point(5, 5).

        THIS-OBJECT:ParmgroupBox1:Name = "ParmgroupBox1".

        THIS-OBJECT:ParmgroupBox1:Size = NEW System.Drawing.Size(654, 84).

        THIS-OBJECT:ParmgroupBox1:TabIndex = 0.

        THIS-OBJECT:ParmgroupBox1:TabStop = FALSE.

        THIS-OBJECT:ParmgroupBox1:Text = "Session's Parameter information".

        THIS-OBJECT:ParmgroupBox1:UseCompatibleTextRendering = TRUE.

        /*  */

        /* parmtextBox1 */

        /*  */

        DEFINE VARIABLE nestedvar3 AS System.Windows.Forms.AnchorStyles NO-UNDO.

        nestedvar3 = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:parmtextBox1:Anchor = CAST(Progress.Util.EnumHelper:Or(nestedvar3, System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:parmtextBox1:BackColor = System.Drawing.Color:LightGray.

        THIS-OBJECT:parmtextBox1:BorderStyle = System.Windows.Forms.BorderStyle:FixedSingle.

        THIS-OBJECT:parmtextBox1:Location = NEW System.Drawing.Point(6, 20).

        THIS-OBJECT:parmtextBox1:Multiline = TRUE.

        THIS-OBJECT:parmtextBox1:Name = "parmtextBox1".

        THIS-OBJECT:parmtextBox1:ReadOnly = TRUE.

        THIS-OBJECT:parmtextBox1:Size = NEW System.Drawing.Size(642, 54).

        THIS-OBJECT:parmtextBox1:TabIndex = 0.

        THIS-OBJECT:parmtextBox1:Text = "parameter infro".

        /*  */

        /* SesInfotableLayout */

        /*  */

        DEFINE VARIABLE nestedvar4 AS System.Windows.Forms.AnchorStyles NO-UNDO.

        nestedvar4 = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:SesInfotableLayout:Anchor = CAST(Progress.Util.EnumHelper:Or(nestedvar4, System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:SesInfotableLayout:AutoScroll = TRUE.

        THIS-OBJECT:SesInfotableLayout:CellBorderStyle = System.Windows.Forms.TableLayoutPanelCellBorderStyle:Outset.

        THIS-OBJECT:SesInfotableLayout:ColumnCount = 2.

        THIS-OBJECT:SesInfotableLayout:ColumnStyles:Add(NEW System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType:Percent, 50)).

        THIS-OBJECT:SesInfotableLayout:ColumnStyles:Add(NEW System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType:Percent, 50)).

        THIS-OBJECT:SesInfotableLayout:Controls:Add(THIS-OBJECT:SessWMgroupBox1, 0, 0).

        THIS-OBJECT:SesInfotableLayout:Controls:Add(THIS-OBJECT:SessDatabasegroupBox1, 1, 0).

        THIS-OBJECT:SesInfotableLayout:Location = NEW System.Drawing.Point(18, 15).

        THIS-OBJECT:SesInfotableLayout:Name = "SesInfotableLayout".

        THIS-OBJECT:SesInfotableLayout:RowCount = 1.

        THIS-OBJECT:SesInfotableLayout:RowStyles:Add(NEW System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType:Percent, 50)).

        THIS-OBJECT:SesInfotableLayout:RowStyles:Add(NEW System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType:Percent, 50)).

        THIS-OBJECT:SesInfotableLayout:Size = NEW System.Drawing.Size(664, 122).

        THIS-OBJECT:SesInfotableLayout:TabIndex = 0.

        /*  */

        /* SessWMgroupBox1 */

        /*  */

        DEFINE VARIABLE nestedvar5 AS System.Windows.Forms.AnchorStyles NO-UNDO.

        nestedvar5 = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:SessWMgroupBox1:Anchor = CAST(Progress.Util.EnumHelper:Or(nestedvar5, System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:SessWMgroupBox1:Controls:Add(THIS-OBJECT:SessWMdataGridView).

        THIS-OBJECT:SessWMgroupBox1:Font = NEW System.Drawing.Font("Tahoma", 8.25, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, System.Convert:ToByte(0)).

        THIS-OBJECT:SessWMgroupBox1:ForeColor = System.Drawing.Color:RoyalBlue.

        THIS-OBJECT:SessWMgroupBox1:Location = NEW System.Drawing.Point(5, 5).

        THIS-OBJECT:SessWMgroupBox1:Name = "SessWMgroupBox1".

        THIS-OBJECT:SessWMgroupBox1:Size = NEW System.Drawing.Size(323, 112).

        THIS-OBJECT:SessWMgroupBox1:TabIndex = 0.

        THIS-OBJECT:SessWMgroupBox1:TabStop = FALSE.

        THIS-OBJECT:SessWMgroupBox1:Text = "Session's Water Mark".

        THIS-OBJECT:SessWMgroupBox1:UseCompatibleTextRendering = TRUE.

        /*  */

        /* SessWMdataGridView */

        /*  */

        THIS-OBJECT:SessWMdataGridView:AllowUserToAddRows = FALSE.

        THIS-OBJECT:SessWMdataGridView:AllowUserToDeleteRows = FALSE.

        DEFINE VARIABLE nestedvar6 AS System.Windows.Forms.AnchorStyles NO-UNDO.

        nestedvar6 = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:SessWMdataGridView:Anchor = CAST(Progress.Util.EnumHelper:Or(nestedvar6, System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:SessWMdataGridView:AutoSizeColumnsMode = System.Windows.Forms.DataGridViewAutoSizeColumnsMode:Fill.

        THIS-OBJECT:SessWMdataGridView:BackgroundColor = System.Drawing.SystemColors:GradientActiveCaption.

        THIS-OBJECT:SessWMdataGridView:ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode:AutoSize.

        dataGridViewCellStyle1:Alignment = System.Windows.Forms.DataGridViewContentAlignment:MiddleLeft.

        dataGridViewCellStyle1:BackColor = System.Drawing.SystemColors:Window.

        dataGridViewCellStyle1:Font = NEW System.Drawing.Font("Tahoma", 8.25, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, System.Convert:ToByte(0)).

        dataGridViewCellStyle1:ForeColor = System.Drawing.Color:RoyalBlue.

        dataGridViewCellStyle1:Format = "N0".

        dataGridViewCellStyle1:NullValue = ?.

        dataGridViewCellStyle1:SelectionBackColor = System.Drawing.SystemColors:ControlLightLight.

        dataGridViewCellStyle1:SelectionForeColor = System.Drawing.SystemColors:ControlText.

        dataGridViewCellStyle1:WrapMode = System.Windows.Forms.DataGridViewTriState:False.

        THIS-OBJECT:SessWMdataGridView:DefaultCellStyle = dataGridViewCellStyle1.

        THIS-OBJECT:SessWMdataGridView:Location = NEW System.Drawing.Point(6, 20).

        THIS-OBJECT:SessWMdataGridView:Name = "SessWMdataGridView".

        THIS-OBJECT:SessWMdataGridView:ReadOnly = TRUE.

        dataGridViewCellStyle2:ForeColor = System.Drawing.Color:Black.

        dataGridViewCellStyle2:Format = "N0".

        dataGridViewCellStyle2:NullValue = ?.

        dataGridViewCellStyle2:SelectionBackColor = System.Drawing.Color:White.

        THIS-OBJECT:SessWMdataGridView:RowsDefaultCellStyle = dataGridViewCellStyle2.

        THIS-OBJECT:SessWMdataGridView:SelectionMode = System.Windows.Forms.DataGridViewSelectionMode:FullRowSelect.

        THIS-OBJECT:SessWMdataGridView:ShowCellErrors = FALSE.

        THIS-OBJECT:SessWMdataGridView:ShowEditingIcon = FALSE.

        THIS-OBJECT:SessWMdataGridView:ShowRowErrors = FALSE.

        THIS-OBJECT:SessWMdataGridView:Size = NEW System.Drawing.Size(311, 86).

        THIS-OBJECT:SessWMdataGridView:TabIndex = 0.

        /*  */

        /* SessDatabasegroupBox1 */

        /*  */

        DEFINE VARIABLE nestedvar7 AS System.Windows.Forms.AnchorStyles NO-UNDO.

        nestedvar7 = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:SessDatabasegroupBox1:Anchor = CAST(Progress.Util.EnumHelper:Or(nestedvar7, System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:SessDatabasegroupBox1:Controls:Add(THIS-OBJECT:databasedataGrid).

        THIS-OBJECT:SessDatabasegroupBox1:Font = NEW System.Drawing.Font("Tahoma", 8.25, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, System.Convert:ToByte(0)).

        THIS-OBJECT:SessDatabasegroupBox1:ForeColor = System.Drawing.Color:RoyalBlue.

        THIS-OBJECT:SessDatabasegroupBox1:Location = NEW System.Drawing.Point(336, 5).

        THIS-OBJECT:SessDatabasegroupBox1:Name = "SessDatabasegroupBox1".

        THIS-OBJECT:SessDatabasegroupBox1:Size = NEW System.Drawing.Size(323, 112).

        THIS-OBJECT:SessDatabasegroupBox1:TabIndex = 1.

        THIS-OBJECT:SessDatabasegroupBox1:TabStop = FALSE.

        THIS-OBJECT:SessDatabasegroupBox1:Text = "Session's Database Information".

        THIS-OBJECT:SessDatabasegroupBox1:UseCompatibleTextRendering = TRUE.

        /*  */

        /* databasedataGrid */

        /*  */

        THIS-OBJECT:databasedataGrid:AllowUserToAddRows = FALSE.

        THIS-OBJECT:databasedataGrid:AllowUserToDeleteRows = FALSE.

        DEFINE VARIABLE nestedvar8 AS System.Windows.Forms.AnchorStyles NO-UNDO.

        nestedvar8 = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:databasedataGrid:Anchor = CAST(Progress.Util.EnumHelper:Or(nestedvar8, System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:databasedataGrid:AutoSizeColumnsMode = System.Windows.Forms.DataGridViewAutoSizeColumnsMode:Fill.

        THIS-OBJECT:databasedataGrid:BackgroundColor = System.Drawing.SystemColors:GradientActiveCaption.

        THIS-OBJECT:databasedataGrid:ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode:AutoSize.

        THIS-OBJECT:databasedataGrid:GridColor = System.Drawing.SystemColors:ActiveCaption.

        THIS-OBJECT:databasedataGrid:Location = NEW System.Drawing.Point(6, 20).

        THIS-OBJECT:databasedataGrid:Name = "databasedataGrid".

        dataGridViewCellStyle3:SelectionBackColor = System.Drawing.Color:White.

        dataGridViewCellStyle3:SelectionForeColor = System.Drawing.Color:Black.

        THIS-OBJECT:databasedataGrid:RowsDefaultCellStyle = dataGridViewCellStyle3.

        THIS-OBJECT:databasedataGrid:SelectionMode = System.Windows.Forms.DataGridViewSelectionMode:FullRowSelect.

        THIS-OBJECT:databasedataGrid:ShowCellErrors = FALSE.

        THIS-OBJECT:databasedataGrid:ShowEditingIcon = FALSE.

        THIS-OBJECT:databasedataGrid:ShowRowErrors = FALSE.

        THIS-OBJECT:databasedataGrid:Size = NEW System.Drawing.Size(311, 86).

        THIS-OBJECT:databasedataGrid:TabIndex = 0.

        /*  */

        /* menuStrip1 */

        /*  */

        @VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").

        DEFINE VARIABLE arrayvar0 AS System.Windows.Forms.ToolStripItem EXTENT 2 NO-UNDO.

        arrayvar0[1] = THIS-OBJECT:fileToolStripMenuItem.

        arrayvar0[2] = THIS-OBJECT:helpToolStripMenuItem.

        THIS-OBJECT:menuStrip1:Items:AddRange(arrayvar0).

        THIS-OBJECT:menuStrip1:Location = NEW System.Drawing.Point(0, 0).

        THIS-OBJECT:menuStrip1:Name = "menuStrip1".

        THIS-OBJECT:menuStrip1:Size = NEW System.Drawing.Size(735, 24).

        THIS-OBJECT:menuStrip1:TabIndex = 1.

        THIS-OBJECT:menuStrip1:Text = "menuStrip1".

        /*  */

        /* fileToolStripMenuItem */

        /*  */

        @VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").

        DEFINE VARIABLE arrayvar1 AS System.Windows.Forms.ToolStripItem EXTENT 3 NO-UNDO.

        arrayvar1[1] = THIS-OBJECT:newToolStripMenuItem.

        arrayvar1[2] = THIS-OBJECT:toolStripSeparator2.

        arrayvar1[3] = THIS-OBJECT:exitToolStripMenuItem.

        THIS-OBJECT:fileToolStripMenuItem:DropDownItems:AddRange(arrayvar1).

        THIS-OBJECT:fileToolStripMenuItem:Name = "fileToolStripMenuItem".

        THIS-OBJECT:fileToolStripMenuItem:Size = NEW System.Drawing.Size(35, 20).

        THIS-OBJECT:fileToolStripMenuItem:Text = "&File".

        /*  */

        /* newToolStripMenuItem */

        /*  */

        THIS-OBJECT:newToolStripMenuItem:Image = CAST(resources:GetObject("newToolStripMenuItem.Image"), System.Drawing.Image).

        THIS-OBJECT:newToolStripMenuItem:ImageTransparentColor = System.Drawing.Color:Magenta.

        THIS-OBJECT:newToolStripMenuItem:Name = "newToolStripMenuItem".

        DEFINE VARIABLE nestedvar9 AS System.Windows.Forms.Keys NO-UNDO.

        nestedvar9 = System.Windows.Forms.Keys:Control.

        THIS-OBJECT:newToolStripMenuItem:ShortcutKeys = CAST(Progress.Util.EnumHelper:Or(nestedvar9, System.Windows.Forms.Keys:N), System.Windows.Forms.Keys).

        THIS-OBJECT:newToolStripMenuItem:Size = NEW System.Drawing.Size(145, 22).

        THIS-OBJECT:newToolStripMenuItem:Text = "&New".

        /*  */

        /* toolStripSeparator2 */

        /*  */

        THIS-OBJECT:toolStripSeparator2:Name = "toolStripSeparator2".

        THIS-OBJECT:toolStripSeparator2:Size = NEW System.Drawing.Size(142, 6).

        /*  */

        /* exitToolStripMenuItem */

        /*  */

        THIS-OBJECT:exitToolStripMenuItem:Name = "exitToolStripMenuItem".

        THIS-OBJECT:exitToolStripMenuItem:Size = NEW System.Drawing.Size(145, 22).

        THIS-OBJECT:exitToolStripMenuItem:Text = "E&xit".

        THIS-OBJECT:exitToolStripMenuItem:Click:Subscribe(THIS-OBJECT:exitToolStripMenuItem_Click).

        /*  */

        /* helpToolStripMenuItem */

        /*  */

        @VisualDesigner.FormMember (NeedsInitialize="false", InitializeArray="true").

        DEFINE VARIABLE arrayvar2 AS System.Windows.Forms.ToolStripItem EXTENT 3 NO-UNDO.

        arrayvar2[1] = THIS-OBJECT:contentsToolStripMenuItem.

        arrayvar2[2] = THIS-OBJECT:toolStripSeparator5.

        arrayvar2[3] = THIS-OBJECT:aboutToolStripMenuItem.

        THIS-OBJECT:helpToolStripMenuItem:DropDownItems:AddRange(arrayvar2).

        THIS-OBJECT:helpToolStripMenuItem:Name = "helpToolStripMenuItem".

        THIS-OBJECT:helpToolStripMenuItem:Size = NEW System.Drawing.Size(40, 20).

        THIS-OBJECT:helpToolStripMenuItem:Text = "&Help".

        /*  */

        /* contentsToolStripMenuItem */

        /*  */

        THIS-OBJECT:contentsToolStripMenuItem:Name = "contentsToolStripMenuItem".

        THIS-OBJECT:contentsToolStripMenuItem:Size = NEW System.Drawing.Size(129, 22).

        THIS-OBJECT:contentsToolStripMenuItem:Text = "&Contents".

        THIS-OBJECT:contentsToolStripMenuItem:Click:Subscribe(THIS-OBJECT:contentsToolStripMenuItem_Click).

        /*  */

        /* toolStripSeparator5 */

        /*  */

        THIS-OBJECT:toolStripSeparator5:Name = "toolStripSeparator5".

        THIS-OBJECT:toolStripSeparator5:Size = NEW System.Drawing.Size(126, 6).

        /*  */

        /* aboutToolStripMenuItem */

        /*  */

        THIS-OBJECT:aboutToolStripMenuItem:Name = "aboutToolStripMenuItem".

        THIS-OBJECT:aboutToolStripMenuItem:Size = NEW System.Drawing.Size(129, 22).

        THIS-OBJECT:aboutToolStripMenuItem:Text = "&About...".

        THIS-OBJECT:aboutToolStripMenuItem:Click:Subscribe(THIS-OBJECT:aboutToolStripMenuItem_Click).

        /*  */

        /* ProcedureListpanel1 */

        /*  */

        DEFINE VARIABLE nestedvar10 AS System.Windows.Forms.AnchorStyles NO-UNDO.

        nestedvar10 = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:ProcedureListpanel1:Anchor = CAST(Progress.Util.EnumHelper:Or(nestedvar10, System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:ProcedureListpanel1:BorderStyle = System.Windows.Forms.BorderStyle:FixedSingle.

        THIS-OBJECT:ProcedureListpanel1:Controls:Add(THIS-OBJECT:SessionData).

        THIS-OBJECT:ProcedureListpanel1:Location = NEW System.Drawing.Point(24, 310).

        THIS-OBJECT:ProcedureListpanel1:Name = "ProcedureListpanel1".

        THIS-OBJECT:ProcedureListpanel1:Size = NEW System.Drawing.Size(699, 339).

        THIS-OBJECT:ProcedureListpanel1:TabIndex = 2.

        /*  */

        /* SessionData */

        /*  */

        THIS-OBJECT:SessionData:AccessibleDescription = "Session Data ".

        THIS-OBJECT:SessionData:AllowDrop = TRUE.

        DEFINE VARIABLE nestedvar11 AS System.Windows.Forms.AnchorStyles NO-UNDO.

        nestedvar11 = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:SessionData:Anchor = CAST(Progress.Util.EnumHelper:Or(nestedvar11, System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:SessionData:Controls:Add(THIS-OBJECT:ProcedureTimetabPage1).

        THIS-OBJECT:SessionData:Controls:Add(THIS-OBJECT:ProcedureDetailstabPage2).

        THIS-OBJECT:SessionData:Controls:Add(THIS-OBJECT:OperatorsSummarydataPage).

        THIS-OBJECT:SessionData:Controls:Add(THIS-OBJECT:sessStatstabPage1).

        THIS-OBJECT:SessionData:HotTrack = TRUE.

        THIS-OBJECT:SessionData:Location = NEW System.Drawing.Point(19, 3).

        THIS-OBJECT:SessionData:Name = "SessionData".

        THIS-OBJECT:SessionData:SelectedIndex = 0.

        THIS-OBJECT:SessionData:Size = NEW System.Drawing.Size(662, 315).

        THIS-OBJECT:SessionData:TabIndex = 0.

        /*  */

        /* ProcedureTimetabPage1 */

        /*  */

        THIS-OBJECT:ProcedureTimetabPage1:Controls:Add(THIS-OBJECT:ProcedureTimedataGrid).

        THIS-OBJECT:ProcedureTimetabPage1:ForeColor = System.Drawing.Color:Black.

        THIS-OBJECT:ProcedureTimetabPage1:Location = NEW System.Drawing.Point(4, 22).

        THIS-OBJECT:ProcedureTimetabPage1:Name = "ProcedureTimetabPage1".

        THIS-OBJECT:ProcedureTimetabPage1:Padding = NEW System.Windows.Forms.Padding(3).

        THIS-OBJECT:ProcedureTimetabPage1:Size = NEW System.Drawing.Size(654, 289).

        THIS-OBJECT:ProcedureTimetabPage1:TabIndex = 0.

        THIS-OBJECT:ProcedureTimetabPage1:Text = "Procudures /UDFs timing data".

        THIS-OBJECT:ProcedureTimetabPage1:UseVisualStyleBackColor = TRUE.

        /*  */

        /* ProcedureTimedataGrid */

        /*  */

        THIS-OBJECT:ProcedureTimedataGrid:AllowUserToAddRows = FALSE.

        THIS-OBJECT:ProcedureTimedataGrid:AllowUserToDeleteRows = FALSE.

        DEFINE VARIABLE nestedvar12 AS System.Windows.Forms.AnchorStyles NO-UNDO.

        nestedvar12 = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:ProcedureTimedataGrid:Anchor = CAST(Progress.Util.EnumHelper:Or(nestedvar12, System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:ProcedureTimedataGrid:AutoSizeColumnsMode = System.Windows.Forms.DataGridViewAutoSizeColumnsMode:Fill.

        THIS-OBJECT:ProcedureTimedataGrid:BackgroundColor = System.Drawing.Color:Silver.

        dataGridViewCellStyle4:Alignment = System.Windows.Forms.DataGridViewContentAlignment:MiddleLeft.

        dataGridViewCellStyle4:BackColor = System.Drawing.SystemColors:Control.

        dataGridViewCellStyle4:Font = NEW System.Drawing.Font("Microsoft Sans Serif", 8.25, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, System.Convert:ToByte(0)).

        dataGridViewCellStyle4:ForeColor = System.Drawing.SystemColors:WindowText.

        dataGridViewCellStyle4:SelectionBackColor = System.Drawing.SystemColors:Highlight.

        dataGridViewCellStyle4:SelectionForeColor = System.Drawing.SystemColors:HighlightText.

        dataGridViewCellStyle4:WrapMode = System.Windows.Forms.DataGridViewTriState:True.

        THIS-OBJECT:ProcedureTimedataGrid:ColumnHeadersDefaultCellStyle = dataGridViewCellStyle4.

        THIS-OBJECT:ProcedureTimedataGrid:ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode:AutoSize.

        dataGridViewCellStyle5:Alignment = System.Windows.Forms.DataGridViewContentAlignment:MiddleLeft.

        dataGridViewCellStyle5:BackColor = System.Drawing.SystemColors:Window.

        dataGridViewCellStyle5:Font = NEW System.Drawing.Font("Microsoft Sans Serif", 8.25, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, System.Convert:ToByte(0)).

        dataGridViewCellStyle5:ForeColor = System.Drawing.Color:Black.

        dataGridViewCellStyle5:SelectionBackColor = System.Drawing.SystemColors:Highlight.

        dataGridViewCellStyle5:SelectionForeColor = System.Drawing.SystemColors:HighlightText.

        dataGridViewCellStyle5:WrapMode = System.Windows.Forms.DataGridViewTriState:False.

        THIS-OBJECT:ProcedureTimedataGrid:DefaultCellStyle = dataGridViewCellStyle5.

        THIS-OBJECT:ProcedureTimedataGrid:GridColor = System.Drawing.Color:Brown.

        THIS-OBJECT:ProcedureTimedataGrid:Location = NEW System.Drawing.Point(6, 15).

        THIS-OBJECT:ProcedureTimedataGrid:MultiSelect = FALSE.

        THIS-OBJECT:ProcedureTimedataGrid:Name = "ProcedureTimedataGrid".

        THIS-OBJECT:ProcedureTimedataGrid:ReadOnly = TRUE.

        dataGridViewCellStyle6:Alignment = System.Windows.Forms.DataGridViewContentAlignment:MiddleLeft.

        dataGridViewCellStyle6:BackColor = System.Drawing.SystemColors:Control.

        dataGridViewCellStyle6:Font = NEW System.Drawing.Font("Microsoft Sans Serif", 8.25, System.Drawing.FontStyle:Regular, System.Drawing.GraphicsUnit:Point, System.Convert:ToByte(0)).

        dataGridViewCellStyle6:ForeColor = System.Drawing.SystemColors:WindowText.

        dataGridViewCellStyle6:SelectionBackColor = System.Drawing.SystemColors:Highlight.

        dataGridViewCellStyle6:SelectionForeColor = System.Drawing.SystemColors:HighlightText.

        dataGridViewCellStyle6:WrapMode = System.Windows.Forms.DataGridViewTriState:True.

        THIS-OBJECT:ProcedureTimedataGrid:RowHeadersDefaultCellStyle = dataGridViewCellStyle6.

        dataGridViewCellStyle7:SelectionBackColor = System.Drawing.Color:SlateGray.

        dataGridViewCellStyle7:SelectionForeColor = System.Drawing.Color:Black.

        THIS-OBJECT:ProcedureTimedataGrid:RowsDefaultCellStyle = dataGridViewCellStyle7.

        THIS-OBJECT:ProcedureTimedataGrid:SelectionMode = System.Windows.Forms.DataGridViewSelectionMode:FullRowSelect.

        THIS-OBJECT:ProcedureTimedataGrid:ShowCellErrors = FALSE.

        THIS-OBJECT:ProcedureTimedataGrid:Size = NEW System.Drawing.Size(642, 268).

        THIS-OBJECT:ProcedureTimedataGrid:TabIndex = 0.

        THIS-OBJECT:ProcedureTimedataGrid:CellMouseDoubleClick:Subscribe(THIS-OBJECT:ProcedureTimedataGrid_CellMouseDoubleClick).

        /*  */

        /* ProcedureDetailstabPage2 */

        /*  */

        THIS-OBJECT:ProcedureDetailstabPage2:Controls:Add(THIS-OBJECT:moduleDetailsdataGrid).

        THIS-OBJECT:ProcedureDetailstabPage2:ForeColor = System.Drawing.Color:Black.

        THIS-OBJECT:ProcedureDetailstabPage2:Location = NEW System.Drawing.Point(4, 22).

        THIS-OBJECT:ProcedureDetailstabPage2:Name = "ProcedureDetailstabPage2".

        THIS-OBJECT:ProcedureDetailstabPage2:Padding = NEW System.Windows.Forms.Padding(3).

        THIS-OBJECT:ProcedureDetailstabPage2:Size = NEW System.Drawing.Size(654, 289).

        THIS-OBJECT:ProcedureDetailstabPage2:TabIndex = 1.

        THIS-OBJECT:ProcedureDetailstabPage2:Text = "Procedures /UDFs module details".

        THIS-OBJECT:ProcedureDetailstabPage2:UseVisualStyleBackColor = TRUE.

        /*  */

        /* moduleDetailsdataGrid */

        /*  */

        THIS-OBJECT:moduleDetailsdataGrid:AllowUserToAddRows = FALSE.

        THIS-OBJECT:moduleDetailsdataGrid:AllowUserToDeleteRows = FALSE.

        DEFINE VARIABLE nestedvar13 AS System.Windows.Forms.AnchorStyles NO-UNDO.

        nestedvar13 = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:moduleDetailsdataGrid:Anchor = CAST(Progress.Util.EnumHelper:Or(nestedvar13, System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:moduleDetailsdataGrid:BackgroundColor = System.Drawing.Color:Silver.

        THIS-OBJECT:moduleDetailsdataGrid:ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode:AutoSize.

        THIS-OBJECT:moduleDetailsdataGrid:GridColor = System.Drawing.Color:DarkRed.

        THIS-OBJECT:moduleDetailsdataGrid:Location = NEW System.Drawing.Point(6, 6).

        THIS-OBJECT:moduleDetailsdataGrid:Name = "moduleDetailsdataGrid".

        dataGridViewCellStyle8:SelectionBackColor = System.Drawing.Color:SlateGray.

        THIS-OBJECT:moduleDetailsdataGrid:RowsDefaultCellStyle = dataGridViewCellStyle8.

        THIS-OBJECT:moduleDetailsdataGrid:SelectionMode = System.Windows.Forms.DataGridViewSelectionMode:FullRowSelect.

        THIS-OBJECT:moduleDetailsdataGrid:ShowCellErrors = FALSE.

        THIS-OBJECT:moduleDetailsdataGrid:ShowRowErrors = FALSE.

        THIS-OBJECT:moduleDetailsdataGrid:Size = NEW System.Drawing.Size(642, 280).

        THIS-OBJECT:moduleDetailsdataGrid:TabIndex = 0.

        THIS-OBJECT:moduleDetailsdataGrid:CellMouseDoubleClick:Subscribe(THIS-OBJECT:moduleDetailsdataGrid_CellMouseDoubleClick).

        /*  */

        /* OperatorsSummarydataPage */

        /*  */

        THIS-OBJECT:OperatorsSummarydataPage:Controls:Add(THIS-OBJECT:OperatorsdataGridView).

        THIS-OBJECT:OperatorsSummarydataPage:ForeColor = System.Drawing.Color:Black.

        THIS-OBJECT:OperatorsSummarydataPage:Location = NEW System.Drawing.Point(4, 22).

        THIS-OBJECT:OperatorsSummarydataPage:Name = "OperatorsSummarydataPage".

        THIS-OBJECT:OperatorsSummarydataPage:Padding = NEW System.Windows.Forms.Padding(3).

        THIS-OBJECT:OperatorsSummarydataPage:Size = NEW System.Drawing.Size(654, 289).

        THIS-OBJECT:OperatorsSummarydataPage:TabIndex = 2.

        THIS-OBJECT:OperatorsSummarydataPage:Text = "E-code/Action codes".

        THIS-OBJECT:OperatorsSummarydataPage:UseVisualStyleBackColor = TRUE.

        /*  */

        /* OperatorsdataGridView */

        /*  */

        THIS-OBJECT:OperatorsdataGridView:AllowUserToAddRows = FALSE.

        THIS-OBJECT:OperatorsdataGridView:AllowUserToDeleteRows = FALSE.

        DEFINE VARIABLE nestedvar14 AS System.Windows.Forms.AnchorStyles NO-UNDO.

        nestedvar14 = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:OperatorsdataGridView:Anchor = CAST(Progress.Util.EnumHelper:Or(nestedvar14, System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:OperatorsdataGridView:AutoSizeColumnsMode = System.Windows.Forms.DataGridViewAutoSizeColumnsMode:Fill.

        THIS-OBJECT:OperatorsdataGridView:AutoSizeRowsMode = System.Windows.Forms.DataGridViewAutoSizeRowsMode:DisplayedCells.

        THIS-OBJECT:OperatorsdataGridView:BackgroundColor = System.Drawing.Color:Silver.

        THIS-OBJECT:OperatorsdataGridView:ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode:AutoSize.

        THIS-OBJECT:OperatorsdataGridView:GridColor = System.Drawing.Color:DarkRed.

        THIS-OBJECT:OperatorsdataGridView:Location = NEW System.Drawing.Point(6, 6).

        THIS-OBJECT:OperatorsdataGridView:Name = "OperatorsdataGridView".

        THIS-OBJECT:OperatorsdataGridView:Size = NEW System.Drawing.Size(619, 277).

        THIS-OBJECT:OperatorsdataGridView:TabIndex = 0.

        /*  */

        /* sessStatstabPage1 */

        /*  */

        THIS-OBJECT:sessStatstabPage1:Controls:Add(THIS-OBJECT:sessStatsdataGridView1).

        THIS-OBJECT:sessStatstabPage1:Location = NEW System.Drawing.Point(4, 22).

        THIS-OBJECT:sessStatstabPage1:Name = "sessStatstabPage1".

        THIS-OBJECT:sessStatstabPage1:Padding = NEW System.Windows.Forms.Padding(3).

        THIS-OBJECT:sessStatstabPage1:Size = NEW System.Drawing.Size(654, 289).

        THIS-OBJECT:sessStatstabPage1:TabIndex = 4.

        THIS-OBJECT:sessStatstabPage1:Text = "Session Module Stats".

        THIS-OBJECT:sessStatstabPage1:UseVisualStyleBackColor = TRUE.

        /*  */

        /* sessStatsdataGridView1 */

        /*  */

        THIS-OBJECT:sessStatsdataGridView1:AllowUserToAddRows = FALSE.

        THIS-OBJECT:sessStatsdataGridView1:AllowUserToDeleteRows = FALSE.

        DEFINE VARIABLE nestedvar15 AS System.Windows.Forms.AnchorStyles NO-UNDO.

        nestedvar15 = CAST(Progress.Util.EnumHelper:Or(CAST(Progress.Util.EnumHelper:Or(System.Windows.Forms.AnchorStyles:Top, System.Windows.Forms.AnchorStyles:Bottom), System.Windows.Forms.AnchorStyles), System.Windows.Forms.AnchorStyles:Left), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:sessStatsdataGridView1:Anchor = CAST(Progress.Util.EnumHelper:Or(nestedvar15, System.Windows.Forms.AnchorStyles:Right), System.Windows.Forms.AnchorStyles).

        THIS-OBJECT:sessStatsdataGridView1:AutoSizeColumnsMode = System.Windows.Forms.DataGridViewAutoSizeColumnsMode:DisplayedCells.

        THIS-OBJECT:sessStatsdataGridView1:AutoSizeRowsMode = System.Windows.Forms.DataGridViewAutoSizeRowsMode:DisplayedCells.

        THIS-OBJECT:sessStatsdataGridView1:BackgroundColor = System.Drawing.Color:Silver.

        THIS-OBJECT:sessStatsdataGridView1:ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode:AutoSize.

        THIS-OBJECT:sessStatsdataGridView1:GridColor = System.Drawing.Color:DarkRed.

        THIS-OBJECT:sessStatsdataGridView1:Location = NEW System.Drawing.Point(6, 6).

        THIS-OBJECT:sessStatsdataGridView1:Name = "sessStatsdataGridView1".

        THIS-OBJECT:sessStatsdataGridView1:ReadOnly = TRUE.

        THIS-OBJECT:sessStatsdataGridView1:Size = NEW System.Drawing.Size(642, 277).

        THIS-OBJECT:sessStatsdataGridView1:TabIndex = 0.

        /*  */

        /* profiler_extension2 */

        /*  */

        THIS-OBJECT:ClientSize = NEW System.Drawing.Size(735, 673).

        THIS-OBJECT:Controls:Add(THIS-OBJECT:ProcedureListpanel1).

        THIS-OBJECT:Controls:Add(THIS-OBJECT:SessInfopanel1).

        THIS-OBJECT:Controls:Add(THIS-OBJECT:menuStrip1).

        THIS-OBJECT:MainMenuStrip = THIS-OBJECT:menuStrip1.

        THIS-OBJECT:Name = "profiler_extension2".

        THIS-OBJECT:Text = "profiler_extension2".

        THIS-OBJECT:SessInfopanel1:ResumeLayout(FALSE).

        THIS-OBJECT:ParamtableLayout:ResumeLayout(FALSE).

        THIS-OBJECT:ParmgroupBox1:ResumeLayout(FALSE).

        THIS-OBJECT:ParmgroupBox1:PerformLayout().

        THIS-OBJECT:SesInfotableLayout:ResumeLayout(FALSE).

        THIS-OBJECT:SessWMgroupBox1:ResumeLayout(FALSE).

        CAST(THIS-OBJECT:SessWMdataGridView, System.ComponentModel.ISupportInitialize):EndInit().

        THIS-OBJECT:SessDatabasegroupBox1:ResumeLayout(FALSE).

        CAST(THIS-OBJECT:databasedataGrid, System.ComponentModel.ISupportInitialize):EndInit().

        THIS-OBJECT:menuStrip1:ResumeLayout(FALSE).

        THIS-OBJECT:menuStrip1:PerformLayout().

        THIS-OBJECT:ProcedureListpanel1:ResumeLayout(FALSE).

        THIS-OBJECT:SessionData:ResumeLayout(FALSE).

        THIS-OBJECT:ProcedureTimetabPage1:ResumeLayout(FALSE).

        CAST(THIS-OBJECT:ProcedureTimedataGrid, System.ComponentModel.ISupportInitialize):EndInit().

        THIS-OBJECT:ProcedureDetailstabPage2:ResumeLayout(FALSE).

        CAST(THIS-OBJECT:moduleDetailsdataGrid, System.ComponentModel.ISupportInitialize):EndInit().

        THIS-OBJECT:OperatorsSummarydataPage:ResumeLayout(FALSE).

        CAST(THIS-OBJECT:OperatorsdataGridView, System.ComponentModel.ISupportInitialize):EndInit().

        THIS-OBJECT:sessStatstabPage1:ResumeLayout(FALSE).

        CAST(THIS-OBJECT:sessStatsdataGridView1, System.ComponentModel.ISupportInitialize):EndInit().

        THIS-OBJECT:ResumeLayout(FALSE).

        THIS-OBJECT:PerformLayout().

        CATCH e AS Progress.Lang.Error:

            UNDO, THROW e.

        END CATCH.

	END METHOD.





 



	DESTRUCTOR PUBLIC profiler_extension2 ( ):



		IF VALID-OBJECT(components) THEN DO:

			CAST(components, System.IDisposable):Dispose().

		END.



	END DESTRUCTOR.

	

	/*------------------------------------------------------------------------------

			Purpose:  																	  

			Notes:  																	  

	------------------------------------------------------------------------------*/

	@VisualDesigner.

	METHOD PRIVATE VOID moduleDetailsdataGrid_CellMouseDoubleClick( INPUT sender AS System.Object, INPUT e AS System.Windows.Forms.DataGridViewCellMouseEventArgs ):

		DEFINE VARIABLE functinfo  AS functionInformation  NO-UNDO. 

        functinfo = NEW functionInformation(moduledetail.src-id, sessionID,moduledetail.srcname).

        WAIT-FOR functinfo:ShowDialog().

		RETURN.

	END METHOD.





 	/*------------------------------------------------------------------------------

			Purpose:  																	  

			Notes:  																	  

	------------------------------------------------------------------------------*/

	@VisualDesigner.

	METHOD PRIVATE VOID ProcedureTimedataGrid_CellMouseDoubleClick( INPUT sender AS System.Object, INPUT e AS System.Windows.Forms.DataGridViewCellMouseEventArgs ):

		

		DEFINE VARIABLE functinfo  AS functionInformation  NO-UNDO. 

        functinfo = NEW functionInformation(source.srcid, sessionID,source.srcname).

        WAIT-FOR functinfo:ShowDialog().

		RETURN.



	END METHOD.





 	METHOD PUBLIC VOID Wait ( ): 

      

    WAIT-FOR Application:Run ( THIS-OBJECT ). 

    END METHOD. 

    

   /*------------------------------------------------------------------------------

			Purpose:  Initialize all queriesand data binds														  

			Notes:  																	  

------------------------------------------------------------------------------*/

   METHOD PRIVATE VOID initializeQueriesBinds( ):

    /*::definition:::*/

    DEFINE VAR srcCount                AS INTEGER.

    DEFINE VAR ix                      AS INTEGER.

    DEFINE VAR arr_undo-variables      AS "System.Int32[]".

    DEFINE VAR arr_noundo-variables    AS "System.Int32[]".

    DEFINE VAR arr_udf-methods         AS "System.Int32[]".

    DEFINE VAR arr_static-temp-tables  AS "System.Int32[]".

    DEFINE VAR arr_static-queries      AS "System.Int32[]".

    DEFINE VAR arr_static-buffers      AS "System.Int32[]".

    DEFINE VAR arr_datasources         AS "System.Int32[]".

    DEFINE VAR arr_static-datasets     AS "System.Int32[]".

    DEFINE VAR arr_initial-seg-size    AS "System.Int32[]".

    DEFINE VAR arr_express-seg-size    AS "System.Int32[]".

    DEFINE VAR arr_action-seg-size     AS "System.Int32[]".

    DEFINE VAR arr_text-seg-size       AS "System.Int32[]".

    DEFINE VAR arr_parameters          AS "System.Int32[]".

    DEFINE VAR arr_public-elements     AS "System.Int32[]".

    DEFINE VAR arr_protected-elements  AS "System.Int32[]".

    DEFINE VAR arr_class-depth         AS "System.Int32[]".

    DEFINE VAR arr_internal-procedures AS "System.Int32[]".

   /*session watermark*/

	CREATE QUERY sessWMhdqry.

	sessWMhdqry:SET-BUFFERS(BUFFER watermark:HANDLE).

    sessWMhdqry:QUERY-PREPARE("FOR EACH watermark WHERE watermark.SESSION-ID = " + STRING(sessionID)). 

    sessWMhdqry:QUERY-OPEN.

	sessWMBind = NEW Progress.Data.BindingSource(sessWMhdqry, "nested-blocks, pers-proc-class,accessed-ttabs", " "). 

    SessWMdataGridView:DataSource = sessWMBind.

   

   /*database connections */

    CREATE QUERY databasehdqry.

	databasehdqry:SET-BUFFERS(BUFFER databases:HANDLE).

    databasehdqry:QUERY-PREPARE("FOR EACH databases WHERE databases.SESSION-ID = " + STRING(sessionID)). 

	databaseBind = NEW Progress.Data.BindingSource(databasehdqry, "name,num-tables", " "). 

    databasedataGrid:DataSource = databaseBind.

    

    /*session's parameters*/

     FIND parameters WHERE parameters.session-id = sessionID NO-ERROR.

     IF AVAILABLE parameters THEN  DO:

      THIS-OBJECT:parmtextBox1:Text = parameters.paraminfo.

     END.

     ELSE DO:

      THIS-OBJECT:parmtextBox1:Text = "".

     END.

     

     /*get & set the session name*/

     FIND Profile-Session WHERE Profile-Session.session-id = sessionID NO-ERROR.

     IF AVAILABLE Profile-Session THEN  DO:

      sessDesc =  Profile-Session.Session-Desc.

     END.

     ELSE DO:

      sessDesc = "".

     END.

     THIS-OBJECT:Text = "Session Description:: " + CAPS(sessDesc).

     

     /* source -func list*/

    CREATE QUERY hsrcqry.

    hsrcqry:SET-BUFFERS(BUFFER source:HANDLE).

    hsrcqry:QUERY-PREPARE("FOR EACH SOURCE WHERE SOURCE.SESSION-ID = " + STRING(sessionID)

                           + " AND SOURCE.srcid > 0 AND SOURCE.callcnt > 0 "). 

    hsrcqry:QUERY-OPEN. 

    srcBind = NEW Progress.Data.BindingSource(hsrcqry, "srcid,srcname,callcnt,tot_acttime,session-percent", " "). 

    srcBind:AutoSort = TRUE.

    ProcedureTimedataGrid:DataSource = srcBind.

    

    

     /*module procedure udf list*/

    CREATE QUERY hmodqry.

    hmodqry:SET-BUFFERS(BUFFER moduledetail:HANDLE).

    hmodqry:QUERY-PREPARE("FOR EACH moduledetail WHERE"

                               + " moduledetail.src-id > 0 "

                               + " AND moduledetail.SESSION-ID = " + STRING(sessionID)). 

    hmodqry:QUERY-OPEN. 

    modBind = NEW Progress.Data.BindingSource(hmodqry,

                                            "srcname,

                                             highWM,

                                             undo-variables,

                                             noundo-variables,

                                             udf-methods,

                                             internal-procedures,

                                             static-temp-tables,

                                             avrg-ttab-fields,

                                             median-ttab-fields,

                                             lowest-ttab-fields,

                                             highest-ttab-fields,

                                             static-queries,

                                             static-buffers,

                                             datasources,

                                             static-datasets,

                                             parameters,

                                             isclass,

                                             public-elements,

                                             protected-elements,

                                             class-depth,

                                             initial-seg-size,

                                             express-seg-size,

                                             action-seg-size,

                                             text-seg-size"

                                             , ""). 

    modBind:AutoSort = TRUE.

    moduleDetailsdataGrid:DataSource = modBind.

    

    /*sessionOperatorsSummary*/

    FOR EACH operators WHERE operators.SESSION-ID = sessionID BREAK BY operators.name:

      ACCUMULATE count (TOTAL BY operators.name).

     

      IF LAST-OF(operators.name) THEN DO:

        CREATE ttOperatorsData.

        ttOperatorsData.nm = operators.name.

        ttOperatorsData.totalc = ACCUM TOTAL BY operators.name count.

        IF operators.operator-id < 10000 THEN DO:

          ttOperatorsData.descpt = "E-CODE".

        END.

        ELSE DO:

           ttOperatorsData.descpt = "ACTION-CODE".

        END.

      END.

    END.

    

    CREATE QUERY operatorsqry.

    operatorsqry:SET-BUFFERS(BUFFER ttOperatorsData:HANDLE).

    operatorsqry:QUERY-PREPARE("FOR EACH ttOperatorsData"). 

    operatorsqry:QUERY-OPEN. 

    operatorsBind = NEW Progress.Data.BindingSource(operatorsqry, "*", " "). 

    operatorsBind:AutoSort = TRUE.

    OperatorsdataGridView:DataSource = operatorsBind.

     

     /*session Modules details stats */

     FOR EACH moduledetail WHERE moduledetail.SESSION-ID = sessionID:

      ACCUMULATE moduledetail.src-id (COUNT).

     END.

     

        srcCount = ACCUM COUNT moduledetail.src-id .

        arr_undo-variables      = NEW  "System.Int32[]" (srcCount).

        arr_noundo-variables    = NEW  "System.Int32[]" (srcCount).

        arr_udf-methods         = NEW  "System.Int32[]" (srcCount).

        arr_static-temp-tables  = NEW  "System.Int32[]" (srcCount).

        arr_static-queries      = NEW  "System.Int32[]" (srcCount).

        arr_static-buffers      = NEW  "System.Int32[]" (srcCount).

        arr_datasources         = NEW  "System.Int32[]" (srcCount).

        arr_static-datasets     = NEW  "System.Int32[]" (srcCount).

        arr_initial-seg-size    = NEW  "System.Int32[]" (srcCount).

        arr_express-seg-size    = NEW  "System.Int32[]" (srcCount).

        arr_action-seg-size     = NEW  "System.Int32[]" (srcCount).

        arr_text-seg-size       = NEW  "System.Int32[]" (srcCount).

        arr_parameters          = NEW  "System.Int32[]" (srcCount).

        

        ix = 0.

     FOR EACH moduledetail WHERE moduledetail.SESSION-ID = sessionID:

         

       arr_undo-variables:setValue(undo-variables,ix).

       arr_noundo-variables:setValue(noundo-variables,ix).

       arr_udf-methods:setValue(udf-methods,ix).

       arr_static-temp-tables:setValue(static-temp-tables,ix).

       arr_static-queries:setValue(static-queries,ix).

       arr_static-buffers:setValue(static-buffers,ix).

       arr_datasources:setValue(datasources,ix).

       arr_static-datasets:setValue(static-datasets,ix).

       arr_initial-seg-size:setValue(initial-seg-size,ix).

       arr_express-seg-size:setValue(express-seg-size,ix).

       arr_action-seg-size:setValue(action-seg-size,ix).

       arr_text-seg-size:setValue(text-seg-size,ix).

       arr_parameters:setValue(parameters,ix).

       

       ACCUMULATE undo-variables (TOTAL MAXIMUM AVERAGE).

       ACCUMULATE noundo-variables (TOTAL MAXIMUM AVERAGE).

       ACCUMULATE udf-methods (TOTAL MAXIMUM AVERAGE).

       ACCUMULATE static-temp-tables (TOTAL MAXIMUM AVERAGE).

       ACCUMULATE highest-ttab-fields (MAXIMUM).

       ACCUMULATE static-queries (TOTAL MAXIMUM AVERAGE).

       ACCUMULATE static-buffers (TOTAL MAXIMUM AVERAGE).

       ACCUMULATE datasources (TOTAL MAXIMUM AVERAGE).

       ACCUMULATE static-datasets (TOTAL MAXIMUM AVERAGE).

       ACCUMULATE initial-seg-size (TOTAL MAXIMUM MINIMUM AVERAGE).

       ACCUMULATE express-seg-size (TOTAL MAXIMUM MINIMUM AVERAGE).

       ACCUMULATE action-seg-size  (TOTAL MAXIMUM MINIMUM AVERAGE).

       ACCUMULATE text-seg-size    (TOTAL MAXIMUM MINIMUM AVERAGE).     

       /*added for sess. stats*/

       

       ACCUMULATE parameters (TOTAL MAXIMUM AVERAGE MINIMUM).  

       ACCUMULATE isclass (TOTAL).  

    END.

        ix = 0.

        arr_public-elements      = NEW  "System.Int32[]" ((ACCUM TOTAL isclass)).

        arr_protected-elements   = NEW  "System.Int32[]" ((ACCUM TOTAL isclass)).

        arr_class-depth          = NEW  "System.Int32[]" ((ACCUM TOTAL isclass)).

        

    FOR EACH moduledetail WHERE moduledetail.SESSION-ID = sessionID AND moduledetail.isclass = 1:

       arr_public-elements:setValue(public-elements,ix).

       arr_protected-elements:setValue(protected-elements,ix).

       arr_class-depth:setValue(class-depth,ix).

       ACCUMULATE public-elements (TOTAL MAXIMUM MINIMUM AVERAGE). 

       ACCUMULATE protected-elements (TOTAL MAXIMUM MINIMUM AVERAGE). 

       ACCUMULATE class-depth (TOTAL MAXIMUM MINIMUM AVERAGE). 

    END.

    

    FOR EACH moduledetail WHERE moduledetail.SESSION-ID = sessionID AND lowest-ttab-fields > 0:

      ACCUMULATE lowest-ttab-fields (MINIMUM).

    END.

    

    FOR EACH moduledetail WHERE moduledetail.SESSION-ID = sessionID AND avrg-ttab-fields > 0:

      ACCUMULATE avrg-ttab-fields (AVERAGE).

    END.

     

    FOR EACH moduledetail WHERE moduledetail.SESSION-ID = sessionID AND median-ttab-fields > 0:

      ACCUMULATE median-ttab-fields (AVERAGE).

    END.

    

     ix = 0.

     arr_internal-procedures = NEW  "System.Int32[]" ((srcCount - (ACCUM TOTAL isclass))).

    FOR EACH moduledetail WHERE moduledetail.SESSION-ID = sessionID AND moduledetail.isclass = 0:

      arr_internal-procedures:setValue(internal-procedures,ix).

      ACCUMULATE internal-procedures (TOTAL MAXIMUM MINIMUM AVERAGE).

    END.

    

    /*session stats*/

    

    CREATE ttSessionStats.

    ttSessionStats.fld = "NUMBER OF CLASSES".

    ttSessionStats.totv = STRING ((ACCUM TOTAL isclass)). 

    IF( (ACCUM TOTAL isclass) > 0)

    THEN DO:

       /*=======*/

      CREATE ttSessionStats.

      ttSessionStats.fld = "NUMBER OF PUBLIC ELEMENTS ".

      ttSessionStats.totv = STRING((ACCUM TOTAL public-elements)).

      ttSessionStats.avgv = STRING(ROUND((ACCUM AVERAGE public-elements),2)).

      ttSessionStats.maxv = STRING((ACCUM MAXIMUM public-elements)). 

      ttSessionStats.minv = STRING((ACCUM MINIMUM public-elements)).

     /*ttSessionStats.median =*/

      

      /*=======*/

      CREATE ttSessionStats.

      ttSessionStats.fld = "NUMBER OF PROTECTED ELEMENTS ".

      ttSessionStats.totv = STRING((ACCUM TOTAL protected-elements)).

      ttSessionStats.avgv = STRING(ROUND((ACCUM AVERAGE protected-elements),2)).

      ttSessionStats.maxv = STRING((ACCUM MAXIMUM protected-elements)). 

      ttSessionStats.minv = STRING((ACCUM MINIMUM protected-elements)).

      

      /*=======*/

      CREATE ttSessionStats.

      ttSessionStats.fld = "CLASS DEPTH ".

      ttSessionStats.totv = STRING((ACCUM TOTAL class-depth)).

      ttSessionStats.avgv = STRING(ROUND((ACCUM AVERAGE class-depth),2)).

      ttSessionStats.maxv = STRING((ACCUM MAXIMUM class-depth)). 

      ttSessionStats.minv = STRING((ACCUM MINIMUM class-depth)).

    END.

    

    /*=======*/

    

    CREATE ttSessionStats.

    ttSessionStats.fld = "NUMBER OF UNDO-VARIABLES".

    ttSessionStats.totv = STRING((ACCUM TOTAL undo-variables)).

    ttSessionStats.avgv = STRING(ROUND((ACCUM AVERAGE undo-variables),2)).

    ttSessionStats.maxv = STRING((ACCUM MAXIMUM undo-variables)). 

    ttSessionStats.medianv = STRING (median(arr_undo-variables)).

    /*ttSessionStats.minv = STRING((ACCUM MINIMUM undo-variables)).*/

    

    /*=======*/

    CREATE ttSessionStats.

    ttSessionStats.fld = "NUMBER OF NOUNDO-VARIABLES".

    ttSessionStats.totv = STRING((ACCUM TOTAL noundo-variables)).

    ttSessionStats.avgv = STRING(ROUND((ACCUM AVERAGE noundo-variables),2)).

    ttSessionStats.maxv = STRING((ACCUM MAXIMUM noundo-variables)). 

     ttSessionStats.medianv = STRING(median(arr_noundo-variables)).

   /*ttSessionStats.minv = STRING((ACCUM MINIMUM noundo-variables)).*/

    

    

    /*=======*/

    CREATE ttSessionStats.

    ttSessionStats.fld = "NUMBER OF UDF/METHODS".

    ttSessionStats.totv = STRING((ACCUM TOTAL udf-methods)).

    ttSessionStats.avgv = STRING(ROUND((ACCUM AVERAGE udf-methods),2)).

    ttSessionStats.maxv = STRING((ACCUM MAXIMUM udf-methods)). 

    ttSessionStats.medianv = STRING (median(arr_udf-methods)).

  /*ttSessionStats.minv = STRING((ACCUM MINIMUM udf-methods)).*/

    

    

    /*=======*/

    CREATE ttSessionStats.

    ttSessionStats.fld = "NUMBER OF INTERNAL-PROCEDURES".

    ttSessionStats.totv = STRING((ACCUM TOTAL internal-procedures)).

    ttSessionStats.avgv = STRING(ROUND((ACCUM AVERAGE internal-procedures),2)).

    ttSessionStats.maxv = STRING((ACCUM MAXIMUM internal-procedures)). 

    ttSessionStats.medianv = STRING (median(arr_internal-procedures)).

 /*ttSessionStats.minv = STRING((ACCUM MINIMUM internal-procedures)).*/

    

    

    /*=======*/

    CREATE ttSessionStats.

    ttSessionStats.fld = "NUMBER OF STATIC-TEMP-TABLES".

    ttSessionStats.totv = STRING((ACCUM TOTAL static-temp-tables)).

    ttSessionStats.avgv = STRING(ROUND((ACCUM AVERAGE static-temp-tables),2)).

    ttSessionStats.maxv = STRING((ACCUM MAXIMUM static-temp-tables)). 

    ttSessionStats.medianv = STRING (median(arr_static-temp-tables)).

  /*ttSessionStats.minv = STRING((ACCUM MINIMUM static-temp-tables)).*/

  

    

    /*=======*/

    CREATE ttSessionStats.

    ttSessionStats.fld = "NUMBER OF STATIC QUERIES".

    ttSessionStats.totv = STRING((ACCUM TOTAL static-queries)).

    ttSessionStats.avgv = STRING(ROUND((ACCUM AVERAGE static-queries),2)).

    ttSessionStats.maxv = STRING((ACCUM MAXIMUM static-queries)). 

    ttSessionStats.medianv = STRING (median(arr_static-queries)).

   /*ttSessionStats.minv = STRING((ACCUM MINIMUM static-queries)).*/

    

    /*=======*/

    CREATE ttSessionStats.

    ttSessionStats.fld = "NUMBER OF STATIC BUFFERS".

    ttSessionStats.totv = STRING((ACCUM TOTAL static-buffers)).

    ttSessionStats.avgv = STRING(ROUND((ACCUM AVERAGE static-buffers),2)).

    ttSessionStats.maxv = STRING((ACCUM MAXIMUM static-buffers)). 

    ttSessionStats.medianv = STRING (median(arr_static-buffers)).

/*    ttSessionStats.minv = STRING((ACCUM MINIMUM static-buffers)).*/

    

    /*=======*/

    CREATE ttSessionStats.

    ttSessionStats.fld = "NUMBER OF DATASOURCES".

    ttSessionStats.totv = STRING((ACCUM TOTAL  datasources)).

    ttSessionStats.avgv = STRING(ROUND((ACCUM AVERAGE  datasources),2)).

    ttSessionStats.maxv = STRING((ACCUM MAXIMUM  datasources)). 

    ttSessionStats.medianv = STRING (median(arr_datasources)).

/*    ttSessionStats.minv = STRING((ACCUM MINIMUM  datasources)).*/

    

    /*=======*/

    CREATE ttSessionStats.

    ttSessionStats.fld = "NUMBER OF STATIC-DATASETS".

    ttSessionStats.totv = STRING((ACCUM TOTAL    static-datasets)).

    ttSessionStats.avgv = STRING(ROUND((ACCUM AVERAGE  static-datasets),2)).

    ttSessionStats.maxv = STRING((ACCUM MAXIMUM  static-datasets)). 

    ttSessionStats.medianv = STRING (median(arr_static-datasets)).

/*    ttSessionStats.minv = STRING((ACCUM MINIMUM  static-datasets)).*/

    

    /*=======*/

    CREATE ttSessionStats.

    ttSessionStats.fld = "NUMBER OF PARAMETER".

    ttSessionStats.totv = STRING((ACCUM TOTAL    parameters)).

    ttSessionStats.avgv = STRING(ROUND((ACCUM AVERAGE  parameters),2)).

    ttSessionStats.maxv = STRING((ACCUM MAXIMUM  parameters)). 

    ttSessionStats.medianv = STRING (median(arr_parameters)).

/*    ttSessionStats.minv = STRING((ACCUM MINIMUM  parameters)).*/

 

    

    /*=======*/

    CREATE ttSessionStats.

    ttSessionStats.fld = "INITIAL-SEG-SIZE".

    ttSessionStats.totv = STRING((ACCUM TOTAL    initial-seg-size)).

    ttSessionStats.avgv = STRING(ROUND((ACCUM AVERAGE  initial-seg-size),2)).

    ttSessionStats.maxv = STRING((ACCUM MAXIMUM  initial-seg-size)). 

    ttSessionStats.minv = STRING((ACCUM MINIMUM  initial-seg-size)).

    ttSessionStats.medianv = STRING (median(arr_initial-seg-size)).

    

    

    /*=======*/

    CREATE ttSessionStats.

    ttSessionStats.fld = "EXPRESSION-SEG-SIZE".

    ttSessionStats.totv = STRING((ACCUM TOTAL     express-seg-size)).

    ttSessionStats.avgv = STRING(ROUND((ACCUM AVERAGE   express-seg-size),2)).

    ttSessionStats.maxv = STRING((ACCUM MAXIMUM   express-seg-size)). 

    ttSessionStats.minv = STRING((ACCUM MINIMUM   express-seg-size)).

    ttSessionStats.medianv = STRING (median(arr_express-seg-size)).

    

    /*=======*/

    CREATE ttSessionStats.

    ttSessionStats.fld = "ACTION-SEG-SIZE".

    ttSessionStats.totv = STRING((ACCUM TOTAL     action-seg-size)).

    ttSessionStats.avgv = STRING(ROUND((ACCUM AVERAGE   action-seg-size),2)).

    ttSessionStats.maxv = STRING((ACCUM MAXIMUM   action-seg-size)). 

    ttSessionStats.minv = STRING((ACCUM MINIMUM   action-seg-size)).

    ttSessionStats.medianv = STRING (median(arr_action-seg-size)).

    

    /*=======*/

    CREATE ttSessionStats.

    ttSessionStats.fld = "TEXT-SEG-SIZE".

    ttSessionStats.totv = STRING((ACCUM TOTAL     text-seg-size)).

    ttSessionStats.avgv = STRING(ROUND((ACCUM AVERAGE   text-seg-size),2)).

    ttSessionStats.maxv = STRING((ACCUM MAXIMUM   text-seg-size)). 

    ttSessionStats.minv = STRING((ACCUM MINIMUM   text-seg-size)).

    ttSessionStats.medianv = STRING (median(arr_text-seg-size)).

    

    /*=======*/

    CREATE ttSessionStats.

    ttSessionStats.fld     = "NUMBER OF TTAB-FIELDS".

    ttSessionStats.totv    = STRING(ROUND((ACCUM AVERAGE  avrg-ttab-fields)*(ACCUM TOTAL static-temp-tables),2)).

    ttSessionStats.maxv    = STRING((ACCUM MAXIMUM highest-ttab-fields)).

    ttSessionStats.minv    = STRING((ACCUM MINIMUM lowest-ttab-fields)).

    ttSessionStats.avgv    = STRING(ROUND((ACCUM AVERAGE  avrg-ttab-fields),2)). 

    ttSessionStats.medianv = STRING(ROUND((ACCUM AVERAGE  median-ttab-fields),2)) + " avrg all proc's median-ttab-flds".

    

     CREATE QUERY sessStatsqry.

     sessStatsqry:SET-BUFFERS(BUFFER ttSessionStats:HANDLE).

     sessStatsqry:QUERY-PREPARE("FOR EACH ttSessionStats"). 

     sessStatsqry:QUERY-OPEN. 

     sessStatsBind = NEW Progress.Data.BindingSource(sessStatsqry, "*", "minv"). 

     sessStatsBind:AutoSort = TRUE.

     sessStatsdataGridView1:DataSource = sessStatsBind. 

     

   END METHOD.

   

   

  METHOD PRIVATE DECIMAL median (INPUT arrf AS "System.Int32[]"):

      

      DEFINE VAR  ct     AS  INT.

      DEFINE VAR v1      AS INT64.

      DEFINE VAR v2      AS INT64.

      DEFINE VAR  median AS DECIMAL.

      median  =  0.



      IF (arrf:length > 0) THEN 

      DO:

        System.Array:Sort(arrf).

        IF (arrf:length MODULO 2) = 0 THEN

        DO:

            ct =  arrf:length / 2 .

            v1  = arrf:getValue(ct).

            v2 =  arrf:getValue(ct - 1).

            median = (v1 + v2) / 2.

        END.

        ELSE DO:

            ct =  arrf:length / 2.

            median = arrf:getValue(ct - 1).

        END.

      END. 

      RETURN median.



 END METHOD.

 



END CLASS.