&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI
&ANALYZE-RESUME
/* Connected Databases 
          prof             PROGRESS
*/
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*********************************************************************
* Copyright (C) 2000,2009 by Progress Software Corporation ("PSC"),  *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/*------------------------------------------------------------------------
 * June, 1997
 * Version 1.0

  File: sessions.w

  Description: This is the main procedure for the profiler tool. It displays
               a window with a browse of all the profiling sessions loaded in
               the database.

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

def temp-table ttabchild field prochdl as handle
                         field procid as int
                         field session-id as int
                         index sid is primary unique session-id
                         index phdl prochdl.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME DEFAULT-FRAME
&Scoped-define BROWSE-NAME BROWSE-1

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES Profile-Session

/* Definitions for BROWSE BROWSE-1                                      */
&Scoped-define FIELDS-IN-QUERY-BROWSE-1 Profile-Session.session-id ~
Profile-Session.session-date Profile-Session.Session-Desc 
&Scoped-define ENABLED-FIELDS-IN-QUERY-BROWSE-1 
&Scoped-define QUERY-STRING-BROWSE-1 FOR EACH Profile-Session NO-LOCK
&Scoped-define OPEN-QUERY-BROWSE-1 OPEN QUERY BROWSE-1 FOR EACH Profile-Session NO-LOCK.
&Scoped-define TABLES-IN-QUERY-BROWSE-1 Profile-Session
&Scoped-define FIRST-TABLE-IN-QUERY-BROWSE-1 Profile-Session


/* Definitions for FRAME DEFAULT-FRAME                                  */
&Scoped-define OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME ~
    ~{&OPEN-QUERY-BROWSE-1}

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS BROWSE-1 Btn-viewsession btn_addsession ~
btn_delsession Btn_Done radio_set_profilerver 
&Scoped-Define DISPLAYED-OBJECTS radio_set_profilerver 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON Btn-viewsession 
     LABEL "&View Session" 
     SIZE 15 BY 1.05.

DEFINE BUTTON btn_addsession 
     LABEL "&Add Session" 
     SIZE 15 BY 1.05 TOOLTIP "Import data from a profiling session".

DEFINE BUTTON btn_delsession 
     LABEL "D&elete Session" 
     SIZE 15 BY 1.05 TOOLTIP "Delete the current profiling session".

DEFINE BUTTON Btn_Done DEFAULT 
     LABEL "&Done" 
     SIZE 15 BY 1.05
     BGCOLOR 8 .

DEFINE VARIABLE radio_set_profilerver AS INTEGER INITIAL 2 
     VIEW-AS RADIO-SET VERTICAL
     RADIO-BUTTONS 
          "old profiler ver.", 1,
"new extended profiler ver.", 2
     SIZE 32 BY 2.29
     BGCOLOR 7  NO-UNDO.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY BROWSE-1 FOR 
      Profile-Session SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE BROWSE-1
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS BROWSE-1 C-Win _STRUCTURED
  QUERY BROWSE-1 DISPLAY
      Profile-Session.session-id COLUMN-LABEL "SessId" FORMAT ">,>>9":U
      Profile-Session.session-date COLUMN-LABEL "Session Date" FORMAT "99/99/9999":U
      Profile-Session.Session-Desc FORMAT "x(100)":U
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SIZE 80 BY 7.62 TOOLTIP "Double click to view a Session's summary".


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     BROWSE-1 AT ROW 1.24 COL 1
     Btn-viewsession AT ROW 9.1 COL 5
     btn_addsession AT ROW 9.1 COL 23
     btn_delsession AT ROW 9.1 COL 41
     Btn_Done AT ROW 9.1 COL 59
     radio_set_profilerver AT ROW 10.52 COL 6 NO-LABEL WIDGET-ID 2
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1 SCROLLABLE 
         BGCOLOR 8 
         DEFAULT-BUTTON Btn_Done.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "Progress Profiling Viewer"
         HEIGHT             = 13.24
         WIDTH              = 80.4
         MAX-HEIGHT         = 46.52
         MAX-WIDTH          = 256
         VIRTUAL-HEIGHT     = 46.52
         VIRTUAL-WIDTH      = 256
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = 8
         FGCOLOR            = 12
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
   FRAME-NAME Size-to-Fit                                               */
/* BROWSE-TAB BROWSE-1 1 DEFAULT-FRAME */
ASSIGN 
       FRAME DEFAULT-FRAME:SCROLLABLE       = FALSE.

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE BROWSE-1
/* Query rebuild information for BROWSE BROWSE-1
     _TblList          = "prof.Profile-Session"
     _FldNameList[1]   > prof.Profile-Session.session-id
"Profile-Session.session-id" "SessId" ">,>>9" "integer" ? ? ? ? ? ? no ? no no ? yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[2]   > prof.Profile-Session.session-date
"Profile-Session.session-date" "Session Date" "99/99/9999" "date" ? ? ? ? ? ? no ? no no ? yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[3]   > prof.Profile-Session.Session-Desc
"Profile-Session.Session-Desc" ? "x(100)" "character" ? ? ? ? ? ? no ? no no ? yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _Query            is OPENED
*/  /* BROWSE BROWSE-1 */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* Progress Profiling Viewer */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* Progress Profiling Viewer */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BROWSE-1
&Scoped-define SELF-NAME BROWSE-1
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BROWSE-1 C-Win
ON MOUSE-SELECT-DBLCLICK OF BROWSE-1 IN FRAME DEFAULT-FRAME
DO:
  run view-current in this-procedure.
  return no-apply.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn-viewsession
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn-viewsession C-Win
ON CHOOSE OF Btn-viewsession IN FRAME DEFAULT-FRAME /* View Session */
DO:
  run view-current in this-procedure.
  return no-apply.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btn_addsession
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btn_addsession C-Win
ON CHOOSE OF btn_addsession IN FRAME DEFAULT-FRAME /* Add Session */
DO:
  def buffer profsess for profile-session.
  def var sessid as int no-undo.
  
  find last profsess no-error.
  if available profsess then
     sessid = profsess.session-id.
  else sessid = -1.
  
  run import.w.
  
  find last profsess no-error.
  if not available profsess OR sessid EQ profsess.session-id then
     return. /* didn't import a new session */
    
  {&OPEN-BROWSERS-IN-QUERY-{&FRAME-NAME}}

  reposition browse-1 to recid recid(profsess).
  if recid(profsess) NE recid(profile-session) then
    get next browse-1.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btn_delsession
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btn_delsession C-Win
ON CHOOSE OF btn_delsession IN FRAME DEFAULT-FRAME /* Delete Session */
DO:
  def var deleteit as logical no-undo initial no.
  
  if not available(profile-session) then do:
     message "No session selected to delete." view-as alert-box.
     return.
  end.
  
  message "Delete Profiling Session:"
          "'" + Profile-Session.Session-Desc + "'"
          "Are you sure? This could take a while..." 
          view-as alert-box question buttons yes-no update deleteit.
  if not deleteit then
     return.
  
  /* close any outstanding viewing of the session */
  FIND FIRST ttabchild
             where ttabchild.session-id = profile-session.session-id no-error.
  IF available(ttabchild)
      and valid-handle(ttabchild.prochdl)
      and ttabchild.prochdl:type = "Procedure"
      and ttabchild.prochdl:unique-id = ttabchild.procid then
  DO:
     apply "close" to ttabchild.prochdl.
  END.
  
  /* put up hour glass... */
  run adecomm/_setcurs.p ("WAIT").

  blk:
  do transaction on stop undo blk, leave blk on error undo blk, leave blk:
    find current profile-session exclusive-lock.
  
    for each source of profile-session:
      delete source.
    end.
    for each calltree of profile-session:
      delete calltree.
    end.
    for each calltreedata of profile-session:
      delete calltreedata.
    end.
    for each listing-lines of profile-session:
      delete listing-lines.
    end.
    for each sumstmt of profile-session:
      delete sumstmt.
    end.
    for each databases of profile-session:
      delete databases.
    end.

    for each moduledetail of profile-session:
      delete moduledetail.
    end.

    for each operators of profile-session:
      delete operators.
    end.


    for each parameters of profile-session:
      delete parameters.
    end.

    for each watermark of profile-session:
      delete watermark.
    end.

    for each Listing-Lines of profile-session:
      delete Listing-Lines.
    end.

    for each Executable-line of profile-session:
      delete Executable-line.
    end.
    for each USER-DATA of profile-session:
      delete USER-DATA.
    end.

    for each Traceinfo of profile-session:
      delete Traceinfo.
    end.
    delete profile-session.
  end.
  
  run adecomm/_setcurs.p ("").
  
  {&OPEN-BROWSERS-IN-QUERY-{&FRAME-NAME}}
  
  /* take down hour glass */
  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_Done
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_Done C-Win
ON CHOOSE OF Btn_Done IN FRAME DEFAULT-FRAME /* Done */
DO:
  &IF DEFINED (adm-panel) <> 0 &THEN
      RUN dispatch IN THIS-PROCEDURE ('exit').
  &ELSE
      APPLY "CLOSE":U TO THIS-PROCEDURE.
  &ENDIF
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME radio_set_profilerver
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL radio_set_profilerver C-Win
ON VALUE-CHANGED OF radio_set_profilerver IN FRAME DEFAULT-FRAME
DO:
  ASSIGN radio_set_profilerver.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE DO:
   FOR EACH ttabchild:
      IF valid-handle(ttabchild.prochdl)
         and ttabchild.prochdl:type = "Procedure"
         and ttabchild.prochdl:unique-id = ttabchild.procid
      THEN
         APPLY "Close" to ttabchild.prochdl. /* will call killchild in us */
      ELSE
         DELETE ttabchild.
   END.
   RUN disable_UI.
END.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
    QUIT.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY radio_set_profilerver 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE BROWSE-1 Btn-viewsession btn_addsession btn_delsession Btn_Done 
         radio_set_profilerver 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE killchild C-Win 
PROCEDURE killchild :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
def input parameter childhdl as Handle no-undo.

DEFINE BUFFER ttabchild for ttabchild.

FIND FIRST ttabchild where ttabchild.prochdl = childhdl no-error.
IF NOT AVAILABLE(ttabchild) THEN
  RETURN.
DELETE ttabchild.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE refreshmain C-Win 
PROCEDURE refreshmain :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
def input parameter sessid as int no-undo.
def buffer profsess for profile-session.

find first profsess where profsess.session-id = sessid no-error.
if not avail profsess then return.

{&OPEN-BROWSERS-IN-QUERY-{&FRAME-NAME}}

reposition BROWSE-1 to recid recid(profsess).
if recid(profsess) NE recid(profile-session) then
  get next browse-1.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE view-current C-Win 
PROCEDURE view-current :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEF VAR hdl AS Handle NO-UNDO.

if not available(profile-session) then
   return.
   
/* if there's already a child spawned for this session, just bring it to the fore */
FIND FIRST ttabchild
    where ttabchild.session-id = profile-session.session-id no-error.
IF available(ttabchild)
   and valid-handle(ttabchild.prochdl)
   and ttabchild.prochdl:type = "Procedure"
   and ttabchild.prochdl:unique-id = ttabchild.procid then
DO:
  IF radio_set_profilerver = 1 THEN
  DO:
    RUN session_summary IN ttabchild.prochdl.
  END.
  ELSE DO:
     RUN extended_mainp.p PERSISTENT SET hdl (INPUT profile-session.session-id).
     RETURN.
  END.
  RETURN.
END.

IF AVAIL(ttabchild) THEN
  DELETE ttabchild. /* if avail but invalid, then delete */


  IF radio_set_profilerver = 1 THEN
  DO:
    RUN sessmain.p PERSISTENT SET hdl (INPUT THIS-PROCEDURE,
                                   INPUT profile-session.session-id).
  END.
  ELSE DO:
     RUN extended_mainp.p PERSISTENT SET hdl (INPUT profile-session.session-id).
     RETURN.
  END.

create ttabchild.
ASSIGN ttabchild.session-id = profile-session.session-id
       ttabchild.prochdl = hdl
       ttabchild.procid = hdl:unique-id.

  IF radio_set_profilerver = 1 THEN
  DO:
    RUN session_summary IN hdl.
  END.
  ELSE DO:
     RUN extended_mainp.p PERSISTENT SET hdl(INPUT profile-session.session-id).
     RETURN.
  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

