&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12 GUI
&ANALYZE-RESUME
/* Connected Databases 
          prof             PROGRESS
*/
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*********************************************************************
* Copyright (C) 2000,2009 by Progress Software Corporation ("PSC"),  *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/*------------------------------------------------------------------------
 * June, 1997
 * Version 1.0

  File: viewsess.w

  Description: Present summary information for a given profiling session.

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */
DEFINE VAR parentproc AS Handle NO-UNDO.
DEFINE VAR sessionid LIKE profile-session.session-id NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME DEFAULT-FRAME
&Scoped-define BROWSE-NAME BROWSE-3

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES source Profile-Session

/* Definitions for BROWSE BROWSE-3                                      */
&Scoped-define FIELDS-IN-QUERY-BROWSE-3 source.srcname source.callcnt ~
source.avg_acttime source.session-percent 
&Scoped-define ENABLED-FIELDS-IN-QUERY-BROWSE-3 
&Scoped-define FIELD-PAIRS-IN-QUERY-BROWSE-3
&Scoped-define OPEN-QUERY-BROWSE-3 OPEN QUERY BROWSE-3 FOR EACH source ~
      WHERE source.session-id eq sessionid NO-LOCK ~
    BY source.session-percent DESCENDING.
&Scoped-define TABLES-IN-QUERY-BROWSE-3 source
&Scoped-define FIRST-TABLE-IN-QUERY-BROWSE-3 source


/* Definitions for FRAME DEFAULT-FRAME                                  */
&Scoped-define FIELDS-IN-QUERY-DEFAULT-FRAME Profile-Session.session-id ~
Profile-Session.tot_acttime Profile-Session.session-date ~
Profile-Session.Session-Desc 
&Scoped-define ENABLED-FIELDS-IN-QUERY-DEFAULT-FRAME ~
Profile-Session.Session-Desc 
&Scoped-define ENABLED-TABLES-IN-QUERY-DEFAULT-FRAME Profile-Session
&Scoped-define FIRST-ENABLED-TABLE-IN-QUERY-DEFAULT-FRAME Profile-Session

&Scoped-define FIELD-PAIRS-IN-QUERY-DEFAULT-FRAME~
 ~{&FP1}Session-Desc ~{&FP2}Session-Desc ~{&FP3}
&Scoped-define OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME ~
    ~{&OPEN-QUERY-BROWSE-3}
&Scoped-define OPEN-QUERY-DEFAULT-FRAME OPEN QUERY DEFAULT-FRAME FOR EACH Profile-Session ~
      WHERE profile-session.session-id = sessionid SHARE-LOCK.
&Scoped-define TABLES-IN-QUERY-DEFAULT-FRAME Profile-Session
&Scoped-define FIRST-TABLE-IN-QUERY-DEFAULT-FRAME Profile-Session


/* Standard List Definitions                                            */
&Scoped-Define ENABLED-FIELDS Profile-Session.Session-Desc 
&Scoped-define FIELD-PAIRS~
 ~{&FP1}Session-Desc ~{&FP2}Session-Desc ~{&FP3}
&Scoped-define ENABLED-TABLES Profile-Session
&Scoped-define FIRST-ENABLED-TABLE Profile-Session
&Scoped-Define ENABLED-OBJECTS BROWSE-3 findcode Rootbtn closebtn 
&Scoped-Define DISPLAYED-FIELDS Profile-Session.session-id ~
Profile-Session.tot_acttime Profile-Session.session-date ~
Profile-Session.Session-Desc 
&Scoped-Define DISPLAYED-OBJECTS findcode 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD reposquery C-Win 
FUNCTION reposquery RETURNS LOGICAL
  ( input nam as char /* parameter-definitions */ )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON closebtn 
     LABEL "&Close Session" 
     SIZE 17 BY 1.05 TOOLTIP "Close all Windows for this Profiling Session".

DEFINE BUTTON Rootbtn 
     LABEL "&Root Procedure" 
     SIZE 17 BY 1.05 TOOLTIP "Bring up Top level Procedure".

DEFINE VARIABLE findcode AS CHARACTER FORMAT "X(256)":U 
     LABEL "Find Code Block" 
     VIEW-AS FILL-IN 
     SIZE 52.2 BY 1 NO-UNDO.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY BROWSE-3 FOR 
      source SCROLLING.

DEFINE QUERY DEFAULT-FRAME FOR 
      Profile-Session SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE BROWSE-3
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS BROWSE-3 C-Win _STRUCTURED
  QUERY BROWSE-3 DISPLAY
      source.srcname COLUMN-LABEL "Procedure, Function, or Trigger" FORMAT "x(50)"
      source.callcnt COLUMN-LABEL "Times!Called" FORMAT ">>>,>>9"
      source.avg_acttime COLUMN-LABEL "Avg Time!Per Call" FORMAT " >>>9.999999"
      source.session-percent COLUMN-LABEL "Percent   !of Session"
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SIZE 87 BY 11.67 TOOLTIP "Double-click to Review the Profile for the Code".


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     BROWSE-3 AT ROW 1 COL 1
     findcode AT ROW 16.24 COL 16 COLON-ALIGNED
     Rootbtn AT ROW 14.33 COL 71
     closebtn AT ROW 16.24 COL 71
     Profile-Session.session-id AT ROW 12.91 COL 16 COLON-ALIGNED
           VIEW-AS TEXT 
          SIZE 10 BY .62
     Profile-Session.tot_acttime AT ROW 12.91 COL 64 COLON-ALIGNED
          LABEL "Total Time (secs)"
           VIEW-AS TEXT 
          SIZE 22 BY .62
     Profile-Session.session-date AT ROW 13.62 COL 16 COLON-ALIGNED
          LABEL "Date"
           VIEW-AS TEXT 
          SIZE 13.2 BY .62
     Profile-Session.Session-Desc AT ROW 14.33 COL 16 COLON-ALIGNED
          LABEL "Description" FORMAT "x(256)"
          VIEW-AS FILL-IN 
          SIZE 52 BY 1 TOOLTIP "Update the Description"
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 87.8 BY 16.81.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "Session Summary"
         HEIGHT             = 16.81
         WIDTH              = 87.8
         MAX-HEIGHT         = 18.1
         MAX-WIDTH          = 167.2
         VIRTUAL-HEIGHT     = 18.1
         VIRTUAL-WIDTH      = 167.2
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME


/* ***************  Runtime Attributes and UIB Settings  ************** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
   Custom                                                               */
/* BROWSE-TAB BROWSE-3 1 DEFAULT-FRAME */
/* SETTINGS FOR FILL-IN Profile-Session.session-date IN FRAME DEFAULT-FRAME
   NO-ENABLE EXP-LABEL                                                  */
/* SETTINGS FOR FILL-IN Profile-Session.Session-Desc IN FRAME DEFAULT-FRAME
   EXP-LABEL EXP-FORMAT                                                 */
/* SETTINGS FOR FILL-IN Profile-Session.session-id IN FRAME DEFAULT-FRAME
   NO-ENABLE                                                            */
/* SETTINGS FOR FILL-IN Profile-Session.tot_acttime IN FRAME DEFAULT-FRAME
   NO-ENABLE EXP-LABEL                                                  */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE BROWSE-3
/* Query rebuild information for BROWSE BROWSE-3
     _TblList          = "prof.source"
     _OrdList          = "prof.source.session-percent|no"
     _Where[1]         = "source.session-id eq sessionid"
     _FldNameList[1]   > prof.source.srcname
"source.srcname" "Procedure, Function, or Trigger" "x(50)" "character" ? ? ? ? ? ? no ?
     _FldNameList[2]   > prof.source.callcnt
"source.callcnt" "Times!Called" ">>>,>>9" "integer" ? ? ? ? ? ? no ?
     _FldNameList[3]   > prof.source.avg_acttime
"source.avg_acttime" "Avg Time!Per Call" " >>>9.999999" "decimal" ? ? ? ? ? ? no ?
     _FldNameList[4]   > prof.source.session-percent
"source.session-percent" "Percent   !of Session" ? "decimal" ? ? ? ? ? ? no ?
     _Query            is OPENED
*/  /* BROWSE BROWSE-3 */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME DEFAULT-FRAME
/* Query rebuild information for FRAME DEFAULT-FRAME
     _TblList          = "prof.Profile-Session"
     _Where[1]         = "profile-session.session-id = sessionid"
     _Query            is OPENED
*/  /* FRAME DEFAULT-FRAME */
&ANALYZE-RESUME

 




/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* Session Summary */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* Session Summary */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME BROWSE-3
&Scoped-define SELF-NAME BROWSE-3
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BROWSE-3 C-Win
ON MOUSE-SELECT-DBLCLICK OF BROWSE-3 IN FRAME DEFAULT-FRAME
DO:
  RUN view_source IN parentproc (INPUT source.srcid, 0).

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BROWSE-3 C-Win
ON RETURN OF BROWSE-3 IN FRAME DEFAULT-FRAME
DO:
   RUN view_source IN parentproc (INPUT source.srcid, 0).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME closebtn
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL closebtn C-Win
ON CHOOSE OF closebtn IN FRAME DEFAULT-FRAME /* Close Session */
DO:
  apply "close" to parentproc.
  return no-apply.
  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME findcode
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL findcode C-Win
ON LEAVE OF findcode IN FRAME DEFAULT-FRAME /* Find Code Block */
DO:
  assign findcode.
  reposquery(findcode).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL findcode C-Win
ON RETURN OF findcode IN FRAME DEFAULT-FRAME /* Find Code Block */
DO:
  assign findcode.
  reposquery(findcode).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Rootbtn
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Rootbtn C-Win
ON CHOOSE OF Rootbtn IN FRAME DEFAULT-FRAME /* Root Procedure */
DO:
  def buffer proot for source.
  find first proot of profile-session where proot.srcid > 0.
  run view_source in parentproc (INPUT proot.srcid, 0).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Profile-Session.Session-Desc
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Profile-Session.Session-Desc C-Win
ON LEAVE OF Profile-Session.Session-Desc IN FRAME DEFAULT-FRAME /* Description */
DO:
  def var c as char no-undo.
  c = prof.profile-session.session-desc.
  assign prof.profile-session.session-desc.
  if c NE prof.profile-session.session-desc then
     run refreshmain in parentproc (profile-session.session-id).
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE DO:
   IF parentproc NE ? THEN
      RUN killchild IN parentproc (INPUT THIS-PROCEDURE).
   RUN disable_UI.
END.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
&IF DEFINED(UIB_is_Running) NE 0 &THEN
  FIND FIRST profile-session.
  RUN initialize IN THIS-PROCEDURE (INPUT ?, INPUT profile-session.session-id).
&ENDIF
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/

  {&OPEN-QUERY-DEFAULT-FRAME}
  GET FIRST DEFAULT-FRAME.
  DISPLAY findcode 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  IF AVAILABLE Profile-Session THEN 
    DISPLAY Profile-Session.session-id Profile-Session.tot_acttime 
          Profile-Session.session-date Profile-Session.Session-Desc 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE BROWSE-3 findcode Rootbtn closebtn Profile-Session.Session-Desc 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeself C-Win 
PROCEDURE initializeself :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEFINE INPUT PARAMETER parenthdl AS Handle NO-UNDO.
DEFINE INPUT PARAMETER session_id LIKE profile-session.session-id NO-UNDO.

ASSIGN parentproc = parenthdl
       sessionid = session_id.
RUN enable_ui IN THIS-PROCEDURE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Implementations ***************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION reposquery C-Win 
FUNCTION reposquery RETURNS LOGICAL
  ( input nam as char /* parameter-definitions */ ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/
  def buffer tmpsrc for prof.source.
  find first tmpsrc where tmpsrc.session-id = sessionid and tmpsrc.srcname begins nam no-error.
  if not available(tmpsrc) then
     RETURN FALSE.   /* Function return value. */
  reposition browse-3 to recid recid(tmpsrc).
  if recid(tmpsrc) NE recid(source) then
    get next browse-3.
  return true.
END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


