/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/************************************************************************************
	PROCEDURE: psval.p

	PURPOSE:   Browser Widget

	SYNTAX:    "RUN samples/psval.p"

	REMARKS:   Program was created using the User Interface Builder.
                   A BROWSER widget was used with the QUERY statements
                   to show all current customers in the SPORTS database
                   and have the user select one.

	PARAMETERS: 

	AUTHORS:   PROGRESS Consulting
	DATE:      February 1993

	LAST INSPECTED:
	INSPECTED BY:

 ************************************************************************************/
/*Code_Start*/
 
&ANALYZE-SUSPEND _VERSION-NUMBER 7.1A001

DEFINE SHARED VAR s_cust_num     LIKE customer.cust-num NO-UNDO.

&ANALYZE-RESUME


/* Definitions of the field level widgets                               */
/* Definitions of the queries                                           */
DEFINE NEW SHARED VAR s_UIB_TblList  AS CHAR               NO-UNDO.
DEFINE NEW SHARED VAR s_UIB_FldList  AS CHAR               NO-UNDO.
DEFINE NEW SHARED VAR s_UIB_OrdList  AS CHAR               NO-UNDO.
DEFINE NEW SHARED VAR s_UIB_JoinTo   AS INTEGER  EXTENT 20 NO-UNDO.
DEFINE NEW SHARED VAR s_UIB_JoinCode AS CHAR     EXTENT 20 NO-UNDO.
DEFINE NEW SHARED VAR s_UIB_Where    AS CHAR     EXTENT 20 NO-UNDO.
DEFINE NEW SHARED VAR s_UIB_Query    AS CHAR               NO-UNDO.
DEFINE NEW SHARED VAR s_UIB_Browse   AS CHAR               NO-UNDO.
DEFINE NEW SHARED BUFFER Customer FOR Customer.
DEFINE NEW SHARED QUERY cust-num-browse FOR Customer SCROLLING.

/* Definitions of the frame widgets                                     */
 
/* Definitions of the browser frames                                    */
DEFINE BROWSE cust-num-browse QUERY cust-num-browse DISPLAY 
       Cust-Num Name
    WITH OVERLAY  NO-LABELS
        AT COL 10 ROW 7.41  SIZE 40 BY 7 
        BGCOLOR ? FGCOLOR ?.

DEFINE FRAME frm_browse
   cust-num-browse
   WITH OVERLAY NO-LABELS AT COL 10 ROW 7.41 SIZE-CHAR 40 BY 8
   VIEW-AS DIALOG-BOX TITLE "Customers".
   

/* Definitions of the browser widgets                                   */
&ANALYZE-SUSPEND _BROWSER-BLOCK cust-num-browse
OPEN QUERY cust-num-browse FOR EACH Customer.  /* _BROWSER-BLOCK-END */

ON MOUSE-MENU-DOWN OF BROWSE cust-num-browse DO:
  ASSIGN
          s_UIB_TblList     = "Customer"
          s_UIB_FldList     = "Cust-Num Name"
          s_UIB_OrdList     = ""
          s_UIB_Query       = 
               "DEFINE SHARED QUERY cust-num-browse FOR Customer SCROLLING.".

   RUN adeuib/rtqryedt.p ("cust-num-browse").
END.
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK GO cust-num-browse

ON MOUSE-SELECT-DBLCLICK, GO OF BROWSE cust-num-browse DO:
  s_cust_num = customer.cust-num.
  APPLY "GO" TO cust-num-browse IN FRAME frm_browse.
END.
ON ENDKEY OF BROWSE cust-num-browse DO:
   HIDE BROWSE cust-num-browse NO-PAUSE.
   RETURN.
END.
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
UPDATE cust-num-browse WITH FRAME frm_browse.
HIDE BROWSE cust-num-browse NO-PAUSE.
RETURN.










