/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/************************************************************************************
	PROCEDURE: pv.p

	PURPOSE:   Present Value program

	SYNTAX:    "RUN samples/pv.p"

	REMARKS:   

	PARAMETERS:NONE, See loader.p for proclib.ini startup options.

	AUTHORS:   Progress Consulting
	DATE:      February 1993

	LAST INSPECTED:
	INSPECTED BY:

 ************************************************************************************/
/*Code_Start*/

/* pv.p            ******   Present Value Function  ******

   This function determines the present value of an annuity based on
   payment amount, interest rate, and life (number of compounding periods)

  The formula used is as follows:
                        1 - (1 + INTEREST) ^ (- LIFE)
       PV =   PAYMENT * -----------------------------
                                  INTEREST
*/

DEFINE INPUT PARAMETER payment  AS DECIMAL DECIMALS 10.
DEFINE INPUT PARAMETER interest AS DECIMAL DECIMALS 10.
DEFINE INPUT PARAMETER life     AS INTEGER.

DEFINE OUTPUT PARAMETER present_value AS DECIMAL DECIMALS 10.

present_value = payment * ( 1 - EXP((1 + interest),(life * (-1))) /
                interest).


