/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/************************************************************************************
	PROCEDURE: rate.p

	PURPOSE:   Rate calculations

	SYNTAX:    "RUN samples/rate.p"

	REMARKS:   

	PARAMETERS:NONE, See loader.p for proclib.ini startup options.

	AUTHORS:   Progress Consulting
	DATE:      February 1993

	LAST INSPECTED:
	INSPECTED BY:

 ************************************************************************************/
/*Code_Start*/


/* rate.p        **** Periodic Interest Rate Function ***

   This function returns the periodic interest rate required to return the
   future value (FUTURE) based on the present value (PRESENT) and the TERM
   (number of compounding periods).

*/

DEFINE INPUT  PARAMETER present_value AS DECIMAL DECIMALS 10.
DEFINE INPUT  PARAMETER future_value  AS DECIMAL DECIMALS 10.
DEFINE INPUT  PARAMETER term_         AS INTEGER.

DEFINE OUTPUT PARAMETER rate          AS DECIMAL DECIMALS 10.

rate = EXP( (future_value / present_value), (1 / term_) ) - 1.


