/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/************************************************************************************
	PROCEDURE: roman.p

	PURPOSE:   Converts an Arabic number to Roman Numerals

	SYNTAX:    RUN samples/roman.p (INPUT in, OUTPUT out).

	REMARKS:   This code converts an arabic number to roman numerals.

	PARAMETERS:
            INPUT:  arabic number  - integer
            OUTPUT: roman numerals - character string

	AUTHORS:   Judy Rothermal
	DATE:      February 1993

	LAST INSPECTED:
	INSPECTED BY:

 ************************************************************************************/
/*Code_Start*/
/* M=1000, D=500, C=100, L=50, X=10, V=5, I=1 */

DEFINE INPUT  PARAMETER arabic AS INTEGER   NO-UNDO.
DEFINE OUTPUT PARAMETER roman  AS CHARACTER NO-UNDO.

DEFINE VARIABLE  i      AS INTEGER   NO-UNDO.
DEFINE VARIABLE  j      AS INTEGER   NO-UNDO.
DEFINE VARIABLE  k      AS INTEGER   NO-UNDO.

ASSIGN
   roman = "".
IF arabic < 1 OR arabic > 3999 OR arabic = ? THEN roman = ?.
ELSE 
DO j = 1 TO 4:
   k = EXP(10,4 - j).
   IF arabic >= 9 * k THEN 
      ASSIGN
         roman  = roman + ENTRY(j,",CM,XC,IX")
         arabic = arabic - 9 * k.
   IF arabic >= 5 * k THEN 
      ASSIGN
         roman  = roman + ENTRY(j,",D,L,V")
         arabic = arabic - 5 * k.
   IF arabic >= 4 * k THEN 
      ASSIGN
         roman  = roman + ENTRY(j,",CD,XL,IV")
         arabic = arabic - 4 * k.
   IF arabic >= k THEN 
      ASSIGN
         i      = TRUNCATE(arabic / k,0)
         roman  = roman + FILL(ENTRY(j,"M,C,X,I"),i)
         arabic = arabic - i * k.
END.



