/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/************************************************************************************
	PROCEDURE: selval.p

	PURPOSE:   Selection List Display and Selection

	SYNTAX:    "RUN samples/selval.p"

	REMARKS:   Enter a database, file, field to choose from.  The
                   file is read and the field values displayed for 
                   selection.

	PARAMETERS: 

	AUTHORS:   Progress Consulting
	DATE:      February 1993

	LAST INSPECTED:
	INSPECTED BY:

 ************************************************************************************/
/*Code_Start*/

DEFINE SHARED VARIABLE s_carrier LIKE order.carrier NO-UNDO.

DEFINE VARIABLE carrier-list AS CHARACTER VIEW-AS SELECTION-LIST
                             SIZE 30 BY 7.
DEFINE VARIABLE ok-flag      AS LOGICAL.
s_carrier = "".
FORM
   carrier-list
   HELP "Press GO to select carrier."
   WITH FRAME frm_carrier NO-LABEL OVERLAY ROW 5 COLUMN 40
   TITLE " Carriers " VIEW-AS DIALOG-BOX.

FOR EACH order NO-LOCK BREAK BY order.carrier: 
   IF FIRST-OF(order.carrier) AND order.carrier <> "" THEN DO:
      ok-flag = carrier-list:ADD-LAST(order.carrier)
         IN FRAME frm_carrier.
      IF NOT ok-flag THEN UNDO, RETURN.
   END. /* first-of */
END.    /* FOR EACH */

ENABLE carrier-list WITH FRAME frm_carrier.
APPLY "CHOOSE" TO carrier-list IN FRAME frm_carrier.
ON MOUSE-SELECT-DBLCLICK OF carrier-list
   APPLY "GO" TO carrier-list IN FRAME frm_carrier.
UPDATE carrier-list WITH FRAME frm_carrier. 
s_carrier = carrier-list:screen-value.
HIDE FRAME frm_carrier.













