/*   Sockets-HTTP.p
You can use this sample code as the starting point of a program to 
access a web site or as an example of how to use 4GL sockets in a client 
application.

This is a sample program that shows how to access a web site using
the Hypertext Transfer Protocol (HTTP) internet protocol. The program
basically retrieves a web page as a web browser would do and presents
the text of the page (that is, it displays the Source HTML).
It implements socket routines in the 4GL.

This program works with Progress Provision, Provision Plus or Progress 
4GL Version 9.1A and above.

You can find information about the HTTP protocol anywhere on the 
internet, by searching for  the Request for Comments document:RFC821.
Many other RFC documents describe extensions to the SMTP protocol.
Search under:
    - Protocol Directory - TCP/IP
      - http://www.protocols.com/pbook/tcpip.htm
    - Hypertext Transfer Protocol -- HTTP/1.1
      - http://www.faqs.org/rfcs/rfc2616.html
    - Internet RFC search 
      - http://www.landfield.com/rfcs/

The sockets routines that the program uses are in an include file 
called httpget.i so this include file can be included in any program 
that requires this functionality.

*/

DEFINE VARIABLE wurl AS CHARACTER FORMAT "X(255)"
VIEW-AS FILL-IN SIZE 65 BY 1
INITIAL "http://www.progress.com/" LABEL "Url" NO-UNDO.
DEFINE VARIABLE weditor AS CHARACTER VIEW-AS EDITOR INNER-CHARS
72 INNER-LINES 32 LARGE SCROLLBAR-VERTICAL NO-UNDO.
DEFINE BUTTON b-get LABEL "GET".

DEFINE VARIABLE vhost AS CHARACTER NO-UNDO.
DEFINE VARIABLE vport AS CHARACTER NO-UNDO.
DEFINE VARIABLE vpath AS CHARACTER NO-UNDO.
DEFINE VARIABLE vfile AS CHARACTER NO-UNDO.

SESSION:APPL-ALERT-BOXES = YES.
FORM wurl b-get SKIP weditor NO-LABELS
WITH FRAME DEFAULT-FRAME THREE-D SIDE-LABELS.

ON 'RETURN':U OF wurl OR 'CHOOSE':U OF b-get
DO:
    ASSIGN wurl.
    RUN UrlParser(INPUT wurl, OUTPUT vhost, OUTPUT vport, OUTPUT vpath).
    RUN HTTPGet(vhost, vport, vpath, vfile).
    weditor:READ-FILE(vfile).
    RETURN.
END.

RUN adecomm/_tmpfile.p ("i", ".htm", OUTPUT vfile).
MAIN-BLOCK:
DO ON ERROR UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
   DISPLAY wurl weditor WITH FRAME DEFAULT-FRAME.
   ENABLE wurl b-get weditor WITH FRAME DEFAULT-FRAME.
   WAIT-FOR GO OF CURRENT-WINDOW.
END.
OS-DELETE VALUE(vfile) NO-ERROR.

{ src/samples/sockets/HTTP/httpget.i } 

