DEFINE VARIABLE ptp AS LOGICAL INITIAL TRUE.

DEFINE VARIABLE sessionH AS HANDLE.
DEFINE VARIABLE messageH AS HANDLE.
DEF VAR hds1 AS HANDLE.
DEF VAR ret AS LOGICAL NO-UNDO.

/* Definition for Temp-Table ttCust */
DEFINE TEMP-TABLE ttCust NO-UNDO
    BEFORE-TABLE ttCustBef
	    FIELD CustNum LIKE Customer.CustNum
        FIELD Name LIKE Customer.Name COLUMN-LABEL "custlab"
             XML-NODE-TYPE "Attribute"
        FIELD Country LIKE Customer.Country
        FIELD Comments LIKE Customer.Comments FORMAT "x(40)"
        INDEX CustNum IS PRIMARY UNIQUE CustNum
        INDEX Name Name
        INDEX Comments IS WORD-INDEX Comments.


/* Definition for Temp-Table ttOrder */
DEFINE TEMP-TABLE ttOrd
    FIELD OrderNum LIKE Order.OrderNum
    FIELD CustNum LIKE Order.CustNum
    FIELD OrderDate LIKE Order.OrderDate
    INDEX OrderNum IS PRIMARY UNIQUE OrderNum
    INDEX CustOrder IS UNIQUE CustNum OrderNum
    INDEX OrderDate OrderDate.


DEFINE DATASET myds 
    NAMESPACE-URI "urn:myds" NAMESPACE-PREFIX "ds"
    FOR ttCust, ttOrd
    DATA-RELATION custOrd FOR ttCust, ttOrd 
    REPOSITION RELATION-FIELDS (CustNum, CustNum).

/* Creates a session object. */
IF ptp THEN
    RUN  jms/ptpsession.p PERSISTENT SET sessionH ("-SMQConnect").
ELSE
    RUN  jms/pubsubsession.p PERSISTENT SET sessionH ("-SMQConnect").

RUN setBrokerURL IN sessionH ("localhost:2506").
RUN beginSession IN sessionH.


FOR EACH Customer WHERE custNum < 4:
    CREATE ttCust.
    BUFFER-COPY Customer TO ttCust.
    FOR EACH Order OF Customer:
        CREATE ttOrd.
        BUFFER-COPY Order TO ttOrd.
    END.
END.

hds1 = DATASET myds:HANDLE.

/* Uncomment to write XML to a file 
ret = hds1:WRITE-XML("file", "wdsCustOrd.xml", YES, ?,?,YES).
*/

RUN createDatasetMessage in sessionH(OUTPUT messageH).
RUN setDataSet IN messageH( hds1, ?, TRUE).

IF ptp THEN
    RUN sendToQueue IN sessionH ("SampleQ1", messageH, ?, ?, ?).    
ELSE
    RUN PUBLISH IN sessionH ("TestTopic", messageH, ?, ?, ?).
    
RUN deleteMessage IN messageH.
RUN deleteSession in sessionH.

