&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME ConnectionFileC-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS ConnectionFileC-Win 
/*------------------------------------------------------------------------

  File: oechatclnt.w

  Description: Moderated chat client application. Submits questions on a
  queue and listens to responses on a topic.

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

DEFINE VARIABLE sessionH AS HANDLE NO-UNDO.
DEFINE VARIABLE topicConsumerH AS HANDLE NO-UNDO.
DEFINE VARIABLE questionH AS HANDLE NO-UNDO.
DEFINE VARIABLE answerH AS HANDLE NO-UNDO.
DEFINE VARIABLE userN AS CHARACTER INITIAL "anonymous on " NO-UNDO.
DEFINE VARIABLE computerName AS CHARACTER NO-UNDO.
DEFINE VARIABLE clientID AS CHARACTER NO-UNDO.
DEFINE VARIABLE msgSel AS CHARACTER INITIAL ? NO-UNDO.
DEFINE VARIABLE questionTxt AS CHARACTER NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME DEFAULT-FRAME

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS edUserName edChat edQuestion btnAsk btnClear 
&Scoped-Define DISPLAYED-OBJECTS edUserName edChat edQuestion 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR ConnectionFileC-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON btnAsk 
     LABEL "Ask" 
     SIZE 12 BY 1.52.

DEFINE BUTTON btnClear 
     LABEL "Clear" 
     SIZE 12 BY 1.52.

DEFINE VARIABLE edChat AS CHARACTER 
     VIEW-AS EDITOR SCROLLBAR-VERTICAL LARGE
     SIZE 77 BY 10.48 NO-UNDO.

DEFINE VARIABLE edQuestion AS CHARACTER 
     VIEW-AS EDITOR SCROLLBAR-VERTICAL
     SIZE 59 BY 3.81 NO-UNDO.

DEFINE VARIABLE edUserName AS CHARACTER 
     VIEW-AS EDITOR NO-WORD-WRAP MAX-CHARS 32
     SIZE 63 BY .95 TOOLTIP "Enter a user name" NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     edUserName AT ROW 1.95 COL 16 NO-LABEL WIDGET-ID 2
     edChat AT ROW 3.14 COL 2 NO-LABEL WIDGET-ID 6 NO-TAB-STOP 
     edQuestion AT ROW 14.33 COL 2 NO-LABEL WIDGET-ID 8
     btnAsk AT ROW 14.33 COL 65 WIDGET-ID 10
     btnClear AT ROW 16.24 COL 65 WIDGET-ID 12
     "User Name:" VIEW-AS TEXT
          SIZE 13 BY 1.19 AT ROW 1.95 COL 3 WIDGET-ID 4
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 80 BY 18
         DEFAULT-BUTTON btnAsk WIDGET-ID 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW ConnectionFileC-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "OpenEdge Chat Client"
         HEIGHT             = 18
         WIDTH              = 80
         MAX-HEIGHT         = 18
         MAX-WIDTH          = 80
         VIRTUAL-HEIGHT     = 18
         VIRTUAL-WIDTH      = 80
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW ConnectionFileC-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
   FRAME-NAME                                                           */
ASSIGN 
       edChat:READ-ONLY IN FRAME DEFAULT-FRAME        = TRUE.

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(ConnectionFileC-Win)
THEN ConnectionFileC-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME ConnectionFileC-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL ConnectionFileC-Win ConnectionFileC-Win
ON END-ERROR OF ConnectionFileC-Win /* OpenEdge Chat Client */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL ConnectionFileC-Win ConnectionFileC-Win
ON WINDOW-CLOSE OF ConnectionFileC-Win /* OpenEdge Chat Client */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnAsk
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnAsk ConnectionFileC-Win
ON CHOOSE OF btnAsk IN FRAME DEFAULT-FRAME /* Ask */
DO:
  
    questionTxt = edQuestion:SCREEN-VALUE.
    
    /* Create text message to send to queue. */
    IF LENGTH(questionTxt) > 0 THEN DO:
        RUN createTextMessage IN sessionH(OUTPUT questionH).
        
        /* This property displays who sent the question */
        RUN setStringProperty IN questionH("userName", userN).
        
        /* This property is globally unique and is used by the moderator to
           send a message only to this client. */
        RUN setStringProperty IN questionH("client", clientID).
        RUN setText IN questionH(questionTxt).
        
        RUN sendToQueue IN sessionH ("SampleQ1", questionH, ?, ?, ?).
        RUN deleteMessage IN questionH.
        questionTxt = "".
        edQuestion:SCREEN-VALUE = "".
    END.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnClear
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnClear ConnectionFileC-Win
ON CHOOSE OF btnClear IN FRAME DEFAULT-FRAME /* Clear */
DO:
    questionTxt = "".
    edQuestion:SCREEN-VALUE = "".
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME edUserName
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL edUserName ConnectionFileC-Win
ON LEAVE OF edUserName IN FRAME DEFAULT-FRAME
DO:
    /* Change the username upon leving this field */
  IF LENGTH(EDUSERNAME:SCREEN-VALUE) > 0 THEN
      userN = edUserName:SCREEN-VALUE.
  ELSE
      userN = "anonymous on " + computerName.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK ConnectionFileC-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE DO:
    RUN disable_UI.
    RUN disable_MQ.
END.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:

  computerName = OS-GETENV("COMPUTERNAME").
  userN = userN + computerName.
  RUN enable_UI.
  RUN enable_MQ.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_MQ ConnectionFileC-Win 
PROCEDURE disable_MQ :
/*------------------------------------------------------------------------------
  Purpose: Stops message reception and frees up resources     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
RUN stopReceiveMessages IN sessionH.
RUN deleteConsumer IN topicConsumerH.
RUN deleteSession IN sessionH.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI ConnectionFileC-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(ConnectionFileC-Win)
  THEN DELETE WIDGET ConnectionFileC-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_MQ ConnectionFileC-Win 
PROCEDURE enable_MQ :
/*------------------------------------------------------------------------------
  Purpose: Connects to the MQ broker and sets up a listener    
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

RUN jms/jmssession.p PERSISTENT SET sessionH ("-SMQConnect").

/* Uses a connection file that can travel with the application. Sample uses
   tcp://localhost:2506. */
RUN setConnectionFile IN sessionH ("Chat.sjo").

/* This causes messages meant for a specific client to be filtered at the broker. */
RUN setSelectorAtBroker IN sessionH(true).
RUN beginSession IN sessionH.
clientID = BASE64-ENCODE(GENERATE-RANDOM-KEY).
msgSel = "(client IS null) OR (client = '" + clientID + "')".

RUN createMessageConsumer IN sessionH (
                              THIS-PROCEDURE,    /* This proc will handle it */
                             "topicHandler", /* name of internal procedure */
                              OUTPUT topicConsumerH).
RUN subscribe IN sessionH 
    ("OEChat",
        ?, /* durable subscription */
        msgSel, /* Filter out messages not to us */
        YES, /* Wants to get my own publications */
        topicConsumerH).

RUN startReceiveMessages IN sessionH.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI ConnectionFileC-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY edUserName edChat edQuestion 
      WITH FRAME DEFAULT-FRAME IN WINDOW ConnectionFileC-Win.
  ENABLE edUserName edChat edQuestion btnAsk btnClear 
      WITH FRAME DEFAULT-FRAME IN WINDOW ConnectionFileC-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW ConnectionFileC-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE topicHandler ConnectionFileC-Win 
PROCEDURE topicHandler :
/*------------------------------------------------------------------------------
  Purpose: Displays conversation in Chat window    
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEFINE INPUT PARAMETER messageH AS HANDLE NO-UNDO.
DEFINE INPUT PARAMETER messageConsumerH AS HANDLE NO-UNDO.
DEFINE OUTPUT PARAMETER autoReplyH AS HANDLE NO-UNDO. 

DEFINE VARIABLE chatText AS CHARACTER NO-UNDO.

chatText = DYNAMIC-FUNCTION('getText':U IN messageH).
edChat:INSERT-STRING(chatText) IN FRAME DEFAULT-FRAME.
RUN deleteMessage IN messageH.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

