&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS C-Win 
/*------------------------------------------------------------------------

  File: oechatsrv.w

  Description: Moderated chat server application. This application receives
  questions from a queue, and publishes the question and answer to a topic
  where chat clients are subscribed. Moderator has option to skip or answer
  the question, as well as publishing statements.

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */
DEFINE VARIABLE sessionH        AS HANDLE NO-UNDO.
DEFINE VARIABLE queueConsumerH  AS HANDLE NO-UNDO.
DEFINE VARIABLE topicConsumerH  AS HANDLE NO-UNDO.
DEFINE VARIABLE questionH       AS HANDLE NO-UNDO.
DEFINE VARIABLE answerH         AS HANDLE NO-UNDO.

DEFINE VARIABLE questionTxt     AS CHARACTER INITIAL "" NO-UNDO.
DEFINE VARIABLE answerTxt       AS CHARACTER INITIAL "" NO-UNDO.
DEFINE VARIABLE clientID        AS CHARACTER NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME DEFAULT-FRAME

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS btnPost edAnswer edChat btnAnswer edQuestion ~
btnSkip 
&Scoped-Define DISPLAYED-OBJECTS edAnswer edChat edQuestion 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR C-Win AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON btnAnswer 
     LABEL "Answer" 
     SIZE 12 BY 1.24 TOOLTIP "Answer this question".

DEFINE BUTTON btnPost 
     LABEL "Post" 
     SIZE 12 BY 1.24.

DEFINE BUTTON btnSkip 
     LABEL "Skip" 
     SIZE 12 BY 1.24 TOOLTIP "Skip this question".

DEFINE VARIABLE edAnswer AS CHARACTER 
     VIEW-AS EDITOR SCROLLBAR-VERTICAL
     SIZE 69 BY 2.86 NO-UNDO.

DEFINE VARIABLE edChat AS CHARACTER 
     VIEW-AS EDITOR SCROLLBAR-VERTICAL LARGE
     SIZE 83 BY 10.48 NO-UNDO.

DEFINE VARIABLE edQuestion AS CHARACTER 
     VIEW-AS EDITOR SCROLLBAR-VERTICAL
     SIZE 69 BY 2.86 NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME DEFAULT-FRAME
     btnPost AT ROW 16.52 COL 73 WIDGET-ID 12
     edAnswer AT ROW 15.52 COL 2 NO-LABEL WIDGET-ID 2
     edChat AT ROW 1.24 COL 2 NO-LABEL WIDGET-ID 10 NO-TAB-STOP 
     btnAnswer AT ROW 14.52 COL 73 WIDGET-ID 4
     edQuestion AT ROW 12.19 COL 2 NO-LABEL WIDGET-ID 8 NO-TAB-STOP 
     btnSkip AT ROW 12.52 COL 73 WIDGET-ID 6
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 85.2 BY 18.33
         DEFAULT-BUTTON btnAnswer WIDGET-ID 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW C-Win ASSIGN
         HIDDEN             = YES
         TITLE              = "OpenEdge Chat Server"
         HEIGHT             = 18.33
         WIDTH              = 85.2
         MAX-HEIGHT         = 34.33
         MAX-WIDTH          = 204.8
         VIRTUAL-HEIGHT     = 34.33
         VIRTUAL-WIDTH      = 204.8
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW C-Win
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME DEFAULT-FRAME
   FRAME-NAME Custom                                                    */
ASSIGN 
       edChat:READ-ONLY IN FRAME DEFAULT-FRAME        = TRUE.

ASSIGN 
       edQuestion:READ-ONLY IN FRAME DEFAULT-FRAME        = TRUE.

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
THEN C-Win:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME C-Win
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON END-ERROR OF C-Win /* OpenEdge Chat Server */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL C-Win C-Win
ON WINDOW-CLOSE OF C-Win /* OpenEdge Chat Server */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnAnswer
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnAnswer C-Win
ON CHOOSE OF btnAnswer IN FRAME DEFAULT-FRAME /* Answer */
DO:
    /* Format question and answer, package into a text message,
       and publish to the group.
    */
    answerTxt = edAnswer:SCREEN-VALUE.
    RUN createTextMessage IN sessionH(OUTPUT answerH).
    
    /* Grab the question */
    RUN setText IN answerH(questionTxt).
    RUN appendText IN answerH("~n~n").
    
    /* Grab the question */
    RUN appendText IN answerH("[Moderator] ").
    RUN appendText IN answerH(answerTxt).
    RUN appendText IN answerH("~n~n").
    
    /* Publish it to everyone */
    RUN publish IN sessionH ("OEChat", answerH, ?, ?, ?).
    RUN deleteMessage IN answerH.

    /* Clean up UI. */
    questionTxt = "".
    edQuestion:SCREEN-VALUE = "".
    edAnswer:SCREEN-VALUE = "".
    
    /* This allows our queue handler to complete */
    APPLY "U1" TO THIS-PROCEDURE. 
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnPost
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnPost C-Win
ON CHOOSE OF btnPost IN FRAME DEFAULT-FRAME /* Post */
DO:
  /* Just send text as a post */
    answerTxt = edAnswer:SCREEN-VALUE.
    RUN createTextMessage IN sessionH(OUTPUT answerH).
    
    /* Grab text and publish to subscribers */
    RUN setText IN answerH("[Moderator] ").
    RUN appendText IN answerH(answerTxt).
    RUN appendText IN answerH("~n~n").
    RUN publish IN sessionH ("OEChat", answerH, ?, ?, ?).
    RUN deleteMessage IN answerH.

    /* Clean up UI. */
    questionTxt = "".
    edAnswer:SCREEN-VALUE = "".
  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnSkip
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnSkip C-Win
ON CHOOSE OF btnSkip IN FRAME DEFAULT-FRAME /* Skip */
DO:
    /* This discards the current question. */
    RUN createTextMessage IN sessionH(OUTPUT answerH).
    RUN setText IN answerH(questionTxt).
    RUN appendText IN answerH("~n").
    RUN appendText IN answerH("[Moderator has skipped question]~n~n").
    
    /* This property tells clients this response is only for them */
    RUN setStringProperty IN answerH("client", clientID).
    
    RUN publish IN sessionH ("OEChat", answerH, ?, ?, ?).
    
    /* Clean up UI. */
    questionTxt = "".
    edQuestion:SCREEN-VALUE = "".
    edAnswer:SCREEN-VALUE = "".
    
    /* This allows our queue handler to complete */
    APPLY "U1" TO THIS-PROCEDURE. 
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK C-Win 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE DO: 
    RUN disable_MQ.
    RUN disable_UI.
END.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  RUN enable_MQ.
  IF NOT THIS-PROCEDURE:PERSISTENT THEN
    WAIT-FOR CLOSE OF THIS-PROCEDURE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_MQ C-Win 
PROCEDURE disable_MQ :
/*------------------------------------------------------------------------------
  Purpose: Stops message recption, deletes consumers, and closes session    
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
RUN stopReceiveMessages IN sessionH.
RUN deleteConsumer IN queueConsumerH.
RUN deleteConsumer IN topicConsumerH.
RUN deleteSession IN sessionH.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI C-Win  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(C-Win)
  THEN DELETE WIDGET C-Win.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_MQ C-Win 
PROCEDURE enable_MQ :
/*------------------------------------------------------------------------------
  Purpose: Connects to MQ Broker and creates message consumers    
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

RUN jms/jmssession.p PERSISTENT SET sessionH ("-SMQConnect").

/* By using a serialized connection object, you can push the location
   of the MQ broker along with the application. The connection file
   included with the sample uses tcp://localhost:2506. */
RUN setConnectionFile IN sessionH ("Chat.sjo").
RUN beginSession IN sessionH.

RUN createMessageConsumer IN sessionH (
                              THIS-PROCEDURE,    /* This proc will handle it */
                             "queueHandler", /* name of internal procedure */
                              OUTPUT queueConsumerH).

RUN createMessageConsumer IN sessionH (
                              THIS-PROCEDURE,    /* This proc will handle it */
                             "topicHandler", /* name of internal procedure */
                              OUTPUT topicConsumerH).

/* Questions are received on SampleQ1 */
RUN receiveFromQueue IN sessionH 
    ("SampleQ1", 
        ?, 
        queueConsumerH).
        
/* The converstation is published on the OEChat topic */        
RUN subscribe IN sessionH 
    ("OEChat",
        ?, /* durable subscription */
        ?, /* No message selector */
        YES, /* Wants to get my own publications */
        topicConsumerH).

RUN startReceiveMessages IN sessionH.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI C-Win  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY edAnswer edChat edQuestion 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  ENABLE btnPost edAnswer edChat btnAnswer edQuestion btnSkip 
      WITH FRAME DEFAULT-FRAME IN WINDOW C-Win.
  {&OPEN-BROWSERS-IN-QUERY-DEFAULT-FRAME}
  VIEW C-Win.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE queueHandler C-Win 
PROCEDURE queueHandler :
/*------------------------------------------------------------------------------
  Purpose: Handles questions received on queue. Waits for a skip or answer before
           returning.    
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEFINE INPUT PARAMETER messageH AS HANDLE NO-UNDO.
DEFINE INPUT PARAMETER messageConsumerH AS HANDLE NO-UNDO.
DEFINE OUTPUT PARAMETER autoReplyH AS HANDLE NO-UNDO. 

clientID = DYNAMIC-FUNCTION('getCharProperty':U IN messageH, "client").
questionTxt = "[" + DYNAMIC-FUNCTION('getCharProperty':U IN messageH, "userName") + "] ".
questionTxt = questionTxt + DYNAMIC-FUNCTION('getText':U IN messageH).

/* Display question and wait for answer */
edQuestion:SCREEN-VALUE IN FRAME DEFAULT-FRAME = questionTxt .
WAIT-FOR u1 OF THIS-PROCEDURE.

RUN deleteMessage IN messageH.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE topicHandler C-Win 
PROCEDURE topicHandler :
/*------------------------------------------------------------------------------
  Purpose: Handles messages received on topic and displays them in chat window.    
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEFINE INPUT PARAMETER messageH AS HANDLE NO-UNDO.
DEFINE INPUT PARAMETER messageConsumerH AS HANDLE NO-UNDO.
DEFINE OUTPUT PARAMETER autoReplyH AS HANDLE NO-UNDO. 

DEFINE VARIABLE chatText AS CHARACTER NO-UNDO.

/* Display all messages received on topic */
chatText = DYNAMIC-FUNCTION('getText':U IN messageH).
edChat:INSERT-STRING(chatText) IN FRAME DEFAULT-FRAME.
RUN deleteMessage IN messageH.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

