DEFINE VARIABLE ptp AS LOGICAL INITIAL FALSE.

DEFINE VARIABLE sessionH AS HANDLE NO-UNDO.
DEFINE VARIABLE msgConsumer AS HANDLE NO-UNDO.
DEFINE VARIABLE mesgH AS HANDLE NO-UNDO.
DEFINE VARIABLE stillWaiting AS LOGICAL INIT yes.
DEFINE VARIABLE numRecsRead AS INT NO-UNDO INITIAL 0.

RUN jms/jmssession.p PERSISTENT SET sessionH ("-SMQConnect").

RUN setBrokerURL IN sessionH ("localhost:2506").
RUN beginSession IN sessionH.

RUN createMessageConsumer IN sessionH (
                              THIS-PROCEDURE,    /* This proc will handle it */
                             "messageHandler", /* name of internal procedure */
                              OUTPUT msgConsumer).


IF ptp THEN
    RUN receiveFromQueue IN sessionH ("SampleQ1", ?, msgConsumer).
ELSE
    RUN subscribe IN sessionH ("TestTopic",
                                ?, /* durable subscription */
                                ?, /* No message selector */
                                YES, /* Wants to get my own publications */
                                msgConsumer).

RUN startReceiveMessages IN sessionH.

RUN waitForMessages IN sessionH ("inWait", THIS-PROCEDURE, ?).
RUN deleteSession IN sessionH.
MESSAGE "Number of records processed: " + STRING(numRecsRead).



PROCEDURE messageHandler:
DEFINE INPUT PARAMETER messageH AS HANDLE NO-UNDO.
DEFINE INPUT PARAMETER messageConsumerH AS HANDLE NO-UNDO.
DEFINE OUTPUT PARAMETER autoReplyH AS HANDLE NO-UNDO. /* Not used in this example */

DEFINE VARIABLE ttH1 AS HANDLE NO-UNDO.
DEFINE VARIABLE bh1 AS HANDLE NO-UNDO.
DEFINE VARIABLE bh2 AS HANDLE NO-UNDO.
DEFINE VARIABLE qh1 AS HANDLE NO-UNDO.

if DYNAMIC-FUNCTION("getMessageType" in messageH) = "TemptableMessage" THEN DO:

    ttH1 = DYNAMIC-FUNCTION("getTempTable" IN messageH, ?, ?, ?).
    numRecsRead = numRecsRead + 1.

    bh1 = tth1:DEFAULT-BUFFER-HANDLE.
    create query qh1.
    qh1:SET-BUFFERS(bh1).

    qh1:query-prepare("for each tcust").
    qh1:query-open().
    qh1:get-first.

    REPEAT WHILE NOT qh1:QUERY-OFF-END:
       bh2 = bh1:buffer-field("name").
       MESSAGE bh2:string-value().
       qh1:GET-NEXT.
       DELETE OBJECT bh2.
    end.

    qh1:query-close.

    DELETE OBJECT ttH1.
    DELETE OBJECT qh1.

    END.
ELSE
    stillWaiting = no.

RUN deleteMessage IN messageH.
END.

FUNCTION inWait RETURNS LOGICAL.
RETURN stillWaiting.
END.
