DEFINE VARIABLE ptp AS LOGICAL INITIAL FALSE.

DEFINE VARIABLE sessionH AS HANDLE.
DEFINE VARIABLE messageH AS HANDLE.
DEFINE TEMP-TABLE tcust LIKE customer.
DEFINE VARIABLE numRecs AS INT INITIAL 0.
DEFINE VARIABLE ttH AS HANDLE.

/* Creates a session object. */
RUN  jms/jmssession.p PERSISTENT SET sessionH ("-SMQConnect").

RUN setBrokerURL IN sessionH ("localhost:2506").
RUN beginSession IN sessionH.

FOR EACH customer NO-LOCK:
        CREATE tcust.
        tcust.CustNum = customer.CustNum.
        tcust.NAME = customer.Name.
        tcust.Address = customer.Address.
        tcust.Address = customer.Address2.
        tcust.City = customer.City.
        tcust.State = customer.State.
        tcust.PostalCode = customer.PostalCode.
        tcust.Country = customer.Country.
        numRecs = numRecs + 1.
END.
ttH = TEMP-TABLE tcust:HANDLE.

RUN createTemptableMessage in sessionH(OUTPUT messageH).
RUN setTempTable IN messageH( ttH, ?, TRUE).

IF ptp THEN
    RUN sendToQueue IN sessionH ("SampleQ1", messageH, ?, ?, ?).    
ELSE
    RUN PUBLISH IN sessionH ("TestTopic", messageH, ?, ?, ?).

RUN deleteMessage IN messageH.
delete tcust.

MESSAGE "Number of records processed: " + string(numRecs).

RUN createTextMessage in sessionH(OUTPUT messageH).
RUN setText IN messageH(string(numRecs)).
IF ptp THEN
    RUN sendToQueue IN sessionH ("SampleQ1", messageH, ?, ?, ?).    
ELSE
    RUN PUBLISH IN sessionH ("TestTopic", messageH, ?, ?, ?).
RUN deleteMessage IN messageH.

RUN deleteSession IN sessionH.

