/*
  This example demonstrates how to use the X-DOCUMENT support in the
  4GL SonicMQ Adapter.  It will read an XML message from a Sonic queue and
  write it to a LONGCHAR.
*/
DEFINE VARIABLE sessionH AS HANDLE NO-UNDO.
DEFINE VARIABLE msgConsumer AS HANDLE NO-UNDO.
DEFINE VARIABLE stillWaiting AS LOGICAL INIT yes.
DEFINE VARIABLE lch AS LONGCHAR NO-UNDO view-as editor size 70 by 30 large.

/* Start up the session to the SonicMQ broker */
RUN jms/ptpsession.p PERSISTENT SET sessionH ("-H localhost -S 5162 ").
RUN setBrokerURL IN sessionH ("localhost:2506").
RUN beginSession IN sessionH.

/* Create the message consumer and start receiving messages. */
RUN createMessageConsumer IN sessionH (
                              THIS-PROCEDURE,
                             "messageHandler",
                              OUTPUT msgConsumer).
RUN receiveFromQueue IN sessionH ("SampleQ1", ?, msgConsumer).
RUN startReceiveMessages IN sessionH.

/* Wait for all messages to be received. */
RUN waitForMessages IN sessionH ("inWait", THIS-PROCEDURE, ?).
RUN deleteSession IN sessionH.



/* Message handler procedure */
PROCEDURE messageHandler:
DEFINE INPUT PARAMETER messageH AS HANDLE NO-UNDO.
DEFINE INPUT PARAMETER messageConsumerH AS HANDLE NO-UNDO.
DEFINE OUTPUT PARAMETER autoReplyH AS HANDLE NO-UNDO.

DEFINE VARIABLE hdl1 AS HANDLE NO-UNDO.


/*
  The Adapter function GetX-Document will return a handle to a newly
  created X-DOCUMENT and load it with the XML message that has been received.
  The application may then use normal X-DOCUMENT calls to access
  the XML from the message.
*/
hdl1 = DYNAMIC-FUNCTION('GetX-Document':u IN messageH).



hdl1:SAVE("LONGCHAR",lch).
DELETE OBJECT hdl1.
RUN deleteMessage IN messageH.

DISPLAY lch.
lch = "".
stillWaiting = FALSE.
END.


FUNCTION inWait RETURNS LOGICAL.
RETURN stillWaiting.
END.

