/*
  This example demonstrates how to use the X-DOCUMENT support in the
  4GL SonicMQ Adapter.  It will read in the XML from a file into an
  X-DOCUMENT and send it to a Sonic queue using an XML message.
*/

DEFINE VARIABLE sessionH AS HANDLE NO-UNDO.
DEFINE VARIABLE mesgH AS HANDLE NO-UNDO.
DEFINE VARIABLE hdl1 AS HANDLE NO-UNDO.

/* Start up the session to the SonicMQ broker */
RUN jms/ptpsession.p PERSISTENT SET sessionH ("-H localhost -S 5162 ").
RUN setBrokerURL IN sessionH ("localhost:2506").
RUN beginSession IN sessionH.

/* Create the Sonic XML message */
RUN createXMLMessage IN sessionH (OUTPUT mesgH).

/* Load the XML file. */
CREATE X-DOCUMENT hdl1.
hdl1:LOAD("file", "personal.xml", false).


/*
   The Adapter function SetX-Document will copy the XML
   from the X-DOCUMENT into the XML message.
*/
RUN SetX-Document IN mesgH(hdl1).


DELETE OBJECT hdl1.

/* Send the XML message. */
RUN sendToQueue IN sessionH ("SampleQ1", mesgH, ?, ?, ?).

/* Disconnect the session from the SonicMQ broker */
RUN deleteMessage IN mesgH.
RUN deleteSession IN sessionH.

