/* Receives and parse an XML message. */
DEFINE VARIABLE pubsubsession AS HANDLE.
DEFINE VARIABLE msgConsumer1 AS HANDLE.
DEFINE VARIABLE stillWaiting AS LOGICAL INIT yes.
DEFINE VARIABLE msgNum AS INT INIT 0.

RUN  jms/pubsubsession.p PERSISTENT SET pubsubsession ("-H localhost -S 5162 ").
RUN setBrokerURL IN pubsubsession ("localhost:2506").
RUN beginSession IN pubsubsession.
RUN createMessageConsumer IN pubsubsession
      (THIS-PROCEDURE, "messageHandler", OUTPUT msgConsumer1).
RUN subscribe IN pubsubsession ("people",
                                ?, 
                                ?,
                                no, 
                                msgConsumer1) NO-ERROR.
RUN startReceiveMessages IN pubsubsession.
RUN waitForMessages IN pubsubsession ("inWait", THIS-PROCEDURE, ?).
RUN deleteSession IN pubsubsession.

PROCEDURE messageHandler:
DEFINE INPUT PARAMETER messageH AS HANDLE NO-UNDO.
DEFINE INPUT PARAMETER messageConsumerH AS HANDLE NO-UNDO.
DEFINE OUTPUT PARAMETER replyH AS HANDLE NO-UNDO.

DEFINE VAR memptrDoc AS MEMPTR. 
DEFINE VAR hdoc AS HANDLE.
DEFINE VAR hRoot AS HANDLE.
DEFINE VAR xmlText AS CHAR.
DEFINE VAR indx AS INT.

CREATE X-DOCUMENT hdoc.
CREATE X-NODEREF hRoot.
SET-SIZE(memptrDoc) = 400000. /* The size is an estimate. */

indx = 1.
DO WHILE NOT  DYNAMIC-FUNCTION('endOfStream' IN messageH):
  xmlText = DYNAMIC-FUNCTION('getTextSegment':U IN messageH).
  PUT-STRING(memptrDoc, indx)  =  xmlText.
  indx = indx + LENGTH(xmlText).
END.

hdoc:LOAD("memptr", memptrDoc, FALSE).
hdoc:GET-DOCUMENT-ELEMENT(hRoot).
RUN getPeople(hRoot, 1).
RUN deleteMessage IN messageH.
SET-SIZE(memptrDoc) = 0.
stillWaiting = false.
END.

/* Displays the XML node names and XML text. */
PROCEDURE getPeople:
DEFINE INPUT PARAMETER hParent AS HANDLE.
DEFINE INPUT PARAMETER level AS INT.
DEFINE VAR i AS INT.
DEFINE VAR  hNoderef AS HANDLE.

CREATE X-NODEREF hNoderef.
REPEAT i = 1 TO hParent:NUM-CHILDREN.
      hParent:GET-CHILD(hNoderef,i).
      IF hNoderef:NAME = "#text" THEN
         MESSAGE "Text: " hNoderef:NODE-VALUE.
      ELSE
         MESSAGE "Node name: " hNoderef:NAME.
      RUN getPeople(hNoderef, (level + 1)).
END.
DELETE OBJECT hNoderef.
END.

FUNCTION inWait RETURNS LOGICAL.
RETURN stillWaiting.
END.

