/* Receives an XML document in a Bytes message. */
DEFINE VARIABLE pubsubsession AS HANDLE.
DEFINE VARIABLE msgConsumer1 AS HANDLE.
DEFINE VARIABLE stillWaiting AS LOGICAL INIT yes.

RUN  jms/pubsubsession.p PERSISTENT SET pubsubsession ("-H localhost -S 5162 ").
RUN setBrokerURL IN pubsubsession ("localhost:2506").
RUN beginSession IN pubsubsession.
RUN createMessageConsumer IN pubsubsession(THIS-PROCEDURE, "messageHandler",
                                             OUTPUT msgConsumer1).
RUN subscribe IN pubsubsession ("xmlTopic",
                                ?, /* Not a durable subscription */
                                ?, /* No message selector. */
                                no, /* noLocal */
                                msgConsumer1) NO-ERROR.

RUN startReceiveMessages IN pubsubsession.
RUN waitForMessages IN pubsubsession ("inWait", THIS-PROCEDURE, ?).
RUN deleteSession IN pubsubsession.


PROCEDURE messageHandler:
DEFINE INPUT PARAMETER messageH AS HANDLE NO-UNDO.
DEFINE INPUT PARAMETER messageConsumerH AS HANDLE NO-UNDO.
DEFINE OUTPUT PARAMETER replyH AS HANDLE NO-UNDO.

DEFINE VAR memptrDoc AS MEMPTR. 
DEFINE VAR hdoc AS HANDLE.
DEFINE VAR hRoot AS HANDLE.

memptrDoc = DYNAMIC-FUNCTION('getMemptr':U IN messageH).
CREATE X-DOCUMENT hdoc.
CREATE X-NODEREF hRoot.
hdoc:LOAD("memptr", memptrDoc, FALSE).
hdoc:GET-DOCUMENT-ELEMENT(hRoot).
RUN GetChildren(hRoot, 1).
RUN deleteMessage IN messageH.
stillWaiting = false.
END.

PROCEDURE GetChildren:
DEFINE INPUT PARAMETER hParent AS HANDLE.
DEFINE INPUT PARAMETER level AS INT.
DEFINE VAR i AS INT.
DEFINE VAR  hNoderef AS HANDLE.

CREATE X-NODEREF hNoderef.
REPEAT i = 1 TO hParent:NUM-CHILDREN.
      hParent:GET-CHILD(hNoderef,i).
      IF hNoderef:NAME = "#text" THEN
         MESSAGE "Node text: " hNoderef:NODE-VALUE.
      ELSE
         MESSAGE "Node name: " hNoderef:NAME.
      RUN GetChildren(hNoderef, (level + 1)).
END.
DELETE OBJECT hNoderef.
END.

FUNCTION inWait RETURNS LOGICAL.
RETURN stillWaiting.
END.


