/* Receives the customer table in a Stream message. */
DEFINE VARIABLE pubsubsession AS HANDLE.
DEFINE VARIABLE msgConsumer1 AS HANDLE.
DEFINE TEMP-TABLE custt LIKE customer.

RUN  jms/pubsubsession.p PERSISTENT SET pubsubsession 
 ("-H localhost -S 5162 ").
RUN setBrokerURL IN pubsubsession ("localhost:2506").
RUN beginSession IN pubsubsession.
RUN createMessageConsumer IN pubsubsession(THIS-PROCEDURE, "messageHandler",
                                             OUTPUT msgConsumer1).
RUN subscribe IN pubsubsession ("topic1",
                                ?, /* Not a durable subscription */
                                ?, /* No message selector */
                                no, /* noLocal */
                                msgConsumer1).
RUN startReceiveMessages IN pubsubsession.
WAIT-FOR u1 OF THIS-PROCEDURE.

FOR EACH custt:
    DISPLAY custt with 2 column.
END.

RUN deleteSession IN pubsubsession.

PROCEDURE messageHandler:
DEFINE INPUT PARAMETER messageH AS HANDLE NO-UNDO.
DEFINE INPUT PARAMETER messageConsumerH AS HANDLE NO-UNDO.
DEFINE OUTPUT PARAMETER replyH AS HANDLE NO-UNDO.
DEFINE VAR rawCust AS RAW.

DO WHILE NOT  DYNAMIC-FUNCTION('endOfStream' IN messageH):
    DYNAMIC-FUNCTION('moveToNext':U IN messageH).
    rawCust = DYNAMIC-FUNCTION('readBytesToRaw':U IN messageH).
    RAW-TRANSFER rawCust TO custt.
    RELEASE custt.
END.

RUN deleteMessage IN messageH.
APPLY "U1" TO THIS-PROCEDURE.

END.


