/* Receives a Text message from a queue. */
DEFINE VARIABLE ptpsession AS HANDLE.
DEFINE VARIABLE consumerH AS HANDLE.

/* Creates a session object. */
RUN  jms/ptpsession.p PERSISTENT SET ptpsession ("-H localhost -S 5162 ").
RUN setBrokerURL IN ptpsession ("localhost:2506").
RUN beginSession IN ptpsession.

/*  GolfQueue Messages are handled by the "golfHandler" procedure.  */
RUN createMessageConsumer IN ptpsession (
                             THIS-PROCEDURE,    /* This proc will handle it */
                             "golfHandler",      /* name of internal procedure */
                             OUTPUT consumerH).

RUN receiveFromQueue IN ptpsession ("GolfQueue", /* name of queue */
                                  ?,             /* No message selector */
                                  consumerH).    /* Handles incoming messages*/

/* Start receiving messages */
RUN startReceiveMessages IN ptpsession.

/* Wait to receive the messages. Any other IO-blocked statements can be used 
   for receiving messages. 
*/
WAIT-FOR u1 OF THIS-PROCEDURE.

PROCEDURE golfHandler:
DEFINE INPUT PARAMETER messageH AS HANDLE. 
DEFINE INPUT PARAMETER msgConsumerH AS HANDLE.
DEFINE OUTPUT PARAMETER replyH AS HANDLE.

/* Display the message - we assume that reply is not required. */
DISPLAY "Message text: " DYNAMIC-FUNCTION('getText':U IN messageH)
  FORMAT "x(70)".
RUN deleteMessage IN messageH.

APPLY "U1" TO THIS-PROCEDURE. 
END.
