/* Subscribes and receives a Text message. */
DEFINE VARIABLE pubsubsession AS HANDLE.
DEFINE VARIABLE consumerH AS HANDLE.

/* Creates a session object. */
RUN  jms/pubsubsession.p PERSISTENT SET pubsubsession ("-H localhost -S 5162 ").
RUN setBrokerURL IN pubsubsession ("localhost:2506").
RUN beginSession IN pubsubsession.

/* Subscribe to the GolfTopic topic. Messages are handled by the
   "golfHandler" internal procedure.
*/
RUN createMessageConsumer IN pubsubsession (
                              THIS-PROCEDURE,    /* This proc will handle it */
                             "golfHandler", /* name of internal procedure */
                              OUTPUT consumerH).

RUN subscribe IN pubsubsession ("GolfTopic", /* name of topic */
                             ?,               /* Subscription is not durable */
                             ?,               /* No message selector */
                             no,              /* Want my own messages too */
                             consumerH).    /* Handles the incoming messages*/

/* Start receiving messages */
RUN startReceiveMessages IN pubsubsession.

/* Wait to receive the messages. Any other IO-blocked statements can be used 
   for receiving messages. 
*/
WAIT-FOR u1 OF THIS-PROCEDURE.

PROCEDURE golfHandler:
DEFINE INPUT PARAMETER messageH AS HANDLE. 
DEFINE INPUT PARAMETER msgConsumerH AS HANDLE.
DEFINE OUTPUT PARAMETER replyH AS HANDLE.

/* Display the message - we assume that reply is not required. */
DISPLAY "Message text: " DYNAMIC-FUNCTION('getText':U IN messageH)
  FORMAT "x(70)".
RUN deleteMessage IN messageH.

APPLY "U1" TO THIS-PROCEDURE. 
END.
