/* Sends a request to a queue and receives a reply from the server. */
DEFINE VARIABLE ptpsession AS HANDLE.
DEFINE VARIABLE consumerH AS HANDLE.
DEFINE VARIABLE requestH AS HANDLE.
DEFINE VARIABLE request AS CHAR.

/* Creates a session object. */
RUN  jms/ptpsession.p PERSISTENT SET ptpsession ("-H localhost -S 5162 ").
RUN setBrokerURL IN ptpsession ("localhost:2506").
RUN beginSession IN ptpsession.


/* Create a text message */
RUN createTextMessage IN ptpsession (OUTPUT requestH).

/* Creates a consumer for the reply  */
RUN createMessageConsumer IN ptpsession (
                              THIS-PROCEDURE,    /* This proc will handle it */
                             "replyHandler", /* name of internal procedure */
                              OUTPUT consumerH).

/* Start the reply receiving  */
RUN startReceiveMessages IN ptpsession.


/* Loop forever. */
REPEAT:
  UPDATE request WITH FRAME f1 CENTERED.
  RUN setText IN requestH (request).
  /* Sends a request to the requestQueue and handles the reply in the 
     replyHandler internal procedure. */
  RUN requestReply IN ptpsession ( "requestQueue",
                                   requestH,
                                   ?, /* No reply selector. */
                                   consumerH, ?, ?, ?). 

  /* Wait for the reply. */
  WAIT-FOR u1 OF THIS-PROCEDURE.
END.

PROCEDURE replyHandler:
DEFINE INPUT PARAMETER replyH AS HANDLE.
DEFINE INPUT PARAMETER msgConsumerH AS HANDLE.
DEFINE OUTPUT PARAMETER responseH AS HANDLE.

/* Display the reply from the server.                                  */
DISPLAY "reply text: " DYNAMIC-FUNCTION('getText':U IN replyH) FORMAT "X(30)".
RUN deleteMessage IN replyH.

APPLY "U1" TO THIS-PROCEDURE.

END.
