/* Using the automatic reply mechanism. Note that the received message must
   have a JMSReplyTo header field for this to work. Example7 can be used
   to receive the reply.  */
DEFINE VARIABLE pubsubsession AS HANDLE.
DEFINE VARIABLE consumerH AS HANDLE.

/* Creates a session object. */
RUN  jms/pubsubsession.p PERSISTENT SET pubsubsession ("-H localhost -S 5162 ").
RUN setBrokerURL IN pubsubsession ("localhost:2506").
RUN beginSession IN pubsubsession.

/* Subscribe to the GolfTopic topic. Messages are handled by the
   "golfHandler" internal procedure.  */
RUN createMessageConsumer IN pubsubsession (
                              THIS-PROCEDURE,    /* This proc will handle it */
                             "golfHandler",      /* name of internal procedure */
                              OUTPUT consumerH).

RUN subscribe IN pubsubsession ("GolfTopic", /* name of topic */
                             ?,              /* Subscription is not durable */
                             ?,              /* No message selector */
                             no,             /* Want my own messages too */
                             consumerH).     /* Handles the messages */

/* Start receiving messages */
RUN startReceiveMessages IN pubsubsession.

/* Wait forever to receive messages since "u1" is never applied.  */
WAIT-FOR u1 OF THIS-PROCEDURE.

PROCEDURE golfHandler:
DEFINE INPUT PARAMETER messageH AS HANDLE.
DEFINE INPUT PARAMETER msgConsumerH AS HANDLE.
DEFINE OUTPUT PARAMETER replyH AS HANDLE.


/* Creates a reply message. The reply is published automatically when control
   returns to the 4GL-JMS implementation.
*/
DISPLAY DYNAMIC-FUNCTION('getText':U IN messageH) format "x(60)".
IF DYNAMIC-FUNCTION('hasReplyTo':U IN messageH) THEN 
  DO:
    RUN createTextMessage IN pubsubsession (OUTPUT replyH).
    RUN setText IN replyH ("Will bid. Send data in sportsXML format.").
  END.
RUN deleteMessage IN messageH.

END.


