/* Replying explicitly. Note that the received message must
   have a JMSReplyTo header field for this to work. Example7 can be used
   to receive the reply.  */
DEFINE VARIABLE pubsubsession AS HANDLE.
DEFINE VARIABLE msgConsumer AS HANDLE.

/* Creates a session object. */
RUN  jms/pubsubsession.p PERSISTENT SET pubsubsession ("-H localhost -S 5162 ").
RUN setBrokerURL IN pubsubsession ("localhost:2506").
RUN beginSession IN pubsubsession.

RUN createMessageConsumer IN pubsubsession (
                              THIS-PROCEDURE,    /* This proc will handle it */
                             "messageHandler", /* name of internal procedure */
                              OUTPUT msgConsumer).


RUN subscribe IN pubsubsession ("GolfTopic",
                                ?, /* No durable subscription */
                                ?, /* No message selector */
                                no, /* Want to get my own publications */
                                msgConsumer).
RUN startReceiveMessages IN pubsubsession.

/* Wait forever to receive messages since "u1" is never applied.  */
WAIT-FOR u1 OF THIS-PROCEDURE.

RUN deleteSession IN pubsubsession.

PROCEDURE messageHandler:
DEFINE INPUT PARAMETER messageH AS HANDLE NO-UNDO.
DEFINE INPUT PARAMETER messageConsumerH AS HANDLE NO-UNDO.
DEFINE OUTPUT PARAMETER autoReplyH AS HANDLE NO-UNDO. /* Not used in this example */

DEFINE VARIABLE replyH AS HANDLE.

DISPLAY DYNAMIC-FUNCTION('getText':U IN messageH) format "x(60)".
IF NOT DYNAMIC-FUNCTION('hasReplyTo':U IN messageH) THEN RETURN.

/* Publishes a reply explicitly - using the publish call. */
RUN createTextMessage IN pubsubsession (OUTPUT replyH).
RUN setText IN replyH("Will bid. Send data in sportsXML format.").
RUN publish IN pubsubsession (DYNAMIC-FUNCTION('getJMSReplyTo':U IN messageH),
                              replyH, ?, ?, ?).
RUN deleteMessage IN messageH.
RUN deleteMessage IN replyH.

END.


