/* Publishes a message and receives a reply. */
DEFINE VARIABLE pubsubsession AS HANDLE.
DEFINE VARIABLE consumerH AS HANDLE.
DEFINE VARIABLE messageH AS HANDLE.

/* Creates a session object. */
RUN  jms/pubsubsession.p PERSISTENT SET pubsubsession ("-H localhost -S 5162 ").
RUN setBrokerURL IN pubsubsession ("localhost:2506").
RUN beginSession IN pubsubsession.

/* Start receiving messages */
RUN startReceiveMessages IN pubsubsession.

/* Create a text message */
RUN createTextMessage IN pubsubsession (OUTPUT messageH).
RUN setText IN messageH ("Golf shoes on sale today.").

/* Creates a consumer for the reply  */
RUN createMessageConsumer IN pubsubsession (
                              THIS-PROCEDURE,    /* This proc will handle it */
                             "golfHandler", /* name of internal procedure */
                              OUTPUT consumerH).


/* Publish the message onto the Golf topic. Handle the reply in the 
   golfHandler internal procedure. 
*/
RUN requestReply IN pubsubsession (
                           "GolfTopic",
                            messageH,
                            ?, /* No reply selector. */
                            consumerH, ?, ?, ?). 

RUN deleteMessage IN messageH.
/* Wait forever to receive messages since "u1" is never applied.  */
WAIT-FOR u1 OF THIS-PROCEDURE.

PROCEDURE golfHandler:
DEFINE INPUT PARAMETER replyH AS HANDLE.
DEFINE INPUT PARAMETER msgConsumerH AS HANDLE.
DEFINE OUTPUT PARAMETER responseH AS HANDLE.

/* Display the reply - we are not sending a response. */
DISPLAY "reply text: " DYNAMIC-FUNCTION('getText':U IN replyH) FORMAT "X(30)".
RUN deleteMessage IN replyH.

END.
