/* Publishing a Stream message. */
DEFINE VARIABLE pubsubsession AS HANDLE.
DEFINE VARIABLE messageH AS HANDLE.

/* Creates a session object. */
RUN  jms/pubsubsession.p PERSISTENT SET pubsubsession ("-H localhost -S 5162 ").
RUN setBrokerURL IN pubsubsession ("localhost:2506").
RUN beginSession IN pubsubsession.

/* Create a stream message */
RUN createStreamMessage IN pubsubsession (OUTPUT messageH).

/* Load the message with a list of customer names and cust-nums. */
FOR EACH customer:
   RUN writeString IN messageH (customer.name).
   RUN writeInt IN messageH (customer.cust-num).
END.

/* Publish the message on the NewCustomers topic. */
RUN publish IN pubsubsession ("NewCustomers", messageH, ?, ?, ?).
