/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/************************************************************************************
	PROCEDURE: statenam.p

	PURPOSE:   Returns the state name

	SYNTAX:    RUN statenam.p (INPUT in, OUTPUT out).

	REMARKS:   This code returns the name of the state given in the 
		   state abbreviation.

	PARAMETERS:
            INPUT:  state abbreviation
            OUTPUT: state name

	AUTHORS:   Judy Rothermal
	DATE:      February 1993

	LAST INSPECTED:
	INSPECTED BY:

 ************************************************************************************/
/*Code_Start*/

DEFINE INPUT  PARAMETER state-abbr  AS CHAR NO-UNDO.
DEFINE OUTPUT PARAMETER state-name  AS CHAR NO-UNDO.

state-name =
ENTRY(LOOKUP(state-abbr,"AK,AL,AR,AZ,CA,CO,CT,DC,DE,FL,GA,HI,IA,ID," +
  "IL,IN,KA,KY,LA,MA,MD,ME,MI,MN,MO,MS,MT,NC,ND,NE,NH,NJ,NM,NV,NY,OH,OK," +
  "OR,PA,PR,RI,SC,SD,TN,TX,UT,VA,VI,VT,WA,WI,WV,WY") + 1,
  "?,Alaska,Alabama,Arkansas,Arizona,California,Colorado,Connecticut," +
  "Dst of Columbia,Delaware,Florida,Georgia,Hawaii,Iowa,Idaho,Illinois," +
  "Indiana,Kansas,Kentucky,Louisiana,Massachusetts,Maryland,Maine,Michigan," +
  "Minnesota,Missouri,Mississippi,Montana,North Carolina,North Dakota," +
  "Nebraska,New Hampshire,New Jersey,New Mexico,Nevada,New York,Ohio," +
  "Oklahoma,Oregon,Pennsylvania,Puerto Rico,Rhode Island,South Carolina," +
  "South Dakota,Tennessee,Texas,Utah,Virginia,Virgin Islands,Vermont," +
  "Washington,Wisconsin,West Virginia,Wyoming").


