/* SoapEncodedArray.p
   This sample shows how to pass an array to a Rpc/Encoded web service 
   which uses soap encoded arrays. The client uses a Progress 4GL array.
*/
DEFINE VARIABLE hWS AS HANDLE.
DEFINE VARIABLE hPortType AS HANDLE.
DEFINE VARIABLE err AS LOGICAL.
DEFINE VARIABLE discount AS DECIMAL.
DEFINE VARIABLE prices AS DECIMAL EXTENT 6.

CREATE SERVER  hWS. 
hWS:CONNECT ("-WSDL http://localhost/ArraySample/Service1.asmx?wsdl").
MESSAGE "SERVER:CONNECTED  : "  hws:CONNECTED().  
IF NOT hws:CONNECTED() THEN LEAVE.

RUN Service1Soap SET hPortType ON SERVER hWS.
MESSAGE "hPortType valid: " VALID-HANDLE(hPortType).  
IF NOT VALID-HANDLE(hPortType) THEN LEAVE.

/* 10% discount */
discount = 0.90.

prices[1] = 100.00.
prices[2] = 89.95.
prices[3] = 12.99.
prices[4] = 1234.49.
prices[5] = 89.99.
prices[6] = 145.99.

RUN adjustSalesProc IN hPortType (INPUT discount, INPUT-OUTPUT prices) NO-ERROR.
RUN ErrorInfo (OUTPUT err).
IF NOT err THEN
   MESSAGE "The new prices are : " SKIP
     "Price 1 = " STRING(prices[1], ">>,>>>.99") SKIP 
     "Price 2 = " STRING(prices[2], ">>,>>>.99") SKIP 
     "Price 3 = " STRING(prices[3], ">>,>>>.99") SKIP
     "Price 4 = " STRING(prices[4], ">>,>>>.99") SKIP
     "Price 5 = " STRING(prices[5], ">>,>>>.99") SKIP
     "Price 6 = " STRING(prices[6], ">>,>>>.99") 
     VIEW-AS ALERT-BOX.

DELETE PROCEDURE hPortType.
hWS:DISCONNECT(). 
DELETE OBJECT hWS.

PROCEDURE ErrorInfo:
  DEFINE OUTPUT PARAMETER errorfound AS LOGICAL INITIAL FALSE.
    
  DEFINE VARIABLE i AS INTEGER.
  DEFINE VARIABLE hSOAPFault AS HANDLE.
  DEFINE VARIABLE hSOAPFaultDetail AS HANDLE.
  DEFINE VARIABLE HeaderXML AS LONGCHAR VIEW-AS EDITOR SIZE 52 BY 8 LARGE.

  IF ERROR-STATUS:NUM-MESSAGES > 0 THEN 
  DO:
     errorfound = TRUE.
     DO i = 1 TO ERROR-STATUS:NUM-MESSAGES:
        MESSAGE ERROR-STATUS:GET-MESSAGE(i) VIEW-AS ALERT-BOX.
     END.
    
     IF VALID-HANDLE(ERROR-STATUS:ERROR-OBJECT-DETAIL) THEN
     DO:      
       hSOAPFault = ERROR-STATUS:ERROR-OBJECT-DETAIL.
       MESSAGE 
       "Fault Code: "   hSOAPFault:SOAP-FAULT-CODE        SKIP
       "Fault String: " hSOAPFault:SOAP-FAULT-STRING      SKIP
       "Fault Actor: "  hSOAPFault:SOAP-FAULT-ACTOR       SKIP
       "Error Type: "   hSOAPFault:TYPE VIEW-AS ALERT-BOX.

       IF VALID-HANDLE(hSOAPFault:SOAP-FAULT-DETAIL) THEN
        DO:
            hSOAPFaultDetail = hSOAPFault:SOAP-FAULT-DETAIL.
            MESSAGE  "Error Type: " hSOAPFaultDetail:TYPE VIEW-AS ALERT-BOX.
            HeaderXML = hSOAPFaultDetail:GET-SERIALIZED().
            DISPLAY HeaderXML LABEL "Serialized SOAP fault detail" WITH FRAME a.
        END.
     END. 
  END. 
END.

