/**
 * This sample Web Services client application is built to use the client stubs
 * generated by the Apache Axis 1.4 release WSDLtoJava utility.  The input
 * WSDL file is one generated by the WSA for the CustOrders Web Service 
 * Application that is based on the CustOrders demo.
 */
import java.net.URL;
import javax.xml.rpc.holders.*;

import CustOrdersSvc.*;
import CustOrders.CustOrdersSvc.*;
import CustOrders.CustOrdersSvc.holders.*;

public class CustOrdersClient {

  public static void main(String[] args) 
  {

	CustOrdersObjStub appobj = null;
	
    try 
    {
    	CustOrdersService ws = new CustOrdersServiceLocator();
    	
    	// Modify the target WSA's URL if doing special testing, like running
        // through a network proxy monitor to view the HTTP message traffic.
        //
        URL connectURL = new URL((args.length == 0) ? ws.getCustOrdersObjAddress() : args[0]);
        
        System.out.println("connecting to URL: " + connectURL.toString());
    	
    	appobj = (CustOrdersObjStub)ws.getCustOrdersObj(connectURL);
    	
    	// Get Order information for customers 1 through 3
    	Integer[] iCustNumRange = new Integer[2];
    	iCustNumRange[0] = new Integer(1);
    	iCustNumRange[1] = new Integer(3);
    	
    	StringHolder result = new StringHolder();
    	DsCustOrdHolder dsCustOrdH = new DsCustOrdHolder();
    	
    	//call getCustOrders on Web service
    	appobj.getCustOrders(iCustNumRange, result, dsCustOrdH);
    	
    	//get dsCustOrd from holder
    	DsCustOrd dsCustOrd = dsCustOrdH.value;
    	
    	//print out ttCust records
    	DsCustOrdTtCust[] ttCust = dsCustOrd.getTtCust();
    	System.out.println("Printing Customer 1 through 3 Information");
    	for (int i = 0; i< ttCust.length; i++)
    	{
    		System.out.println();
    		System.out.println("CustNum: " + ttCust[i].getCustNum());
    		System.out.println("Name: " + ttCust[i].getName());
    		System.out.println("Balance: " + ttCust[i].getBalance());
    	}
    	
    	//print out ttOrder records
    	DsCustOrdTtOrder ttOrder[] = dsCustOrd.getTtOrder();
    	System.out.println();
    	System.out.println("Printing Order Information");
    	for (int i = 0; i < ttOrder.length; i++)
    	{
    		System.out.println();
    		System.out.println("OrderNum: " + ttOrder[i].getOrderNum());
    		System.out.println("CustNum: " + ttOrder[i].getCustNum());
    		System.out.println("OrderDate: " + ttOrder[i].getOrderDate());
    		
       	}  
      } catch (Exception e){

        System.out.println("CAUGHT EXCEPTION - printing stack trace");
        System.out.println(e.toString());
        e.printStackTrace();
    }
  }
}
