/* getCustOrders_Dyn.p */
DEFINE TEMP-TABLE ttCust NO-UNDO
    FIELD CustNum AS INTEGER
    FIELD Name AS CHARACTER
    FIELD Balance AS DECIMAL
    INDEX CustNumIdx IS UNIQUE PRIMARY CustNum.

DEFINE TEMP-TABLE ttOrder NO-UNDO
    FIELD OrderNum AS INTEGER
    FIELD CustNum AS INTEGER
    FIELD OrderDate AS DATE
    INDEX OrderNumIdx IS UNIQUE PRIMARY OrderNum
    INDEX CustOrdIdx IS UNIQUE CustNum OrderNum. 

DEFINE DATASET dsCustOrd FOR ttCust, ttOrder
    DATA-RELATION CustOrdRel FOR ttCust, ttOrder
            RELATION-FIELDS (CustNum, CustNum).


DEFINE INPUT PARAMETER iCustNum AS INTEGER EXTENT 2.
DEFINE OUTPUT PARAMETER DATASET-HANDLE hDset.


DEFINE VARIABLE hq1 AS HANDLE.
DEFINE VARIABLE hq2 AS HANDLE.
DEFINE VARIABLE lret AS LOGICAL.
DEFINE DATA-SOURCE dsCust FOR Customer.
DEFINE DATA-SOURCE dsOrder FOR Order.

/* fill dataset and return to caller */
CREATE QUERY hq1.
hq1:SET-BUFFERS(BUFFER Customer:HANDLE).
lret = hq1:QUERY-PREPARE("for each Customer where CustNum >= " + STRING (iCustNum[1]) + " AND CustNum <= " + STRING(iCustNum[2])).

DATA-SOURCE dsCust:QUERY = hq1.

/* attach the data-sources to the dataset buffers */
BUFFER ttCust:HANDLE:ATTACH-DATA-SOURCE(DATA-SOURCE dsCust:HANDLE,?,?,?).
BUFFER ttOrder:HANDLE:ATTACH-DATA-SOURCE(DATA-SOURCE dsOrder:HANDLE,?,?,?).


DATASET dsCustOrd:FILL().

hDset = DATASET dsCustOrd:HANDLE.


