/*
 * Class:    ColumnMetaData
 */

import java.lang.*;

/* This class holds the metadata for a RowSet column.
 * The RowSet's m_schema member is a ColumnMetaData[] array
 */

 public class ColumnMetaData {

  protected String name;
  protected int type;
  protected int extent;

  // Constants for supported column types
  public static final   int   CHAR_TYPE     = 1;
  public static final   int   INT_TYPE      = 2;
  public static final   int   BOOLEAN_TYPE  = 3;
  public static final   int   DECIMAL_TYPE  = 4;
  public static final   int   DATE_TYPE     = 5;
  public static final   int   RAW_TYPE      = 6;
  public static final   int   DATETIME_TYPE = 7;

  public ColumnMetaData(String colName, int colType, int colExtent) {
    name = colName;
    type = colType;
    extent = colExtent;
  }
}