Imports System.ComponentModel

Public Class OrderDetails
    Inherits System.Windows.Forms.Form

    Dim details(-1) As details

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents lblCustName As System.Windows.Forms.Label
    Friend WithEvents grdDetails As System.Windows.Forms.DataGrid
    Friend WithEvents btnClose As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.lblCustName = New System.Windows.Forms.Label()
        Me.grdDetails = New System.Windows.Forms.DataGrid()
        Me.btnClose = New System.Windows.Forms.Button()
        CType(Me.grdDetails, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(96, 16)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(56, 16)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Customer:"
        '
        'lblCustName
        '
        Me.lblCustName.Font = New System.Drawing.Font("Microsoft Sans Serif", 8.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblCustName.Location = New System.Drawing.Point(160, 16)
        Me.lblCustName.Name = "lblCustName"
        Me.lblCustName.Size = New System.Drawing.Size(256, 16)
        Me.lblCustName.TabIndex = 1
        '
        'grdDetails
        '
        Me.grdDetails.DataMember = ""
        Me.grdDetails.HeaderForeColor = System.Drawing.SystemColors.ControlText
        Me.grdDetails.Location = New System.Drawing.Point(8, 56)
        Me.grdDetails.Name = "grdDetails"
        Me.grdDetails.Size = New System.Drawing.Size(544, 184)
        Me.grdDetails.TabIndex = 2
        '
        'btnClose
        '
        Me.btnClose.Location = New System.Drawing.Point(243, 248)
        Me.btnClose.Name = "btnClose"
        Me.btnClose.TabIndex = 3
        Me.btnClose.Text = "Close"
        '
        'OrderDetails
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(560, 301)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnClose, Me.grdDetails, Me.lblCustName, Me.Label1})
        Me.Name = "OrderDetails"
        Me.Text = "OrderDetails"
        CType(Me.grdDetails, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub OrderDetails_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Initialize the grid with formatting information
        InitGrid()
    End Sub

    Public Sub ShowDetails(ByVal custName As String, ByVal proxy As OrderService.CustomerOrderObj)

        ' This procedure is what actually makes the call to the service and sticks the results
        ' into a new Details array. This is required to take advantage of the data binding
        ' support in the grid. The class created based on the WSDL, OrderDetailsRow, uses fields
        ' to hold the temp table values. Data binding requires the use of properties, which the
        ' Details class defines.
        Dim i, length As Integer
        Dim results(-1) As OrderService.OrderDetailsRow

        Try
            lblCustName.Text = custName
            proxy.GetOrderDetails(results)
            length = results.GetLength(0) - 1
            details = New Details(length) {}
            For i = 0 To length
                details(i) = New Details(results(i))
            Next

            ' Set the grid data source to our Details array
            grdDetails.DataSource = details
        Catch exp As Exception
            handleWebServiceException(exp)
        End Try

    End Sub

    Private Sub InitGrid()
        Dim gs As DataGridTableStyle = New DataGridTableStyle()
        gs.MappingName = details.GetType().Name

        Dim cs As DataGridTextBoxColumn = New DataGridTextBoxColumn()
        cs.MappingName = "OrderNum"
        cs.HeaderText = "Order Number"
        cs.Alignment = HorizontalAlignment.Center
        cs.Width = 50
        gs.GridColumnStyles.Add(cs)

        cs = New DataGridTextBoxColumn()
        cs.MappingName = "SalesRep"
        cs.HeaderText = "Sales Rep"
        cs.Alignment = HorizontalAlignment.Center
        cs.Width = 60
        gs.GridColumnStyles.Add(cs)

        cs = New DataGridTextBoxColumn()
        cs.MappingName = "OrderDate"
        cs.HeaderText = "Order Date"
        cs.Alignment = HorizontalAlignment.Right
        cs.Width = 80
        gs.GridColumnStyles.Add(cs)

        cs = New DataGridTextBoxColumn()
        cs.MappingName = "ShipDate"
        cs.HeaderText = "Ship Date"
        cs.Alignment = HorizontalAlignment.Right
        cs.Width = 100
        gs.GridColumnStyles.Add(cs)

        cs = New DataGridTextBoxColumn()
        cs.MappingName = "TotalDollars"
        cs.HeaderText = "Total $$$"
        cs.Alignment = HorizontalAlignment.Right
        cs.Width = 100
        gs.GridColumnStyles.Add(cs)

        cs = New DataGridTextBoxColumn()
        cs.MappingName = "OrderStatus"
        cs.HeaderText = "Status"
        cs.Alignment = HorizontalAlignment.Right
        cs.Width = 100
        gs.GridColumnStyles.Add(cs)

        grdDetails.TableStyles.Add(gs)

    End Sub

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Hide()
    End Sub

    Private Sub handleWebServiceException(ByVal e As Exception)
        If TypeOf e Is System.Net.WebException Then
            MsgBox(e.Message, MsgBoxStyle.Critical, "Communications Error")
        ElseIf TypeOf e Is System.Web.Services.Protocols.SoapException Then
            Dim soapEx As System.Web.Services.Protocols.SoapException
            Dim detail As String, reqId As String
            soapEx = e
            detail = parseSoapException(soapEx.Detail, reqId)
            MsgBox(detail, MsgBoxStyle.Critical, soapEx.Message)
        Else
            MsgBox(e.Message, MsgBoxStyle.Critical, "Unhandled Exception")
        End If

    End Sub

    Private Function parseSoapException(ByVal node As System.Xml.XmlNode, ByRef reqId As String) As String
        Dim child As System.Xml.XmlNode
        Dim reqIdNode As System.Xml.XmlElement
        Dim errMsgNode As System.Xml.XmlElement

        parseSoapException = "Unknown"
        reqId = "Unknown"

        For Each child In node.ChildNodes
            If child.NodeType = Xml.XmlNodeType.Element Then
                If child.LocalName = "FaultDetail" Then
                    reqIdNode = child.Item("requestID")
                    If (reqIdNode Is Nothing) = False Then
                        reqId = reqIdNode.FirstChild.Value
                    End If
                    errMsgNode = child.Item("errorMessage")
                    If (errMsgNode Is Nothing) = False Then
                        parseSoapException = errMsgNode.FirstChild.Value
                    End If
                    Exit For
                End If
            End If
        Next

    End Function

End Class

Class Details

    Private m_OrderNum As Integer
    Private m_OrderDate As Date
    Private m_ShipDate As Date
    Private m_TotalDollars As String
    Private m_SalesRep As String
    Private m_OrderStatus As String

    Public ReadOnly Property OrderNum() As Integer
        Get
            OrderNum = m_OrderNum
        End Get
    End Property

    Public ReadOnly Property SalesRep() As String
        Get
            SalesRep = m_SalesRep
        End Get
    End Property

    Public ReadOnly Property OrderDate() As Date
        Get
            OrderDate = m_OrderDate
        End Get
    End Property

    Public ReadOnly Property ShipDate() As Date
        Get
            ShipDate = m_ShipDate
        End Get
    End Property

    Public ReadOnly Property TotalDollars() As String
        Get
            TotalDollars = m_TotalDollars
        End Get
    End Property

    Public ReadOnly Property OrderStatus() As String
        Get
            OrderStatus = m_OrderStatus
        End Get
    End Property

    Public Sub New(ByVal detail As OrderService.OrderDetailsRow)
        ' This constructor takes a row returned by the service and sticks the values into
        ' a Details class.
        Me.m_OrderNum = detail.OrderNum
        Me.m_OrderDate = detail.OrderDate
        ' ShipDate can be ?
        If detail.ShipDate.HasValue Then
            Me.m_ShipDate = detail.ShipDate
        End If
        Me.m_TotalDollars = FormatCurrency(detail.TotalDollars)
        Me.m_SalesRep = detail.SalesRep
        Me.m_OrderStatus = detail.OrderStatus
    End Sub
End Class