using System;
using System.ComponentModel;
using System.Web.Services;
using System.Web.Services.Protocols;

namespace SOAPHeader
{
    //Declare the WS
	[WebService
		 (Namespace="http://ServiceHost/SOAPHeader",
		 Description="More advanced work with SOAP headers")]

	public class Headers : System.Web.Services.WebService
	{

	    //Define a SOAP header derived from the base class
		public class AuthorizeHeader : SoapHeader
		{
			public string AccessID;
			public string Password;
		}

		public Headers()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		//Create the SOAP header from the derived class
		public AuthorizeHeader myHeaderVariable;

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		//Build the WS methods
		[SoapDocumentMethod(ParameterStyle=SoapParameterStyle.Bare)]
		[WebMethod(Description="1st step, get a header and populate the AccessID")]
		[SoapHeader("myHeaderVariable",Direction=SoapHeaderDirection.InOut)]
		public string OpenAccess()
		{
			if (myHeaderVariable.AccessID == "")
			{
				myHeaderVariable.AccessID = "XYZZY";
				return "AccessID to the web service has been set.";
			}
		}

		[SoapDocumentMethod(ParameterStyle=SoapParameterStyle.Bare)]
		[WebMethod(Description="2nd step, get a header containing the AccessID, and check it")]
		[SoapHeader("myHeaderVariable",Direction=SoapHeaderDirection.InOut)]
		public string HelloWorld()
		{
			if (myHeaderVariable.AccessID == "XYZZY")
			{
				return "You made it this far with the AccessID:  " + myHeaderVariable.AccessID;
			}
		}

		[SoapDocumentMethod(ParameterStyle=SoapParameterStyle.Bare)]
		[WebMethod(Description="3rd step, get a header containing the Password, and check it")]
		[SoapHeader("myHeaderVariable",Direction=SoapHeaderDirection.InOut)]
		public string HelloSecureWorld()
		{
			if (myHeaderVariable.Password == "Administrator")
			{
				return "Congratulations!  You passed the authentication test!";
			}
			else
			{
				throw new SoapException("Invalid Password!  Try again!",SoapException.ClientFaultCode,Context.Request.Url.AbsoluteUri);
			}
		}
	}
}
