DEFINE VARIABLE disp-status AS CHARACTER FORMAT "X(40)" LABEL "Action" NO-UNDO.

DEFINE VARIABLE disp-time   AS CHARACTER LABEL "Time"                  NO-UNDO.

DEFINE VARIABLE i           AS INTEGER                                 NO-UNDO.

DEFINE VARIABLE status-ok   AS LOGICAL   INIT FALSE                    NO-UNDO.



DEFINE VARIABLE lApplAlertBoxes     AS LOGICAL    NO-UNDO.

DEFINE VARIABLE lSystemAlertBoxes   AS LOGICAL    NO-UNDO.



ASSIGN

    lApplAlertBoxes             = SESSION:APPL-ALERT-BOXES

    lSystemAlertBoxes           = SESSION:SYSTEM-ALERT-BOXES

    SESSION:APPL-ALERT-BOXES    = NO

    SESSION:SYSTEM-ALERT-BOXES  = NO

    .



DO WHILE NOT status-ok:



    DISPLAY STRING(TIME,'hh:mm:ss') @ disp-time

            "Deleting old data"     @ disp-status

        WITH FRAME F-status DOWN.

    DOWN WITH FRAME F-status.

    PAUSE 1.



    ASSIGN status-ok = TRUE.

    {dyndelete.i art_invoice}

    {dyndelete.i ivt_inventorytrans}

    {dyndelete.i ivc_it_type}

    {dyndelete.i art_orderline}

    {dyndelete.i art_order}

    {dyndelete.i apt_poline}

    {dyndelete.i apt_purchaseorder}

    {dyndelete.i gem_status}

    {dyndelete.i arx_order_address}

    {dyndelete.i apx_supplier_item}

    {dyndelete.i ivm_bin}

    {dyndelete.i ivm_item}

    {dyndelete.i apx_supplier_address}

    {dyndelete.i ivx_warehouse_address}

    {dyndelete.i arx_customer_address}

    {dyndelete.i gem_address }

    {dyndelete.i gec_address_type}

    {dyndelete.i apm_supplier}

    {dyndelete.i ivm_warehouse}

    {dyndelete.i art_refcall}

    {dyndelete.i arm_customer}

    {dyndelete.i gem_state}

    {dyndelete.i arx_salesrep_region}

    {dyndelete.i gem_region}

    {dyndelete.i arm_monthly_quota}

    {dyndelete.i arm_salesrep}

    {dyndelete.i hrm_employee}

    {dyndelete.i hrm_family}

    {dyndelete.i hrt_timesheet}

    {dyndelete.i hrt_vacation}

    {dyndelete.i hrc_vacation_type}

    {dyndelete.i hrm_department}

    {dyndelete.i hrm_benefits}



END.





/* m02.p */

/* sports2000 -> dynsports

 *

 * dynsports tables initialized from sports2000:

 *

 *         1 arm_salesrep

 *         2 arm_monthly_quota

 *         3 arx_salesrep_region

 *         4 gem_region

 *         5 gem_state

 *         6 arm_customer

 *         7 gem_address

 *         8 gec_address_type

 *         9 arx_customer_address

 *        10 apm_supplier

 *        11 apx_supplier_address

 *        12 ivm_warehouse

 *        13 ivx_warehouse_address

 */



DEFINE TEMP-TABLE tt_num_obj_relation

    FIELD tbl AS CHAR

    FIELD obj AS DEC

    FIELD num AS INT

    INDEX tbl-num IS PRIMARY tbl num.



/* Missing salesrep in std sports2000                   */

/* DO TRANS:                                            */

/*     CREATE salesrep.                                 */

/*     ASSIGN salesrep.salesrep = 'WEB'                 */

/*            salesrep.repname = 'Orders from the WEB'. */

/* END.                                                 */



DISPLAY STRING(TIME,'hh:mm:ss') @ disp-time

        "Creating - Salesrep"   @ disp-status

    WITH FRAME F-status DOWN.

DOWN WITH FRAME F-status.

PAUSE 1.



FOR EACH salesrep:



    /* salesrep data */    

    CREATE arm_salesrep.

    ASSIGN

        arm_salesrep.salesrep_code     = salesrep.salesrep 

        arm_salesrep.salesrep_name     = salesrep.repname

        arm_salesrep.salesrep_comments = ""

        .

    {dynvalidate.i arm_salesrep}



    /* monthly quota */    

    REPEAT i = 1 TO 12:



        CREATE arm_monthly_quota.

        ASSIGN

            arm_monthly_quota.salesrep_obj               = arm_salesrep.salesrep_obj

            arm_monthly_quota.monthly_quota_month_number = i

            arm_monthly_quota.monthly_quota_month_name   = 

                ENTRY(i, "January,February,March,April,May,June,July,August,September,October,November,December",",")

            arm_monthly_quota.monthly_quota_Value        = salesrep.monthquota[i]

            .

        {dynvalidate.i arm_monthly_quota}



    END.



    /* region */

    FIND FIRST gem_region NO-LOCK

        WHERE gem_region.region_name = salesrep.region

        NO-ERROR.



    IF NOT AVAILABLE gem_region THEN

    DO:



        CREATE gem_region.

        ASSIGN 

            gem_region.region_name        = salesrep.region

            gem_region.region_code        = salesrep.region

            gem_region.region_description = "Region " + salesrep.region

            .

        {dynvalidate.i gem_region}



    END.



    CREATE arx_salesrep_region.

    ASSIGN

        arx_salesrep_region.salesrep_obj = arm_salesrep.salesrep_obj

        arx_salesrep_region.region_obj = gem_region.region_obj

        .

    {dynvalidate.i arx_salesrep_region}



END.



DISPLAY STRING(TIME,'hh:mm:ss') @ disp-time

        "Creating - State"      @ disp-status

    WITH FRAME F-status DOWN.

DOWN WITH FRAME F-status.

PAUSE 1.



/* state */

FOR EACH state:



    CREATE gem_state.

    FIND FIRST gem_region NO-LOCK

        WHERE gem_region.region_code BEGINS state.region

        NO-ERROR. 



    ASSIGN

        gem_state.region_obj        = IF AVAILABLE gem_region

                                      THEN gem_region.region_obj

                                      ELSE 0

        gem_state.state_code        = state.state

        gem_state.state_name        = state.statename

        gem_state.state_description = ""

        .

    {dynvalidate.i gem_state}



END.



DISPLAY STRING(TIME,'hh:mm:ss') @ disp-time

        "Creating - customer"   @ disp-status

    WITH FRAME F-status DOWN.

DOWN WITH FRAME F-status.

PAUSE 1.



DO TRANSACTION:



    CREATE gec_address_type.

    ASSIGN

        gec_address_type.address_type_name        = "Customer Mail Address"

        gec_address_type.address_type_code        = "Mail"

        gec_address_type.address_type_description = ""

        .

    {dynvalidate.i gec_address_type}



END.



/* customer */

FOR EACH customer:



    FIND FIRST salesrep OF customer NO-LOCK.

    FIND FIRST arm_salesrep NO-LOCK

        WHERE salesrep.salesrep = arm_salesrep.salesrep_code.



    CREATE arm_customer.

    ASSIGN

        arm_customer.login_company_obj      = 0

        arm_customer.salesrep_obj           = arm_salesrep.salesrep_obj

        arm_customer.customer_code          = STRING(customer.custnum)

        arm_customer.customer_name          = customer.name

        arm_customer.customer_comments      = customer.comments

        arm_customer.customer_credit_limit  = customer.creditlimit

        arm_customer.customer_balance       = customer.balance

        arm_customer.customer_discount      = customer.discount

        arm_customer.customer_terms         = customer.terms

        arm_customer.customer_fax           = customer.fax

        arm_customer.customer_email_address = customer.emailaddress

        .

    {dynvalidate.i arm_customer}



    /* Customer Mail address */

    FIND FIRST gem_state NO-LOCK

        WHERE gem_state.state_code = customer.state

        NO-ERROR.



    CREATE gem_address.

    ASSIGN 

        gem_address.state_obj          = IF AVAILABLE gem_state

                                         THEN gem_state.state_obj

                                         ELSE 0

        gem_address.address_contact    = customer.contact

        gem_address.address_address    = customer.address

        gem_address.address_address2   = customer.address2

        gem_address.address_city       = customer.city

        gem_address.address_country    = customer.country

        gem_address.address_phone      = customer.phone

        gem_address.address_postalcode = customer.postalcode

        gem_address.address_comments   = customer.comments.

    {dynvalidate.i gem_address}        



    CREATE arx_customer_address.

    ASSIGN

        arx_customer_address.customer_obj     = arm_customer.customer_obj

        arx_customer_address.address_type_obj = gec_address_type.address_type_obj

        arx_customer_address.address_obj      = gem_address.address_obj

        .

    {dynvalidate.i arx_customer_address}        



END.



DISPLAY STRING(TIME,'hh:mm:ss') @ disp-time

        "Creating - billto"     @ disp-status

    WITH FRAME F-status DOWN.

DOWN WITH FRAME F-status.

PAUSE 1.



/* customer BillTo address */

DO TRANSACTION:



    CREATE gec_address_type.

    ASSIGN 

        gec_address_type.address_type_name        = "Customer Bill To Address"

        gec_address_type.address_type_code        = "BillTo"

        gec_address_type.address_type_description = ""

        .

    {dynvalidate.i gec_address_type}        



    FOR EACH billto:



        FIND FIRST customer NO-LOCK

            WHERE customer.custnum = billto.custnum.

        FIND FIRST arm_customer NO-LOCK

            WHERE arm_customer.customer_code = STRING(customer.custnum).

        FIND FIRST gem_state NO-LOCK

            WHERE gem_state.state_code = billto.state

            NO-ERROR.



        CREATE gem_address.

        ASSIGN 

            gem_address.state_obj          = IF AVAILABLE gem_state

                                             THEN gem_state.state_obj

                                             ELSE 0

            gem_address.address_contact    = billto.contact

            gem_address.address_address    = billto.address

            gem_address.address_address2   = billto.address2

            gem_address.address_city       = billto.city

            gem_address.address_country    = ""

            gem_address.address_phone      = billto.phone

            gem_address.address_postalcode = billto.postalcode

            gem_address.address_comments   = ""

            .

        {dynvalidate.i gem_address}        

                                                                                                 

        CREATE tt_num_obj_relation.

        ASSIGN 

            tt_num_obj_relation.num = billto.billtoid

            tt_num_obj_relation.obj = gem_address.address_obj

            tt_num_obj_relation.tbl = "billto"

            .

        

        CREATE arx_customer_address.

        ASSIGN

            arx_customer_address.customer_obj     = arm_customer.customer_obj

            arx_customer_address.address_type_obj = gec_address_type.address_type_obj

            arx_customer_address.address_obj      = gem_address.address_obj

            .

        {dynvalidate.i arx_customer_address}        



    END.

        

END.



DISPLAY STRING(TIME,'hh:mm:ss') @ disp-time

        "Creating - shipto"     @ disp-status

    WITH FRAME F-status DOWN.

DOWN WITH FRAME F-status.

PAUSE 1.



/* customer ShipTo address */

DO TRANSACTION:



    CREATE gec_address_type.

    ASSIGN 

        gec_address_type.address_type_name        = "Customer Ship To Address"

        gec_address_type.address_type_code        = "ShipTo"

        gec_address_type.address_type_description = ""

        .

    {dynvalidate.i gec_address_type}        



    FOR EACH shipto:



        FIND FIRST customer NO-LOCK

            WHERE customer.custnum = shipto.custnum.

        FIND FIRST arm_customer NO-LOCK

            WHERE arm_customer.customer_code = string(customer.custnum).

        FIND FIRST gem_state NO-LOCK

            WHERE gem_state.state_code = shipto.state

            NO-ERROR.



        CREATE gem_address.

        ASSIGN 

            gem_address.state_obj          = IF AVAILABLE gem_state

                                             THEN gem_state.state_obj

                                             ELSE 0

            gem_address.address_contact    = shipto.contact

            gem_address.address_address    = shipto.address

            gem_address.address_address2   = shipto.address2

            gem_address.address_city       = shipto.city

            gem_address.address_country    = ""

            gem_address.address_phone      = shipto.phone

            gem_address.address_postalcode = shipto.postalcode

            gem_address.address_comments   = shipto.comments.

        {dynvalidate.i gem_address}                



        CREATE tt_num_obj_relation.

        ASSIGN 

            tt_num_obj_relation.num = shipto.shiptoid

            tt_num_obj_relation.obj = gem_address.address_obj

            tt_num_obj_relation.tbl = "shipto"

            .

        

        CREATE arx_customer_address.

        ASSIGN

            arx_customer_address.customer_obj     = arm_customer.customer_obj

            arx_customer_address.address_type_obj = gec_address_type.address_type_obj

            arx_customer_address.address_obj      = gem_address.address_obj

            .

        {dynvalidate.i arx_customer_address}        



    END.        



END.

    

DISPLAY STRING(TIME,'hh:mm:ss') @ disp-time

        "Creating - refcall"    @ disp-status

    WITH FRAME F-status DOWN.

DOWN WITH FRAME F-status.

PAUSE 1.



/* refcall */

FOR EACH refcall BY refcall.callnum:



    FIND FIRST customer NO-LOCK

        WHERE customer.custnum = refcall.custnum.

    FIND FIRST arm_customer NO-LOCK

        WHERE arm_customer.customer_code = STRING(customer.custnum).

    FIND FIRST salesrep NO-LOCK

        WHERE salesrep.salesrep = refcall.salesrep.

    FIND FIRST arm_salesrep NO-LOCK

        WHERE arm_salesrep.salesrep_code = salesrep.salesrep.

    FIND tt_num_obj_relation

        WHERE tbl = "refcall"

          AND num = INTEGER(PARENT)

       NO-ERROR.



    CREATE art_refcall.

    ASSIGN

        art_refcall.customer_obj        = arm_customer.customer_obj

        art_refcall.salesrep_obj        = arm_salesrep.salesrep_obj

        art_refcall.refcall_date        = refcall.calldate

        art_refcall.refcall_code        = STRING(refcall.callnum) 

        art_refcall.refcall_parent      = IF AVAILABLE tt_num_obj_relation

                                          THEN obj

                                          ELSE 0 

        art_refcall.refcall_description = refcall.txt

        .

    {dynvalidate.i art_refcall}               



    CREATE tt_num_obj_relation.

    ASSIGN 

        tt_num_obj_relation.num = INTEGER(refcall.callnum)

        tt_num_obj_relation.obj = art_refcall.refcall_obj

        tt_num_obj_relation.tbl = "refcall"

        .



END.



DISPLAY STRING(TIME,'hh:mm:ss') @ disp-time

        "Creating - Warehouse"  @ disp-status

    WITH FRAME F-status DOWN.

DOWN WITH FRAME F-status.

PAUSE 1.



/* warehouse */

DO TRANSACTION:



    CREATE gec_address_type.

    ASSIGN 

        gec_address_type.address_type_name        = "Warehouse Address"

        gec_address_type.address_type_code        = "Warehouse"

        gec_address_type.address_type_description = ""

        .

    {dynvalidate.i gec_address_type}        



    FOR EACH warehouse:



        CREATE ivm_warehouse.

        ASSIGN

            ivm_warehouse.warehouse_code        = STRING(warehouse.warehousenum)

            ivm_warehouse.warehouse_name        = warehouse.warehousename

            ivm_warehouse.warehouse_description = ""

            .

        {dynvalidate.i ivm_warehouse}

        

        FIND FIRST gem_state NO-LOCK

            WHERE gem_state.state_code = warehouse.state

            NO-ERROR.



        CREATE gem_address.

        ASSIGN 

            gem_address.state_obj          = IF AVAILABLE gem_state

                                             THEN gem_state.state_obj

                                             ELSE 0

            gem_address.address_contact    = ""

            gem_address.address_address    = warehouse.address

            gem_address.address_address2   = warehouse.address2

            gem_address.address_city       = warehouse.city

            gem_address.address_country    = warehouse.country

            gem_address.address_phone      = warehouse.phone

            gem_address.address_postalcode = warehouse.postalcode

            gem_address.address_comments   = ""

            .

        {dynvalidate.i gem_address}        

        

        CREATE ivx_warehouse_address.

        ASSIGN

            ivx_warehouse_address.warehouse_obj    = ivm_warehouse.warehouse_obj

            ivx_warehouse_address.address_type_obj = gec_address_type.address_type_obj

            ivx_warehouse_address.address_obj      = gem_address.address_obj

            .

        {dynvalidate.i ivx_warehouse_address}        



    END.



END.



DISPLAY STRING(TIME,'hh:mm:ss') @ disp-time

        "Creating - Supplier"   @ disp-status

    WITH FRAME F-status DOWN.

DOWN WITH FRAME F-status.

PAUSE 1.



/* supplier  */

DO TRANSACTION:



    CREATE gec_address_type.

    ASSIGN 

        gec_address_type.address_type_name        = "supplier address"

        gec_address_type.address_type_code        = "supplier"

        gec_address_type.address_type_description = ""

        .

    {dynvalidate.i gec_address_type}        



    FOR EACH supplier:



        CREATE apm_supplier.

        ASSIGN

            apm_supplier.supplier_code        = STRING(supplier.supplieridnum)

            apm_supplier.supplier_name        = supplier.name

            apm_supplier.supplier_comments    = supplier.comments

            apm_supplier.supplier_password    = supplier.password

            apm_supplier.supplier_login_date  = supplier.logindate

            apm_supplier.supplier_ship_amount = supplier.shipamount

            apm_supplier.supplier_discount    = supplier.discount

            .

        {dynvalidate.i apm_supplier}        

 

        FIND FIRST gem_state NO-LOCK

            WHERE gem_state.state_code = supplier.state

            NO-ERROR.



        CREATE gem_address.

        ASSIGN 

            gem_address.state_obj          = IF AVAILABLE gem_state

                                             THEN gem_state.state_obj

                                             ELSE 0

            gem_address.address_contact    = ""

            gem_address.address_address    = supplier.address

            gem_address.address_address2   = supplier.address2

            gem_address.address_city       = supplier.city

            gem_address.address_country    = supplier.country

            gem_address.address_phone      = supplier.phone

            gem_address.address_postalcode = supplier.postalcode

            gem_address.address_comments   = supplier.comments

            .

        {dynvalidate.i gem_address}        

        

        CREATE apx_supplier_address.

        ASSIGN

            apx_supplier_address.supplier_obj     = apm_supplier.supplier_obj

            apx_supplier_address.address_type_obj = gec_address_type.address_type_obj

            apx_supplier_address.address_obj      = gem_address.address_obj

            .

        {dynvalidate.i apx_supplier_address}        



    END.



END.



DISPLAY STRING(TIME,'hh:mm:ss') @ disp-time

        "Creating - Item"       @ disp-status

    WITH FRAME F-status DOWN.

DOWN WITH FRAME F-status.

PAUSE 1.



FOR EACH item:



    CREATE ivm_item.

    ASSIGN

        ivm_item.item_allocated       = item.allocated

        ivm_item.item_category1       = item.category1

        ivm_item.item_category2       = item.category2 

        ivm_item.item_cat_description = item.catdescription 

        ivm_item.item_cat_page        = item.catpage 

        ivm_item.item_code            = STRING(item.itemnum) 

        ivm_item.item_min_qty         = item.minqty

        ivm_item.item_name            = item.itemname 

        ivm_item.item_on_hand         = item.onhand

        ivm_item.item_on_order        = item.onorder 

        ivm_item.item_price           = item.price 

        ivm_item.item_reorder         = item.reorder 

        ivm_item.item_special         = item.special 

        ivm_item.item_weight          = item.weight

        .

{dynvalidate.i ivm_item}        

END.

       

DISPLAY STRING(TIME,'hh:mm:ss') @ disp-time

        "Creating - Bin"        @ disp-status

    WITH FRAME F-status DOWN.

DOWN WITH FRAME F-status.

PAUSE 1.



FOR EACH bin:



    FIND FIRST ivm_item

        WHERE ivm_item.item_code = STRING(bin.itemnum).

    FIND FIRST ivm_warehouse

        WHERE ivm_warehouse.warehouse_code = STRING(bin.warehousenum).



    CREATE ivm_bin.

    ASSIGN

        ivm_bin.bin_code        = STRING(bin.binnum) 

        ivm_bin.bin_description = ""

        ivm_bin.bin_name        = bin.binname 

        ivm_bin.bin_qty         = bin.qty

        ivm_bin.item_obj        = ivm_item.item_obj

        ivm_bin.warehouse_obj   = ivm_warehouse.warehouse_obj

        .

    {dynvalidate.i ivm_bin}        



END.



DISPLAY STRING(TIME,'hh:mm:ss')   @ disp-time

        "Creating - SupplierXRef" @ disp-status

    WITH FRAME F-status DOWN.

DOWN WITH FRAME F-status.

PAUSE 1.



FOR EACH supplieritemxref:

    

    FIND apm_supplier NO-LOCK

        WHERE apm_supplier.supplier_code = STRING(supplieritemxref.supplieridnum)

        NO-ERROR .

    FIND ivm_item NO-LOCK

        WHERE ivm_item.item_code = STRING(supplieritemxref.itemnum)

        NO-ERROR.



    CREATE apx_supplier_item.

    ASSIGN

        apx_supplier_item.item_obj     = IF AVAILABLE ivm_item 

                                         THEN ivm_item.item_obj

                                         ELSE 0

        apx_supplier_item.supplier_obj = IF AVAILABLE apm_supplier

                                         THEN apm_supplier.supplier_obj

                                         ELSE 0

        .

    {dynvalidate.i apx_supplier_item}        

END.



DISPLAY STRING(TIME,'hh:mm:ss')    @ disp-time

        "Creating - Purchaseorder" @ disp-status

    WITH FRAME F-status DOWN.

DOWN WITH FRAME F-status.

PAUSE 1.



FOR EACH purchaseorder:

    

    FIND apm_supplier

        WHERE apm_supplier.supplier_code = STRING(purchaseorder.supplieridnum).

    FIND gem_status

        WHERE status_name = purchaseorder.postatus

        NO-ERROR.



    IF NOT AVAILABLE gem_status THEN

    DO:



        CREATE gem_status.

        ASSIGN 

            gem_status.status_code        = "in_" +

                                            SUBSTRING(purchaseorder.postatus,1,4)

            gem_status.status_description = purchaseorder.postatus

            gem_status.status_name        = purchaseorder.postatus

            .

        {dynvalidate.i gem_status}



    END.



    CREATE apt_purchaseorder.

    ASSIGN

        apt_purchaseorder.status_obj                 = gem_status.status_obj

        apt_purchaseorder.purchaseorder_code         = STRING( purchaseorder.ponum )

        apt_purchaseorder.purchaseorder_date_entered = purchaseorder.dateentered 

        apt_purchaseorder.purchaseorder_receive_date = purchaseorder.receivedate

        apt_purchaseorder.supplier_obj               = apm_supplier.supplier_obj

        apt_purchaseorder.purchaseorder_incoming     = TRUE

        .

    {dynvalidate.i apt_purchaseorder}



    CREATE tt_num_obj_relation.

    ASSIGN

        tt_num_obj_relation.num = purchaseorder.ponum

        tt_num_obj_relation.obj = apt_purchaseorder.purchaseorder_obj

        tt_num_obj_relation.tbl = "PurchaseOrder"

        .

    /* PurchaseOrder.PONum */    

    

    FOR EACH poline OF purchaseorder:

        

        FIND ivm_item

            WHERE item_code = STRING(poline.itemnum).

        FIND gem_status

            WHERE status_name = poline.polinestatus

            NO-ERROR.



        IF NOT AVAILABLE gem_status THEN

        DO:



            CREATE gem_status.

            ASSIGN 

                gem_status.status_code = "in_" + SUBSTRING(POLine.POLineStatus,1,4)

                gem_status.status_description = POLine.POLineStatus

                gem_status.status_name = POLine.POLineStatus

                .

            {dynvalidate.i gem_status}



        END.

        

        CREATE apt_poline.

        ASSIGN apt_poline.item_obj              = ivm_item.item_obj

               apt_poline.status_obj            = gem_status.status_obj

               apt_poline.poline_discount       = poline.discount

               apt_poline.poline_extended_price = poline.extendedprice             

               apt_poline.poline_price          = poline.price

               apt_poline.poline_qty            = poline.qty

               apt_poline.purchaseorder_obj     = apt_purchaseorder.purchaseorder_obj

               apt_poline.poline_line_number    = poline.linenum

               .

        {dynvalidate.i apt_poline}

     END.

END.



DISPLAY STRING(TIME,'hh:mm:ss') @ disp-time

        "Creating - Order"      @ disp-status

    WITH FRAME F-status DOWN.

DOWN WITH FRAME F-status.

PAUSE 1.



FOR EACH order:

    

    FIND arm_customer NO-LOCK

        WHERE arm_customer.customer_code = STRING(order.custnum).

    FIND arm_salesrep NO-LOCK

        WHERE arm_salesrep.salesrep_code = order.salesrep

        NO-ERROR.

    FIND ivm_warehouse NO-LOCK

        WHERE ivm_warehouse.warehouse_code = STRING(order.warehousenum)

        NO-ERROR.



    IF NOT AVAILABLE ivm_warehouse THEN

        FIND FIRST ivm_warehouse NO-LOCK.



    FIND gem_status

        WHERE status_name = order.orderstatus

        NO-ERROR.



    IF NOT AVAILABLE gem_status THEN

    DO: 



        CREATE gem_status.

        ASSIGN gem_status.status_code        = "out_" +

                                               SUBSTRING(order.orderstatus,1,4)

               gem_status.status_description = order.orderstatus

               gem_status.status_name        = order.orderstatus

               .

        {dynvalidate.i gem_status}



    END.



    CREATE art_order.

    ASSIGN art_order.customer_obj       = arm_customer.customer_obj 

           art_order.status_obj         = gem_status.status_obj

           art_order.order_code         = STRING( order.ordernum )

           art_order.order_carrier      = order.carrier 

           art_order.order_creditcard   = order.creditcard 

           art_order.order_date         = order.orderdate 

           art_order.order_instructions = order.instructions 

           art_order.order_po           = order.po 

           art_order.order_promise_date = order.promisedate 

           art_order.order_ship_date    = order.shipdate

           art_order.order_terms        = order.terms

           art_order.salesrep_obj       = IF AVAILABLE arm_salesrep

                                          THEN arm_salesrep.salesrep_obj

                                          ELSE 0

           art_order.warehouse_obj      = IF AVAILABLE ivm_warehouse

                                          THEN ivm_warehouse.warehouse_obj

                                          ELSE 0

           art_order.order_incoming     = FALSE

           .

    {dynvalidate.i art_order}

        

    CREATE tt_num_obj_relation.

    ASSIGN tt_num_obj_relation.num = order.ordernum

           tt_num_obj_relation.obj = art_order.order_obj

           tt_num_obj_relation.tbl = "Order"

           .

   /* Order.PONum */    

    

    FIND gec_address_type

        WHERE gec_address_type.address_type_code = "Billto".

    FIND tt_num_obj_relation

        WHERE tbl = "billto"

          AND num = order.billtoid

        NO-ERROR.



    IF NOT AVAILABLE tt_num_obj_relation THEN

        FIND FIRST arx_customer_address NO-LOCK

            WHERE arx_customer_address.customer_obj = arm_customer.customer_obj

            NO-ERROR.



    CREATE arx_order_address.

    ASSIGN arx_order_address.address_obj      = IF AVAILABLE tt_num_obj_relation 

                                                THEN tt_num_obj_relation.obj

                                                ELSE arx_customer_address.address_obj

           arx_order_address.address_type_obj = gec_address_type.address_type_obj

           arx_order_address.order_obj        = art_order.order_obj

           .

    {dynvalidate.i arx_order_address}



    FIND gec_address_type

        WHERE gec_address_type.address_type_code = "shipto".

    FIND tt_num_obj_relation

        WHERE tbl = "shipto"

          AND num = order.shiptoid

        NO-ERROR.



    IF NOT AVAILABLE tt_num_obj_relation THEN

        FIND FIRST arx_customer_address NO-LOCK

            WHERE arx_customer_address.customer_obj = arm_customer.customer_obj

            NO-ERROR.



    CREATE arx_order_address.

    ASSIGN arx_order_address.address_obj      = IF AVAILABLE tt_num_obj_relation 

                                                THEN tt_num_obj_relation.obj

                                                ELSE arx_customer_address.address_obj

           arx_order_address.address_type_obj = gec_address_type.address_type_obj

           arx_order_address.order_obj        = art_order.order_obj

           .

    {dynvalidate.i arx_order_address}    



    FOR EACH orderline OF order:

        

        FIND ivm_item

            WHERE item_code = STRING(orderline.itemnum).

        FIND gem_status

            WHERE status_name = orderline.orderlinestatus

            NO-ERROR.



        IF NOT AVAILABLE gem_status THEN

        DO: 



            CREATE gem_status.

            ASSIGN 

                gem_status.status_code        = "out_" +

                                                SUBSTRING(orderline.orderlinestatus,1,4)

                gem_status.status_description = orderline.orderlinestatus

                gem_status.status_name        = orderline.orderlinestatus

                .

            {dynvalidate.i gem_status}



        END.

        

        CREATE art_orderline.

        ASSIGN 

            art_orderline.item_obj = ivm_item.ITEM_obj

            art_orderline.status_obj   = gem_status.status_obj

            art_orderline.Orderline_discount = Orderline.Discount

            art_orderline.Orderline_extended_price  = Orderline.ExtendedPrice             

            art_orderline.Orderline_price = Orderline.Price

            art_orderline.Orderline_qty = Orderline.Qty

            art_orderline.Order_obj = art_order.Order_obj

            art_orderline.orderline_price = orderline.Price

            art_orderline.orderline_line_number = Orderline.Linenum

            .

        {dynvalidate.i art_orderline}

    

    END.



END.



DISPLAY STRING(TIME,'hh:mm:ss')     @ disp-time

        "Creating - Inventorytrans" @ disp-status

    WITH FRAME F-status DOWN.

DOWN WITH FRAME F-status.

PAUSE 1.



/* Trigger procedure do not allow unknown bin,warehouse,purchaseorder or order num */

ON WRITE OF inventorytrans OVERRIDE 

DO:

    RETURN.

END.



DEFINE BUFFER po-tt_num_obj_relation FOR tt_num_obj_relation.



FOR EACH inventorytrans:



    FIND FIRST ivm_bin NO-LOCK

        WHERE ivm_bin.bin_code = STRING(InventoryTrans.BinNum)

        NO-ERROR.

    FIND ivm_item NO-LOCK

        WHERE ivm_item.item_code = STRING(InventoryTrans.Itemnum)

        NO-ERROR.

    FIND tt_num_obj_relation NO-LOCK

        WHERE tt_num_obj_relation.Tbl = "Order"

          AND tt_num_obj_relation.num = InventoryTrans.Ordernum

        NO-ERROR.

    FIND po-tt_num_obj_relation

        WHERE po-tt_num_obj_relation.Tbl = "PurchaseOrder"

          AND po-tt_num_obj_relation.num = InventoryTrans.POnum

        NO-ERROR.

    FIND ivm_warehouse NO-LOCK

        WHERE ivm_warehouse.warehouse_code = STRING(InventoryTrans.WarehouseNum)

        NO-ERROR.

    FIND ivc_it_type

        WHERE it_type_code = inventorytrans.invtype

        NO-ERROR.



    IF NOT AVAILABLE ivc_it_type THEN

    DO: 



        CREATE ivc_it_type.

        ASSIGN 

            ivc_it_type.it_type_code        = inventorytrans.invtype

            ivc_it_type.it_type_description = inventorytrans.invtype

            ivc_it_type.it_type_name        = inventorytrans.invtype

            .

        {dynvalidate.i ivc_it_type}



    END.



    CREATE ivt_inventorytrans.

    ASSIGN 

        ivt_inventorytrans.bin_obj             = IF AVAILABLE ivm_bin

                                                 THEN ivm_bin.bin_obj

                                                 ELSE 0

        ivt_inventorytrans.inventorytrans_date = inventorytrans.transdate

        ivt_inventorytrans.inventorytrans_qty  = inventorytrans.qty

        ivt_inventorytrans.inventorytrans_time = inventorytrans.transtime

        ivt_inventorytrans.item_obj            = IF AVAILABLE ivm_item

                                                 THEN ivm_item.item_obj

                                                 ELSE 0

        ivt_inventorytrans.it_type_obj         = ivc_it_type.it_type_obj

        ivt_inventorytrans.order_obj           = IF AVAILABLE tt_num_obj_relation

                                                 THEN tt_num_obj_relation.obj

                                                 ELSE 0

        ivt_inventorytrans.purchaseorder_obj   = IF AVAILABLE po-tt_num_obj_relation

                                                 THEN po-tt_num_obj_relation.obj

                                                 ELSE 0 

        ivt_inventorytrans.warehouse_obj       = IF AVAILABLE ivm_warehouse

                                                 THEN ivm_warehouse.warehouse_obj

                                                 ELSE 0

        .

    {dynvalidate.i ivt_inventorytrans}



END.



DISPLAY STRING(TIME,'hh:mm:ss') @ disp-time

        "Creating - Invoice"    @ disp-status

    WITH FRAME F-status DOWN.

DOWN WITH FRAME F-status.

PAUSE 1.



FOR EACH invoice:



    FIND arm_customer NO-LOCK

        WHERE arm_customer.customer_code = STRING(invoice.custnum).

    FIND tt_num_obj_relation

        WHERE tbl                     = "Order"

          AND tt_num_obj_relation.num = invoice.ordernum

        NO-ERROR.



    CREATE art_invoice.

    ASSIGN 

        art_invoice.customer_obj        = arm_customer.customer_obj

        art_invoice.invoice_adjustment  = invoice.adjustment

        art_invoice.invoice_amount      = invoice.amount

        art_invoice.invoice_date        = invoice.invoicedate

        art_invoice.invoice_ship_charge = invoice.shipcharge

        art_invoice.invoice_total_paid  = invoice.totalpaid

        art_invoice.order_obj           = tt_num_obj_relation.obj

        art_invoice.invoice_code        = STRING(invoice.invoicenum)

        .

    {dynvalidate.i art_invoice}    

              

END.



DISPLAY STRING(TIME,'hh:mm:ss') @ disp-time

        "Creating - Department" @ disp-status

    WITH FRAME F-status DOWN.

DOWN WITH FRAME F-status.

PAUSE 1.



FOR EACH department NO-LOCK:



    /* Department data */    

    CREATE hrm_department.

    ASSIGN

        hrm_department.department_code        = department.deptcode 

        hrm_department.department_name        = department.deptname

        hrm_department.department_description = ""

        .

    {dynvalidate.i hrm_department}



END.



DISPLAY STRING(TIME,'hh:mm:ss') @ disp-time

        "Creating - Employee"   @ disp-status

    WITH FRAME F-status DOWN.

DOWN WITH FRAME F-status.

PAUSE 1.



/* Create two new address type records for Employee Addresses */

/* Create one vacation type record */

DO TRANSACTION:



    CREATE gec_address_type.

    ASSIGN 

        gec_address_type.address_type_name        = "Employee Home Address"

        gec_address_type.address_type_code        = "EmpHome"

        gec_address_type.address_type_description = ""

        .

    {dynvalidate.i gec_address_type}        



    CREATE gec_address_type.

    ASSIGN 

        gec_address_type.address_type_name        = "Employee Work Address"

        gec_address_type.address_type_code        = "EmpWork"

        gec_address_type.address_type_description = ""

        .

    {dynvalidate.i gec_address_type}        



    CREATE hrc_vacation_type.

    ASSIGN

        hrc_vacation_type.vacation_type_code        = "VAC"

        hrc_vacation_type.vacation_type_name        = "Vacation"

        hrc_vacation_type.Vacation_type_description = "Time off to do whatever you want to do."

        .

    {dynvalidate.i hrc_vacation_type}.

END.



FOR EACH employee NO-LOCK:



    FIND FIRST department OF employee NO-LOCK.

    FIND FIRST hrm_department NO-LOCK

        WHERE department.deptcode = hrm_department.department_code.



    CREATE hrm_employee.

    ASSIGN

        hrm_employee.department_obj              = hrm_department.department_obj

        hrm_employee.employee_last_name          = employee.lastname

        hrm_employee.employee_first_name         = employee.firstname

        hrm_employee.employee_position           = employee.position

        hrm_employee.employee_vacation_days_left = employee.vacationdaysleft

        hrm_employee.employee_sick_days_left     = employee.sickdaysleft

        hrm_employee.employee_start_date         = employee.startdate

        hrm_employee.employee_birth_date         = employee.birthdate

        .

    {dynvalidate.i hrm_employee}



    /* Employee Home address */

    FIND FIRST gem_state NO-LOCK

        WHERE gem_state.state_code = employee.state NO-ERROR.



    CREATE gem_address.

    ASSIGN 

        gem_address.state_obj          = IF AVAILABLE gem_state

                                         THEN gem_state.state_obj

                                         ELSE 0

        gem_address.address_contact    = ""

        gem_address.address_address    = employee.address

        gem_address.address_address2   = employee.address2

        gem_address.address_city       = employee.city

        gem_address.address_country    = ""

        gem_address.address_phone      = employee.homephone

        gem_address.address_postalcode = employee.postalcode

        gem_address.address_comments   = ""

        .

    {dynvalidate.i gem_address}        



    /* Create Xref record for Employee Home Address (EmpHome) */

    FIND FIRST gec_address_type NO-LOCK

        WHERE gec_address_type.address_type_code = "EmpHome".



    CREATE hrx_employee_address.

    ASSIGN

        hrx_employee_address.employee_obj     = hrm_employee.employee_obj

        hrx_employee_address.address_type_obj = gec_address_type.address_type_obj

        hrx_employee_address.address_obj      = gem_address.address_obj

        .

    {dynvalidate.i hrx_employee_address}        



    /* Employee Work address */

    CREATE gem_address.

    ASSIGN 

        gem_address.state_obj          = 0

        gem_address.address_contact    = ""

        gem_address.address_address    = ""

        gem_address.address_address2   = ""

        gem_address.address_city       = ""

        gem_address.address_country    = ""

        gem_address.address_phone      = employee.workphone

        gem_address.address_postalcode = ""

        gem_address.address_comments   = ""

        .

    {dynvalidate.i gem_address}        



    /* Create Xref record for Employee Work Address (EmpWork) */

    FIND FIRST gec_address_type NO-LOCK

        WHERE gec_address_type.address_type_code = "EmpWork".



    CREATE hrx_employee_address.

    ASSIGN

        hrx_employee_address.employee_obj     = hrm_employee.employee_obj

        hrx_employee_address.address_type_obj = gec_address_type.address_type_obj

        hrx_employee_address.address_obj      = gem_address.address_obj

        .

    {dynvalidate.i hrx_employee_address}        



    DISPLAY STRING(TIME,'hh:mm:ss')             @ disp-time

            "Creating - Family for Employee " +

            STRING(employee.empnum)             @ disp-status

        WITH FRAME F-status DOWN.

    DOWN WITH FRAME F-status.

    PAUSE 1.

    

    FOR EACH family OF employee:

    

        CREATE hrm_family.

        ASSIGN

            hrm_family.employee_obj               = hrm_employee.employee_obj

            hrm_family.family_relative_name       = family.relativename

            hrm_family.family_relation            = family.relation

            hrm_family.family_birth_date          = family.birthdate

            hrm_family.family_benefit_date        = family.benefitdate

            hrm_family.family_covered_on_benefits = family.coveredonbenefits

            .

        {dynvalidate.i hrm_family}

    

    END.



    DISPLAY STRING(TIME,'hh:mm:ss')               @ disp-time

            "Creating - Vacation for Employee " +

           STRING(employee.empnum)                @ disp-status

        WITH FRAME F-status DOWN.

    DOWN WITH FRAME F-status.

    PAUSE 1.

    

    FIND FIRST hrc_vacation_type NO-LOCK

        WHERE hrc_vacation_type.vacation_type_code = "VAC".



    FOR EACH vacation WHERE vacation.empnum = employee.empnum NO-LOCK:

    

        CREATE hrt_vacation.

        ASSIGN

            hrt_vacation.employee_obj        = hrm_employee.employee_obj

            hrt_vacation.vacation_start_date = vacation.startdate

            hrt_vacation.vacation_end_date   = vacation.enddate

            .

        IF AVAILABLE hrc_vacation_type THEN

            ASSIGN hrt_vacation.vacation_type_obj = hrc_vacation_type.vacation_type_obj.



        {dynvalidate.i hrt_vacation}

    

    END.



    DISPLAY STRING(TIME,'hh:mm:ss')               @ disp-time

            "Creating - Benefits for Employee " +

            STRING(employee.empnum)               @ disp-status

        WITH FRAME F-status DOWN.

    DOWN WITH FRAME F-status.

    PAUSE 1.

    

    FOR EACH benefits OF employee NO-LOCK:

    

        CREATE hrm_benefits.

        ASSIGN

            hrm_benefits.employee_obj              = hrm_employee.employee_obj

            hrm_benefits.benefits_health_care      = benefits.healthcare

            hrm_benefits.benefits_life_insurance   = benefits.lifeinsurance

            hrm_benefits.benefits_pension_401k     = benefits.pension401k

            hrm_benefits.benefits_stock_purchase   = benefits.stockpurchase

            hrm_benefits.benefits_medical_spending = benefits.medicalspending

            hrm_benefits.benefits_dependent_care   = benefits.dependentcare

            .

        {dynvalidate.i hrm_benefits}

    

    END.



    DISPLAY STRING(TIME,'hh:mm:ss')                @ disp-time

            "Creating - Timesheet for Employee " +

            STRING(employee.empnum)                @ disp-status

        WITH FRAME F-status DOWN.

    DOWN WITH FRAME F-status.

    PAUSE 1.

    

    FOR EACH timesheet OF employee NO-LOCK:

    

        CREATE hrt_timesheet.

        ASSIGN

            hrt_timesheet.employee_obj             = hrm_employee.employee_obj

            hrt_timesheet.timesheet_day_recorded   = timesheet.dayrecorded

            hrt_timesheet.timesheet_am_time_in     = timesheet.amtimein

            hrt_timesheet.timesheet_am_time_out    = timesheet.amtimeout

            hrt_timesheet.timesheet_pm_time_in     = timesheet.pmtimein

            hrt_timesheet.timesheet_pm_time_out    = timesheet.pmtimeout

            hrt_timesheet.timesheet_regular_hours  = timesheet.regularhours

            hrt_timesheet.timesheet_overtime_hours = timesheet.overtimehours

            .

        {dynvalidate.i hrt_timesheet}

    

    END.



END.    /* FOR EACH employee */



ASSIGN

    SESSION:APPL-ALERT-BOXES    = lApplAlertBoxes

    SESSION:SYSTEM-ALERT-BOXES  = lSystemAlertBoxes

    .

