TRIGGER PROCEDURE FOR DELETE OF apm_supplier .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   apm_supplier           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE apm_supplier

&SCOPED-DEFINE TRIGGER_FLA apmsu

&SCOPED-DEFINE TRIGGER_OBJ supplier_obj





DEFINE BUFFER lb_table FOR apm_supplier.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR apm_supplier.     /* Used for lock upgrades */



DEFINE BUFFER o_apm_supplier FOR apm_supplier.



/* Standard top of DELETE trigger code */

{af/sup/aftrigtopd.i}



  









/* Generated by ICF ERwin Template */

/* apm_supplier has apx_supplier_address ON PARENT DELETE CASCADE */

&IF DEFINED(lbe_supplier_address) = 0 &THEN

  DEFINE BUFFER lbe_supplier_address FOR apx_supplier_address.

  &GLOBAL-DEFINE lbe_supplier_address yes

&ENDIF

FOR EACH apx_supplier_address NO-LOCK

   WHERE apx_supplier_address.supplier_obj = apm_supplier.supplier_obj

   ON STOP UNDO, RETURN ERROR "AF^104^apmsutrigd.p^delete apx_supplier_address":U:

    FIND FIRST lbe_supplier_address EXCLUSIVE-LOCK

         WHERE ROWID(lbe_supplier_address) = ROWID(apx_supplier_address)

         NO-ERROR.

    IF AVAILABLE lbe_supplier_address THEN

      DO:

        {af/sup/afvalidtrg.i &action = "DELETE" &table = "lbe_supplier_address"}

      END.

END.











/* Generated by ICF ERwin Template */

/* apm_supplier is supplier for apt_purchaseorder ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST apt_purchaseorder WHERE

    apt_purchaseorder.supplier_obj = apm_supplier.supplier_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "apm_supplier|apt_purchaseorder":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.







/* Generated by ICF ERwin Template */

/* apm_supplier supplies apx_supplier_item ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST apx_supplier_item WHERE

    apx_supplier_item.supplier_obj = apm_supplier.supplier_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "apm_supplier|apx_supplier_item":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.











/* Generic comments deletion */

DEFINE BUFFER lbx_gsm_comment FOR gsm_comment.

DEFINE BUFFER lby_gsm_comment FOR gsm_comment.

IF CAN-FIND(FIRST lbx_gsm_comment 

            WHERE lbx_gsm_comment.owning_obj = apm_supplier.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_comment NO-LOCK

       WHERE lbx_gsm_comment.owning_obj = apm_supplier.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^apmsutrigd.p^delete gsm_comment":U:

        FIND FIRST lby_gsm_comment EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_comment) = ROWID(lbx_gsm_comment)

             NO-ERROR.

        IF AVAILABLE lby_gsm_comment THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_comment"}

          END.

    END.

/* Generic security allocation deletion */

DEFINE BUFFER lbx_gsm_user_allocation FOR gsm_user_allocation.

DEFINE BUFFER lby_gsm_user_allocation FOR gsm_user_allocation.

IF CAN-FIND(FIRST lbx_gsm_user_allocation 

            WHERE lbx_gsm_user_allocation.owning_obj = apm_supplier.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_user_allocation NO-LOCK

       WHERE lbx_gsm_user_allocation.owning_obj = apm_supplier.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^apmsutrigd.p^delete gsm_user_allocation":U:

        FIND FIRST lby_gsm_user_allocation EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_user_allocation) = ROWID(lbx_gsm_user_allocation)

             NO-ERROR.

        IF AVAILABLE lby_gsm_user_allocation THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_user_allocation"}

          END.

    END.

/* Generic multi-media deletion */

DEFINE BUFFER lbx_gsm_multi_media FOR gsm_multi_media.

DEFINE BUFFER lby_gsm_multi_media FOR gsm_multi_media.

IF CAN-FIND(FIRST lbx_gsm_multi_media 

            WHERE lbx_gsm_multi_media.owning_obj = apm_supplier.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_multi_media NO-LOCK

       WHERE lbx_gsm_multi_media.owning_obj = apm_supplier.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^apmsutrigd.p^delete gsm_multi_media":U:

        FIND FIRST lby_gsm_multi_media EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_multi_media) = ROWID(lbx_gsm_multi_media)

             NO-ERROR.

        IF AVAILABLE lby_gsm_multi_media THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_multi_media"}

          END.

    END.





















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'apmsu':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "DELETE":U, INPUT "apmsu":U, INPUT BUFFER apm_supplier:HANDLE, INPUT BUFFER o_apm_supplier:HANDLE).



/* Standard bottom of DELETE trigger code */

{af/sup/aftrigendd.i}





/* Place any specific DELETE trigger customisations here */

