TRIGGER PROCEDURE FOR WRITE OF apt_poline OLD BUFFER o_apt_poline.



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   apt_poline           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE apt_poline

&SCOPED-DEFINE TRIGGER_FLA aptpl

&SCOPED-DEFINE TRIGGER_OBJ poline_obj





DEFINE BUFFER lb_table FOR apt_poline.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR apt_poline.     /* Used for lock upgrades */







/* Standard top of WRITE trigger code */

{af/sup/aftrigtopw.i}



/* properform fields if enabled for table */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'aptpl':U

              AND gsc_entity_mnemonic.auto_properform_strings = YES) THEN

  RUN af/app/afpropfrmp.p (INPUT BUFFER apt_poline:HANDLE).

  







/* Generated by ICF ERwin Template */

/* gem_status defines status for apt_poline ON CHILD UPDATE SET NULL */

IF NEW apt_poline OR  apt_poline.status_obj <> o_apt_poline.status_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST gem_status WHERE

        apt_poline.status_obj = gem_status.status_obj)) THEN DO:

        

        ASSIGN apt_poline.status_obj = 0 .

    END.

    

    

  END.



/* Generated by ICF ERwin Template */

/* apt_purchaseorder consists of apt_poline ON CHILD UPDATE RESTRICT */

IF NEW apt_poline OR  apt_poline.purchaseorder_obj <> o_apt_poline.purchaseorder_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST apt_purchaseorder WHERE

        apt_poline.purchaseorder_obj = apt_purchaseorder.purchaseorder_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "apt_poline|apt_purchaseorder":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.



/* Generated by ICF ERwin Template */

/* ivm_item belongs to apt_poline ON CHILD UPDATE RESTRICT */

IF NEW apt_poline OR  apt_poline.item_obj <> o_apt_poline.item_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST ivm_item WHERE

        apt_poline.item_obj = ivm_item.item_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "apt_poline|ivm_item":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.

















IF NOT NEW apt_poline AND apt_poline.{&TRIGGER_OBJ} <> o_apt_poline.{&TRIGGER_OBJ} THEN

    DO:

        ASSIGN lv-error = YES lv-errgrp = "AF":U lv-errnum = 13 lv-include = "table object number":U.

        RUN error-message (lv-errgrp,lv-errnum,lv-include).

    END.



/* Customisations to WRITE trigger */

{dynsports/trg/aptpltrigw.i}







/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'aptpl':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "WRITE":U, INPUT "aptpl":U, INPUT BUFFER apt_poline:HANDLE, INPUT BUFFER o_apt_poline:HANDLE).



/* Standard bottom of WRITE trigger code */

{af/sup/aftrigendw.i}







