TRIGGER PROCEDURE FOR CREATE OF apt_purchaseorder .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   apt_purchaseorder           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE apt_purchaseorder

&SCOPED-DEFINE TRIGGER_FLA aptpo

&SCOPED-DEFINE TRIGGER_OBJ purchaseorder_obj





DEFINE BUFFER lb_table FOR apt_purchaseorder.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR apt_purchaseorder.     /* Used for lock upgrades */



DEFINE BUFFER o_apt_purchaseorder FOR apt_purchaseorder.



/* Standard top of CREATE trigger code */

{af/sup/aftrigtopc.i}



  







/* Generated by ICF ERwin Template */

/* gem_status defines status for apt_purchaseorder ON CHILD INSERT SET NULL */

IF NOT(CAN-FIND(FIRST gem_status WHERE

    apt_purchaseorder.status_obj = gem_status.status_obj)) THEN

  DO:

    

    ASSIGN apt_purchaseorder.status_obj = 0 .

  END.







/* Generated by ICF ERwin Template */

/* apm_supplier is supplier for apt_purchaseorder ON CHILD INSERT RESTRICT */

IF 

    ( apt_purchaseorder.supplier_obj <> 0 ) THEN

  DO:

    IF NOT(CAN-FIND(FIRST apm_supplier WHERE

        apt_purchaseorder.supplier_obj = apm_supplier.supplier_obj)) THEN

        DO:

          /* Cannot create child because parent does not exist ! */

          ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 102 lv-include = "apt_purchaseorder|apm_supplier":U.

          RUN error-message (lv-errgrp, lv-errnum, lv-include).

        END.

    

    

  END.













ASSIGN apt_purchaseorder.{&TRIGGER_OBJ} = getNextObj().















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'aptpo':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "CREATE":U, INPUT "aptpo":U, INPUT BUFFER apt_purchaseorder:HANDLE, INPUT BUFFER o_apt_purchaseorder:HANDLE).



/* Standard bottom of CREATE trigger code */

{af/sup/aftrigendc.i}





/* Place any specific CREATE trigger customisations here */

