TRIGGER PROCEDURE FOR DELETE OF apt_purchaseorder .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   apt_purchaseorder           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE apt_purchaseorder

&SCOPED-DEFINE TRIGGER_FLA aptpo

&SCOPED-DEFINE TRIGGER_OBJ purchaseorder_obj





DEFINE BUFFER lb_table FOR apt_purchaseorder.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR apt_purchaseorder.     /* Used for lock upgrades */



DEFINE BUFFER o_apt_purchaseorder FOR apt_purchaseorder.



/* Standard top of DELETE trigger code */

{af/sup/aftrigtopd.i}



  









/* Generated by ICF ERwin Template */

/* apt_purchaseorder influences ivt_inventorytrans ON PARENT DELETE SET NULL */



&IF DEFINED(lbe_inventorytrans) = 0 &THEN

  DEFINE BUFFER lbe_inventorytrans FOR ivt_inventorytrans.

  &GLOBAL-DEFINE lbe_inventorytrans yes

&ENDIF

FOR EACH ivt_inventorytrans NO-LOCK

   WHERE ivt_inventorytrans.purchaseorder_obj = apt_purchaseorder.purchaseorder_obj

   ON STOP UNDO, RETURN ERROR "AF^104^aptpotrigd.p^update ivt_inventorytrans":U:

    FIND FIRST lbe_inventorytrans EXCLUSIVE-LOCK

         WHERE ROWID(lbe_inventorytrans) = ROWID(ivt_inventorytrans)

         NO-ERROR.

    IF AVAILABLE lbe_inventorytrans THEN

      DO:

        

        ASSIGN lbe_inventorytrans.purchaseorder_obj = 0 .

      END.

END.







/* Generated by ICF ERwin Template */

/* apt_purchaseorder consists of apt_poline ON PARENT DELETE CASCADE */

&IF DEFINED(lbe_poline) = 0 &THEN

  DEFINE BUFFER lbe_poline FOR apt_poline.

  &GLOBAL-DEFINE lbe_poline yes

&ENDIF

FOR EACH apt_poline NO-LOCK

   WHERE apt_poline.purchaseorder_obj = apt_purchaseorder.purchaseorder_obj

   ON STOP UNDO, RETURN ERROR "AF^104^aptpotrigd.p^delete apt_poline":U:

    FIND FIRST lbe_poline EXCLUSIVE-LOCK

         WHERE ROWID(lbe_poline) = ROWID(apt_poline)

         NO-ERROR.

    IF AVAILABLE lbe_poline THEN

      DO:

        {af/sup/afvalidtrg.i &action = "DELETE" &table = "lbe_poline"}

      END.

END.















/* Generic comments deletion */

DEFINE BUFFER lbx_gsm_comment FOR gsm_comment.

DEFINE BUFFER lby_gsm_comment FOR gsm_comment.

IF CAN-FIND(FIRST lbx_gsm_comment 

            WHERE lbx_gsm_comment.owning_obj = apt_purchaseorder.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_comment NO-LOCK

       WHERE lbx_gsm_comment.owning_obj = apt_purchaseorder.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^aptpotrigd.p^delete gsm_comment":U:

        FIND FIRST lby_gsm_comment EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_comment) = ROWID(lbx_gsm_comment)

             NO-ERROR.

        IF AVAILABLE lby_gsm_comment THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_comment"}

          END.

    END.

/* Generic security allocation deletion */

DEFINE BUFFER lbx_gsm_user_allocation FOR gsm_user_allocation.

DEFINE BUFFER lby_gsm_user_allocation FOR gsm_user_allocation.

IF CAN-FIND(FIRST lbx_gsm_user_allocation 

            WHERE lbx_gsm_user_allocation.owning_obj = apt_purchaseorder.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_user_allocation NO-LOCK

       WHERE lbx_gsm_user_allocation.owning_obj = apt_purchaseorder.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^aptpotrigd.p^delete gsm_user_allocation":U:

        FIND FIRST lby_gsm_user_allocation EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_user_allocation) = ROWID(lbx_gsm_user_allocation)

             NO-ERROR.

        IF AVAILABLE lby_gsm_user_allocation THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_user_allocation"}

          END.

    END.

/* Generic multi-media deletion */

DEFINE BUFFER lbx_gsm_multi_media FOR gsm_multi_media.

DEFINE BUFFER lby_gsm_multi_media FOR gsm_multi_media.

IF CAN-FIND(FIRST lbx_gsm_multi_media 

            WHERE lbx_gsm_multi_media.owning_obj = apt_purchaseorder.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_multi_media NO-LOCK

       WHERE lbx_gsm_multi_media.owning_obj = apt_purchaseorder.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^aptpotrigd.p^delete gsm_multi_media":U:

        FIND FIRST lby_gsm_multi_media EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_multi_media) = ROWID(lbx_gsm_multi_media)

             NO-ERROR.

        IF AVAILABLE lby_gsm_multi_media THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_multi_media"}

          END.

    END.





















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'aptpo':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "DELETE":U, INPUT "aptpo":U, INPUT BUFFER apt_purchaseorder:HANDLE, INPUT BUFFER o_apt_purchaseorder:HANDLE).



/* Standard bottom of DELETE trigger code */

{af/sup/aftrigendd.i}





/* Place any specific DELETE trigger customisations here */

