TRIGGER PROCEDURE FOR WRITE OF apt_purchaseorder OLD BUFFER o_apt_purchaseorder.



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   apt_purchaseorder           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE apt_purchaseorder

&SCOPED-DEFINE TRIGGER_FLA aptpo

&SCOPED-DEFINE TRIGGER_OBJ purchaseorder_obj





DEFINE BUFFER lb_table FOR apt_purchaseorder.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR apt_purchaseorder.     /* Used for lock upgrades */







/* Standard top of WRITE trigger code */

{af/sup/aftrigtopw.i}



/* properform fields if enabled for table */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'aptpo':U

              AND gsc_entity_mnemonic.auto_properform_strings = YES) THEN

  RUN af/app/afpropfrmp.p (INPUT BUFFER apt_purchaseorder:HANDLE).

  







/* Generated by ICF ERwin Template */

/* gem_status defines status for apt_purchaseorder ON CHILD UPDATE SET NULL */

IF NEW apt_purchaseorder OR  apt_purchaseorder.status_obj <> o_apt_purchaseorder.status_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST gem_status WHERE

        apt_purchaseorder.status_obj = gem_status.status_obj)) THEN DO:

        

        ASSIGN apt_purchaseorder.status_obj = 0 .

    END.

    

    

  END.



/* Generated by ICF ERwin Template */

/* apm_supplier is supplier for apt_purchaseorder ON CHILD UPDATE RESTRICT */

IF NEW apt_purchaseorder OR  apt_purchaseorder.supplier_obj <> o_apt_purchaseorder.supplier_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST apm_supplier WHERE

        apt_purchaseorder.supplier_obj = apm_supplier.supplier_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "apt_purchaseorder|apm_supplier":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.

















IF NOT NEW apt_purchaseorder AND apt_purchaseorder.{&TRIGGER_OBJ} <> o_apt_purchaseorder.{&TRIGGER_OBJ} THEN

    DO:

        ASSIGN lv-error = YES lv-errgrp = "AF":U lv-errnum = 13 lv-include = "table object number":U.

        RUN error-message (lv-errgrp,lv-errnum,lv-include).

    END.



/* Customisations to WRITE trigger */

{dynsports/trg/aptpotrigw.i}







/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'aptpo':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "WRITE":U, INPUT "aptpo":U, INPUT BUFFER apt_purchaseorder:HANDLE, INPUT BUFFER o_apt_purchaseorder:HANDLE).



/* Standard bottom of WRITE trigger code */

{af/sup/aftrigendw.i}







