TRIGGER PROCEDURE FOR CREATE OF apx_supplier_item .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   apx_supplier_item           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE apx_supplier_item

&SCOPED-DEFINE TRIGGER_FLA apxsi



&SCOPED-DEFINE TRIGGER_OBJ none



DEFINE BUFFER lb_table FOR apx_supplier_item.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR apx_supplier_item.     /* Used for lock upgrades */



DEFINE BUFFER o_apx_supplier_item FOR apx_supplier_item.



/* Standard top of CREATE trigger code */

{af/sup/aftrigtopc.i}



  







/* Generated by ICF ERwin Template */

/* apm_supplier supplies apx_supplier_item ON CHILD INSERT RESTRICT */

IF 

    ( apx_supplier_item.supplier_obj <> 0 ) THEN

  DO:

    IF NOT(CAN-FIND(FIRST apm_supplier WHERE

        apx_supplier_item.supplier_obj = apm_supplier.supplier_obj)) THEN

        DO:

          /* Cannot create child because parent does not exist ! */

          ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 102 lv-include = "apx_supplier_item|apm_supplier":U.

          RUN error-message (lv-errgrp, lv-errnum, lv-include).

        END.

    

    

  END.



/* Generated by ICF ERwin Template */

/* ivm_item is supplied by apx_supplier_item ON CHILD INSERT RESTRICT */

IF 

    ( apx_supplier_item.item_obj <> 0 ) THEN

  DO:

    IF NOT(CAN-FIND(FIRST ivm_item WHERE

        apx_supplier_item.item_obj = ivm_item.item_obj)) THEN

        DO:

          /* Cannot create child because parent does not exist ! */

          ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 102 lv-include = "apx_supplier_item|ivm_item":U.

          RUN error-message (lv-errgrp, lv-errnum, lv-include).

        END.

    

    

  END.































/* Standard bottom of CREATE trigger code */

{af/sup/aftrigendc.i}





/* Place any specific CREATE trigger customisations here */

