TRIGGER PROCEDURE FOR DELETE OF arm_customer .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   arm_customer           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE arm_customer

&SCOPED-DEFINE TRIGGER_FLA armcu

&SCOPED-DEFINE TRIGGER_OBJ customer_obj





DEFINE BUFFER lb_table FOR arm_customer.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR arm_customer.     /* Used for lock upgrades */



DEFINE BUFFER o_arm_customer FOR arm_customer.



/* Standard top of DELETE trigger code */

{af/sup/aftrigtopd.i}



  









/* Generated by ICF ERwin Template */

/* arm_customer has arx_customer_address ON PARENT DELETE CASCADE */

&IF DEFINED(lbe_customer_address) = 0 &THEN

  DEFINE BUFFER lbe_customer_address FOR arx_customer_address.

  &GLOBAL-DEFINE lbe_customer_address yes

&ENDIF

FOR EACH arx_customer_address NO-LOCK

   WHERE arx_customer_address.customer_obj = arm_customer.customer_obj

   ON STOP UNDO, RETURN ERROR "AF^104^armcutrigd.p^delete arx_customer_address":U:

    FIND FIRST lbe_customer_address EXCLUSIVE-LOCK

         WHERE ROWID(lbe_customer_address) = ROWID(arx_customer_address)

         NO-ERROR.

    IF AVAILABLE lbe_customer_address THEN

      DO:

        {af/sup/afvalidtrg.i &action = "DELETE" &table = "lbe_customer_address"}

      END.

END.











/* Generated by ICF ERwin Template */

/* arm_customer has art_refcall ON PARENT DELETE CASCADE */

&IF DEFINED(lbe_refcall) = 0 &THEN

  DEFINE BUFFER lbe_refcall FOR art_refcall.

  &GLOBAL-DEFINE lbe_refcall yes

&ENDIF

FOR EACH art_refcall NO-LOCK

   WHERE art_refcall.customer_obj = arm_customer.customer_obj

   ON STOP UNDO, RETURN ERROR "AF^104^armcutrigd.p^delete art_refcall":U:

    FIND FIRST lbe_refcall EXCLUSIVE-LOCK

         WHERE ROWID(lbe_refcall) = ROWID(art_refcall)

         NO-ERROR.

    IF AVAILABLE lbe_refcall THEN

      DO:

        {af/sup/afvalidtrg.i &action = "DELETE" &table = "lbe_refcall"}

      END.

END.











/* Generated by ICF ERwin Template */

/* arm_customer receives art_invoice ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST art_invoice WHERE

    art_invoice.customer_obj = arm_customer.customer_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "arm_customer|art_invoice":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.







/* Generated by ICF ERwin Template */

/* arm_customer has art_order ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST art_order WHERE

    art_order.customer_obj = arm_customer.customer_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "arm_customer|art_order":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.











/* Generic comments deletion */

DEFINE BUFFER lbx_gsm_comment FOR gsm_comment.

DEFINE BUFFER lby_gsm_comment FOR gsm_comment.

IF CAN-FIND(FIRST lbx_gsm_comment 

            WHERE lbx_gsm_comment.owning_obj = arm_customer.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_comment NO-LOCK

       WHERE lbx_gsm_comment.owning_obj = arm_customer.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^armcutrigd.p^delete gsm_comment":U:

        FIND FIRST lby_gsm_comment EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_comment) = ROWID(lbx_gsm_comment)

             NO-ERROR.

        IF AVAILABLE lby_gsm_comment THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_comment"}

          END.

    END.

/* Generic security allocation deletion */

DEFINE BUFFER lbx_gsm_user_allocation FOR gsm_user_allocation.

DEFINE BUFFER lby_gsm_user_allocation FOR gsm_user_allocation.

IF CAN-FIND(FIRST lbx_gsm_user_allocation 

            WHERE lbx_gsm_user_allocation.owning_obj = arm_customer.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_user_allocation NO-LOCK

       WHERE lbx_gsm_user_allocation.owning_obj = arm_customer.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^armcutrigd.p^delete gsm_user_allocation":U:

        FIND FIRST lby_gsm_user_allocation EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_user_allocation) = ROWID(lbx_gsm_user_allocation)

             NO-ERROR.

        IF AVAILABLE lby_gsm_user_allocation THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_user_allocation"}

          END.

    END.

/* Generic multi-media deletion */

DEFINE BUFFER lbx_gsm_multi_media FOR gsm_multi_media.

DEFINE BUFFER lby_gsm_multi_media FOR gsm_multi_media.

IF CAN-FIND(FIRST lbx_gsm_multi_media 

            WHERE lbx_gsm_multi_media.owning_obj = arm_customer.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_multi_media NO-LOCK

       WHERE lbx_gsm_multi_media.owning_obj = arm_customer.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^armcutrigd.p^delete gsm_multi_media":U:

        FIND FIRST lby_gsm_multi_media EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_multi_media) = ROWID(lbx_gsm_multi_media)

             NO-ERROR.

        IF AVAILABLE lby_gsm_multi_media THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_multi_media"}

          END.

    END.





















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'armcu':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "DELETE":U, INPUT "armcu":U, INPUT BUFFER arm_customer:HANDLE, INPUT BUFFER o_arm_customer:HANDLE).



/* Standard bottom of DELETE trigger code */

{af/sup/aftrigendd.i}





/* Place any specific DELETE trigger customisations here */

