TRIGGER PROCEDURE FOR WRITE OF arm_customer OLD BUFFER o_arm_customer.



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   arm_customer           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE arm_customer

&SCOPED-DEFINE TRIGGER_FLA armcu

&SCOPED-DEFINE TRIGGER_OBJ customer_obj





DEFINE BUFFER lb_table FOR arm_customer.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR arm_customer.     /* Used for lock upgrades */







/* Standard top of WRITE trigger code */

{af/sup/aftrigtopw.i}



/* properform fields if enabled for table */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'armcu':U

              AND gsc_entity_mnemonic.auto_properform_strings = YES) THEN

  RUN af/app/afpropfrmp.p (INPUT BUFFER arm_customer:HANDLE).

  







/* Generated by ICF ERwin Template */

/* arm_salesrep manages arm_customer ON CHILD UPDATE RESTRICT */

IF NEW arm_customer OR  arm_customer.salesrep_obj <> o_arm_customer.salesrep_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST arm_salesrep WHERE

        arm_customer.salesrep_obj = arm_salesrep.salesrep_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "arm_customer|arm_salesrep":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.

















IF NOT NEW arm_customer AND arm_customer.{&TRIGGER_OBJ} <> o_arm_customer.{&TRIGGER_OBJ} THEN

    DO:

        ASSIGN lv-error = YES lv-errgrp = "AF":U lv-errnum = 13 lv-include = "table object number":U.

        RUN error-message (lv-errgrp,lv-errnum,lv-include).

    END.



/* Customisations to WRITE trigger */

{dynsports/trg/armcutrigw.i}







/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'armcu':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "WRITE":U, INPUT "armcu":U, INPUT BUFFER arm_customer:HANDLE, INPUT BUFFER o_arm_customer:HANDLE).



/* Standard bottom of WRITE trigger code */

{af/sup/aftrigendw.i}







