TRIGGER PROCEDURE FOR DELETE OF arm_salesrep .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   arm_salesrep           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE arm_salesrep

&SCOPED-DEFINE TRIGGER_FLA armsr

&SCOPED-DEFINE TRIGGER_OBJ salesrep_obj





DEFINE BUFFER lb_table FOR arm_salesrep.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR arm_salesrep.     /* Used for lock upgrades */



DEFINE BUFFER o_arm_salesrep FOR arm_salesrep.



/* Standard top of DELETE trigger code */

{af/sup/aftrigtopd.i}



  









/* Generated by ICF ERwin Template */

/* arm_salesrep operates in arx_salesrep_region ON PARENT DELETE CASCADE */

&IF DEFINED(lbe_salesrep_region) = 0 &THEN

  DEFINE BUFFER lbe_salesrep_region FOR arx_salesrep_region.

  &GLOBAL-DEFINE lbe_salesrep_region yes

&ENDIF

FOR EACH arx_salesrep_region NO-LOCK

   WHERE arx_salesrep_region.salesrep_obj = arm_salesrep.salesrep_obj

   ON STOP UNDO, RETURN ERROR "AF^104^armsrtrigd.p^delete arx_salesrep_region":U:

    FIND FIRST lbe_salesrep_region EXCLUSIVE-LOCK

         WHERE ROWID(lbe_salesrep_region) = ROWID(arx_salesrep_region)

         NO-ERROR.

    IF AVAILABLE lbe_salesrep_region THEN

      DO:

        {af/sup/afvalidtrg.i &action = "DELETE" &table = "lbe_salesrep_region"}

      END.

END.











/* Generated by ICF ERwin Template */

/* arm_salesrep has art_refcall ON PARENT DELETE CASCADE */

&IF DEFINED(lbe_refcall) = 0 &THEN

  DEFINE BUFFER lbe_refcall FOR art_refcall.

  &GLOBAL-DEFINE lbe_refcall yes

&ENDIF

FOR EACH art_refcall NO-LOCK

   WHERE art_refcall.salesrep_obj = arm_salesrep.salesrep_obj

   ON STOP UNDO, RETURN ERROR "AF^104^armsrtrigd.p^delete art_refcall":U:

    FIND FIRST lbe_refcall EXCLUSIVE-LOCK

         WHERE ROWID(lbe_refcall) = ROWID(art_refcall)

         NO-ERROR.

    IF AVAILABLE lbe_refcall THEN

      DO:

        {af/sup/afvalidtrg.i &action = "DELETE" &table = "lbe_refcall"}

      END.

END.











/* Generated by ICF ERwin Template */

/* arm_salesrep has arm_monthly_quota ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST arm_monthly_quota WHERE

    arm_monthly_quota.salesrep_obj = arm_salesrep.salesrep_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "arm_salesrep|arm_monthly_quota":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.







/* Generated by ICF ERwin Template */

/* arm_salesrep manages arm_customer ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST arm_customer WHERE

    arm_customer.salesrep_obj = arm_salesrep.salesrep_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "arm_salesrep|arm_customer":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.







/* Generated by ICF ERwin Template */

/* arm_salesrep sold art_order ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST art_order WHERE

    art_order.salesrep_obj = arm_salesrep.salesrep_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "arm_salesrep|art_order":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.











/* Generic comments deletion */

DEFINE BUFFER lbx_gsm_comment FOR gsm_comment.

DEFINE BUFFER lby_gsm_comment FOR gsm_comment.

IF CAN-FIND(FIRST lbx_gsm_comment 

            WHERE lbx_gsm_comment.owning_obj = arm_salesrep.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_comment NO-LOCK

       WHERE lbx_gsm_comment.owning_obj = arm_salesrep.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^armsrtrigd.p^delete gsm_comment":U:

        FIND FIRST lby_gsm_comment EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_comment) = ROWID(lbx_gsm_comment)

             NO-ERROR.

        IF AVAILABLE lby_gsm_comment THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_comment"}

          END.

    END.

/* Generic security allocation deletion */

DEFINE BUFFER lbx_gsm_user_allocation FOR gsm_user_allocation.

DEFINE BUFFER lby_gsm_user_allocation FOR gsm_user_allocation.

IF CAN-FIND(FIRST lbx_gsm_user_allocation 

            WHERE lbx_gsm_user_allocation.owning_obj = arm_salesrep.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_user_allocation NO-LOCK

       WHERE lbx_gsm_user_allocation.owning_obj = arm_salesrep.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^armsrtrigd.p^delete gsm_user_allocation":U:

        FIND FIRST lby_gsm_user_allocation EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_user_allocation) = ROWID(lbx_gsm_user_allocation)

             NO-ERROR.

        IF AVAILABLE lby_gsm_user_allocation THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_user_allocation"}

          END.

    END.

/* Generic multi-media deletion */

DEFINE BUFFER lbx_gsm_multi_media FOR gsm_multi_media.

DEFINE BUFFER lby_gsm_multi_media FOR gsm_multi_media.

IF CAN-FIND(FIRST lbx_gsm_multi_media 

            WHERE lbx_gsm_multi_media.owning_obj = arm_salesrep.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_multi_media NO-LOCK

       WHERE lbx_gsm_multi_media.owning_obj = arm_salesrep.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^armsrtrigd.p^delete gsm_multi_media":U:

        FIND FIRST lby_gsm_multi_media EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_multi_media) = ROWID(lbx_gsm_multi_media)

             NO-ERROR.

        IF AVAILABLE lby_gsm_multi_media THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_multi_media"}

          END.

    END.





















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'armsr':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "DELETE":U, INPUT "armsr":U, INPUT BUFFER arm_salesrep:HANDLE, INPUT BUFFER o_arm_salesrep:HANDLE).



/* Standard bottom of DELETE trigger code */

{af/sup/aftrigendd.i}





/* Place any specific DELETE trigger customisations here */

