TRIGGER PROCEDURE FOR WRITE OF arm_salesrep OLD BUFFER o_arm_salesrep.



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   arm_salesrep           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE arm_salesrep

&SCOPED-DEFINE TRIGGER_FLA armsr

&SCOPED-DEFINE TRIGGER_OBJ salesrep_obj





DEFINE BUFFER lb_table FOR arm_salesrep.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR arm_salesrep.     /* Used for lock upgrades */







/* Standard top of WRITE trigger code */

{af/sup/aftrigtopw.i}



/* properform fields if enabled for table */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'armsr':U

              AND gsc_entity_mnemonic.auto_properform_strings = YES) THEN

  RUN af/app/afpropfrmp.p (INPUT BUFFER arm_salesrep:HANDLE).

  





















IF NOT NEW arm_salesrep AND arm_salesrep.{&TRIGGER_OBJ} <> o_arm_salesrep.{&TRIGGER_OBJ} THEN

    DO:

        ASSIGN lv-error = YES lv-errgrp = "AF":U lv-errnum = 13 lv-include = "table object number":U.

        RUN error-message (lv-errgrp,lv-errnum,lv-include).

    END.



/* Customisations to WRITE trigger */

{dynsports/trg/armsrtrigw.i}







/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'armsr':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "WRITE":U, INPUT "armsr":U, INPUT BUFFER arm_salesrep:HANDLE, INPUT BUFFER o_arm_salesrep:HANDLE).



/* Standard bottom of WRITE trigger code */

{af/sup/aftrigendw.i}







