TRIGGER PROCEDURE FOR WRITE OF art_invoice OLD BUFFER o_art_invoice.



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   art_invoice           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE art_invoice

&SCOPED-DEFINE TRIGGER_FLA artiv

&SCOPED-DEFINE TRIGGER_OBJ invoice_obj





DEFINE BUFFER lb_table FOR art_invoice.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR art_invoice.     /* Used for lock upgrades */







/* Standard top of WRITE trigger code */

{af/sup/aftrigtopw.i}



/* properform fields if enabled for table */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'artiv':U

              AND gsc_entity_mnemonic.auto_properform_strings = YES) THEN

  RUN af/app/afpropfrmp.p (INPUT BUFFER art_invoice:HANDLE).

  







/* Generated by ICF ERwin Template */

/* art_order invoices art_invoice ON CHILD UPDATE RESTRICT */

IF NEW art_invoice OR  art_invoice.order_obj <> o_art_invoice.order_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST art_order WHERE

        art_invoice.order_obj = art_order.order_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "art_invoice|art_order":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.



/* Generated by ICF ERwin Template */

/* arm_customer receives art_invoice ON CHILD UPDATE RESTRICT */

IF NEW art_invoice OR  art_invoice.customer_obj <> o_art_invoice.customer_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST arm_customer WHERE

        art_invoice.customer_obj = arm_customer.customer_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "art_invoice|arm_customer":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.

















IF NOT NEW art_invoice AND art_invoice.{&TRIGGER_OBJ} <> o_art_invoice.{&TRIGGER_OBJ} THEN

    DO:

        ASSIGN lv-error = YES lv-errgrp = "AF":U lv-errnum = 13 lv-include = "table object number":U.

        RUN error-message (lv-errgrp,lv-errnum,lv-include).

    END.



/* Customisations to WRITE trigger */

{dynsports/trg/artivtrigw.i}







/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'artiv':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "WRITE":U, INPUT "artiv":U, INPUT BUFFER art_invoice:HANDLE, INPUT BUFFER o_art_invoice:HANDLE).



/* Standard bottom of WRITE trigger code */

{af/sup/aftrigendw.i}







