TRIGGER PROCEDURE FOR WRITE OF art_orderline OLD BUFFER o_art_orderline.



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   art_orderline           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE art_orderline

&SCOPED-DEFINE TRIGGER_FLA artol

&SCOPED-DEFINE TRIGGER_OBJ orderline_obj





DEFINE BUFFER lb_table FOR art_orderline.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR art_orderline.     /* Used for lock upgrades */







/* Standard top of WRITE trigger code */

{af/sup/aftrigtopw.i}



/* properform fields if enabled for table */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'artol':U

              AND gsc_entity_mnemonic.auto_properform_strings = YES) THEN

  RUN af/app/afpropfrmp.p (INPUT BUFFER art_orderline:HANDLE).

  







/* Generated by ICF ERwin Template */

/* gem_status defines status for art_orderline ON CHILD UPDATE SET NULL */

IF NEW art_orderline OR  art_orderline.status_obj <> o_art_orderline.status_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST gem_status WHERE

        art_orderline.status_obj = gem_status.status_obj)) THEN DO:

        

        ASSIGN art_orderline.status_obj = 0 .

    END.

    

    

  END.



/* Generated by ICF ERwin Template */

/* ivm_item is inserted into art_orderline ON CHILD UPDATE RESTRICT */

IF NEW art_orderline OR  art_orderline.item_obj <> o_art_orderline.item_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST ivm_item WHERE

        art_orderline.item_obj = ivm_item.item_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "art_orderline|ivm_item":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.



/* Generated by ICF ERwin Template */

/* art_order contains art_orderline ON CHILD UPDATE RESTRICT */

IF NEW art_orderline OR  art_orderline.order_obj <> o_art_orderline.order_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST art_order WHERE

        art_orderline.order_obj = art_order.order_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "art_orderline|art_order":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.

















IF NOT NEW art_orderline AND art_orderline.{&TRIGGER_OBJ} <> o_art_orderline.{&TRIGGER_OBJ} THEN

    DO:

        ASSIGN lv-error = YES lv-errgrp = "AF":U lv-errnum = 13 lv-include = "table object number":U.

        RUN error-message (lv-errgrp,lv-errnum,lv-include).

    END.



/* Customisations to WRITE trigger */

{dynsports/trg/artoltrigw.i}







/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'artol':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "WRITE":U, INPUT "artol":U, INPUT BUFFER art_orderline:HANDLE, INPUT BUFFER o_art_orderline:HANDLE).



/* Standard bottom of WRITE trigger code */

{af/sup/aftrigendw.i}







