TRIGGER PROCEDURE FOR CREATE OF art_order .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   art_order           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE art_order

&SCOPED-DEFINE TRIGGER_FLA artor

&SCOPED-DEFINE TRIGGER_OBJ order_obj





DEFINE BUFFER lb_table FOR art_order.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR art_order.     /* Used for lock upgrades */



DEFINE BUFFER o_art_order FOR art_order.



/* Standard top of CREATE trigger code */

{af/sup/aftrigtopc.i}



  







/* Generated by ICF ERwin Template */

/* gem_status defines status for art_order ON CHILD INSERT SET NULL */

IF NOT(CAN-FIND(FIRST gem_status WHERE

    art_order.status_obj = gem_status.status_obj)) THEN

  DO:

    

    ASSIGN art_order.status_obj = 0 .

  END.







/* Generated by ICF ERwin Template */

/* ivm_warehouse processes art_order ON CHILD INSERT RESTRICT */

IF 

    ( art_order.warehouse_obj <> 0 ) THEN

  DO:

    IF NOT(CAN-FIND(FIRST ivm_warehouse WHERE

        art_order.warehouse_obj = ivm_warehouse.warehouse_obj)) THEN

        DO:

          /* Cannot create child because parent does not exist ! */

          ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 102 lv-include = "art_order|ivm_warehouse":U.

          RUN error-message (lv-errgrp, lv-errnum, lv-include).

        END.

    

    

  END.



/* Generated by ICF ERwin Template */

/* arm_customer has art_order ON CHILD INSERT RESTRICT */

IF 

    ( art_order.customer_obj <> 0 ) THEN

  DO:

    IF NOT(CAN-FIND(FIRST arm_customer WHERE

        art_order.customer_obj = arm_customer.customer_obj)) THEN

        DO:

          /* Cannot create child because parent does not exist ! */

          ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 102 lv-include = "art_order|arm_customer":U.

          RUN error-message (lv-errgrp, lv-errnum, lv-include).

        END.

    

    

  END.













ASSIGN art_order.{&TRIGGER_OBJ} = getNextObj().















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'artor':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "CREATE":U, INPUT "artor":U, INPUT BUFFER art_order:HANDLE, INPUT BUFFER o_art_order:HANDLE).



/* Standard bottom of CREATE trigger code */

{af/sup/aftrigendc.i}





/* Place any specific CREATE trigger customisations here */

