TRIGGER PROCEDURE FOR DELETE OF art_order .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   art_order           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE art_order

&SCOPED-DEFINE TRIGGER_FLA artor

&SCOPED-DEFINE TRIGGER_OBJ order_obj





DEFINE BUFFER lb_table FOR art_order.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR art_order.     /* Used for lock upgrades */



DEFINE BUFFER o_art_order FOR art_order.



/* Standard top of DELETE trigger code */

{af/sup/aftrigtopd.i}



  









/* Generated by ICF ERwin Template */

/* art_order has arx_order_address ON PARENT DELETE CASCADE */

&IF DEFINED(lbe_order_address) = 0 &THEN

  DEFINE BUFFER lbe_order_address FOR arx_order_address.

  &GLOBAL-DEFINE lbe_order_address yes

&ENDIF

FOR EACH arx_order_address NO-LOCK

   WHERE arx_order_address.order_obj = art_order.order_obj

   ON STOP UNDO, RETURN ERROR "AF^104^artortrigd.p^delete arx_order_address":U:

    FIND FIRST lbe_order_address EXCLUSIVE-LOCK

         WHERE ROWID(lbe_order_address) = ROWID(arx_order_address)

         NO-ERROR.

    IF AVAILABLE lbe_order_address THEN

      DO:

        {af/sup/afvalidtrg.i &action = "DELETE" &table = "lbe_order_address"}

      END.

END.











/* Generated by ICF ERwin Template */

/* art_order influences ivt_inventorytrans ON PARENT DELETE SET NULL */



&IF DEFINED(lbe_inventorytrans) = 0 &THEN

  DEFINE BUFFER lbe_inventorytrans FOR ivt_inventorytrans.

  &GLOBAL-DEFINE lbe_inventorytrans yes

&ENDIF

FOR EACH ivt_inventorytrans NO-LOCK

   WHERE ivt_inventorytrans.order_obj = art_order.order_obj

   ON STOP UNDO, RETURN ERROR "AF^104^artortrigd.p^update ivt_inventorytrans":U:

    FIND FIRST lbe_inventorytrans EXCLUSIVE-LOCK

         WHERE ROWID(lbe_inventorytrans) = ROWID(ivt_inventorytrans)

         NO-ERROR.

    IF AVAILABLE lbe_inventorytrans THEN

      DO:

        

        ASSIGN lbe_inventorytrans.order_obj = 0 .

      END.

END.







/* Generated by ICF ERwin Template */

/* art_order contains art_orderline ON PARENT DELETE CASCADE */

&IF DEFINED(lbe_orderline) = 0 &THEN

  DEFINE BUFFER lbe_orderline FOR art_orderline.

  &GLOBAL-DEFINE lbe_orderline yes

&ENDIF

FOR EACH art_orderline NO-LOCK

   WHERE art_orderline.order_obj = art_order.order_obj

   ON STOP UNDO, RETURN ERROR "AF^104^artortrigd.p^delete art_orderline":U:

    FIND FIRST lbe_orderline EXCLUSIVE-LOCK

         WHERE ROWID(lbe_orderline) = ROWID(art_orderline)

         NO-ERROR.

    IF AVAILABLE lbe_orderline THEN

      DO:

        {af/sup/afvalidtrg.i &action = "DELETE" &table = "lbe_orderline"}

      END.

END.















/* Generic comments deletion */

DEFINE BUFFER lbx_gsm_comment FOR gsm_comment.

DEFINE BUFFER lby_gsm_comment FOR gsm_comment.

IF CAN-FIND(FIRST lbx_gsm_comment 

            WHERE lbx_gsm_comment.owning_obj = art_order.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_comment NO-LOCK

       WHERE lbx_gsm_comment.owning_obj = art_order.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^artortrigd.p^delete gsm_comment":U:

        FIND FIRST lby_gsm_comment EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_comment) = ROWID(lbx_gsm_comment)

             NO-ERROR.

        IF AVAILABLE lby_gsm_comment THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_comment"}

          END.

    END.

/* Generic security allocation deletion */

DEFINE BUFFER lbx_gsm_user_allocation FOR gsm_user_allocation.

DEFINE BUFFER lby_gsm_user_allocation FOR gsm_user_allocation.

IF CAN-FIND(FIRST lbx_gsm_user_allocation 

            WHERE lbx_gsm_user_allocation.owning_obj = art_order.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_user_allocation NO-LOCK

       WHERE lbx_gsm_user_allocation.owning_obj = art_order.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^artortrigd.p^delete gsm_user_allocation":U:

        FIND FIRST lby_gsm_user_allocation EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_user_allocation) = ROWID(lbx_gsm_user_allocation)

             NO-ERROR.

        IF AVAILABLE lby_gsm_user_allocation THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_user_allocation"}

          END.

    END.

/* Generic multi-media deletion */

DEFINE BUFFER lbx_gsm_multi_media FOR gsm_multi_media.

DEFINE BUFFER lby_gsm_multi_media FOR gsm_multi_media.

IF CAN-FIND(FIRST lbx_gsm_multi_media 

            WHERE lbx_gsm_multi_media.owning_obj = art_order.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_multi_media NO-LOCK

       WHERE lbx_gsm_multi_media.owning_obj = art_order.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^artortrigd.p^delete gsm_multi_media":U:

        FIND FIRST lby_gsm_multi_media EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_multi_media) = ROWID(lbx_gsm_multi_media)

             NO-ERROR.

        IF AVAILABLE lby_gsm_multi_media THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_multi_media"}

          END.

    END.





















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'artor':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "DELETE":U, INPUT "artor":U, INPUT BUFFER art_order:HANDLE, INPUT BUFFER o_art_order:HANDLE).



/* Standard bottom of DELETE trigger code */

{af/sup/aftrigendd.i}





/* Place any specific DELETE trigger customisations here */

