TRIGGER PROCEDURE FOR WRITE OF art_refcall OLD BUFFER o_art_refcall.



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   art_refcall           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE art_refcall

&SCOPED-DEFINE TRIGGER_FLA artrc

&SCOPED-DEFINE TRIGGER_OBJ refcall_obj





DEFINE BUFFER lb_table FOR art_refcall.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR art_refcall.     /* Used for lock upgrades */







/* Standard top of WRITE trigger code */

{af/sup/aftrigtopw.i}



/* properform fields if enabled for table */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'artrc':U

              AND gsc_entity_mnemonic.auto_properform_strings = YES) THEN

  RUN af/app/afpropfrmp.p (INPUT BUFFER art_refcall:HANDLE).

  







/* Generated by ICF ERwin Template */

/* art_refcall provides data for art_refcall ON CHILD UPDATE SET NULL */

IF NEW art_refcall OR  art_refcall.refcall_parent_obj <> o_art_refcall.refcall_parent_obj  THEN

  DO:

    

    IF NOT(CAN-FIND(FIRST lb_table WHERE

        art_refcall.refcall_parent_obj = lb_table.refcall_obj)) THEN DO:

        

        ASSIGN art_refcall.refcall_parent_obj = 0 .

    END.

    

  END.



/* Generated by ICF ERwin Template */

/* arm_salesrep has art_refcall ON CHILD UPDATE RESTRICT */

IF NEW art_refcall OR  art_refcall.salesrep_obj <> o_art_refcall.salesrep_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST arm_salesrep WHERE

        art_refcall.salesrep_obj = arm_salesrep.salesrep_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "art_refcall|arm_salesrep":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.



/* Generated by ICF ERwin Template */

/* arm_customer has art_refcall ON CHILD UPDATE RESTRICT */

IF NEW art_refcall OR  art_refcall.customer_obj <> o_art_refcall.customer_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST arm_customer WHERE

        art_refcall.customer_obj = arm_customer.customer_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "art_refcall|arm_customer":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.

















IF NOT NEW art_refcall AND art_refcall.{&TRIGGER_OBJ} <> o_art_refcall.{&TRIGGER_OBJ} THEN

    DO:

        ASSIGN lv-error = YES lv-errgrp = "AF":U lv-errnum = 13 lv-include = "table object number":U.

        RUN error-message (lv-errgrp,lv-errnum,lv-include).

    END.



/* Customisations to WRITE trigger */

{dynsports/trg/artrctrigw.i}







/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'artrc':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "WRITE":U, INPUT "artrc":U, INPUT BUFFER art_refcall:HANDLE, INPUT BUFFER o_art_refcall:HANDLE).



/* Standard bottom of WRITE trigger code */

{af/sup/aftrigendw.i}







