TRIGGER PROCEDURE FOR WRITE OF arx_order_address OLD BUFFER o_arx_order_address.



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   arx_order_address           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE arx_order_address

&SCOPED-DEFINE TRIGGER_FLA arxoa



&SCOPED-DEFINE TRIGGER_OBJ none



DEFINE BUFFER lb_table FOR arx_order_address.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR arx_order_address.     /* Used for lock upgrades */







/* Standard top of WRITE trigger code */

{af/sup/aftrigtopw.i}



/* properform fields if enabled for table */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'arxoa':U

              AND gsc_entity_mnemonic.auto_properform_strings = YES) THEN

  RUN af/app/afpropfrmp.p (INPUT BUFFER arx_order_address:HANDLE).

  







/* Generated by ICF ERwin Template */

/* gec_address_type defines type for arx_order_address ON CHILD UPDATE RESTRICT */

IF NEW arx_order_address OR  arx_order_address.address_type_obj <> o_arx_order_address.address_type_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST gec_address_type WHERE

        arx_order_address.address_type_obj = gec_address_type.address_type_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "arx_order_address|gec_address_type":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.



/* Generated by ICF ERwin Template */

/* gem_address is used by arx_order_address ON CHILD UPDATE RESTRICT */

IF NEW arx_order_address OR  arx_order_address.address_obj <> o_arx_order_address.address_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST gem_address WHERE

        arx_order_address.address_obj = gem_address.address_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "arx_order_address|gem_address":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.



/* Generated by ICF ERwin Template */

/* art_order has arx_order_address ON CHILD UPDATE RESTRICT */

IF NEW arx_order_address OR  arx_order_address.order_obj <> o_arx_order_address.order_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST art_order WHERE

        arx_order_address.order_obj = art_order.order_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "arx_order_address|art_order":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.



















/* Customisations to WRITE trigger */

{dynsports/trg/arxoatrigw.i}











/* Standard bottom of WRITE trigger code */

{af/sup/aftrigendw.i}







