TRIGGER PROCEDURE FOR WRITE OF arx_salesrep_region OLD BUFFER o_arx_salesrep_region.



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   arx_salesrep_region           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE arx_salesrep_region

&SCOPED-DEFINE TRIGGER_FLA arxsr



&SCOPED-DEFINE TRIGGER_OBJ none



DEFINE BUFFER lb_table FOR arx_salesrep_region.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR arx_salesrep_region.     /* Used for lock upgrades */







/* Standard top of WRITE trigger code */

{af/sup/aftrigtopw.i}



/* properform fields if enabled for table */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'arxsr':U

              AND gsc_entity_mnemonic.auto_properform_strings = YES) THEN

  RUN af/app/afpropfrmp.p (INPUT BUFFER arx_salesrep_region:HANDLE).

  







/* Generated by ICF ERwin Template */

/* gem_region is covered by arx_salesrep_region ON CHILD UPDATE RESTRICT */

IF NEW arx_salesrep_region OR  arx_salesrep_region.region_obj <> o_arx_salesrep_region.region_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST gem_region WHERE

        arx_salesrep_region.region_obj = gem_region.region_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "arx_salesrep_region|gem_region":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.



/* Generated by ICF ERwin Template */

/* arm_salesrep operates in arx_salesrep_region ON CHILD UPDATE RESTRICT */

IF NEW arx_salesrep_region OR  arx_salesrep_region.salesrep_obj <> o_arx_salesrep_region.salesrep_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST arm_salesrep WHERE

        arx_salesrep_region.salesrep_obj = arm_salesrep.salesrep_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "arx_salesrep_region|arm_salesrep":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.



















/* Customisations to WRITE trigger */

{dynsports/trg/arxsrtrigw.i}











/* Standard bottom of WRITE trigger code */

{af/sup/aftrigendw.i}







