TRIGGER PROCEDURE FOR WRITE OF gec_address_type OLD BUFFER o_gec_address_type.



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   gec_address_type           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE gec_address_type

&SCOPED-DEFINE TRIGGER_FLA gecat

&SCOPED-DEFINE TRIGGER_OBJ address_type_obj





DEFINE BUFFER lb_table FOR gec_address_type.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR gec_address_type.     /* Used for lock upgrades */







/* Standard top of WRITE trigger code */

{af/sup/aftrigtopw.i}



/* properform fields if enabled for table */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'gecat':U

              AND gsc_entity_mnemonic.auto_properform_strings = YES) THEN

  RUN af/app/afpropfrmp.p (INPUT BUFFER gec_address_type:HANDLE).

  





















IF NOT NEW gec_address_type AND gec_address_type.{&TRIGGER_OBJ} <> o_gec_address_type.{&TRIGGER_OBJ} THEN

    DO:

        ASSIGN lv-error = YES lv-errgrp = "AF":U lv-errnum = 13 lv-include = "table object number":U.

        RUN error-message (lv-errgrp,lv-errnum,lv-include).

    END.



/* Customisations to WRITE trigger */

{dynsports/trg/gecattrigw.i}







/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'gecat':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "WRITE":U, INPUT "gecat":U, INPUT BUFFER gec_address_type:HANDLE, INPUT BUFFER o_gec_address_type:HANDLE).



/* Standard bottom of WRITE trigger code */

{af/sup/aftrigendw.i}







