TRIGGER PROCEDURE FOR DELETE OF gem_address .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   gem_address           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE gem_address

&SCOPED-DEFINE TRIGGER_FLA gemad

&SCOPED-DEFINE TRIGGER_OBJ address_obj





DEFINE BUFFER lb_table FOR gem_address.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR gem_address.     /* Used for lock upgrades */



DEFINE BUFFER o_gem_address FOR gem_address.



/* Standard top of DELETE trigger code */

{af/sup/aftrigtopd.i}



  









/* Generated by ICF ERwin Template */

/* gem_address is used by hrx_employee_address ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST hrx_employee_address WHERE

    hrx_employee_address.address_obj = gem_address.address_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "gem_address|hrx_employee_address":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.







/* Generated by ICF ERwin Template */

/* gem_address is used by arx_order_address ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST arx_order_address WHERE

    arx_order_address.address_obj = gem_address.address_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "gem_address|arx_order_address":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.







/* Generated by ICF ERwin Template */

/* gem_address is used by apx_supplier_address ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST apx_supplier_address WHERE

    apx_supplier_address.address_obj = gem_address.address_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "gem_address|apx_supplier_address":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.







/* Generated by ICF ERwin Template */

/* gem_address is used by ivx_warehouse_address ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST ivx_warehouse_address WHERE

    ivx_warehouse_address.address_obj = gem_address.address_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "gem_address|ivx_warehouse_address":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.







/* Generated by ICF ERwin Template */

/* gem_address is used by arx_customer_address ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST arx_customer_address WHERE

    arx_customer_address.address_obj = gem_address.address_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "gem_address|arx_customer_address":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.











/* Generic comments deletion */

DEFINE BUFFER lbx_gsm_comment FOR gsm_comment.

DEFINE BUFFER lby_gsm_comment FOR gsm_comment.

IF CAN-FIND(FIRST lbx_gsm_comment 

            WHERE lbx_gsm_comment.owning_obj = gem_address.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_comment NO-LOCK

       WHERE lbx_gsm_comment.owning_obj = gem_address.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^gemadtrigd.p^delete gsm_comment":U:

        FIND FIRST lby_gsm_comment EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_comment) = ROWID(lbx_gsm_comment)

             NO-ERROR.

        IF AVAILABLE lby_gsm_comment THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_comment"}

          END.

    END.

/* Generic security allocation deletion */

DEFINE BUFFER lbx_gsm_user_allocation FOR gsm_user_allocation.

DEFINE BUFFER lby_gsm_user_allocation FOR gsm_user_allocation.

IF CAN-FIND(FIRST lbx_gsm_user_allocation 

            WHERE lbx_gsm_user_allocation.owning_obj = gem_address.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_user_allocation NO-LOCK

       WHERE lbx_gsm_user_allocation.owning_obj = gem_address.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^gemadtrigd.p^delete gsm_user_allocation":U:

        FIND FIRST lby_gsm_user_allocation EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_user_allocation) = ROWID(lbx_gsm_user_allocation)

             NO-ERROR.

        IF AVAILABLE lby_gsm_user_allocation THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_user_allocation"}

          END.

    END.

/* Generic multi-media deletion */

DEFINE BUFFER lbx_gsm_multi_media FOR gsm_multi_media.

DEFINE BUFFER lby_gsm_multi_media FOR gsm_multi_media.

IF CAN-FIND(FIRST lbx_gsm_multi_media 

            WHERE lbx_gsm_multi_media.owning_obj = gem_address.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_multi_media NO-LOCK

       WHERE lbx_gsm_multi_media.owning_obj = gem_address.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^gemadtrigd.p^delete gsm_multi_media":U:

        FIND FIRST lby_gsm_multi_media EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_multi_media) = ROWID(lbx_gsm_multi_media)

             NO-ERROR.

        IF AVAILABLE lby_gsm_multi_media THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_multi_media"}

          END.

    END.





















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'gemad':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "DELETE":U, INPUT "gemad":U, INPUT BUFFER gem_address:HANDLE, INPUT BUFFER o_gem_address:HANDLE).



/* Standard bottom of DELETE trigger code */

{af/sup/aftrigendd.i}





/* Place any specific DELETE trigger customisations here */

