TRIGGER PROCEDURE FOR WRITE OF gem_address OLD BUFFER o_gem_address.



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   gem_address           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE gem_address

&SCOPED-DEFINE TRIGGER_FLA gemad

&SCOPED-DEFINE TRIGGER_OBJ address_obj





DEFINE BUFFER lb_table FOR gem_address.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR gem_address.     /* Used for lock upgrades */







/* Standard top of WRITE trigger code */

{af/sup/aftrigtopw.i}



/* properform fields if enabled for table */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'gemad':U

              AND gsc_entity_mnemonic.auto_properform_strings = YES) THEN

  RUN af/app/afpropfrmp.p (INPUT BUFFER gem_address:HANDLE).

  







/* Generated by ICF ERwin Template */

/* gem_state contains gem_address ON CHILD UPDATE SET NULL */

IF NEW gem_address OR  gem_address.state_obj <> o_gem_address.state_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST gem_state WHERE

        gem_address.state_obj = gem_state.state_obj)) THEN DO:

        

        ASSIGN gem_address.state_obj = 0 .

    END.

    

    

  END.

















IF NOT NEW gem_address AND gem_address.{&TRIGGER_OBJ} <> o_gem_address.{&TRIGGER_OBJ} THEN

    DO:

        ASSIGN lv-error = YES lv-errgrp = "AF":U lv-errnum = 13 lv-include = "table object number":U.

        RUN error-message (lv-errgrp,lv-errnum,lv-include).

    END.



/* Customisations to WRITE trigger */

{dynsports/trg/gemadtrigw.i}







/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'gemad':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "WRITE":U, INPUT "gemad":U, INPUT BUFFER gem_address:HANDLE, INPUT BUFFER o_gem_address:HANDLE).



/* Standard bottom of WRITE trigger code */

{af/sup/aftrigendw.i}







