TRIGGER PROCEDURE FOR CREATE OF gem_state .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   gem_state           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE gem_state

&SCOPED-DEFINE TRIGGER_FLA gemsa

&SCOPED-DEFINE TRIGGER_OBJ state_obj





DEFINE BUFFER lb_table FOR gem_state.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR gem_state.     /* Used for lock upgrades */



DEFINE BUFFER o_gem_state FOR gem_state.



/* Standard top of CREATE trigger code */

{af/sup/aftrigtopc.i}



  







/* Generated by ICF ERwin Template */

/* gem_region defines region for gem_state ON CHILD INSERT RESTRICT */

IF 

    ( gem_state.region_obj <> 0 ) THEN

  DO:

    IF NOT(CAN-FIND(FIRST gem_region WHERE

        gem_state.region_obj = gem_region.region_obj)) THEN

        DO:

          /* Cannot create child because parent does not exist ! */

          ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 102 lv-include = "gem_state|gem_region":U.

          RUN error-message (lv-errgrp, lv-errnum, lv-include).

        END.

    

    

  END.













ASSIGN gem_state.{&TRIGGER_OBJ} = getNextObj().















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'gemsa':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "CREATE":U, INPUT "gemsa":U, INPUT BUFFER gem_state:HANDLE, INPUT BUFFER o_gem_state:HANDLE).



/* Standard bottom of CREATE trigger code */

{af/sup/aftrigendc.i}





/* Place any specific CREATE trigger customisations here */

