TRIGGER PROCEDURE FOR DELETE OF gem_state .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   gem_state           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE gem_state

&SCOPED-DEFINE TRIGGER_FLA gemsa

&SCOPED-DEFINE TRIGGER_OBJ state_obj





DEFINE BUFFER lb_table FOR gem_state.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR gem_state.     /* Used for lock upgrades */



DEFINE BUFFER o_gem_state FOR gem_state.



/* Standard top of DELETE trigger code */

{af/sup/aftrigtopd.i}



  









/* Generated by ICF ERwin Template */

/* gem_state contains gem_address ON PARENT DELETE SET NULL */



&IF DEFINED(lbe_address) = 0 &THEN

  DEFINE BUFFER lbe_address FOR gem_address.

  &GLOBAL-DEFINE lbe_address yes

&ENDIF

FOR EACH gem_address NO-LOCK

   WHERE gem_address.state_obj = gem_state.state_obj

   ON STOP UNDO, RETURN ERROR "AF^104^gemsatrigd.p^update gem_address":U:

    FIND FIRST lbe_address EXCLUSIVE-LOCK

         WHERE ROWID(lbe_address) = ROWID(gem_address)

         NO-ERROR.

    IF AVAILABLE lbe_address THEN

      DO:

        

        ASSIGN lbe_address.state_obj = 0 .

      END.

END.











/* Generic comments deletion */

DEFINE BUFFER lbx_gsm_comment FOR gsm_comment.

DEFINE BUFFER lby_gsm_comment FOR gsm_comment.

IF CAN-FIND(FIRST lbx_gsm_comment 

            WHERE lbx_gsm_comment.owning_obj = gem_state.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_comment NO-LOCK

       WHERE lbx_gsm_comment.owning_obj = gem_state.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^gemsatrigd.p^delete gsm_comment":U:

        FIND FIRST lby_gsm_comment EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_comment) = ROWID(lbx_gsm_comment)

             NO-ERROR.

        IF AVAILABLE lby_gsm_comment THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_comment"}

          END.

    END.

/* Generic security allocation deletion */

DEFINE BUFFER lbx_gsm_user_allocation FOR gsm_user_allocation.

DEFINE BUFFER lby_gsm_user_allocation FOR gsm_user_allocation.

IF CAN-FIND(FIRST lbx_gsm_user_allocation 

            WHERE lbx_gsm_user_allocation.owning_obj = gem_state.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_user_allocation NO-LOCK

       WHERE lbx_gsm_user_allocation.owning_obj = gem_state.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^gemsatrigd.p^delete gsm_user_allocation":U:

        FIND FIRST lby_gsm_user_allocation EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_user_allocation) = ROWID(lbx_gsm_user_allocation)

             NO-ERROR.

        IF AVAILABLE lby_gsm_user_allocation THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_user_allocation"}

          END.

    END.

/* Generic multi-media deletion */

DEFINE BUFFER lbx_gsm_multi_media FOR gsm_multi_media.

DEFINE BUFFER lby_gsm_multi_media FOR gsm_multi_media.

IF CAN-FIND(FIRST lbx_gsm_multi_media 

            WHERE lbx_gsm_multi_media.owning_obj = gem_state.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_multi_media NO-LOCK

       WHERE lbx_gsm_multi_media.owning_obj = gem_state.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^gemsatrigd.p^delete gsm_multi_media":U:

        FIND FIRST lby_gsm_multi_media EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_multi_media) = ROWID(lbx_gsm_multi_media)

             NO-ERROR.

        IF AVAILABLE lby_gsm_multi_media THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_multi_media"}

          END.

    END.





















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'gemsa':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "DELETE":U, INPUT "gemsa":U, INPUT BUFFER gem_state:HANDLE, INPUT BUFFER o_gem_state:HANDLE).



/* Standard bottom of DELETE trigger code */

{af/sup/aftrigendd.i}





/* Place any specific DELETE trigger customisations here */

