TRIGGER PROCEDURE FOR DELETE OF gem_status .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   gem_status           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE gem_status

&SCOPED-DEFINE TRIGGER_FLA gemst

&SCOPED-DEFINE TRIGGER_OBJ status_obj





DEFINE BUFFER lb_table FOR gem_status.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR gem_status.     /* Used for lock upgrades */



DEFINE BUFFER o_gem_status FOR gem_status.



/* Standard top of DELETE trigger code */

{af/sup/aftrigtopd.i}



  









/* Generated by ICF ERwin Template */

/* gem_status defines status for art_order ON PARENT DELETE SET NULL */



&IF DEFINED(lbe_order) = 0 &THEN

  DEFINE BUFFER lbe_order FOR art_order.

  &GLOBAL-DEFINE lbe_order yes

&ENDIF

FOR EACH art_order NO-LOCK

   WHERE art_order.status_obj = gem_status.status_obj

   ON STOP UNDO, RETURN ERROR "AF^104^gemsttrigd.p^update art_order":U:

    FIND FIRST lbe_order EXCLUSIVE-LOCK

         WHERE ROWID(lbe_order) = ROWID(art_order)

         NO-ERROR.

    IF AVAILABLE lbe_order THEN

      DO:

        

        ASSIGN lbe_order.status_obj = 0 .

      END.

END.







/* Generated by ICF ERwin Template */

/* gem_status defines status for art_orderline ON PARENT DELETE SET NULL */



&IF DEFINED(lbe_orderline) = 0 &THEN

  DEFINE BUFFER lbe_orderline FOR art_orderline.

  &GLOBAL-DEFINE lbe_orderline yes

&ENDIF

FOR EACH art_orderline NO-LOCK

   WHERE art_orderline.status_obj = gem_status.status_obj

   ON STOP UNDO, RETURN ERROR "AF^104^gemsttrigd.p^update art_orderline":U:

    FIND FIRST lbe_orderline EXCLUSIVE-LOCK

         WHERE ROWID(lbe_orderline) = ROWID(art_orderline)

         NO-ERROR.

    IF AVAILABLE lbe_orderline THEN

      DO:

        

        ASSIGN lbe_orderline.status_obj = 0 .

      END.

END.







/* Generated by ICF ERwin Template */

/* gem_status defines status for apt_purchaseorder ON PARENT DELETE SET NULL */



&IF DEFINED(lbe_purchaseorder) = 0 &THEN

  DEFINE BUFFER lbe_purchaseorder FOR apt_purchaseorder.

  &GLOBAL-DEFINE lbe_purchaseorder yes

&ENDIF

FOR EACH apt_purchaseorder NO-LOCK

   WHERE apt_purchaseorder.status_obj = gem_status.status_obj

   ON STOP UNDO, RETURN ERROR "AF^104^gemsttrigd.p^update apt_purchaseorder":U:

    FIND FIRST lbe_purchaseorder EXCLUSIVE-LOCK

         WHERE ROWID(lbe_purchaseorder) = ROWID(apt_purchaseorder)

         NO-ERROR.

    IF AVAILABLE lbe_purchaseorder THEN

      DO:

        

        ASSIGN lbe_purchaseorder.status_obj = 0 .

      END.

END.







/* Generated by ICF ERwin Template */

/* gem_status defines status for apt_poline ON PARENT DELETE SET NULL */



&IF DEFINED(lbe_poline) = 0 &THEN

  DEFINE BUFFER lbe_poline FOR apt_poline.

  &GLOBAL-DEFINE lbe_poline yes

&ENDIF

FOR EACH apt_poline NO-LOCK

   WHERE apt_poline.status_obj = gem_status.status_obj

   ON STOP UNDO, RETURN ERROR "AF^104^gemsttrigd.p^update apt_poline":U:

    FIND FIRST lbe_poline EXCLUSIVE-LOCK

         WHERE ROWID(lbe_poline) = ROWID(apt_poline)

         NO-ERROR.

    IF AVAILABLE lbe_poline THEN

      DO:

        

        ASSIGN lbe_poline.status_obj = 0 .

      END.

END.











/* Generic comments deletion */

DEFINE BUFFER lbx_gsm_comment FOR gsm_comment.

DEFINE BUFFER lby_gsm_comment FOR gsm_comment.

IF CAN-FIND(FIRST lbx_gsm_comment 

            WHERE lbx_gsm_comment.owning_obj = gem_status.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_comment NO-LOCK

       WHERE lbx_gsm_comment.owning_obj = gem_status.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^gemsttrigd.p^delete gsm_comment":U:

        FIND FIRST lby_gsm_comment EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_comment) = ROWID(lbx_gsm_comment)

             NO-ERROR.

        IF AVAILABLE lby_gsm_comment THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_comment"}

          END.

    END.

/* Generic security allocation deletion */

DEFINE BUFFER lbx_gsm_user_allocation FOR gsm_user_allocation.

DEFINE BUFFER lby_gsm_user_allocation FOR gsm_user_allocation.

IF CAN-FIND(FIRST lbx_gsm_user_allocation 

            WHERE lbx_gsm_user_allocation.owning_obj = gem_status.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_user_allocation NO-LOCK

       WHERE lbx_gsm_user_allocation.owning_obj = gem_status.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^gemsttrigd.p^delete gsm_user_allocation":U:

        FIND FIRST lby_gsm_user_allocation EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_user_allocation) = ROWID(lbx_gsm_user_allocation)

             NO-ERROR.

        IF AVAILABLE lby_gsm_user_allocation THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_user_allocation"}

          END.

    END.

/* Generic multi-media deletion */

DEFINE BUFFER lbx_gsm_multi_media FOR gsm_multi_media.

DEFINE BUFFER lby_gsm_multi_media FOR gsm_multi_media.

IF CAN-FIND(FIRST lbx_gsm_multi_media 

            WHERE lbx_gsm_multi_media.owning_obj = gem_status.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_multi_media NO-LOCK

       WHERE lbx_gsm_multi_media.owning_obj = gem_status.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^gemsttrigd.p^delete gsm_multi_media":U:

        FIND FIRST lby_gsm_multi_media EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_multi_media) = ROWID(lbx_gsm_multi_media)

             NO-ERROR.

        IF AVAILABLE lby_gsm_multi_media THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_multi_media"}

          END.

    END.





















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'gemst':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "DELETE":U, INPUT "gemst":U, INPUT BUFFER gem_status:HANDLE, INPUT BUFFER o_gem_status:HANDLE).



/* Standard bottom of DELETE trigger code */

{af/sup/aftrigendd.i}





/* Place any specific DELETE trigger customisations here */

