TRIGGER PROCEDURE FOR CREATE OF hrm_benefits .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   hrm_benefits           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE hrm_benefits

&SCOPED-DEFINE TRIGGER_FLA hrmbf

&SCOPED-DEFINE TRIGGER_OBJ benefits_obj





DEFINE BUFFER lb_table FOR hrm_benefits.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR hrm_benefits.     /* Used for lock upgrades */



DEFINE BUFFER o_hrm_benefits FOR hrm_benefits.



/* Standard top of CREATE trigger code */

{af/sup/aftrigtopc.i}



  







/* Generated by ICF ERwin Template */

/* hrm_employee has hrm_benefits ON CHILD INSERT RESTRICT */

IF 

    ( hrm_benefits.employee_obj <> 0 ) THEN

  DO:

    IF NOT(CAN-FIND(FIRST hrm_employee WHERE

        hrm_benefits.employee_obj = hrm_employee.employee_obj)) THEN

        DO:

          /* Cannot create child because parent does not exist ! */

          ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 102 lv-include = "hrm_benefits|hrm_employee":U.

          RUN error-message (lv-errgrp, lv-errnum, lv-include).

        END.

    

    

  END.













ASSIGN hrm_benefits.{&TRIGGER_OBJ} = getNextObj().















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'hrmbf':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "CREATE":U, INPUT "hrmbf":U, INPUT BUFFER hrm_benefits:HANDLE, INPUT BUFFER o_hrm_benefits:HANDLE).



/* Standard bottom of CREATE trigger code */

{af/sup/aftrigendc.i}





/* Place any specific CREATE trigger customisations here */

