TRIGGER PROCEDURE FOR DELETE OF hrm_employee .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   hrm_employee           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE hrm_employee

&SCOPED-DEFINE TRIGGER_FLA hrmem

&SCOPED-DEFINE TRIGGER_OBJ employee_obj





DEFINE BUFFER lb_table FOR hrm_employee.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR hrm_employee.     /* Used for lock upgrades */



DEFINE BUFFER o_hrm_employee FOR hrm_employee.



/* Standard top of DELETE trigger code */

{af/sup/aftrigtopd.i}



  









/* Generated by ICF ERwin Template */

/* hrm_employee has hrx_employee_address ON PARENT DELETE CASCADE */

&IF DEFINED(lbe_employee_address) = 0 &THEN

  DEFINE BUFFER lbe_employee_address FOR hrx_employee_address.

  &GLOBAL-DEFINE lbe_employee_address yes

&ENDIF

FOR EACH hrx_employee_address NO-LOCK

   WHERE hrx_employee_address.employee_obj = hrm_employee.employee_obj

   ON STOP UNDO, RETURN ERROR "AF^104^hrmemtrigd.p^delete hrx_employee_address":U:

    FIND FIRST lbe_employee_address EXCLUSIVE-LOCK

         WHERE ROWID(lbe_employee_address) = ROWID(hrx_employee_address)

         NO-ERROR.

    IF AVAILABLE lbe_employee_address THEN

      DO:

        {af/sup/afvalidtrg.i &action = "DELETE" &table = "lbe_employee_address"}

      END.

END.











/* Generated by ICF ERwin Template */

/* hrm_employee has hrt_timesheet ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST hrt_timesheet WHERE

    hrt_timesheet.employee_obj = hrm_employee.employee_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "hrm_employee|hrt_timesheet":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.







/* Generated by ICF ERwin Template */

/* hrm_employee has reserved hrt_vacation ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST hrt_vacation WHERE

    hrt_vacation.employee_obj = hrm_employee.employee_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "hrm_employee|hrt_vacation":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.







/* Generated by ICF ERwin Template */

/* hrm_employee relates to hrm_family ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST hrm_family WHERE

    hrm_family.employee_obj = hrm_employee.employee_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "hrm_employee|hrm_family":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.







/* Generated by ICF ERwin Template */

/* hrm_employee has hrm_benefits ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST hrm_benefits WHERE

    hrm_benefits.employee_obj = hrm_employee.employee_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "hrm_employee|hrm_benefits":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.











/* Generic comments deletion */

DEFINE BUFFER lbx_gsm_comment FOR gsm_comment.

DEFINE BUFFER lby_gsm_comment FOR gsm_comment.

IF CAN-FIND(FIRST lbx_gsm_comment 

            WHERE lbx_gsm_comment.owning_obj = hrm_employee.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_comment NO-LOCK

       WHERE lbx_gsm_comment.owning_obj = hrm_employee.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^hrmemtrigd.p^delete gsm_comment":U:

        FIND FIRST lby_gsm_comment EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_comment) = ROWID(lbx_gsm_comment)

             NO-ERROR.

        IF AVAILABLE lby_gsm_comment THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_comment"}

          END.

    END.

/* Generic security allocation deletion */

DEFINE BUFFER lbx_gsm_user_allocation FOR gsm_user_allocation.

DEFINE BUFFER lby_gsm_user_allocation FOR gsm_user_allocation.

IF CAN-FIND(FIRST lbx_gsm_user_allocation 

            WHERE lbx_gsm_user_allocation.owning_obj = hrm_employee.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_user_allocation NO-LOCK

       WHERE lbx_gsm_user_allocation.owning_obj = hrm_employee.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^hrmemtrigd.p^delete gsm_user_allocation":U:

        FIND FIRST lby_gsm_user_allocation EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_user_allocation) = ROWID(lbx_gsm_user_allocation)

             NO-ERROR.

        IF AVAILABLE lby_gsm_user_allocation THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_user_allocation"}

          END.

    END.

/* Generic multi-media deletion */

DEFINE BUFFER lbx_gsm_multi_media FOR gsm_multi_media.

DEFINE BUFFER lby_gsm_multi_media FOR gsm_multi_media.

IF CAN-FIND(FIRST lbx_gsm_multi_media 

            WHERE lbx_gsm_multi_media.owning_obj = hrm_employee.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_multi_media NO-LOCK

       WHERE lbx_gsm_multi_media.owning_obj = hrm_employee.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^hrmemtrigd.p^delete gsm_multi_media":U:

        FIND FIRST lby_gsm_multi_media EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_multi_media) = ROWID(lbx_gsm_multi_media)

             NO-ERROR.

        IF AVAILABLE lby_gsm_multi_media THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_multi_media"}

          END.

    END.





















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'hrmem':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "DELETE":U, INPUT "hrmem":U, INPUT BUFFER hrm_employee:HANDLE, INPUT BUFFER o_hrm_employee:HANDLE).



/* Standard bottom of DELETE trigger code */

{af/sup/aftrigendd.i}





/* Place any specific DELETE trigger customisations here */

