TRIGGER PROCEDURE FOR WRITE OF hrm_employee OLD BUFFER o_hrm_employee.



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   hrm_employee           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE hrm_employee

&SCOPED-DEFINE TRIGGER_FLA hrmem

&SCOPED-DEFINE TRIGGER_OBJ employee_obj





DEFINE BUFFER lb_table FOR hrm_employee.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR hrm_employee.     /* Used for lock upgrades */







/* Standard top of WRITE trigger code */

{af/sup/aftrigtopw.i}



/* properform fields if enabled for table */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'hrmem':U

              AND gsc_entity_mnemonic.auto_properform_strings = YES) THEN

  RUN af/app/afpropfrmp.p (INPUT BUFFER hrm_employee:HANDLE).

  







/* Generated by ICF ERwin Template */

/* hrm_department holds hrm_employee ON CHILD UPDATE RESTRICT */

IF NEW hrm_employee OR  hrm_employee.department_obj <> o_hrm_employee.department_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST hrm_department WHERE

        hrm_employee.department_obj = hrm_department.department_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "hrm_employee|hrm_department":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.

















IF NOT NEW hrm_employee AND hrm_employee.{&TRIGGER_OBJ} <> o_hrm_employee.{&TRIGGER_OBJ} THEN

    DO:

        ASSIGN lv-error = YES lv-errgrp = "AF":U lv-errnum = 13 lv-include = "table object number":U.

        RUN error-message (lv-errgrp,lv-errnum,lv-include).

    END.



/* Customisations to WRITE trigger */

{dynsports/trg/hrmemtrigw.i}







/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'hrmem':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "WRITE":U, INPUT "hrmem":U, INPUT BUFFER hrm_employee:HANDLE, INPUT BUFFER o_hrm_employee:HANDLE).



/* Standard bottom of WRITE trigger code */

{af/sup/aftrigendw.i}







