TRIGGER PROCEDURE FOR CREATE OF hrt_vacation .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   hrt_vacation           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE hrt_vacation

&SCOPED-DEFINE TRIGGER_FLA hrtva

&SCOPED-DEFINE TRIGGER_OBJ vacation_obj





DEFINE BUFFER lb_table FOR hrt_vacation.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR hrt_vacation.     /* Used for lock upgrades */



DEFINE BUFFER o_hrt_vacation FOR hrt_vacation.



/* Standard top of CREATE trigger code */

{af/sup/aftrigtopc.i}



  







/* Generated by ICF ERwin Template */

/* hrc_vacation_type defines type for hrt_vacation ON CHILD INSERT RESTRICT */

IF 

    ( hrt_vacation.vacation_type_obj <> 0 ) THEN

  DO:

    IF NOT(CAN-FIND(FIRST hrc_vacation_type WHERE

        hrt_vacation.vacation_type_obj = hrc_vacation_type.vacation_type_obj)) THEN

        DO:

          /* Cannot create child because parent does not exist ! */

          ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 102 lv-include = "hrt_vacation|hrc_vacation_type":U.

          RUN error-message (lv-errgrp, lv-errnum, lv-include).

        END.

    

    

  END.



/* Generated by ICF ERwin Template */

/* hrm_employee has reserved hrt_vacation ON CHILD INSERT RESTRICT */

IF 

    ( hrt_vacation.employee_obj <> 0 ) THEN

  DO:

    IF NOT(CAN-FIND(FIRST hrm_employee WHERE

        hrt_vacation.employee_obj = hrm_employee.employee_obj)) THEN

        DO:

          /* Cannot create child because parent does not exist ! */

          ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 102 lv-include = "hrt_vacation|hrm_employee":U.

          RUN error-message (lv-errgrp, lv-errnum, lv-include).

        END.

    

    

  END.













ASSIGN hrt_vacation.{&TRIGGER_OBJ} = getNextObj().















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'hrtva':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "CREATE":U, INPUT "hrtva":U, INPUT BUFFER hrt_vacation:HANDLE, INPUT BUFFER o_hrt_vacation:HANDLE).



/* Standard bottom of CREATE trigger code */

{af/sup/aftrigendc.i}





/* Place any specific CREATE trigger customisations here */

