TRIGGER PROCEDURE FOR CREATE OF ivm_bin .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   ivm_bin           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE ivm_bin

&SCOPED-DEFINE TRIGGER_FLA ivmbn

&SCOPED-DEFINE TRIGGER_OBJ bin_obj





DEFINE BUFFER lb_table FOR ivm_bin.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR ivm_bin.     /* Used for lock upgrades */



DEFINE BUFFER o_ivm_bin FOR ivm_bin.



/* Standard top of CREATE trigger code */

{af/sup/aftrigtopc.i}



  







/* Generated by ICF ERwin Template */

/* ivm_item is stored in ivm_bin ON CHILD INSERT RESTRICT */

IF 

    ( ivm_bin.item_obj <> 0 ) THEN

  DO:

    IF NOT(CAN-FIND(FIRST ivm_item WHERE

        ivm_bin.item_obj = ivm_item.item_obj)) THEN

        DO:

          /* Cannot create child because parent does not exist ! */

          ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 102 lv-include = "ivm_bin|ivm_item":U.

          RUN error-message (lv-errgrp, lv-errnum, lv-include).

        END.

    

    

  END.



/* Generated by ICF ERwin Template */

/* ivm_warehouse contains ivm_bin ON CHILD INSERT RESTRICT */

IF 

    ( ivm_bin.warehouse_obj <> 0 ) THEN

  DO:

    IF NOT(CAN-FIND(FIRST ivm_warehouse WHERE

        ivm_bin.warehouse_obj = ivm_warehouse.warehouse_obj)) THEN

        DO:

          /* Cannot create child because parent does not exist ! */

          ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 102 lv-include = "ivm_bin|ivm_warehouse":U.

          RUN error-message (lv-errgrp, lv-errnum, lv-include).

        END.

    

    

  END.













ASSIGN ivm_bin.{&TRIGGER_OBJ} = getNextObj().















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'ivmbn':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "CREATE":U, INPUT "ivmbn":U, INPUT BUFFER ivm_bin:HANDLE, INPUT BUFFER o_ivm_bin:HANDLE).



/* Standard bottom of CREATE trigger code */

{af/sup/aftrigendc.i}





/* Place any specific CREATE trigger customisations here */

