TRIGGER PROCEDURE FOR WRITE OF ivm_bin OLD BUFFER o_ivm_bin.



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   ivm_bin           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE ivm_bin

&SCOPED-DEFINE TRIGGER_FLA ivmbn

&SCOPED-DEFINE TRIGGER_OBJ bin_obj





DEFINE BUFFER lb_table FOR ivm_bin.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR ivm_bin.     /* Used for lock upgrades */







/* Standard top of WRITE trigger code */

{af/sup/aftrigtopw.i}



/* properform fields if enabled for table */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'ivmbn':U

              AND gsc_entity_mnemonic.auto_properform_strings = YES) THEN

  RUN af/app/afpropfrmp.p (INPUT BUFFER ivm_bin:HANDLE).

  







/* Generated by ICF ERwin Template */

/* ivm_item is stored in ivm_bin ON CHILD UPDATE RESTRICT */

IF NEW ivm_bin OR  ivm_bin.item_obj <> o_ivm_bin.item_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST ivm_item WHERE

        ivm_bin.item_obj = ivm_item.item_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "ivm_bin|ivm_item":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.



/* Generated by ICF ERwin Template */

/* ivm_warehouse contains ivm_bin ON CHILD UPDATE RESTRICT */

IF NEW ivm_bin OR  ivm_bin.warehouse_obj <> o_ivm_bin.warehouse_obj  THEN

  DO:

    IF NOT(CAN-FIND(FIRST ivm_warehouse WHERE

        ivm_bin.warehouse_obj = ivm_warehouse.warehouse_obj)) THEN

              DO:

                /* Cannot update child because parent does not exist ! */

                ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 103 lv-include = "ivm_bin|ivm_warehouse":U.

                RUN error-message (lv-errgrp, lv-errnum, lv-include).

              END.

    

    

  END.

















IF NOT NEW ivm_bin AND ivm_bin.{&TRIGGER_OBJ} <> o_ivm_bin.{&TRIGGER_OBJ} THEN

    DO:

        ASSIGN lv-error = YES lv-errgrp = "AF":U lv-errnum = 13 lv-include = "table object number":U.

        RUN error-message (lv-errgrp,lv-errnum,lv-include).

    END.



/* Customisations to WRITE trigger */

{dynsports/trg/ivmbntrigw.i}







/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'ivmbn':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "WRITE":U, INPUT "ivmbn":U, INPUT BUFFER ivm_bin:HANDLE, INPUT BUFFER o_ivm_bin:HANDLE).



/* Standard bottom of WRITE trigger code */

{af/sup/aftrigendw.i}







