TRIGGER PROCEDURE FOR DELETE OF ivm_warehouse .



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   ivm_warehouse           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE ivm_warehouse

&SCOPED-DEFINE TRIGGER_FLA ivmwh

&SCOPED-DEFINE TRIGGER_OBJ warehouse_obj





DEFINE BUFFER lb_table FOR ivm_warehouse.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR ivm_warehouse.     /* Used for lock upgrades */



DEFINE BUFFER o_ivm_warehouse FOR ivm_warehouse.



/* Standard top of DELETE trigger code */

{af/sup/aftrigtopd.i}



  









/* Generated by ICF ERwin Template */

/* ivm_warehouse has ivx_warehouse_address ON PARENT DELETE CASCADE */

&IF DEFINED(lbe_warehouse_address) = 0 &THEN

  DEFINE BUFFER lbe_warehouse_address FOR ivx_warehouse_address.

  &GLOBAL-DEFINE lbe_warehouse_address yes

&ENDIF

FOR EACH ivx_warehouse_address NO-LOCK

   WHERE ivx_warehouse_address.warehouse_obj = ivm_warehouse.warehouse_obj

   ON STOP UNDO, RETURN ERROR "AF^104^ivmwhtrigd.p^delete ivx_warehouse_address":U:

    FIND FIRST lbe_warehouse_address EXCLUSIVE-LOCK

         WHERE ROWID(lbe_warehouse_address) = ROWID(ivx_warehouse_address)

         NO-ERROR.

    IF AVAILABLE lbe_warehouse_address THEN

      DO:

        {af/sup/afvalidtrg.i &action = "DELETE" &table = "lbe_warehouse_address"}

      END.

END.











/* Generated by ICF ERwin Template */

/* ivm_warehouse processes ivt_inventorytrans ON PARENT DELETE SET NULL */



&IF DEFINED(lbe_inventorytrans) = 0 &THEN

  DEFINE BUFFER lbe_inventorytrans FOR ivt_inventorytrans.

  &GLOBAL-DEFINE lbe_inventorytrans yes

&ENDIF

FOR EACH ivt_inventorytrans NO-LOCK

   WHERE ivt_inventorytrans.warehouse_obj = ivm_warehouse.warehouse_obj

   ON STOP UNDO, RETURN ERROR "AF^104^ivmwhtrigd.p^update ivt_inventorytrans":U:

    FIND FIRST lbe_inventorytrans EXCLUSIVE-LOCK

         WHERE ROWID(lbe_inventorytrans) = ROWID(ivt_inventorytrans)

         NO-ERROR.

    IF AVAILABLE lbe_inventorytrans THEN

      DO:

        

        ASSIGN lbe_inventorytrans.warehouse_obj = 0 .

      END.

END.







/* Generated by ICF ERwin Template */

/* ivm_warehouse contains ivm_bin ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST ivm_bin WHERE

    ivm_bin.warehouse_obj = ivm_warehouse.warehouse_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "ivm_warehouse|ivm_bin":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.







/* Generated by ICF ERwin Template */

/* ivm_warehouse processes art_order ON PARENT DELETE RESTRICT */

IF CAN-FIND(FIRST art_order WHERE

    art_order.warehouse_obj = ivm_warehouse.warehouse_obj) THEN

    DO:

      /* Cannot delete parent because child exists! */

      ASSIGN lv-error = YES lv-errgrp = "AF ":U lv-errnum = 101 lv-include = "ivm_warehouse|art_order":U.

      RUN error-message (lv-errgrp, lv-errnum, lv-include).

    END.











/* Generic comments deletion */

DEFINE BUFFER lbx_gsm_comment FOR gsm_comment.

DEFINE BUFFER lby_gsm_comment FOR gsm_comment.

IF CAN-FIND(FIRST lbx_gsm_comment 

            WHERE lbx_gsm_comment.owning_obj = ivm_warehouse.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_comment NO-LOCK

       WHERE lbx_gsm_comment.owning_obj = ivm_warehouse.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^ivmwhtrigd.p^delete gsm_comment":U:

        FIND FIRST lby_gsm_comment EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_comment) = ROWID(lbx_gsm_comment)

             NO-ERROR.

        IF AVAILABLE lby_gsm_comment THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_comment"}

          END.

    END.

/* Generic security allocation deletion */

DEFINE BUFFER lbx_gsm_user_allocation FOR gsm_user_allocation.

DEFINE BUFFER lby_gsm_user_allocation FOR gsm_user_allocation.

IF CAN-FIND(FIRST lbx_gsm_user_allocation 

            WHERE lbx_gsm_user_allocation.owning_obj = ivm_warehouse.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_user_allocation NO-LOCK

       WHERE lbx_gsm_user_allocation.owning_obj = ivm_warehouse.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^ivmwhtrigd.p^delete gsm_user_allocation":U:

        FIND FIRST lby_gsm_user_allocation EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_user_allocation) = ROWID(lbx_gsm_user_allocation)

             NO-ERROR.

        IF AVAILABLE lby_gsm_user_allocation THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_user_allocation"}

          END.

    END.

/* Generic multi-media deletion */

DEFINE BUFFER lbx_gsm_multi_media FOR gsm_multi_media.

DEFINE BUFFER lby_gsm_multi_media FOR gsm_multi_media.

IF CAN-FIND(FIRST lbx_gsm_multi_media 

            WHERE lbx_gsm_multi_media.owning_obj = ivm_warehouse.{&TRIGGER_OBJ}) THEN

    FOR EACH lbx_gsm_multi_media NO-LOCK

       WHERE lbx_gsm_multi_media.owning_obj = ivm_warehouse.{&TRIGGER_OBJ}

       ON STOP UNDO, RETURN ERROR "AF^104^ivmwhtrigd.p^delete gsm_multi_media":U:

        FIND FIRST lby_gsm_multi_media EXCLUSIVE-LOCK

             WHERE ROWID(lby_gsm_multi_media) = ROWID(lbx_gsm_multi_media)

             NO-ERROR.

        IF AVAILABLE lby_gsm_multi_media THEN

          DO:

            {af/sup/afvalidtrg.i &action = "DELETE" &table = "lby_gsm_multi_media"}

          END.

    END.





















/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'ivmwh':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "DELETE":U, INPUT "ivmwh":U, INPUT BUFFER ivm_warehouse:HANDLE, INPUT BUFFER o_ivm_warehouse:HANDLE).



/* Standard bottom of DELETE trigger code */

{af/sup/aftrigendd.i}





/* Place any specific DELETE trigger customisations here */

