TRIGGER PROCEDURE FOR WRITE OF ivm_warehouse OLD BUFFER o_ivm_warehouse.



/* Created automatically using ERwin ICF Trigger template db/af/erw/afercustrg.i

   Do not change manually. Customisations to triggers should be placed in separate

   include files pulled into the trigger. ICF auto generates write trigger custom

   include files. Delete or create customisation include files need to be created

   manually. Be sure to put the hook in ERwin directly so as not to have you changes

   overwritten.

   User defined Macro (UDP) Summary (case sensitive)

   ivm_warehouse           Expands to full table name, e.g. gsm_user

   %TableFLA            Expands to table unique code, e.g. gsmus

   %TableObj            If blank or not defined expands to table_obj with no prefix (framework standard)

                        If defined, uses this field as the object field

                        If set to "none" then indicates table does not have an object field

   XYZ                  Do not define so we can compare against an empty string



   See docs for explanation of replication macros 

*/   



&SCOPED-DEFINE TRIGGER_TABLE ivm_warehouse

&SCOPED-DEFINE TRIGGER_FLA ivmwh

&SCOPED-DEFINE TRIGGER_OBJ warehouse_obj





DEFINE BUFFER lb_table FOR ivm_warehouse.      /* Used for recursive relationships */

DEFINE BUFFER lb1_table FOR ivm_warehouse.     /* Used for lock upgrades */







/* Standard top of WRITE trigger code */

{af/sup/aftrigtopw.i}



/* properform fields if enabled for table */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'ivmwh':U

              AND gsc_entity_mnemonic.auto_properform_strings = YES) THEN

  RUN af/app/afpropfrmp.p (INPUT BUFFER ivm_warehouse:HANDLE).

  





















IF NOT NEW ivm_warehouse AND ivm_warehouse.{&TRIGGER_OBJ} <> o_ivm_warehouse.{&TRIGGER_OBJ} THEN

    DO:

        ASSIGN lv-error = YES lv-errgrp = "AF":U lv-errnum = 13 lv-include = "table object number":U.

        RUN error-message (lv-errgrp,lv-errnum,lv-include).

    END.



/* Customisations to WRITE trigger */

{dynsports/trg/ivmwhtrigw.i}







/* Update Audit Log */

IF CAN-FIND(FIRST gsc_entity_mnemonic

            WHERE gsc_entity_mnemonic.entity_mnemonic = 'ivmwh':U

              AND gsc_entity_mnemonic.auditing_enabled = YES) THEN

  RUN af/app/afauditlgp.p (INPUT "WRITE":U, INPUT "ivmwh":U, INPUT BUFFER ivm_warehouse:HANDLE, INPUT BUFFER o_ivm_warehouse:HANDLE).



/* Standard bottom of WRITE trigger code */

{af/sup/aftrigendw.i}







